#define _CRT_SECURE_NO_WARNINGS
// #pragma comment(linker, "/Stack:480000000")

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <set>

using namespace std;

int main() {
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif
  ios::sync_with_stdio(0);
  cin.tie(0);

  int n;
  cin >> n;

  vector<int> a(n);
  for (int i = 0; i < n; ++i)
    cin >> a[i];

  struct State {
    int posLeft, posRight, mn, mx;
    
    bool operator<(const State &s) const {
      return posLeft < s.posLeft;
    }
  };

  set<State> s;

  vector<pair<int, int>> t;
  t.reserve(n);
  for (int i = 0; i < n; ++i)
    t.push_back({ a[i], i });
  sort(t.begin(), t.end());

  for (auto e : t) {
    int x = e.first, i = e.second;
    auto it = s.lower_bound(State{ i });
    if (it != s.begin()) it--;
    State tmp = State{ i, i, x, x };
    vector<State> todel;

    while (it != s.end() && it->posRight == tmp.posLeft - 1) {
      if (tmp.mn >= it->mn && tmp.mx >= it->mx) {
        todel.push_back(*it);
        tmp.mn = it->mn;
        tmp.posLeft = it->posLeft;
        if (it == s.begin()) break;
        it--;
      }
      else break;
    }

    for (auto t : todel)
      s.erase(t);
    s.insert(tmp);
    
  }

  cout << s.size() << endl;

  return 0;
}
