#include <bits/stdc++.h>
using namespace std;

int n;
vector<vector<int>> ord, pos;

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n;
    ord.resize(n);
    pos.resize(n);
    for (int i = 0; i < n; i++) {
        ord[i].resize(n);
        pos[i].resize(n);
    }

    vector<int> ans1;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> ord[i][j];
            ord[i][j]--;
            pos[i][ord[i][j]] = j;
        }
        if (ord[i][0] == i) {
            ans1.push_back(i);
        }
    }

    int p;
    cin >> p;
    if (p == 1) {
        cout << ans1.size() << endl;
        for (int i : ans1) {
            cout << i + 1 << " ";
        }
        cout << endl;
    } else {

        vector<vector<bool>> a(n, vector<bool> (n));
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                for (int k = j + 1; k < n; k++) {
                    a[ord[i][j]][ord[i][k]] = true;
                }
            }
        }

        vector<bool> res(n);
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                int x = ord[i][j];
                bool ok = true;
                for (int i1 = 0; i1 < n; i1++) {
                    if (i1 == i) continue;
                    int mn1 = n, mx2 = -1;
                    for (int j1 = j; j1 < n; j1++) {
                        mn1 = min(mn1, pos[i1][ord[i][j1]]);
                    }
                    for (int j1 = 0; j1 < j; j1++) {
                        mx2 = max(mx2, pos[i1][ord[i][j1]]);
                    }
                    if (mn1 > mx2) {
                        ok = false;
                        break;
                    }
                }
                if (ok) {
                    res[x] = true;
                }
            }
        }

        vector<int> ans2;
        for (int i = 0; i < n; i++) {
            if (res[i]) {
                ans2.push_back(i);
            }
        }

        cout << ans2.size() << endl;
        for (int i : ans2) {
            cout << i + 1 << " ";
        }
        cout << endl;

    }

    return 0;
}