#include <bits/stdc++.h>
using namespace std;

const int INF = 2000000000;
int n;
vector<int> a;

int count(int i, int s1, int s2) {
    int ans = 0;
    int ti = INF;
    if (s1 != -1) {
        ti = min(ti, a[i] + abs(i - s1));
    }
    if (s2 != -1) {
        ti = min(ti, a[i] + abs(i - s2));
    }

    for (int j = 0; j < n; j++) {
        int tj = INF;
        if (s1 != -1) {
            tj = min(tj, a[j] + abs(j - s1));
        }
        if (s2 != -1) {
            tj = min(tj, a[j] + abs(j - s2));
        }
        if (tj < ti) {
            ans++;
        }
    }

    return ans;
}

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int p;
    cin >> n >> p;
    if (p == 1) {
        return 1;
    }
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    vector<int> ans1(n), ans2(n);

    for (int i = 0; i < n / 2; i++) {
        ans1[i] = count(i, -1, n - 1);
        ans2[i] = count(i, 0, 2 * i);
    }
    for (int i = n / 2; i < n; i++) {
        ans1[i] = count(i, -1, 0);
        ans2[i] = count(i, n - 1, n - 1 - 2 * (n - 1 - i));
    }

    for (int i = 0; i < n; i++) {
        cout << max(ans1[i], ans2[i]) + 1 << "\n";
    }

    return 0;
}
