#include <bits/stdc++.h>
#define ll long long
#define mp make_pair
#define pb push_back
#define X first
#define Y second
#define pii pair<int, int>

using namespace std;

int solve();
int sol();

const int MAXN = 510;
int n;
int a[MAXN][MAXN];
set<int> ans;
int enter[MAXN][MAXN];

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // DEBUG
    cin >> n;
    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= n; j++)
        {
            cin >> a[i][j];
            enter[i][a[i][j]] = j;
        }
    int p; cin >> p;
    if (p == 1)
        solve();
    else
        sol();
    return 0;
}

int solve()
{
    for (int i = 1; i <= n; i++)
        if (a[i][1] == i)
            ans.insert(i);
    cout << (int)ans.size() << endl;
    for (auto it = ans.begin(); it != ans.end(); it++)
        cout << *it << " ";
}

bool dp[MAXN][MAXN];

bool check(int i, int c)
{
    for (int j = 1; j <= n; j++)
    {
        if (i == j)
            continue;
        bool f = false;
        for (int q = enter[i][c]; q <= n; q++)
            if (dp[j][a[i][q]])
            {
                f = true;
                break;
            }
        if (!f)
        {
            dp[i][c] = 0;
            return 1;
        }
    }
    return 0;
}

int sol()
{
    memset(dp, 1, sizeof(dp));
    for (int p = 1; p <= n; p++)
    {
        for (int i = enter[p][p] + 1; i <= n; i++)
        {
            dp[p][a[p][i]] = 0;
        }
    }
    while(1)
    {
        bool f = false;
        for (int i = 1; i <= n; i++)
            for (int c = 1; c <= n; c++)
            {
                if (!dp[i][c])
                    continue;
                if (check(i, c))
                    f = true;
            }
        if (!f)
            break;
    }

    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= n; j++)
            if (dp[i][j])
                ans.insert(j);
    cout << (int)ans.size() << endl;
    for (auto it = ans.begin(); it != ans.end(); it++)
        cout << *it << " ";
}
