#include <bits/stdc++.h>
#define ll long long
#define mp make_pair
#define pb push_back
#define X first
#define Y second
#define pii pair<int, int>

using namespace std;

int solve();

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // DEBUG
    solve();
    return 0;
}

const int MAXN = (int)1e4 + 10;
const int INF = (int)1e9 + 10;

int d[MAXN];
int n, m, k;
pii g[MAXN];
int p[MAXN];
set<pii> q;

void find_path(int v)
{
    for (int i = 1; i <= k; i++)
        d[i] = INF;
    p[v] = -1;
    d[v] = 0;
    q.insert(mp(d[v], v));
    while(!q.empty())
    {
        pii u = *q.begin();
        q.erase(q.begin());
        for (int i = 1; i <= k; i++)
            if (i != u.Y)
            {
                ll len = 1 << max(abs(g[i].X - g[u.Y].X), abs(g[i].Y - g[u.Y].Y));
                if (u.X + len < d[i])
                {
                    q.erase(mp(d[i], i));
                    d[i] = u.X + len;
                    p[i] = u.Y;
                    q.insert(mp(d[i], i));
                }
            }
    }
}

vector<int> ans;

int solve()
{
    cin >> n >> m >> k;
    for (int i = 1; i <= k; i++)
        cin >> g[i].X >> g[i].Y;
    find_path(1);
    int v = k;
    while(v != -1)
    {
        ans.pb(v);
        v = p[v];
    }
    reverse(ans.rbegin(), ans.rend());
    cout << (int)ans.size() << endl;
    for (int i = 0; i < (int)ans.size(); i++)
        cout << ans[i] << " ";
}
