#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <cmath>
#include <random>
#include <ctime>

#pragma comment(linker, "/STACK:256000000")
#pragma GCC optimize("O3")

using namespace std;

#define all(a) a.begin(), a.end()
const int inf = 1e9;

int main() {
	int n, m, q;
	cin >> n >> m >> q;
	vector<vector<int>> a(n, vector<int>(m));
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < m; ++j)
			cin >> a[i][j];
	vector<int> maxn(n, 0), maxm(m, 0);
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < m; ++j) {
			if (a[i][j] > a[i][maxn[i]])
				maxn[i] = j;
			if (a[i][j] > a[maxm[j]][j])
				maxm[j] = i;
		}
	vector<bool> po(n, false);
	for (int i = 0; i < n; ++i)
		po[i] = maxm[maxn[i]] == i;
	int cnt = 0;
	for (int i = 0; i < n; ++i)
		cnt += po[i];
	while (q--) {
		int r, c, x;
		cin >> r >> c >> x;
		r--; c--;
		if (x > a[r][maxn[r]])
			maxn[r] = c;
		if (x > a[maxm[c]][c])
			maxm[c] = r;
		a[r][c] = x;
		if (maxn[r] == c) {
			if (maxm[c] == r) {
				if (!po[r])
					cnt++;
				po[r] = true;
			}
			else {
				if (po[r])
					cnt--;
				po[r] = false;
			}
		}
		cout << cnt << '\n';
	}
	return 0;
}