#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <cmath>
#include <random>
#include <ctime>

#pragma comment(linker, "/STACK:256000000")
#pragma GCC optimize("O3")

using namespace std;

#define all(a) a.begin(), a.end()
const int inf = 1e9;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	int n;
	cin >> n;
	vector<vector<int>> pr(n, vector<int>(n));
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < n; ++j) {
			cin >> pr[i][j];
			pr[i][j]--;
		}
	int p;
	cin >> p;
	if (p == 1) {
		vector<bool> k(n, false);
		for (int i = 0; i < n; ++i)
			k[i] = i == pr[i][0];
		int cnt = 0;
		for (int i = 0; i < n; ++i)
			cnt += k[i];
		cout << cnt << '\n';
		for (int i = 0; i < n; ++i)
			if (k[i])
				cout << i + 1 << ' ';
		return 0;
	}
	vector<vector<int>> b(n, vector<int>(n));
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < n; ++j)
			b[i][pr[i][j]] = j;
	vector<bool> ans(n, false);
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < n; ++j) {
			if (b[j][j] < b[j][i])
				continue;
			vector<bool> k(n, false);
			for (int l = 0; l < b[j][i]; ++l)
				k[pr[j][l]] = true;
			bool q = true;
			for (int l = 0; l < n; ++l) {
				if (k[l]) {
					bool qq = false;
					for (int r = 0; pr[l][r] != l; ++r)
						if (!k[pr[l][r]]) {
							qq = true;
							break;
						}
					if (qq == false) {
						q = false;
						break;
					}
				}
			}
			if (q) {
				ans[i] = true;
				break;
			}
		}

	int cnt = 0;
	for (int i = 0; i < n; ++i)
		cnt += ans[i];
	cout << cnt << '\n';
	for (int i = 0; i < n; ++i) {
		if (ans[i])
			cout << i + 1 << ' ';
	}
	return 0;
}