#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <cmath>
#include <random>
#include <ctime>

#pragma comment(linker, "/STACK:256000000")
#pragma GCC optimize("O3")

using namespace std;

#define all(a) a.begin(), a.end()
const int inf = 1000000000;


vector<int> sum(vector<int> a, vector<int> & b) {
	for (int i = 0, carry = 0; i < (int)a.size() || i < (int)b.size() || carry; ++i) {
		if (i == (int)a.size())
			a.push_back(0);
		a[i] += carry + (i < (int)b.size() ? b[i] : 0);
		carry = a[i] / inf;
		a[i] -= carry * inf;
	}
	return a;
}

bool bol(vector<int> & a, vector<int> & b) {
	if (a.size() != b.size())
		return a.size() < b.size();
	for (int i = (int)a.size() - 1; i + 1; --i)
		if (a[i] != b[i])
			return a[i] < b[i];
	return false;
}
int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	int n, m, k;
	cin >> n >> m >> k;
	vector<pair<int, int>> a(k);
	for (int i = 0; i < k; ++i) {
		cin >> a[i].first >> a[i].second;
		a[i].first--; a[i].second--;
	}
	vector<vector<int>> st(max(n, m), vector<int>(1, 1));
	for (int i = 1; i < (int)st.size(); ++i)
		st[i] = sum(st[i - 1], st[i - 1]);
	vector<vector<int>> d(k, st[max(n, m) - 1]);
	d[0] = vector<int>(1, 0);
	vector<int> p(k, 0);
	vector<bool> used(k, false);
	for (int i = 0; i < k; ++i) {
		int v = -1;
		for (int j = 0; j < k; ++j)
			if (!used[j] && (v == -1 || bol(d[j], d[v])))
				v = j;
		used[v] = true;
		for (int j = 0; j < k; ++j) {
			if (j == v)
				continue;
			auto tmp = sum(d[v], st[max(abs(a[v].first - a[j].first), abs(a[v].second - a[j].second))]);
			if (v != j && bol(tmp, d[j])) {
				d[j] = tmp;
				p[j] = v;
			}
		}
	}
	vector<int> order;
	for (int i = k - 1; i != p[i]; i = p[i])
		order.push_back(i);
	reverse(all(order));
	cout << (int)order.size() + 1 << '\n' << "1 ";
	for (int i = 0; i < (int)order.size(); ++i) {
		cout << order[i] + 1 << ' ';
	}
	return 0;
}