#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <deque>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <ctime>
#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
using namespace std;

#define int int64_t
#define mp make_pair
#define pb push_back
#define pbb pop_back
#define pf pop_front
#define pff push_front
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()
using ld = long double;
using ll = long long;
using pii = pair<int, int>;
using treap = tree<pii, null_type, less<pii>, rb_tree_tag, tree_order_statistics_node_update>;

int32_t main()
{
    int n, p;
    cin >> n >> p;
    vector<int> nums(n);
    for (int i = 0; i < n; ++i)
        cin >> nums[i];

    vector<int> ans(n);
    treap left, right, both, just;
    for (int i = 0; i < n; ++i) {
        left.insert(mp(nums[i] + i, i));
        right.insert(mp(nums[i] + n - i - 1, i));
        both.insert(mp(nums[i] + min(i, n - i - 1), i));
        just.insert(mp(nums[i], i));
    }
    for (int i = 0; i < n; ++i) {
        int a = left.order_of_key(mp(nums[i] + i, 0));
        int b = right.order_of_key(mp(nums[i] + n - i - 1, 0));
        int c = both.order_of_key(mp(nums[i] + min(i, n - i - 1), 0));
        int d = just.order_of_key(mp(nums[i] + 1, 0)) - 1;
        ans[i] = max(max(a, b), max(c, d)) + 1;
    }

    for (int elem : ans)
        cout << elem << endl;

    return 0;
}
