#include <bits/stdc++.h>

using namespace std;

const int maxN = 3005;
const int INF = 1e9;

int arr[maxN];
int pos[maxN];
vector<pair<int, int>> ans;
int process(int l, int r, int n) {
    vector<int> arr2;

    for (int i = 1; i <= r - l; i += 2) arr2.push_back(arr[l + i]);
    for (int i = 0; i <= r - l; i += 2) arr2.push_back(arr[l + i]);

    for (int i = 0; i <= r - l; i++) arr[l + i] = arr2[i];

    for (int i = 0; i < n; i++) pos[arr[i]] = i;

    ans.push_back({l, r});
}

void solve(int l, int r, int n) {
    int x = arr[l];

    while (l != r) {
        int c = 0;
        //while (r - c >= 0 && (l - pos[r - c]) % 2 == 0) c++;

        process(pos[r - c + 1], r, n);
        l = pos[x];
    }
}

int main() {
    #ifdef DEBUG
        freopen("in.in", "r", stdin);
    #endif // DEBUG

    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int n;
    cin >> n;

    for (int i = 0; i < n; i++) {
        cin >> arr[i];
        arr[i]--;
    }

    for (int i = 0; i < n; i++) pos[arr[i]] = i;
    for (int i = n - 1; i >= 1; i--) {
        solve(pos[i], i, n);
    }

    for (int i = 0; i < n; i++) assert(arr[i] == i);

    cout << ans.size() << endl;
    for (auto p : ans) cout << p.first + 1 << " " << p.second + 1 << endl;

    return 0;
}
