#include <bits/stdc++.h>
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)

using namespace std;

typedef long long ll;

const int dd = 3007;

int pos[dd];
int A[dd];

int oldA[dd], oldpos[dd];

vector<pair<int, int> > ans, ansR;
int cur[dd];
int ic;

void mv(int l, int r) {
    ans.push_back({ l, r });

    ic = 0;
    for (int i = l + 1; i <= r; i += 2) cur[ic++] = A[i];
    for (int i = l; i <= r; i += 2) cur[ic++] = A[i];

    for (int i = 0; i < ic; i++) {
        A[i + l] = cur[i];
        pos[A[i + l]] = i + l;
    }
}


void mvR(int l, int r) {
    ansR.push_back({ l, r });

    ic = 0;
    for (int i = l + 1; i <= r; i += 2) cur[ic++] = A[i];
    for (int i = l; i <= r; i += 2) cur[ic++] = A[i];

    for (int i = 0; i < ic; i++) {
        A[i + l] = cur[i];
        pos[A[i + l]] = i + l;
    }
}

void make(int st, int fn) {
    if (st == fn) return;
    assert(st < fn);

    if ((fn - st) % 2 == 0) {
        mv(fn - 1, fn);
        fn--;
    }

    mv(st, fn);

    int len = fn - st + 1;
    make(st, st + len / 2 - 1);
}

void makeR(int st, int fn) {
    if (st == fn) return;
    assert(st > fn);

    //err("st = %d, fn = %d\n", st, fn);

    if ((fn - st) % 2 == 0) {
        mvR(fn, fn + 1);
        fn++;
    }

    mvR(fn, st);

    int len = st - fn + 1;
    makeR(st, fn + len / 2);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n; cin >> n;

    for (int i = 0; i < n; i++) {
        int x; cin >> x;
        x--;
        A[i] = x; pos[x] = i;
        oldA[i] = x; oldpos[x] = i;
    }

    for (int val = n - 1; val >= 0; val--) {
        //err("%d\n", val);
        makeR(val, pos[val]);
    }

    for (int i = 0; i < n; i++) A[i] = oldA[i], pos[i] = oldpos[i];

    for (int i = 0; i < n; i++) {
        make(i, pos[i]);
    }

    if (ansR.size() < ans.size()) ans = ansR;

    cout << (int)ans.size() << "\n";
    for (auto c : ans) cout << c.first + 1 << " " << c.second + 1 << "\n";
    return 0;
}
