#include <bits/stdc++.h>

using namespace std;

void print(int x) {
    string s;
    while (x != 0) {
        s.push_back('0' + (x & 1));
        x >>= 1;
    }
    reverse(s.begin(), s.end());
    cout << s << endl;
}

void input(int & x) {
    x = 0;
    string s;
    cin >> s;
    for (char c : s) {
        x <<= 1;
        x |= (c == '1');
    }
}

vector<int> v;
vector<int> d;
int ans = 1e9;

void solve(int i, int sum, int orr) {
    if (i == v.size()) {
        if (sum == orr)
            ans = min(ans, orr);
        return;
    }
    for (int k = (v[i] << 2); k >= v[i]; --k)
        solve(i + 1, sum + k, orr | k);
}

int main() {
    int n;
    cin >> n;
    int max_len = 1;
    vector<int> d(300000);
    string s;
    for (int j = 0; j < n; ++j) {
        cin >> s;
        reverse(s.begin(), s.end());
        for (int i = 0; i < s.size(); ++i)
            d[i] += (s[i] == '1');
        max_len = max(max_len, (int)s.size());
    }
    int bal = 0;
    string res;
    for (int i = 0; i < max_len || bal > 0; ++i) {
        bal += d[i];
        if (bal > 0) {
            res.push_back('1');
            bal--;
        } else
            res.push_back('0');
    }
    reverse(res.begin(), res.end());
    cout << res << endl;
}

