#pragma GCC optimize("Ofast,O3")
#include <bits/stdc++.h>
using namespace std;
#define int long long

const int MAXN = 4e5;
int arr[MAXN];
int tree[MAXN * 4];

vector <int> imp;

int get(int v, int cl, int cr, int l, int r) {
	if (cr < l || r < cl || l > r) return 0;
	if (l <= cl && cr <= r) return tree[v];
	int cm = (cl + cr) / 2;
	return get(v * 2, cl, cm, l, r) + get(v * 2 + 1, cm + 1, cr, l, r);
}

void update(int v, int l, int r, int p) {
	tree[v]++;
	if (l < r) {
		int m = (l + r) / 2;
		if (p <= m)
			update(v * 2, l, m, p);
		else
			update(v * 2 + 1, m + 1, r, p);
	}
}

signed main() {
	ios_base::sync_with_stdio(false);

	int n, p;
	cin >> n >> p;
	for (int i = 0; i < n; i++) {
		cin >> arr[i];
	}
	if (p == 1) {
		vector <int> num(n, 1);

		for (int i = 0; i < n; i++) imp.push_back(arr[i] - i);
		sort(imp.begin(), imp.end());
		imp.resize(unique(imp.begin(), imp.end()) - imp.begin());
		for (int i = 0; i < n; i++) {
			int pos = lower_bound(imp.begin(), imp.end(), arr[i] - i) - imp.begin();
			num[i] += get(1, 0, imp.size() - 1, 0, pos - 1);
			update(1, 0, imp.size() - 1, pos);
		}

		imp.clear();
		fill(tree, tree + n * 4, 0);

		for (int i = 0; i < n; i++) imp.push_back(arr[i] + i);
		sort(imp.begin(), imp.end());
		imp.resize(unique(imp.begin(), imp.end()) - imp.begin());
		for (int i = n - 1; i >= 0; i--) {
			int pos = lower_bound(imp.begin(), imp.end(), arr[i] + i) - imp.begin();
			num[i] += get(1, 0, imp.size() - 1, 0, pos - 1);
			update(1, 0, imp.size() - 1, pos);
		}
		for (int i = 0; i < n; i++) {
			cout << num[i] << "\n";
		}


	} else {
		int SHIFT = (n <= 20) ? 20 : 5;
		vector <int> pl(n, 1);
		vector <pair <int, int> > cur;
	  	for (int left = -1; left <= n; left++) {
			for (int right = left + 1; right <= n; right++) {
				if (left == -1 && right == n) continue;
				if (left >= 0 && right <= n - 1) continue;
				cur.clear();
				for (int i = 0; i <= left; i++) {
					cur.push_back({arr[i], i});
				}
				for (int i = right; i < n; i++) {
					cur.push_back({arr[i], i});
				}
				for (int i = left + 1; i < right; i++) {
					cur.push_back({arr[i] + min((left >= 0) ? i - left : 1e9, (right < n) ? right - i : 1e9), i});
				}
				sort(cur.begin(), cur.end());
				int prev = 0;
				for (int i = 0; i < n; i++) {
					if (i == 0 || cur[i - 1].first < cur[i].first) {
						prev = i;
					}
					pl[cur[i].second] = max(pl[cur[i].second], prev + 1);
				}
			}
		}
		for (int i = 0; i < n; i++) {
			cout << pl[i] << "\n";
		}
	}
	return 0;
}