#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <functional>
using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
#define all(v) v.begin(), v.end()

struct bint {

};
const int mod = 10;
vector<int> sum(vector<int> &a, vector<int> &b) {
	int n = a.size();
	int m = b.size();
	vector<int> res(max(n, m) + 1);
	for (int i = 0; i < res.size() - 1; i++) {
		if (i < n) res[i] += a[i];
		if (i < m) res[i] += b[i];
		res[i + 1] += res[i] / mod;
		res[i] %= mod;
	} 
	while (res.size() > 1 && res.back() == 0) res.pop_back();
	return res;
}
vector<int> mult2(vector<int> &a) {
	vector<int> res = a;
	res.push_back(0);
	for (int i = 0; i < res.size() - 1; i++)
		res[i] *= 2;
	for (int i = 0; i < res.size() - 1; i++) {
		res[i + 1] += res[i] / mod;
		res[i] %= mod;
	}
	while (res.size() > 1 && res.back() == 0) res.pop_back();
	return res;
}

struct comp {
	bool comp2(const vector<int> &a, const vector<int> &b) const {
		if (a.size() < b.size()) return true;
		if (a.size() > b.size()) return false;
		for (int i = a.size() - 1; i >= 0; i--) {
			if (a[i] < b[i]) return true;
			if (a[i] > b[i]) return false;
		}
		return false;
	}
	bool operator()(const pair<vector<int>, int> &a, 
		const pair<vector<int>, int> &b) const {
		if (a.first == b.first) return a.second < b.second;
		else return comp2(a.first, b.first);
	}
};

int main() {
	ios_base::sync_with_stdio(0);
	greater<int>;
	int n, m, k;
	cin >> n >> m >> k;
	vector<pii> v(k);
	for (int i = 0; i < k; i++) {
		cin >> v[i].first >> v[i].second;
	}
	int t = max(n, m) + 1;
	vector<vector<int>> pows(t);
	pows[0] = { 1 };
	for (int i = 1; i < t; i++) {
		pows[i] = mult2(pows[i - 1]);
	}
	vector<vector<int>> d(k);
	vector<int> p(k);
	for (int i = 0; i < k; i++) {
		d[i] = pows.back();
		p[i] = -1;
	}
	d[0] = { 0 };
	p[0] = 0;
	comp c;
	set<pair<vector<int>, int>, comp> s;
	s.insert({ d[0], 0 });
	while (s.size() > 0) {
		int f = s.begin()->second;
		s.erase(s.begin());
		for (int i = 0; i < k; i++) {
			if (i == 5) {
				int a = 5;
			}
			if (i == f) continue;
			vector<int> q = pows[max(abs(v[f].first - v[i].first),
				abs(v[f].second - v[i].second))];
			vector<int> cur = sum(d[f], q);
			if (c.comp2(cur, d[i])) {
				s.erase({ d[i], i });
				d[i] = cur;
				p[i] = f;
				s.insert({ d[i], i });
			}
		}
	}
	vector<int> ans;
	int cur = k - 1;
	while (cur != 0) {
		ans.push_back(cur);
		cur = p[cur];
	}
	ans.push_back(0);
	reverse(all(ans));
	cout << ans.size() << "\n";
	for (int i = 0; i < ans.size(); i++)
		cout << ans[i] + 1 << " ";
}