#include <bits/stdc++.h>

//#define int long long
#define pb push_back
#define mp make_pair

using namespace std;

int a[300000];
int tmin[4 * 300000];
int tmax[4 * 300000];

void buildmin(int v, int l, int r) {
    if (l + 1 == r) {
        tmin[v] = l;
        return;
    }
    int m = ((l + r) >> 1);
    buildmin(v * 2 + 1, l, m);
    buildmin(v * 2 + 2, m, r);
    if (a[tmin[v * 2 + 1]] < a[tmin[v * 2 + 2]])
        tmin[v] = tmin[v * 2 + 1];
    else
        tmin[v] = tmin[v * 2 + 2];
}

void buildmax(int v, int l, int r) {
    if (l + 1 == r) {
        tmax[v] = l;
        return;
    }
    int m = ((l + r) >> 1);
    buildmax(v * 2 + 1, l, m);
    buildmax(v * 2 + 2, m, r);
    if (a[tmax[v * 2 + 1]] > a[tmax[v * 2 + 2]])
        tmax[v] = tmax[v * 2 + 1];
    else
        tmax[v] = tmax[v * 2 + 2];
}

int getmin(int v, int tl, int tr, int l, int r) {
    if (tl >= l && tr <= r)
        return tmin[v];
    int tm = ((tl + tr) >> 1);

    int p, q;

    if (tl >= r || tm <= l)
        p = -1;
    else
        p = getmin(v * 2 + 1, tl, tm, l, r);

    if (tm >= r || tr <= l)
        q = -1;
    else
        q = getmin(v * 2 + 2, tm, tr, l, r);

    if (p == -1 || q == -1)
        return (p == -1 ? q : p);

    if (a[p] < a[q])
        return p;
    else
        return q;
}

int getmax(int v, int tl, int tr, int l, int r) {
    if (tl >= l && tr <= r)
        return tmax[v];
    int tm = ((tl + tr) >> 1);
    int p, q;
    if (tl >= r || tm <= l)
        p = -1;
    else
        p = getmax(v * 2 + 1, tl, tm, l, r);
    if (tm >= r || tr <= l)
        q = -1;
    else
        q = getmax(v * 2 + 2, tm, tr, l, r);
    if (p == -1 || q == -1)
        return (p == -1 ? q : p);
    if (a[p] > a[q])
        return p;
    else
        return q;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    for (int i = 0; i < n; i++)
        cin >> a[i];
    buildmin(0, 0, n);
    buildmax(0, 0, n);
    int ans = 0;
    for (int i = 0; i < n; i++) {
        int l = i, r = n;
        while (l + 1 < r) {
            int m = (l + r) / 2;
            int t = getmin(0, 0, n, i, m + 1);
            if (a[t] == a[i])
                l = m;
            else
                r = m;
        }
        ans++;
        int t = getmax(0, 0, n, i, l + 1);
        i = t;
    }
    cout << ans;
    return 0;
}
