#include <bits/stdc++.h>

//#define int long long
#define pb push_back
#define mp make_pair

using namespace std;

int a[300000];
int tmax[4 * 300000];
int tmin[300000][19];
int n;

void buildmax(int v, int l, int r) {
    if (l + 1 == r) {
        tmax[v] = l;
        return;
    }
    int m = ((l + r) >> 1);
    buildmax(v * 2 + 1, l, m);
    buildmax(v * 2 + 2, m, r);
    if (a[tmax[v * 2 + 1]] > a[tmax[v * 2 + 2]])
        tmax[v] = tmax[v * 2 + 1];
    else
        tmax[v] = tmax[v * 2 + 2];
}

int getmax(int v, int tl, int tr, int l, int r) {
    if (tl >= r || tr <= l)
        return -1;
    if (tl >= l && tr <= r)
        return tmax[v];
    int tm = ((tl + tr) >> 1);
    int p = getmax(v * 2 + 1, tl, tm, l, r);
    int q = getmax(v * 2 + 2, tm, tr, l, r);
    if (p == -1 || q == -1)
        return (p == -1 ? q : p);
    if (a[p] > a[q])
        return p;
    else
        return q;
}

void buildmin() {
    for (int i = 0; i < n; i++)
        tmin[i][0] = i;
    for (int i = 1; i < 19; i++) {
        for (int j = 0; j < n; j++) {
            if (j + (1 << i) - 1 >= n)
                continue;
            if (a[tmin[j][i - 1]] < a[tmin[j + (1 << (i - 1))][i - 1]])
                tmin[j][i] = tmin[j][i - 1];
            else
                tmin[j][i] = tmin[j + (1 << (i - 1))][i - 1];
        }
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> n;
    for (int i = 0; i < n; i++)
        cin >> a[i];
    buildmin();
    buildmax(0, 0, n);
    int ans = 0;
    for (int i = 0; i < n; i++) {
        int l = i, r = n;
        while (l + 1 < r) {
            int m = (l + r) / 2;
            int x = trunc(log(m - i + 1) / log(2));
            int t;
            if (a[tmin[i][x]] < a[tmin[m - (1 << x) + 1][x]])
                t = tmin[i][x];
            else
                t = tmin[m - (1 << x) + 1][x];
            if (a[t] == a[i])
                l = m;
            else
                r = m;
        }
        ans++;
        int t = getmax(0, 0, n, i, l + 1);
        i = t;
    }
    cout << ans;
    return 0;
}
