#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <math.h>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <queue>

#define pb push_back
#define mp make_pair
#define all(x) x.begin(), x.end()
#define pp " "
#define nn "\n"

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 1e9;
const ll cnst = 1e9 + 7;

ll n, m, k;
vector <vector <pair <ll, ll>>> g;
set<pair <ll, ll>> s;
vector <ll> p;
vector <pair <ll, ll>> key;
ll dva[30];

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	dva[0] = 1;
	for (ll i = 1; i <= 20; i++) {
		dva[i] = dva[i - 1] * 2;
	}
	cin >> n >> m >> k;
	g.resize(k);
	p.resize(k);
	key.resize(k);
	vector <ll> d(k, INF);
	ll x, y;
	for (ll i = 0; i < k; i++) {
		cin >> x >> y;
		key[i] = mp(x, y);
		for (ll j = 0; j < i; j++) {
			g[i].push_back(mp(j, max(abs(key[j].first - x), abs(key[j].second - y)) * cnst));
			g[j].push_back(mp(i, max(abs(key[j].first - x), abs(key[j].second - y)) * cnst));
		}
	}
	p[0] = -1;
	d[0] = 0;
	s.insert(mp(0, 0));
	while (!s.empty()) {
		ll v = s.begin()->second;
		s.erase(s.begin());
		for (ll i = 0; i < g[v].size(); i++) {
			ll to = g[v][i].first;
			if (d[to] > d[v] + g[v][i].second) {
				s.erase(mp(d[to], to));
				d[to] = d[v] + g[v][i].second;
				p[to] = v;
				s.insert(mp(d[to], to));
			}
		}
	}
	ll tv = k - 1;
	vector <ll> ans;
	while (p[tv] != -1) {
		ans.push_back(tv);
		tv = p[tv];
	}
	ans.pb(0);
	reverse(all(ans));
	cout << ans.size() << nn;
	for (ll i = 0; i < ans.size(); i++) {
		cout << ans[i] + 1 << pp;
	}
}