#include <iostream>
#include<bits/stdc++.h>
#define ll long long

using namespace std;


int N = 300001;

vector<ll> v(N);

struct nodeMax{
    ll val,index;
    int left,right;
    nodeMax* leftChild, *rightChild;
};


nodeMax* build(int l,int r){

    nodeMax* res = new nodeMax();
    res->left = l;
    res->right = r;

    if(l == r){
        res->val = v[l];
        res->index  = l;
    }else{
        int mid = (l+r)/2;
        nodeMax* left =build(l,mid);
        nodeMax* right = build(mid+1,r);
        res->val = max(left->val,right->val);
        res->index = right->index;
        if(left->val>right->val){
            res->index = left->index;
        }
        res->leftChild = left;
        res->rightChild = right;
    }
    return res;
}

pair<ll,ll>  qu(nodeMax* root,int l,int r){
    if(root == nullptr)return {-1,-1};
    if(root->left>r||root->right<l){
        return{-1,-1};
    }

    if(root->left>=l&&root->right<=r){
        return {root->val,root->index};
    }

    auto respleft = qu(root->leftChild,l,r);
    auto respRight = qu(root->rightChild,l,r);
    if(respRight.first>=respleft.first){
        return respRight;
    }
    return respleft;
}

int maxIndex(int l,int r){
    int maxI = l;
    for(int i = l;i<r;++i){
        if(v[maxI]<=v[i]){
            maxI = i;
        }
    }
    return maxI;
}

int main()
{
   ios_base::sync_with_stdio(0);

    int n;
    cin>>n;

    for(int i = 0;i<n;++i){
        cin>>v[i];
    }

    nodeMax* rootMax = build(0,n-1);


    //cout<<qu(rootMax,1,5).first;

    int l = 0,r=0;

    int cnt = 0;


    while(r<n){
        while(r<n&&v[r]>=v[l]){
            ++r;
        }
        r = qu(rootMax,l,r).second;
        l = r+1;
        ++r;
        ++cnt;
  //      cout<<r<<" ";
    }


    cout<<cnt;

    return 0;
}
