#include <bits/stdc++.h>
#define x first
#define y second
#define pb push_back
using namespace std;
 
const int MAXN = 1 << 19;
 
struct fen {
    int a[MAXN];
    int s;
    int v[MAXN];
     
    int get_id(int i) {
        return lower_bound(v, v + s, i) - v;
    }
 
    void clear() {
        for (int i = 0; i < s; ++i) {
            a[i] = 0;
        }
    }
 
    void add(int i, int w = 1) {
        i = get_id(i);
        while (i < MAXN) {
            a[i] += w;
            i |= (i + 1);
        }
    }
 
    int get(int c) {
        int i = get_id(c) - 1;
        int ans = 0;
        while (i >= 0) {
            ans += a[i];
            i &= (i + 1);
            --i;
        }
        return ans;
    }
};
 
int n, p;
int a[MAXN];
int ans[MAXN];
fen L, R, M;
 
 
int main() {
    ios::sync_with_stdio(0);
    //assert(freopen("input.in", "r", stdin));
    scanf("%d%d", &n, &p);
    for (int i = 0; i < n; ++i) {
        scanf("%d", &a[i]);
        R.v[R.s++] = (a[i] + i);   
        L.v[L.s++] = (a[i] - i);
        M.v[M.s++] = (a[i]);
        ans[i] = 0;
    } 
    sort(L.v, L.v + L.s);
    sort(R.v, R.v + R.s);
    sort(M.v, M.v + M.s);
    int lstL = 0;
    for (int i = 0; i < n; ++i) {
        int Lc = 0, Rc = n - 1;
        if (abs(Lc - i) > abs(Rc - i)) {
            Lc = i - abs(Rc - i);
        }
        int speed = a[i] + abs(Lc - i);
        R.add(a[i] + i);
        while (lstL < Lc) {
            R.add(a[lstL] + lstL, -1);
            M.add(a[lstL]);
            ++lstL;
        }
        ans[i] += R.get(speed + lstL);
        ans[i] += M.get(speed);
    }
    M.clear();
    int lstR = n - 1;
    for (int i = n; i--;) {
        int Lc = 0, Rc = n - 1;
        if (abs(Lc - i) < abs(Rc - i)) {
            Rc = i + abs(Lc - i);
        }
        int speed = a[i] + abs(Rc - i);
        L.add(a[i] - i);
        while (lstR > Rc) {
            L.add(a[lstR] - lstR, -1);
            M.add(a[lstR]);
            --lstR;
        }
        ans[i] += M.get(speed);
        ans[i] += L.get(speed - lstR);
    }
    for (int i = 0; i < n; ++i) {
        printf("%d\n", max(ans[i], max(R.get_id(a[i] + i), L.get_id(a[i] - i))) + 1);
    }
}