#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

bool comp(string a, string b) {
	if (a.size() == b.size()) {
		int i = 0;
		while (i < a.size() && a[i] == b[i]) i++;
		if (i == a.size()) return false;
		return a[i] < b[i];
	}
	return a.size() < b.size();
}

int main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	int n;
	cin >> n;
	vector<int> a(1000000, 0);
	vector<int> a2(1000000, 0);
	int len = 0;
	vector<string> s(n);
	for (int i = 0; i < n; i++) {
		cin >> s[i];
	}
	sort(s.begin(), s.end(), comp);
	for (int k = 0; k < n; k++) {
		reverse(s[k].begin(), s[k].end());
		vector<int> flag(1000000, 0);
		//cout << s << endl;
		for (int i = 0; i < s[k].size(); i++) {
			if (s[k][i] == '1' && a[i] == 1) {
				for (int j = 0; j < i; j++) {
					if (flag[j]) a[j] = 0;
				}
				while (i < s[k].size() && s[k][i] == '1') i++;
				if (i == s[k].size()) {
					while (a[i] == 1) {
						i++;
					}
					if (!a[i]) flag[i] = 1;
					a[i] = 1;
					if (i > len) len = i;
				}
				else {
					s[k][i] = '1';
					i--;
				}
			}
			else {
				if (s[k][i] == '1' && a[i] == 0) {
					if (!a[i]) flag[i] = 1;
					a[i] = 1;
					if (i > len) len = i;
				}
			}
		}
	}
	reverse(s.begin(), s.end());
	for (int k = 0; k < n; k++) {
		reverse(s[k].begin(), s[k].end());
		vector<int> flag(1000000, 0);
		//cout << s << endl;
		for (int i = 0; i < s[k].size(); i++) {
			if (s[k][i] == '1' && a2[i] == 1) {
				for (int j = 0; j < i; j++) {
					if (flag[j]) a2[j] = 0;
				}
				while (i < s[k].size() && s[k][i] == '1') i++;
				if (i == s[k].size()) {
					while (a2[i] == 1) {
						i++;
					}
					if (!a2[i]) flag[i] = 1;
					a2[i] = 1;
					//if (i > len) len = i;
				}
				else {
					s[k][i] = '1';
					i--;
				}
			}
			else {
				if (s[k][i] == '1' && a2[i] == 0) {
					if (!a2[i]) flag[i] = 1;
					a2[i] = 1;
					//if (i > len) len = i;
				}
			}
		}
	}
	string ans1 = "", ans2 = "";
	for (int i = len; i >= 0; i--) {
		ans1 += a[i] == 0 ? '0' : '1';
		ans2 += a2[i] == 0 ? '0' : '1';
	}
	if (comp(ans1, ans2)) {
		cout << ans1;
	}
	else {
		cout << ans2;
	}
	//cout.flush();
	return 0;
}