#pragma GCC optimize "-O3"
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
using namespace std;
#define int long long
#define INF 1791791791

struct node {
	int x;
	int prior = rand() % 1791791791;
	int tc = 1;
	int cnt = 1;
	node *left = nullptr, *right = nullptr;
	node(int x) : x(x) {}
	void rcnt()
	{
		cnt = tc;
		if (left)
			cnt += left->cnt;
		if (right)
			cnt += right->cnt;
	}
};


void split(node * t, int x, node *&l, node *&r)
{
	if (!t)
		l = r = nullptr;
	else {
		if (t->x < x) {
			split(t->right, x, t->right, r);
			l = t;
		}
		else {
			split(t->left, x, l, t->left);
			r = t;
		}
	}
	if (l)
		l->rcnt();
	if (r)
		r->rcnt();
}

node* merge(node *l, node *r) {
	if (!l)
		return r;
	if (!r)
		return l;
	if (l->prior > r->prior) {
		l->right = merge(l->right, r);
		return l;
	}
	else {
		r->left = merge(l, r->left);
		return r;
	}
}

void insert(node *&t, node *x)
{
	if (!t)
		t = x;
	else if (x->prior > t->prior) {
		split(t, x->x, x->left, x->right);
		t = x;
	}
	else if (t->x > x->x) {
		insert(t->left, x);
	}
	else
		insert(t->right, x);
	t->rcnt();
}

node* find(node *t, int x) {
	if (!t)
		return nullptr;
	t->rcnt();
	if (t->x == x)
		return t;
	node *r;
	if (t->x > x)
		r = find(t->left, x);
	else
		r = find(t->right, x);
	t->rcnt();
	return r;
}

int lt(node * t, int x) {
	if (!t)
		return 0;
	if (t->x == x)
		return t->left ? t->left->cnt : 0;
	if (t->x > x)
		return lt(t->left, x);
	else
		return lt(t->right, x) + t->cnt - (t->right ? t->right->cnt : 0);
}

signed main()
{
	cin.tie();
	cout.tie();
	ios::sync_with_stdio(false);
	int n, x;
	cin >> n >> x;
	vector<int> p(n);
	for (int i = 0; i < n; ++i)
		cin >> p[i];
	node *b = nullptr;
	/*for (int i = 0; i < n; ++i) {
		node*x = find(b, p[i]);
		if (x) {
			x->tc++;
			find(b, p[i]);
		}
		else {
			insert(b, new node(p[i]));
		}
	}
	for (int i = 0; i < n; ++i) {
		int c = lt(b, p[i] + 1) - 1;
		int los = 0;
		for (int j = 1; j < min(i, n - i - 1); ++j) {
			int r = lt(b, p[i] + 1);
			if (p[i] < )
		}
	}*/
	for (int i = 0; i < n; ++i) {
		int r = 0;
		for (int j = 1; j < (1 << n); ++j) {
			vector<int> dist(n, INF);
			for (int i = 0; i < n; ++i)
				if (j & (1 << i))
					dist[i] = 0;
			for (int i = 1; i < n; ++i)
				dist[i] = min(dist[i], dist[i - 1] + 1);
			for (int i = n - 2; i >= 0; --i)
				dist[i] = min(dist[i], dist[i + 1] + 1);
			int c = 0;
			for (int j = 0; j < n; ++j)
				if (p[j] + dist[j] < p[i] + dist[i])
					++c;
			r = max(r, c);
		}
		cout << r + 1 << '\n';
	}
}