#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

struct s
{
    int used[505];
    s(int a)
    {
        if(a == 0)
        {
            memset(used, 0, sizeof(used));
        } else
        {
            for(int i = 0; i < 505; ++i)
            {
                used[i] = 1;
            }
        }
    }
};

s get(s a, int pos)
{
    a.used[pos]++;
    for(int p = pos;; ++p)
    {
        if(a.used[p] > 1)
        {
            a.used[p + 1] += a.used[p] / 2;
            a.used[p] %= 2;
        } else
        {
            break;
        }
    }

    return a;
}

bool cmp(s a, s b)
{
    for(int i = 504; i >= 0; --i)
    {
        if(a.used[i] > b.used[i])
        {
            return true;
        } else if(a.used[i] < b.used[i])
        {
            return false;
        }
    }
    return true;
}

int n, m, k;
vector<pair<int, int> > arr;
vector<vector<pair<int, ll> > > g;
vector<int> p;
vector<s> dp;
vector<char> vis;

int main()
{
    scanf("%d%d%d", &n, &m, &k);
    arr.resize(k);
    for(int i = 0; i < k; ++i)
    {
        scanf("%d%d", &arr[i].first, &arr[i].second);
    }
    g.resize(k);
    p.resize(k, -1);
    dp.resize(k, 1);
    for(int i = 0; i < 505; ++i)
    {
        dp[0].used[i] = 0;
    }
    vis.resize(k, false);
    for(;;)
    {
        s u(1);
        int num;
        for(int i = 0; i < k; ++i)
        {
            if(!vis[i] && cmp(u, dp[i]))
            {
                u = dp[i];
                num = i;
            }
        }
        if(num == k - 1)
        {
            break;
        }
        for(int i = 0; i < k; ++i)
        {
            if(vis[i])
            {
                continue;
            }
            int dist = max(abs(arr[num].first - arr[i].first), abs(arr[num].second - arr[i].second));
            s uu = get(u, dist);
            if(cmp(dp[i], uu))
            {
                //dp[i] = uu;
                for(int j = 0; j < 505; ++j)
                {
                    dp[i].used[j] = uu.used[j];
                }
                p[i] = num;
            }
        }
        vis[num] = true;
    }
    vector<int> ans;
    for(int v = k - 1; v != -1; v = p[v])
    {
        ans.push_back(v + 1);
    }
    reverse(ans.begin(), ans.end());
    printf("%d\n", ans.size());
    for(int i = 0; i < ans.size(); ++i)
    {
        printf("%d ", ans[i]);
    }

    return 0;
}
