#include <iostream>
#include <cstring>
#include <vector>
#include <cstdio>

using namespace std;

int main() {
    cin.tie(nullptr);
    cin.sync_with_stdio(false);
    cout.tie(nullptr);
    cout.sync_with_stdio(false);

    int n, m, q;
    cin >> n >> m >> q;

    int rows[n], rowp[n], cols[m], colp[m];

    for (int i = n; i --> 0;)
        rows[i] = -1;

    for (int j = m; j --> 0;)
        cols[j] = -1;

    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++) {
            int t;
            cin >> t;
            if (t > rows[i]) {
                rows[i] = t;
                rowp[i] = j;
            }
            if (t > cols[j]) {
                cols[j] = t;
                colp[j] = i;
            }
        }

    int good = 0;
    for (int i = 0; i < n; i++)
        if (rows[i] == cols[rowp[i]])
            good++;

    while (q --> 0) {
        int r, c, x;
        cin >> r >> c >> x;
        r -= 1;
        c -= 1;

        if (x > rows[r] && rows[r] == cols[rowp[r]])
            good--;
        if (x > cols[c] && cols[c] == rows[colp[c]])
            good--;
        if (rows[r] == cols[c])
            good++;

        if (x > rows[r]) {
            rows[r] = x;
            rowp[r] = c;
        }
        if (x > cols[c]) {
            cols[c] = x;
            colp[c] = r;
        }
        if (rows[r] == cols[c])
            good++;

        cout << good << endl;
    }
    return 0;
}