#include <algorithm>
#include <iostream>
#include <iterator>
#include <utility>
#include <vector>

using namespace std;

typedef long long int lint;
typedef pair<lint, lint> P;

int main() {
    cin.tie(nullptr);
    cin.sync_with_stdio(false);
    cout.tie(nullptr);
    cout.sync_with_stdio(false);

    int n;
    cin >> n;

    vector<P> p(n);

    for (int i = n; i --> 0;) {
        cin >> p[i].first >> p[i].second;
    }

    sort(p.begin(), p.end(), [] (P &a, P &b) {
        return a.first > b.first;
    });

    lint m = 0;
    for (auto i = p.begin(); i != p.end(); i++) {
        lint q = (distance(p.begin(), i) + 1) * i->first;
        m = max(m, q);

        sort(i + 1, p.end(), [] (P &a, P &b) {
            return a.second > b.second;
        });

        for (auto j = i + 1; j != p.end(); j++) {
            m = max(m, q + distance(i, j) * j->second);
            if (q + distance(i, j) * j->second == 290) {
                cout << "wtf" << endl;
            }
        }

        sort(i + 1, p.end(), [] (P &a, P &b) {
            return a.first > b.first;
        });
    }

    cout << m;

    return 0;
}