#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
#include <set>
using namespace std;

vector<vector<int> > g, ag;
vector<int> u;

bool dfs(int v){
    u[v] = 2;
    //cout << v << ' ';
    for(int i = 0; i<g[v].size(); i++){
        if(u[g[v][i]]==2){
            return false;
        }
        if(!u[g[v][i]])
            if(!dfs(g[v][i]))
                return false;
    }
    return true;
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<vector<int> > a(n, vector<int>(n)), c(n, vector<int>(n));
    for(int i = 0; i<n; i++){
        for(int j = 0; j<n; j++){
            cin >> a[i][j];
        }
    }
    int p;
    cin >> p;
    vector<int> ans;
    for(int i = 0; i<n; i++)
        if(a[i][0]==i+1)
            ans.push_back(i+1);
    if(p==1){
        cout << ans.size() << '\n';
        for(int i = 0; i<ans.size(); i++)
            cout << ans[i] << ' ';
        return 0;
    }
    g.resize(n);
    ag.resize(n);
    for(int i = 0; i<n; i++){
        for(int j = 0; j<n; j++){
            if(a[i][j]==i+1)
                break;
            g[a[i][j]-1].push_back(i);
            ag[i].push_back(a[i][j]-1);
        }
    }
    for(int i = 0; i<n; i++){
        if(g[i].size()==0&&ag[i].size())
            continue;
        u = vector<int>(n, true);
        for(int j = 0; j<ag[i].size(); j++)
            u[ag[i][j]] = false;
        if(ag[i].size()&&dfs(ag[i][0]))
            ans.push_back(i+1);
        //cout << endl;
    }
    sort(ans.begin(), ans.end());
    cout << ans.size() << '\n';
    for(int i = 0; i<ans.size(); i++)
        cout << ans[i] << ' ';

    return 0;
}
/*
2
1 2
2 1
1

2
1 2
2 1
2

2
2 1
1 2
1

2
2 1
1 2
2

2
1 2
1 2
1

2
1 2
1 2
2

4
3 2 4 1
1 4 2 3
3 1 2 4
1 4 2 3
1

4
3 2 4 1
1 4 2 3
3 1 2 4
1 4 2 3
2
*/
