#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
#include <set>
using namespace std;

vector<vector<int> > g, ag;
vector<int> u;

bool dfs(int v){
    u[v] = 2;
    if(ag[v].size()==0)
        return false;
    //cout << v << ' ';
    for(int i = 0; i<g[v].size(); i++){
        if(u[g[v][i]]==2){
            return false;
        }
        if(!u[g[v][i]])
            if(!dfs(g[v][i]))
                return false;
    }
    return true;
}

vector<int> u1;
int n;

bool dfs1(int v){
    u1[v] =- true;
    u = vector<int>(n, true);
    for(int j = 0; j<ag[v].size(); j++)
        u[ag[v][j]] = false;
    bool kek = true;
    for(int j = 0; j<ag[v].size(); j++){
        if(!u[ag[v][j]])
            kek &= dfs(ag[v][j]);
        if(!kek)
            break;
    }
    for(int i = 0; i<g[v].size(); i++)
        if(!u[g[v][i]])
            kek |= dfs(g[v][i]);
    return kek;
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    vector<vector<int> > a(n, vector<int>(n)), c(n, vector<int>(n));
    for(int i = 0; i<n; i++){
        for(int j = 0; j<n; j++){
            cin >> a[i][j];
        }
    }
    int p;
    cin >> p;
    vector<int> ans;
    if(p==1){
        for(int i = 0; i<n; i++)
            if(a[i][0]==i+1)
                ans.push_back(i+1);
        cout << ans.size() << '\n';
        for(int i = 0; i<ans.size(); i++)
            cout << ans[i] << ' ';
        return 0;
    }
    g.resize(n);
    ag.resize(n);
    for(int i = 0; i<n; i++){
        for(int j = 0; j<n; j++){
            if(a[i][j]==i+1)
                break;
            g[a[i][j]-1].push_back(i);
            ag[i].push_back(a[i][j]-1);
        }
    }
    for(int i = 0; i<n; i++){
        u1 = vector<int>(n, false);
        if(dfs1(i))
            ans.push_back(i+1);
        //cout << endl;
    }
    sort(ans.begin(), ans.end());
    cout << ans.size() << '\n';
    for(int i = 0; i<ans.size(); i++)
        cout << ans[i] << ' ';

    return 0;
}
/*
2
1 2
2 1
1

2
1 2
2 1
2

2
2 1
1 2
1

2
2 1
1 2
2

2
1 2
1 2
1

2
1 2
1 2
2

4
3 2 4 1
1 4 2 3
3 1 2 4
1 4 2 3
1

4
3 2 4 1
1 4 2 3
3 1 2 4
1 4 2 3
2
*/
