#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define F first
#define S second
#define add push_back
#define pw(x) (1ll << (x))

const ll INF = (ll)1e9 + 2018;

const int N = 5010;
const int L = 20;
int arr[N], dp[N], tmax[L][N], logs[N];

void build(int n) {
	logs[1] = 0;
	for (int i = 2; i < N; i++) {
		logs[i] = logs[i / 2] + 1;
	}
	for (int i = 1; i <= n; i++) {
		tmax[0][i] = arr[i];
	}
	for (int l = 1; l < L; l++) {
		for (int i = 1; i + pw(l) <= n + 1; i++) {
			tmax[l][i] = max(tmax[l - 1][i], tmax[l - 1][i + pw(l - 1)]);
		}
	}
}

int get(int l, int r) {
	int lg = logs[r - l + 1];
	return max(tmax[lg][l], tmax[lg][r - pw(lg) + 1]);
}

void $main() {
	int n;
	cin >> n;
	for (int i = 1; i <= n; i++) {
		cin >> arr[i];
	}
	build(n);
	dp[1] = 1;
	for (int i = 2; i <= n; i++) {
		int l = 0, r = i, m;
		while (l + 1 < r) {
			m = (l + r) / 2;
			if (get(m, i) > arr[i]) {
				l = m;
			} else {
				r = m;
			}
		}
		dp[i] = dp[i - 1] + 1;
		int mn = arr[i], dpmn = INF;
		for (int j = i - 1; j >= r; j--) {
			if (arr[j] == mn) {
				dpmn = min(dpmn, dp[j - 1]);
			}
			if (arr[j] < mn) {
				mn = arr[j];
				dpmn = dp[j - 1];
			}
		}
		dp[i] = min(dp[i], dpmn + 1);
		//cout << i << " " << r << endl;
	}
	cout << dp[n];
}

int main() {
	ios::sync_with_stdio(0);
#ifdef flaax
	freopen("input.txt", "r", stdin);
#endif
	$main();
}