#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;

#ifndef LOCAL
#define endl "\n"
#endif

template<typename t>
istream &operator>>(istream &in, vector<t> &a) {
    for (auto &x : a) {
        in >> x;
    }
    return in;
}

template<typename t1, typename t2>
ostream &operator<<(ostream &out, const pair<t1, t2> &a) {
    out << a.first << " " << a.second;
    return out;
};

template<typename t>
ostream &operator<<(ostream &out, const vector<t> &a) {
    for (auto &x : a) {
        out << x << endl;
    }
    return out;
}

ostream &operator<<(ostream &out, const vector<int> &a) {
    for (auto &x : a) {
        out << x << " ";
    }
    return out;
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    assert(n == 2);
    vector<string> a(n);
    cin >> a;
    int maxl = 0;
    for (auto &x : a) {
        reverse(x.begin(), x.end());
        maxl = max<int>(maxl, x.size());
    }
    sort(a.begin(), a.end());
    a[0].resize(maxl + 3, '0');
    a[1].resize(maxl + 3, '0');
    string ans;
    ans.reserve(n + maxl + 1);
    int ind = maxl - 1;
    while (ind >= 0 && (a[0][ind] != '1' || a[1][ind] != '1')) {
        --ind;
    }
    if (ind < 0) {
        for (int i = 0; i < maxl + 1; ++i) {
            if (a[0][i] == '1' || a[1][i] == '1') {
                ans.push_back('1');
            } else {
                ans.push_back('0');
            }
        }
        while (ans.back() == '0') {
            ans.pop_back();
        }
        reverse(ans.begin(), ans.end());
        cout << ans << endl;
        return 0;
    }
    int ind1 = ind + 1;
    while (ind >= 0) {
        a[1][ind--] = '0';
    }
    a[1][ind1] = '1';
    ind = ind1;
    while (a[0][ind] == '1' && a[1][ind] == '1') {
        a[1][ind++] = '0';
        a[1][ind] = '1';
    }
    for (int i = 0; i < maxl + 1; ++i) {
        if (a[0][i] == '1' || a[1][i] == '1') {
            ans.push_back('1');
        } else {
            ans.push_back('0');
        }
    }
    while (ans.back() == '0') {
        ans.pop_back();
    }
    reverse(ans.begin(), ans.end());
    cout << ans << endl;
    return 0;
}