#include <iostream>
#include <algorithm>

using namespace std;

const int MAXN = 150005;

int prices[2 * MAXN];
pair<int, int> arr[MAXN];
int n, ans = -1;

signed main()
{
	cin >> n;
	for (int i = 0; i < n; ++i)
	{
		int a, b;
		cin >> a >> b;
		arr[i] = { a, b };
		prices[2 * i] = a;
		prices[2 * i + 1] = b;
	}

	sort(arr, arr + 2 * n);
	reverse(arr, arr + 2 * n);

	for (int i = 0; i < 2 * n; ++i)
	{
		for (int j = i; j < 2 * n; ++j)
		{
			int res = 0;
			int cx = prices[i];
			int cy = prices[j];
			for (pair<int, int> p : arr)
			{
				if (cx <= p.first)
				{
					res += cx;
				}
				else if (cy <= p.second)
				{
					res += cy;
				}
			}
			ans = max(ans, res);
		}
	}
	
	cout << ans << "\n";

	return 0;
}