#include <iostream>
#include <vector>

using namespace std;

int n;
vector<int> arr, pos;

void go(int a, int b)
{
	vector<int> tmp;
	for (int i = 0; i < a; ++i)
	{
		tmp.push_back(arr[i]);
		pos[arr[i]] = tmp.size() - 1;
	}
	for (int i = a + 1; i <= b; i += 2)
	{
		tmp.push_back(arr[i]);
		pos[arr[i]] = tmp.size() - 1;
	}
	for (int i = a; i <= b; i += 2)
	{
		tmp.push_back(arr[i]);
		pos[arr[i]] = tmp.size() - 1;
	}
	for (int i = b + 1; i < n; ++i)
	{
		tmp.push_back(arr[i]);
		pos[arr[i]] = tmp.size() - 1;
	}
	arr = tmp;
}

bool sorted(vector<int> v)
{
	for (int i = 0; i < n - 1; ++i)
	{
		if (v[i] > v[i + 1])
		{
			return 0;
		}
	}
	return 1;
}

signed main()
{
	cin >> n;
	arr.resize(n);
	pos.resize(n + 1);
	for (int i = 0; i < n; ++i)
	{
		cin >> arr[i];
		pos[arr[i]] = i;
	}

	int l = 0;
	vector<pair<int, int> > res;
	for (int x = 1; x <= n; ++x)
	{
		int p = pos[x];
		while (p != l)
		{
			if ((p - l) % 2 == 1)
			{
				res.push_back({ l, p });
				go(l, p);
				p = pos[x];
			}
			else
			{
				res.push_back({ l + 1, p });
				go(l + 1, p);
				p = pos[x];
			}
		}
		++l;
	}

	cout << res.size() << "\n";
	for (auto p : res)
	{
		cout << p.first + 1 << " " << p.second + 1 << '\n';
	}
	return 0;
}

/*
8
2 4 1 5 3 6 7 8
*/