#pragma GCC optimize("O3")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int BIG = 1e9 + 239;
const int M = 3 * 1e5 + 239;
const int T = (1 << 20);

int len;
vector<char> ans;

bool solve(int d, vector<string> v)
{
    if (v.empty())
    {
        for (int i = 0; i < len - d; i++)
            ans.push_back('0');
        return true;
    }
    if (v[0].size() == 0) return true;
    vector<string> u = v;
    for (int i = 0; i < v.size(); i++)
        u[i].erase(u[i].begin());
    bool can = true;
    for (int i = 0; i < v.size(); i++)
        can &= (v[i][0] == '0');
    if (can)
    {
        ans.push_back('0');
        if (solve(d + 1, u)) return true;
        ans.pop_back();
    }
    int sz = 0;
    for (int i = 0; i < v.size(); i++)
        sz += (v[i][0] == '1');
    if (sz >= 2) return false;
    int id = 0;
    for (int i = 1; i < v.size(); i++)
        if (v[id] < v[i])
            id = i;
    u.clear();
    for (int i = 0; i < v.size(); i++)
    {
        if (i != id)
            u.push_back(v[i]);
        else if (sz != 0)
            u.push_back(v[i]);
    }
    for (int i = 0; i < u.size(); i++)
        u[i].erase(u[i].begin());
    ans.push_back('1');
    bool ch = solve(d + 1, u);
    if (!ch) ans.pop_back();
    return ch;
}

int n;
string s[M];

int main()
{   /*
    freopen("test.in", "r", stdin);
    freopen("test.out", "w", stdout); /**/
    ios::sync_with_stdio(0);
    cin >> n;
    for (int i = 0; i < n; i++)
        cin >> s[i];
    len = 0;
    for (int i = 0; i < n; i++)
        len = max(len, (int)s[i].size() + n);
    for (int i = 0; i < n; i++)
    {
        int k = len - (int)s[i].size();
        for (int x = 0; x < k; x++)
            s[i] = "0" + s[i];
    }
    vector<string> u;
    for (int i = 0; i < n; i++)
        u.push_back(s[i]);
    solve(0, u);
    bool wr = false;
    for (int i = 0; i < len; i++)
    {
        if (!wr && ans[i] != '0')
            wr = true;
        if (wr)
            cout << ans[i];
    }
    return 0;
}
