#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>

using namespace std;

#define LL long long

int main()
{
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	ios_base::sync_with_stdio(NULL); cin.tie(0); cout.tie(0);

	int n;
	cin >> n;

	vector< vector < int > > vosp(n, vector < int >(n));


	for (size_t i = 0; i < n; i++)
	{
		for (size_t j = 0; j < n; j++)
		{
			cin >> vosp[i][j];
			vosp[i][j]--;
		}
	}

	int p;
	cin >> p;

	if (p == 1)
	{
		int ans = 0;
		queue<int> q;

		for (size_t i = 0; i < n; i++)
		{
			if (vosp[i][0] == i)
			{
				q.push(i + 1);
				ans++;
			}
		}

		cout << ans << "\n";

		while (!q.empty())
		{
			cout << q.front() << " ";
			q.pop();
		}
	}

	return 0;
}