#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <stack>

using namespace std;

vector<int> a;

int get_ans(int l, int r)
{
	stack<int> st;
	st.push(a[l]);

	for (int i = l + 1; i < r; i++) {
		while (!st.empty() && st.top() < a[i])
			st.pop();
		if (st.empty() || a[i] < st.top())
			st.push(a[i]);
	}

	return st.size();
}

int main()
{
	ios_base::sync_with_stdio(0), cin.tie(0);

	int n;
	cin >> n;
	a.resize(n);

	for (int i = 0; i < n; i++)
		cin >> a[i];

	int imin = 0;
	int ans = 0;

	for (int i = 0; i < n; ) {
		int j = i + 1;
		while (j < n && a[j] >= a[i])
			j++;

		ans += get_ans(i, j);
		i = j;
	}

	cout << ans;
}
