#include <iostream>
#include <algorithm>
#include <vector>
#include <set>

using namespace std;

int main()
{
	int n;
	cin >> n;

	vector<int> a(n);
	for (int i = 0; i < n; i++)
		cin >> a[i];

	//set<pair<pair<int, int>, pair<int, int>>> s;
	vector<pair<int, int>> seg;

	for (int i = 0; i < n; i++) {
		if (seg.size() == 0 || a[i] < a[i - 1])
			seg.push_back({ i, i });
		else
			seg.back().second = i;
	}

	n = seg.size();

	vector<int> dp(n, n);
	dp[0] = 1;

	for (int i = 1; i < seg.size(); i++) {
		bool can = true;
		for (int j = i - 1; j >= 0 && can; j--)
			if (a[seg[j].first] <= a[seg[i].first] && a[seg[j].second] <= a[seg[i].second])
				dp[i] = min(dp[i], j == 0 ? 1 : dp[j - 1]);
			else if (a[seg[j].second] > a[seg[i].second])
				can = false;
	}

	cout << dp[n - 1];
}
