import java.util.*;
import java.io.*;

public class Main {
    static int n;

    public static void main(String args[]) throws IOException {
        InReader in = new InReader();
        OutWriter out = new OutWriter();
        n = in.nextInt();
        long pow[]=new long[30];
        pow[0]=1;
        for (int i = 1; i < 30; i++) {
            pow[i]=2*pow[i-1];

        }
        int m = in.nextInt();
        int k = in.nextInt();
        V all[]=new V[k];
        for (int i = 0; i < k; i++) {
            all[i]=new V();
            all[i].x=in.nextInt();
            all[i].y=in.nextInt();
            all[i].numb=i;

        }
        all[0].dist=0;
        for (int i = 0; i < k; i++) {
            for (int j = 0; j < k; j++) {
                if(i!=j){
                E e=new E();
                e.end=all[j];
                e.mass=pow[Math.max(Math.abs(all[i].x-all[j].x),Math.abs(all[i].y-all[j].y))];
                all[i].e.add(e);
                }
            }
        }
        TreeSet<V> a=new TreeSet<>();
        for (int i = 0; i < k; i++) {
            a.add(all[i]);
        }
        boolean used[]=new boolean[k];
        while(a.size()!=0){
            V curr=a.pollFirst();
            used[curr.numb]=true;
            for (int i = 0; i < curr.e.size(); i++) {
                V now=curr.e.get(i).end;
                long mass=curr.e.get(i).mass;
                if(!used[now.numb]){
                    a.remove(now);
                    if(now.dist>curr.dist+mass){
                        now.p=curr;
                        now.dist=curr.dist+mass;
                    }
                    a.add(now);
                }
            }

        }
        ArrayList<Integer > ans=new ArrayList<>();

        V curr=all[k-1];
        while (curr!=null){
            ans.add(curr.numb+1);
            curr=curr.p;
        }
        out.println(ans.size());
        for (int i = ans.size()-1; i >=0; i--) {
            out.print(ans.get(i)+" ");
        }        out.close();
    }
    static  class V implements Comparable<V>{
        int x;
        int y;
        int numb;
        V p;
        long dist=Integer.MAX_VALUE;
        ArrayList<E> e=new ArrayList<>();

        @Override
        public int compareTo(V o) {
            if(dist!=o.dist){
                return (int)(dist-o.dist);
            }else {
                return numb-o.numb;
            }
        }
    }
    static class E{
        V end;
        long mass;
    }


    static class Human {
        int a;
        int b;


    }

    static class InReader {
        BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
        StringTokenizer tokenizer = new StringTokenizer("");

        void update() throws IOException {
            if (!tokenizer.hasMoreTokens()) {
                String a = in.readLine();
                if (a != null) {
                    tokenizer = new StringTokenizer(a);
                }
            }
        }

        int nextInt() throws IOException {
            update();
            return Integer.parseInt(tokenizer.nextToken());
        }
    }

    static class OutWriter {
        PrintWriter out = new PrintWriter(System.out);
        StringBuilder cout = new StringBuilder();

        <T> void print(T a) {
            cout.append(a);
        }

        <T> void println(T a) {
            cout.append(a);
            cout.append('\n');
        }

        void close() {
            out.print(cout.toString());
            out.close();
        }
    }

}

