#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>

using namespace std;

int main() {
    int n, m, q;
    cin >> n >> m >> q;
    vector<vector<int> > a(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }
    int maxRow[n];
    int maxCall[m];
    int indexMaxRow[n];
    int indexMaxCall[m];
    for (int i = 0; i < n; ++i) {
        int ans = 0;
        for (int j = 0; j < m; ++j) {
            if (ans < a[i][j]) {
                indexMaxRow[i] = j;
                ans = a[i][j];
            }
        }
        maxRow[i] = ans;
    }
    for (int i = 0; i < m; ++i) {
        int ans = 0;
        for (int j = 0; j < n; ++j) {
            if (ans < a[j][i]) {
                indexMaxCall[i] = j;
                ans = a[j][i];
            }
            ans = max(ans, a[j][i]);
        }
        maxCall[i] = ans;
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (maxRow[i] == maxCall[j])
                ans++;
        }
    }
    //cerr << ans << endl;
    for (int request = 0; request < q; ++request) {
        int r, c, x;
        cin >> r >> c >> x;
        --r, --c;

        if (a[r][c] == maxRow[r]) {
            if (a[r][c] == maxCall[c]) {
                //cerr << "!1" << endl;
                cout << ans << endl;
                a[r][c] = x;
                maxRow[r] = x;
                maxCall[c] = x;
                continue;
            }
        }

        a[r][c] = x;
        //cerr << maxCall[c] << endl;
        //cerr << maxRow[r] << endl;
        if (x >= maxCall[c]) {
            //cerr << "!2" << endl;
            if (maxCall[c] == maxRow[indexMaxCall[c]]) {
                //cerr << "!2.0" << endl;
                ans--;
            }
            maxCall[c] = x;
            indexMaxCall[c] = r;
        }
        if (x >= maxRow[r]) {
            //cerr << "!3" << endl;
            if (maxRow[r] == maxCall[indexMaxRow[r]]) {
                //cerr << "!3.0" << endl;
                ans--;
            }
            maxRow[r] = x;
            indexMaxRow[r] = c;
        }
        if (maxRow[r] == maxCall[c]) {
            //cerr << "!4" << endl;
            ans++;
        }
        cout << ans << endl;


        /*
            else {
                if (x > maxCall[c]) {
                    if (maxCall[c] == maxRow[indexMaxCall[c]]) {
                        ans--;
                    }
                    ans++;
                    cout << ans << endl;
                    a[r][c] = x;
                    maxCall[c] = x;
                    indexMaxCall[c] = r;
                    continue;
                }
                else {
                    cout << ans << endl;
                    a[r][c] = x;
                    continue;
                }
                maxRow[r] = x;
            }
        }
        else {
            if (a[r][c] == maxCall[c]) {
                if (x > maxRow[r]) {
                    if (maxRow[r] == maxCall[indexMaxRow[r]]) {
                        ans--;
                    }
                    ans++;
                    cout << ans << endl;
                    a[r][c] = x;
                    maxRow[r] = x;
                    maxCall[c] = x;
                    indexMaxRow[r] = c;
                    continue;
                }
                else {
                    cout << ans << endl;
                    a[r][c] = x;
                    maxCall[c] = x;
                    continue;
                }
            }
            else {
                if (x < maxCall[c] && x < maxCall[r]) {
                    cout << ans;
                    a[r][c] = x;
                    continue;
                }
                if (x > maxCall[c] && x > maxCall[r]) {
                    if (maxRow[r] == maxCall[indexMaxRow[r]]) {
                        ans--;
                    }
                    if (maxCall[c] == maxRow[indexMaxCall[c]]) {
                        ans--;
                    }
                    ans++;
                    cout << ans << endl;
                    maxCall[c] = x;
                    maxRow[r] = x;
                    indexMaxRow[r] = c;
                    indexMaxCall[c] = r;
                    a[r][c] = x;
                    continue;
                }
                if (x > maxCall[c]) {
                    if (maxCall[c] == maxRow[indexMaxCall[c]]) {
                        ans--;
                    }
                    cout << ans << endl;
                    maxCall[c] = x;
                    indexMaxCall[c] = r;
                    a[r][c] = x;
                    continue;
                }
                else {
                    if (maxRow[r] == maxCall[indexMaxRow[r]]) {
                        ans--;
                    }
                    cout << ans << endl;
                    maxRow[r] = x;
                    indexMaxRow[r] = c;
                    a[r][c] = x;
                    continue;
                }
            }
        }*/
    }
}
