#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>

using namespace std;

int d[2 * 300000];

int get (int v, int L ,int R, int l, int r, vector<int> &a) {
    if (r < l) {
        return -1;
    }
    if (L == l && R == r) {
        return d[v];
    }
    int M = (R + L) / 2;
    int x = get(2 * v, L, M, l, min(M, r), a);
    int y = get(2 * v + 1, M + 1, R, max(l, M + 1), r, a);
    if (x == -1) {
        return y;
    }
    if (y == -1) {
        return x;
    }
    if (a[x] >= a[y]) {
        return x;
    }
    else {
        return y;
    }
}

int p1(int n, vector<int> a) {
    int g = 0;
    vector<int> r(n);
    for (int i = 0; i < n; ++i) {
        if (a[i] < a[g]) {
            for (int j = g; j < i; ++j) {
                r[j] = i - 1;
            }
            g = i;
        }
    }
    for (int i = g; i < n; ++i) {
        r[i] = n - 1;
    }
    int siz = 1;

    while (siz < n) {
        siz *= 2;
    }
    for (int i = n; i < siz; ++i) {
        a.push_back(0);
    }
    for (int i = siz; i < 2 * siz; ++i) {
        d[i] = i - siz;
    }

    for (int i = siz - 1; i >= 1; --i) {
        if (a[d[2 * i]] >= a[d[2 * i + 1]]) {
            d[i] = d[2 * i];
        }
        else {
            d[i] = d[2 * i + 1];
        }
    }
    /*
    for (int i = 1; i < 2 * siz; ++i) {
        cerr << d[i] << " ";
    }
    cerr << endl;

    for (int i = 0; i < n; ++i) {
        cerr << r[i] << " ";
    }
    cerr << endl;

    cerr << "!!!" << get(1, 0, siz - 1, 3, 6, a) << endl;
    */
    int ans = 0;
    for (int i = 0; i < n;) {
        ans++;
        i = get(1, 0, siz - 1, i, r[i], a) + 1;
        while (i + 1 < n && a[i + 1] == a[i]) i++;
        //cerr << i << endl;
        //int x;
        //cin >> x;
    }
    return ans;
}

int p2(int n, vector<int> a) {
    int ans = 0;
    for (int i = 0; i < n;) {
        //cerr << i << endl;
        int m = a[i];
        int index = i + 1;
        int j = i + 1;
        while (j < n && a[j] >= a[i]) {
            //cerr << j << endl;
            if (a[j] >= m) {
                m = a[j];
                index = j + 1;
            }
            j++;
        }
        //cerr << index << endl;
        //cerr << endl << endl;
        ans++;
        i = index;
    }
    return ans;
}

int main() {

    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    cout << p1(n, a) << endl;
    /*
    vector<int> a(7);
    a[0] = 3;
    a[1] = 1;
    a[2] = 10;
    a[3] = 8;
    a[4] = 4;
    a[5] = 8;
    a[6] = 3;
    cout << p1(7, a);*/
}
