#include<bits/stdc++.h>
#define int long long
#define all(a) a.begin(), a.end()
#define rev(a) reverse(all(a))
#define pii pair<int, int>
#define F first
#define S second
#define vii vector<pii>
#define pb push_back
using namespace std;

bool comp(pii a, pii b)
{
    return a.S < b.S;
}

struct vrtx
{
    int l, r, val;
    vrtx()
    {
        l = r = -1;
        val = 0;
    }
};

int sz = 1;
const int S = 1e7;
vrtx seg[S];

void add(int now, int l, int r, int x)
{
    if(l == r)
    {
        seg[now].val++;
        return;
    }
    if(seg[now].l == -1)
    {
        seg[now].l = sz++;
    }
    if(seg[now].r == -1)
    {
        seg[now].r = sz++;
    }
    int mid = (l + r) / 2;
    if(mid > x)
    {
        add(seg[now].l, l, mid, x);
    }
    else
    {
        add(seg[now].r, mid + 1, r, x);
    }
    seg[now].val = (seg[seg[now].l].val + seg[seg[now].r].val);
}

int answ(int now, int l, int r, int b, int e)
{
    if(l == b && r == e)
    {
        return seg[now].val;
    }
    if(b > e)
    {
        return 0;
    }
    if(seg[now].l == -1)
    {
        seg[now].l = sz++;
    }
    if(seg[now].r == -1)
    {
        seg[now].r = sz++;
    }
    int mid = (l + r) / 2;
    return (answ(seg[now].l, l, mid, b, min(mid, e)) + answ(seg[now].r, mid + 1, r, max(mid + 1, b), e));
}

void solve()
{
    int n;
    cin >> n;
    vii a(n), b(n);
    for(int i = 0; i < n; i++)
    {
        cin >> a[i].F >> a[i].S;
        b[i] = a[i];
    }
    sort(all(a));
    sort(all(b), comp);
    int uk = n - 1;
    int ans = 0;
    for(int i = n - 1; i >= 0; i--)
    {
        int am = 0;
        add(0, 0, 1e9, a[i].S);
        for(int j = n - 1; j >= 0; j--)
        {
            ans = max((n - i) * a[i].F + (n - j - answ(0, 0, 1e9, b[j].S, 1e9)) * b[j].S, ans);
        }
    }
    cout << ans;
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    while(t--)
    {
        solve();
    }
    return 0;
}
/*
5
80 20
60 50
40 40
15 10
70 30
*/
