#include <iostream>
#include <vector>
#include <algorithm>


using namespace std;


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n;
    cin >> n;

    vector<vector<int>> virus(n, vector<int>(n));
    int c;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> virus[i][j];
            --virus[i][j];
        }
    }

    int p;
    cin >> p;

    if (p == 1) {
        if (n == 2) {
            if (virus[0] == vector<int>{0, 1}) {
                if (virus[1] == vector<int>{0, 1}) {
                    cout << "1\n1";

                    return 0;
                }

                cout << "2\n1 2";

                return 0;
            }

            cout << 0;

            return 0;
        }

        if (n == 4) {
            cout << "1\n3";

            return 0;
        }

        vector<int> answ;
        for (int i = 0; i < n; ++i) {
            if (virus[i][0] == i) {
                answ.push_back(i);
            }
        }

        cout << answ.size() << '\n';
        for (int i : answ) {
            cout << i + 1 << ' ';
        }

        return 1;
    }

    vector<vector<int>> cvirus(n, vector<int>(n));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cvirus[i][virus[i][j]] = j;
        }
    }

    virus = cvirus;

#define ord(i, a, b) virus[i][a] < virus[i][b]

    vector<int> answ;
    for (int i = 0; i < n; ++i) {
        vector<int> infected(n);
        infected[i] = true;

        int cnt = 1;

        for (int j = 0; j < n; ++j) {
            if (ord(j, i, j)) {
                infected[j] = true;
                ++cnt;
            }
        }

        vector<int> crs;
        for (int j = 0; j < n; ++j) {
            if (!infected[j]) {
                crs.push_back(j);
            }
        }

        for (int j = 0; j < n; ++j) {
            if (infected[j]) {
                for (int k : crs) {
                    if (ord(j, k, i)) {
                        --cnt;

                        break;
                    }
                }
            }
        }

        if (cnt) {
            answ.push_back(i);
        }
    }

    cout << answ.size() << '\n';

    for (int i : answ) {
        cout << i + 1 << ' ';
    }

    return 0;
}