#include <iostream>
#include <vector>
#include <algorithm>
#include <set>


using namespace std;


#define int long long


struct C {
    int a, b;

    C() {};
    C(int _a, int _b) : a(_a), b(_b) {};

    bool operator<(const C &c) const {
        return a < c.a;
    }
};


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n;
    cin >> n;

    vector<C> cs(n);
    for (int i = 0; i < n; ++i) {
        cin >> cs[i].a >> cs[i].b;
    }

    sort(cs.rbegin(), cs.rend());

    multiset<int> bs;
    
    for (int i = 0; i < n; ++i) {
        bs.insert(cs[i].b);
    }

    int answ = 0;
    int i = 0;
    for (int it : bs) {
        answ = max(answ, it * (n - i));
        ++i;
    }

    for (int i = 0; i < n; ++i) {
        if (i != n - 1 && cs[i].a == cs[i + 1].a) {
            bs.erase(cs[i].b);
            continue;
        }
        
        int plus = cs[i].a * (i + 1);
        bs.erase(cs[i].b);

        answ = max(answ, plus);

        int j = 0;
        for (int it : bs) {
            answ = max(answ, plus + it * ((int)bs.size() - j));
            ++j;
        }
    }

    cout << answ;

    return 0;
}