#include <iostream>
#include <vector>
#include <algorithm>


using namespace std;


int n;
vector<int> arr;
vector<pair<int, int>> ops;


void op(int a, int b) {
    vector<int> nar;
    nar.reserve(b - a);

    for (int i = a + 1; i < b; i += 2) {
        nar.push_back(arr[i]);
    }

    for (int i = a; i < b; i += 2) {
        nar.push_back(arr[i]);
    }

    for (int i = a; i < b; ++i) {
        arr[i] = nar[i - a];
    }

    ops.emplace_back(a + 1, b);
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> n;

    arr.resize(n);

    for (int i = 0; i < n; ++i) {
        cin >> arr[i];
        --arr[i];
    }

    int lb = 0, ub = n - 1;

    while (lb < ub) {
        for (; lb < ub && arr[lb] == lb; ++lb);
        for (; lb < ub && arr[ub] == ub; --ub);

        if (lb >= ub) {
            break;
        }

        int lind, uind;
        for (int i = lb; i <= ub; ++i) {
            if (arr[i] == lb) {
                lind = i;
            } else if (arr[i] == ub) {
                uind = i;
            }
        }

        if (uind < lind && lind - uind % 2) {
            op(lb + (uind - lb) % 2, ub + 1);
        } else {
            op(lb + (lind - lb - 1) % 2, lind + 1);
        }
    }

    cout << ops.size() << '\n';
    for (auto &i : ops) {
        cout << i.first << ' ' << i.second << '\n';
    }

    return 0;
}