#include <iostream>
#include <vector>
#include <algorithm>


using namespace std;


int n;
vector<pair<int, int>> np;


int get(int i) {
    sort(np.begin(), np.end());

    int last = -1, place = 1;
    for (int j = 0; j < n; ++j) {
        if (np[j].first != last) {
            place = j;
            last = np[j].first;
        }

        if (np[j].second == i) {
            return place + 1;
        }
    }
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int p;
    cin >> n >> p;

    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first;
        a[i].second = i;
    }

    for (int i = 0; i < n; ++i) {
        int answ = 0;

        np = a;

        int d = min(i, n - i - 1);

        np[i].first += d;

        for (int j = 1; j < d; ++j) {
            np[i - j].first += d - j;
            np[i + j].first += d - j;
        }

        answ = get(i);

        np = a;

        for (int j = 0; j < n; ++j) {
            np[j].first += j;
        }

        answ = max(answ, get(i));

        np = a;

        for (int j = 0; j < n; ++j) {
            np[n - j - 1].first += j;
        }

        cout << max(answ, get(i)) << '\n';
    }

    return 0;
}