//#pragma GCC optimize "Ofast"

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

ll n;
vector<ll> a;

vector<pair<ll, ll>> ops;

void bubble(ll l, ll r) {
    if (l == r - 1)
        return;
    if (l == r - 2) {
        ops.emplace_back(r - 2, r - 1);
        swap(a[r - 2], a[r - 1]);
        return;
    }
    if (l & 1) {
        ops.emplace_back(l, r - 1);
        vector<ll> olda = a;
        ll j = l;
        for (ll i = l + 1; i < r; i += 2) {
            a[j] = olda[i];
            j++;
        }
        for (ll i = l; i < r; i += 2) {
            a[j] = olda[i];
            j++;
        }
        ll newl = l + (r - l) / 2;
        bubble(newl, r);
    } else {
        ll z = r / 2 + l / 2;
        ops.emplace_back(0, r - 1);
        vector<ll> olda = a;
        ll j = 0;
        for (ll i = 1; i < r; i += 2) {
            a[j] = olda[i];
            j++;
        }
        for (ll i = 0; i < r; i += 2) {
            a[j] = olda[i];
            j++;
        }
        bubble(z, r);
    }
}

int main() {
    cin >> n;
    a.resize(n);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }

    for (ll i = n; i > 0; --i) {
        for (ll j = 0; j < n; ++j) {
            if (a[j] == i) {
                bubble(j, i);
            }
        }
    }

    cout << ops.size() << endl;
    for (auto p : ops) {
        cout << p.first + 1 << " " << p.second + 1 << endl;
    }
    return 0;
}