#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

int main()
{
#ifdef POSPELOV
    freopen("in.txt", "r", stdin);
#endif // POSPELOV
    ios_base::sync_with_stdio(0);
    int n, m, q;
    cin >> n >> m >> q;
    vector <vector <int>> arr(n, vector <int> (m));
    vector <set <pair <int, int>>> x(n);
    vector <set <pair <int, int>>> y(m);
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            cin >> arr[i][j];
            x[i].insert({arr[i][j], j});
            y[j].insert({arr[i][j], i});
        }
    }
    int cur = 0;
    for (int i = 0; i < n; i++)
        for (int j = 0; j < n; j++)
            if (x[i].rbegin()->second == j && y[j].rbegin()->second == i)
                cur++;
    auto check = [&](int a, int b)
    {
        return x[a].rbegin()->second == b && y[b].rbegin()->second == a;
    };
    while (q--)
    {
        int a, b, c;
        cin >> a >> b >> c;
        a--, b--;
        auto d1 = *x[a].rbegin();
        auto d2 = *y[b].rbegin();
        if (check(a, x[a].rbegin()->second) && x[a].rbegin()->second != b && x[a].rbegin()->first < c)
            cur--;
        if (check(y[b].rbegin()->second, b) && y[b].rbegin()->second != a && y[b].rbegin()->first < c)
            cur--;
        if (!(x[a].rbegin()->second == b && y[b].rbegin()->second == a) && x[a].rbegin()->first < c && y[b].rbegin()->first < c)
            cur++;
        x[a].erase({arr[a][b], b});
        y[b].erase({arr[a][b], a});
        arr[a][b] = c;
        x[a].insert({arr[a][b], b});
        y[b].insert({arr[a][b], a});
        cout << cur << "\n";
    }

    return 0;
}
