#include <bits/stdc++.h>

using namespace std;

#define f first
#define s second
#define mp make_pair
#define pb push_back
#define all(a) a.begin(), a.end()
#define REP(i, st, n) for (int i = (st); i < (n); ++i)

typedef long long ll;

template <typename T1, typename T2> inline void chkmin(T1 &x, T2 y) { if (y < x) x = y; };
template <typename T1, typename T2> inline void chkmax(T1 &x, T2 y) { if (y > x) x = y; };

const int N = 150005;
int n;
ll a[N], b[N];

ll calc(ll A, ll B) {
    ll cost = 0;
    for (int i = 0; i < n; ++i) {
        if (A <= a[i])
            cost += A;
        else if (B <= b[i])
            cost += B;
    }
    return cost;
}

bool check(ll A, ll B) {
    return calc(A, B + 1) - calc(A, B) >= 0;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
#ifdef DEBUG
    freopen("C.in", "r", stdin);
#endif // DEBUG

    cin >> n;
    set <ll> x;
    for (int i = 0; i < n; ++i) {
        cin >> a[i] >> b[i];
        x.insert(a[i]);
        x.insert(a[i] + 1);
        x.insert(b[i]);
        x.insert(b[i] + 1);
    }

    ll ans = 0;
    for (ll A : x) {
        for (ll B : x) {
            chkmax(ans, calc(A, B));
        }
        /*ll bl = -1, br = A;
        while (br - bl > 1) {
            ll B = (bl + br) >> 1;
            if (check(A, B))
                bl = B;
            else
                br = B;
        }
        if (A == 70) {
            cout << bl + 1 << "KEKEKEKE\n";
        }
        chkmax(ans, calc(A, bl + 1));*/
    }
    cout << ans << '\n';
    //cout << calc(70, 40) << endl;

    return 0;
}
