import java.awt.image.ImagingOpException;
import java.io.*;
import java.util.Locale;
import java.util.StringTokenizer;

public class Main {
    public void solve() throws IOException {
        int n = nextInt();
        int m = nextInt();
        int q = nextInt();
        int res = 0;
        int[][] a = new int[n][m];
        int[] r = new int[n];
        int[] l = new int[m];
        int[] r2 = new int[n];
        int[] l2 = new int[m];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                a[i][j] = nextInt();
                if (r[i] < a[i][j]) {
                    r[i] = Math.max(r[i], a[i][j]);
                    r2[i] = j;
                }
                if (l[j] < a[i][j]) {
                    l[j] = Math.max(l[j], a[i][j]);
                    l2[j] = i;
                }
            }
        }
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (a[i][j] == Math.max(l[j], r[i])) {
                    res++;
                }
            }
        }
        for (int i = 0; i < q; i++) {
            int r1 = nextInt() - 1;
            int l1 = nextInt() - 1;
            if (a[r1][l1] != Math.max(l[l1], r[r1])) {
                a[r1][l1] = nextInt();
                int c = r2[r1];
                if (c != l1 && a[r1][c] == Math.max(r[r1], l[c]) && a[r1][l1] > r[r1]) res--;
                c = l2[l1];
                if (c != r1 && a[c][l1] == Math.max(r[c], l[l1]) && a[r1][l1] > l[l1]) res--;
                if (a[r1][l1] > r[r1]) {
                    r[r1] = Math.max(r[r1], a[r1][l1]);
                    r2[r1] = l1;
                }
                if (a[r1][l1] > l[l1]) {
                    l[l1] = Math.max(l[l1], a[r1][l1]);
                    l2[l1] = r1;
                }
            } else {
                a[r1][l1] = nextInt();
                r[r1] = a[r1][l1];
                l[l1] = a[r1][l1];
            }
            if (a[r1][l1] == Math.max(l[l1], r[r1])) res++;
            out.println(res);
        }
    }

    BufferedReader br;
    StringTokenizer sc;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                sc = null;
            }
        }
        return sc.nextToken();
    }

    public Integer nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public Long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

    public void run() throws IOException {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }
}
