import java.awt.image.ImagingOpException;
import java.io.*;
import java.util.ArrayList;
import java.util.Locale;
import java.util.StringTokenizer;

public class Main {
    ArrayList<ArrayList<Integer>> q;
    boolean[] used;
    void dfs(int v){
        if (!used[v]){
            used[v] = true;
            for (int i = 0; i < q.get(v).size(); i++) {
                dfs(q.get(v).get(i));
            }
        }
    }
    public void solve() throws IOException {
        int n = nextInt();
        int[][] a = new int[n][n];
        ArrayList<Integer> res1 = new ArrayList<>();
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                a[i][j] = nextInt() - 1;
            }
            if (a[i][0] == i) {
                res1.add(i + 1);
            }
        }
        if (nextInt() == 1) {
            out.println(res1.size());
            for (int i = 0; i < res1.size(); i++) {
                out.print(res1.get(i) + " ");
            }
            return;
        }
        q = new ArrayList<>();
        res1 = new ArrayList<>();
        for (int i = 0; i < n; i++) {
            q.add(new ArrayList<>());
        }
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if (a[i][j] == i)break;
                q.get(a[i][j]).add(i);
            }
        }
        for (int i = 0; i < n; i++) {
            used = new boolean[n];
            for (int j = n - 1; j >= 0; j--) {
                dfs(a[i][j]);
                if (a[i][j] == i)break;
            }
            boolean[] d = new boolean[n];
            for (int j = 0; j < n; j++) {
                d[j] = used[j];
            }
            used = new boolean[n];
            for (int j = 0; j < n; j++) {
                if (a[i][j] == i)break;
                if (!d[a[i][j]])dfs(a[i][j]);
            }
            boolean z = false;
            for (int j = 0; j < n; j++) {
                if (!used[j] && d[j]){
                    z = true;
                }
            }
            if (z){
                res1.add(i + 1);
            }
        }
        out.println(res1.size());
        for (int i = 0; i < res1.size(); i++) {
            out.print(res1.get(i) + " ");
        }
    }

    BufferedReader br;
    StringTokenizer sc;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                sc = null;
            }
        }
        return sc.nextToken();
    }

    public Integer nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public Long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

    public void run() throws IOException {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }
}