import com.sun.org.apache.bcel.internal.generic.IF_ACMPEQ;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.lang.reflect.Array;
import java.util.Arrays;
import java.util.Locale;
import java.util.StringTokenizer;

public class Main {

    public void solve() throws IOException {
        int n = nextInt();
        int[] max = new int[1010];
        Arrays.fill(max, 1);
        String[] s = new String[n];
        int[][] a = new int[n][1010];
        int[] x = new int[1010];
        for (int i = 0; i < n; i++) {
            s[i] = nextToken();
            for (int j = 0; j < s[i].length(); j++) {
                if (s[i].charAt(j) == '1') {
                    x[s[i].length() - j - 1]++;
                    a[s[i].length() - j - 1][i] = 1;
                }
            }
        }
        for (int i = 0; i < (1 << n); i++) {
            boolean t = true;
            for (int j = 0; j < 1010; j++) {
                if (x[j] > 1) {
                    int z = 0;
                    for (int k = 0; k < n; k++) {
                        if (a[j][k] == 1 && ((i >> k) & 1) == 0) {
                            z++;
                        }
                    }
                    if (z > 1) {
                        t = false;
                        break;
                    }
                }
            }
            if (t) {
                int[] b = new int[1010];
                for (int j = 0; j < 1010; j++) {
                    if (x[j] >= 1) {
                        int z = 0;
                        for (int k = 0; k < n; k++) {
                            if (a[j][k] == 1 && ((i >> k) & 1) == 0) {
                                z++;
                            }
                        }
                        if (z >= 1) {
                            b[j] = 1;
                        }
                    }
                }
                for (int j = 0; j < n; j++) {
                    if (((i >> j) & 1) == 1) {
                        int p = 1009;
                        for (int k = 1009; k >= 0; k--) {
                            if (a[k][j] == 1 && b[k] == 1) break;
                            if (a[k][j] == 0 && b[k] == 0) p = k;
                        }
                        b[p] = 1;
                    }
                }
                boolean r = false;
                for (int j = 1009; j >= 0; j--) {
                    if (b[j] == 0 && max[j] == 1) {
                        r = true;
                        break;
                    }
                    if (b[j] == 1 && max[j] == 0) break;
                }
                if (r) {
                    for (int j = 1009; j >= 0; j--) {
                        max[j] = b[j];
                    }
                }
            }
        }
        boolean r = false;
        for (int i = 1009; i >= 0; i--) {
            if (max[i] == 1) {
                out.print(1);
                r = true;
            } else {
                if (r)out.print(0);
            }
        }
    }

    BufferedReader br;
    StringTokenizer sc;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                sc = null;
            }
        }
        return sc.nextToken();
    }

    public Integer nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

    public void run() throws IOException {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }
}