#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <stdio.h>
#include <map>


using namespace std;

template<class T>
void print(vector<T> s){
    for (int i = 0; i < s.size(); i++)
        cout << s[i];
    cout << endl;
}

int main()
{
    #ifdef ONPC
        freopen("test.in", "r", stdin);
    #endif // ONPC
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    string s1, s2;
    cin >> s1 >> s2;
    if (s1.size() < s2.size())
        swap(s1, s2);
    if (s1.size() == s2.size()){
        cout << 1 << min(s1, s2) << endl;
        return 0;
    }
    reverse(s1.begin(), s1.end());
    reverse(s2.begin(), s2.end());
    int cur = -1;
    for (int i = 0; i < s2.size(); i++){
        if (s1[i] == s2[i] && s1[i] == '1')
            cur = i;
    }
    if (cur == -1){
        vector<char> answer(s1.size(), 0);
        for (int i = 0; i < s1.size(); i++)
            answer[i] = s1[i];
        for (int i = 0; i < s2.size(); i++)
            if (s2[i] == '1')
                answer[i] = '1';
        reverse(answer.begin(), answer.end());
        print(answer);
    }
    return 0;
}
