#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>

using namespace std;

typedef long long LL;

const int N = (int)2e5 + 7;

int n, b[N];
pair <int, int> a[N];

void read() {
	cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> a[i].first >> b[i];
		a[i].second = i;
	}
}

bool check_eq() {
	for (int i = 0; i < n; i++)
		if (b[i] != a[i].first)
			return false;
	return true;
}

LL get_max(const vector <int> &v) {
	LL res = 0;
	int sz = v.size();
	for (int i = 0; i < sz; i++) {
		res = max(res, 1LL * v[i] * (sz - i));
	}
	return res;
}

void solve() {
	LL ans = 0;
	sort(a, a + n);
	for (int i = 0; i < n; i++) {
		LL res = 1LL * a[i].first * (n - i);
		vector <int> v;
		for (int j = 0; j < i; j++)
			v.push_back(b[a[j].second]);
		sort(v.begin(), v.end());
		res += get_max(v);
		ans = max(ans, res);
	}
	cout << ans;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	read();
	solve();
}