#define _CRT_SECURE_NO_DEPRECATE

#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <string>
#include <cstring>
#include <algorithm>
#include <cstdlib>
#include <bitset>

using namespace std;
void solve();

typedef long long ll;
typedef pair<int, int> pii;

#define X first
#define Y second
#define mp make_pair

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
	return 0;
}
const int maxn = 100000;
int n;
pii p[maxn];
vector<int> v;
bool cmp(pii a, pii b) {
	if (a.X == b.X)return a.Y < b.Y;
	return a.X > b.X;
}

int u = 0;
vector<int> vals;
void add(int x) {
	vals.push_back(x);
	while (u + 1 < vals.size() && 1ll * vals[u] * (vals.size() - u) < 1ll * vals[u + 1] * (vals.size() - u - 1ll))++u;
}
ll ask(int val = -1) {
	if (val == -1) {
		return (0ll + vals.size() - u) * vals[u];
	}
	return 0;
}

void solve() {
	cin >> n;
	for (int i = 0; i < n; ++i)
		cin >> p[i].X >> p[i].Y;
	sort(p, p + n, cmp);
	if (n > 3000) {
		bool alb0 = true;
		for (int i = 0; i < n; ++i)
			alb0 &= p[i].Y == 0;

		ll ans = 0;
		if (alb0) {
			for (int i = 0; i < n; ++i) {
				ll cur = (1ll + i) * p[i].X;
				ans = max(ans, cur);
			}
		}
		else {
			for (int i = n - 1; i >= 0; --i) {
				ll cur = (1ll + i) * p[i].X;
				ans = max(ans, cur);
				if (i + 1 < n) {
					add(p[i].Y);
					ans = max(ans, cur + ask());
				}

			}
		}
		cout << ans << endl;
		return;
	}
	ll ans = 0;
	for (int i = 0; i < n; ++i) {
		ll cur = (1ll + i) * p[i].X;
		ans = max(ans, cur);
		v.clear();
		for (int j = i + 1; j < n; ++j) {
			v.push_back(p[j].Y);
		}
		sort(v.begin(), v.end());
		reverse(v.begin(), v.end());
		for (int j = 0; j < v.size(); ++j)
			if (v[j] <= p[i].X)ans = max(ans, cur + (1ll + j) * v[j]);
	}
	cout << ans << endl;
}