#define _CRT_SECURE_NO_DEPRECATE

#include <iostream>
#include <set>
#include <map>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;

void solve();

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
	return 0;
}

const int maxn = 3000;
int n;
int a[maxn];
vector<int> ansL;
vector<int> ansR;

void solve() {
	cin >> n;
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	while (true) {
		bool ok = true;
		for(int i = 1; i < n; ++i)
			if (a[i - 1] > a[i]) {
				ok = false;
				swap(a[i], a[i - 1]);
				ansL.push_back(i);
				ansR.push_back(i + 1);
			}
		if (ok)break;
	}
	cout << ansL.size() << endl;
	for (int i = 0; i < ansL.size(); ++i)
		cout << ansL[i] << ' ' << ansR[i] << endl;
}
