#include <bits/stdc++.h>
#define int long long

using namespace std;

const int INF = (int)(1e12);



const int maxLog = (int)(20);

int to_int(string & s) {
    int x = 0;
    for (int i = 0; i < s.size(); ++i) {
        x *= 2;
        x += s[i] - '0';
    }
    return x;
}

string to_s(int x) {
    if (x == 0) return "0";
    string s;
    while (x > 0) {
        s += (x % 2 + '0');
        x /= 2;
    }
    return s;
}

inline bool ok(int a, int b) {
    string s1 = to_s(a), s2 = to_s(b);
    for (int i = 0; i < min(s1.size(), s2.size()); ++i) {
        if (s1[i] == '1' && s2[i] == '1') return false;
    }
    return true;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n;
    cin >> n;
    string s1, s2;
    cin >> s1 >> s2;

    int best_price = INF, best_a = -1, best_b = -1;

    int a = to_int(s1), b = to_int(s2);
    for (int dx = 0; dx < 4000; ++dx) {
        for (int dy = 0; dy < 4000; ++dy) {
            if (ok(a + dx, b + dy) && (dx + dy) < best_price) {
                best_price = dx + dy;
                best_a = a + dx;
                best_b = b + dy;
            }
        }
    }

    string r1 = to_s(best_a), r2 = to_s(best_b);
    while (r1.size() < r2.size()) r1 += '0';
    while (r2.size() < r1.size()) r2 += '0';
    reverse(r1.begin(), r1.end());
    reverse(r2.begin(), r2.end());
    for (int i= 0; i < r1.size(); ++i) {
        if (r1[i] == r2[i]) {
            cout << 0;
        } else {
            cout << 1;
        }
    }
    cout << "\n";

}