#include <bits/stdc++.h>
#define ll long long

using namespace std;

const int INF = 1e9 + 7;
const int MAXN = 1e6 + 7;
const double EPS = 1e-7;

int main() {
    #ifdef MY
        freopen("input.txt", "r", stdin);
    #else
        ios_base::sync_with_stdio(0);
        cin.tie(0);
        cout.tie(0);
    #endif // MY
    int n, m, q;
    cin >> n >> m >> q;
    vector <vector <int> > a(n, vector <int> (m, 0));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
        }
    }
    vector <pair <int, int> > maxa(n, {-1, -1}), maxb(m, {-1, -1});
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            maxa[i] = max(maxa[i], {a[i][j], j});
            maxb[j] = max(maxb[j], {a[i][j], i});
        }
    }
    int cnt = 0;
    vector <vector <bool> > good(n, vector <bool> (m, 0));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (maxa[i].second == j && maxb[j].second == i) {
                good[i][j] = true;
                cnt++;
            }
        }
    }
    for (int i = 0; i < q; i++) {
        int x, y, d;
        cin >> x >> y >> d;
        x--, y--;
        if (d > a[x][maxa[x].second] && good[x][maxa[x].second]) {
            good[x][maxa[x].second] = false;
            cnt--;
        }
        if (d > a[maxb[y].second][y] && good[maxb[y].second][y]) {
            good[maxb[y].second][y] = false;
            cnt--;
        }
        a[x][y] = d;
        maxa[x] = max(maxa[x], {a[x][y], y});
        maxb[y] = max(maxb[y], {a[x][y], x});
        if (maxa[x].second == y && maxb[y].second == x) {
            good[x][y] = true;
            cnt++;
        }
        cout << cnt << "\n";
    }
}
