#include <bits/stdc++.h>
#define ll long long

using namespace std;

const int INF = 1e9 + 7;
const int MAXN = 1e6 + 7;
const double EPS = 1e-7;
const int N = 540;

bool isGreater(vector <int> &a, vector <int> &b) {
    for (int i = N - 1; i >= 0; i--) {
        if (a[i] > b[i]) {
            return true;
        }
        if (a[i] < b[i]) {
            return false;
        }
    }
    return false;
}

int main() {
    #ifdef MY
        freopen("input.txt", "r", stdin);
    #else
        ios_base::sync_with_stdio(0);
        cin.tie(0);
        cout.tie(0);
    #endif // MY
    int n, m, k;
    cin >> n >> m >> k;
    vector <int> x(k), y(k);
    for (int i = 0; i < k; i++) {
        cin >> x[i] >> y[i];
    }
    vector <vector <int> > dp(k, vector <int> (N, INF));
    dp[0] = vector <int> (N, 0);
    vector <int> pred(k, -1);
    vector <bool> used(k, 0);
    while (true) {
        vector <int> mink = vector <int> (N, INF);
        int v = -1;
        for (int j = 0; j < k; j++) {
            if (!used[j] && isGreater(mink, dp[j])) {
                v = j;
                mink = dp[j];
            }
        }
        if (v == -1) break;
        used[v] = 1;
        for (int i = 0; i < k; i++) {
            if (used[i]) continue;
            auto a = dp[v];
            int d = max(abs(x[i] - x[v]), abs(y[i] - y[v]));
            a[d]++;
            while (a[d] > 1) {
                a[d + 1]++;
                a[d] = 0;
                d++;
            }
            if (isGreater(dp[i], a)) {
                dp[i] = a;
                pred[i] = v;
            }
        }
    }
    vector <int> res;
    int now = k - 1;
    while (now != -1) {
        res.push_back(now);
        now = pred[now];
    }
    reverse(res.begin(), res.end());
    cout << res.size() << "\n";
    for (int x : res) {
        cout << x + 1 << " ";
    }
    cout << "\n";
}
