#define _CRT_SECURE_NO_WARNINGS
//
//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("sse,sse2,sse3,sse4,popcnt,tune=native")

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <unordered_map>
#include <string>
#include <cassert>

using namespace std;

typedef long long ll;
typedef long double ld;

#define int long long
#define sz(v) (int)v.size()
#define all(v) v.begin(),v.end()
#define rall(v) v.rbegin(),v.rend()

void run();

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	iostream::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	run();
#ifdef _DEBUG
	cerr << "\nOK\n";
	while (1);
#endif
}

const int MAXN = 3e5 + 123;
const int INF = 1e9 + 123;

void run() {
	int n;
	cin >> n;
	int ans = 0;
	vector<int> mas(n);
	for (int i = 0; i < n; i++) {
		cin >> mas[i];
	}

	vector<int> low_closest(n, INF);
	vector<int> high_closest(n, INF);
	/*set<pair<int, int>, decltype(greater<int>)> nums;
	for (int i = n - 1; i >= 0; i--) {
		
		auto hit = nums.lower_bound({ mas[i], INF});
		if (hit != nums.end())
			high_closest[i] = hit->second;
		hit = nums.lower_bound({ mas[i], -1 });
		if (hit != nums.begin()) {
			hit--;
			low_closest[i] = hit->second;
		}

		nums.emplace(mas[i], i);

	}*/

	vector<int> lst;
	vector<int> hst;
	for (int i = 0; i < n; i++) {
		while (!lst.empty() && mas[lst.back()] > mas[i]) {
			low_closest[lst.back()] = i;
			lst.pop_back();
		}
		while (!hst.empty() && mas[hst.back()] <= mas[i]) {
			high_closest[hst.back()] = i;
			hst.pop_back();
		}
		hst.push_back(i);
		lst.push_back(i);
	}

	int cmin = 0;
	int cmax = 0;
	for (int i = 1; i < n; i++) {
		
		int low = low_closest[cmin];
		int high = high_closest[cmax];
		if (low <= high || high == INF) {
			ans++;
			cmin = cmax = i;
		}
		else {
			if (mas[i] >= mas[cmax])
				cmax = i;
		}
	}

	cout << ans + 1;
}