#include <iostream>
#include <stdio.h>
#include <cstdlib>
#include <algorithm>

using namespace std;

const int INF = 1e9 + 1;

int a[300000], d[300000], n, s[300000], start = 1, cnt;

pair <int, int> t[1200000];

void update (int x, int d)
{
	x += start;

	t[x].first = d;

	x /= 2;

	while (x)
	{
		t[x] = min (t[2 * x], t[2 * x + 1]);
		x /= 2;
	}
}

pair <int, int> get (int l, int r)
{
	l += start;
	r += start;

	pair <int, int> mn = make_pair (INF, INF);

	while (1)
	{

		if (l % 2) 
		{
			mn = min (t[l], mn);
			l++;
		}
		if (r % 2 == 0) 
		{
			mn = min (t[r], mn);
			r--;
		}
		if (l > r) break;
		if (l == r) break;
		l /= 2;
		r /= 2;
	}

	if (l == r) mn = min (t[l], mn);

	return mn;
}

int main ()
{
	scanf ("%d", &n);
	
	while (start < n) start <<= 1;

	for (int i = 0; i < n; i++)
	{
		t[i + start].second = i;
	}

	for (int i = 0; i < n; i++)
	{
		scanf ("%d", &a[i]);
		t[i + start].first = a[i];
	}

	for (int i = start - 1; i; i--)
		t[i] = min (t[2 * i], t[2 * i + 1]);

	for (int i = n - 1; i >= 0; i--)
	{
		int j = i;

		while (j != -1 && a[j] <= a[i])
			j--;

		j++;

		pair <int, int> s = get (j, i);

		i = s.second;
		cnt++;
	}

	cout << cnt;
}