#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

#include <stdio.h>
#include <bits/stdc++.h>
  
#define ll long long
#define ld long double
#define fi first
#define se second
#define rep(i, l, r) for (int i = l; i < r; i++)
#define repb(i, l, r) for (int i = l; i > r; i--)
#define sz(a) (int)a.size()
#define mp(a, b) make_pair(a, b)
#define y1 qwertyuiop
#define plus sdfghj
#define minus cvbn
  
using namespace std;
  
inline void setmin(int &x, int y) { if (y < x) x = y; }
inline void setmax(int &x, int y) { if (y > x) x = y; }
inline void setmin(ll &x, ll y) { if (y < x) x = y; }
inline void setmax(ll &x, ll y) { if (y > x) x = y; }
  
const int N = 400000;
const int inf = (int)1e9 + 1;
const ll big = (ll)1e18 + 1;
const int MOD = (int)1e9 + 7;
 
int F[N];
  
void add(int x, int v, int L)
{
    for (; x < L; x = (x | (x + 1)))
        F[x] += v;
}
  
int get(int x)
{
    int res = 0;
    for (; x >= 0; x = (x & (x + 1)) - 1)
        res += F[x];
    return res;
}
 
int F1[N];
  
void add1(int x, int v, int L)
{
    for (; x < L; x = (x | (x + 1)))
        F1[x] += v;
}
  
int get1(int x)
{
    int res = 0;
    for (; x >= 0; x = (x & (x + 1)) - 1)
        res += F1[x];
    return res;
}
 
int F2[N];
  
void add2(int x, int v, int L)
{
    for (; x < L; x = (x | (x + 1)))
        F2[x] += v;
}
  
int get2(int x)
{
    int res = 0;
    for (; x >= 0; x = (x & (x + 1)) - 1)
        res += F2[x];
    return res;
}
 
int a[N];
int ans1[N], ans2[N];
int plus[N], minus[N];
 
int main()
{
    //freopen("a.in", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.precision(20);
    cout << fixed;
    int n, p;
    cin >> n >> p;
    rep(i, 0, n)
        cin >> a[i];
    rep(i, 0, n)
    {
        plus[i] = a[i] + i;
        minus[i] = a[i] - i;
    }
    sort(plus, plus + n);
    sort(minus, minus + n);
    rep(i, 0, n)
        if (i < n / 2)
            ans1[i] = lower_bound(minus, minus + n, a[i] - i) - minus;
        else
            ans1[i] = lower_bound(plus, plus + n, a[i] + i) - plus;
    if (n >= 3)
    {
        vector<int> diff, diff1, diff2;
        rep(i, 0, n)
        {
            diff.push_back(a[i]);
            diff1.push_back(a[i] + i);
            diff2.push_back(a[i] - i);
        }
        sort(diff.begin(), diff.end());
        diff.resize(unique(diff.begin(), diff.end()) - diff.begin());
        sort(diff1.begin(), diff1.end());
        diff1.resize(unique(diff1.begin(), diff1.end()) - diff1.begin());
        sort(diff2.begin(), diff2.end());
        diff2.resize(unique(diff2.begin(), diff2.end()) - diff2.begin());
        int L = sz(diff), L1 = sz(diff1), L2 = sz(diff2);
         
        fill(F, F + L, 0);
        fill(F1, F1 + L1, 0);
        fill(F2, F2 + L2, 0);
        rep(i, 0, n)
            if (i != 1)
            {
                int v = lower_bound(diff.begin(), diff.end(), a[i]) - diff.begin();
                add(v, 1, L);
            }
        rep(i, 1, (n % 2 == 0 ? n / 2 : n / 2 + 1))
        {
            int v = lower_bound(diff.begin(), diff.end(), a[i] + i) - diff.begin();
            ans2[i] += get(v - 1);
            int v1 = lower_bound(diff1.begin(), diff1.end(), a[i] + i) - diff1.begin();
            ans2[i] += get1(v1 - 1);
            int v2 = lower_bound(diff2.begin(), diff2.end(), a[i] - i) - diff2.begin();
            ans2[i] += get2(v2 - 1);
 
            if (i == (n % 2 == 0 ? n / 2 : n / 2 + 1) - 1)
                break;
 
            v = lower_bound(diff.begin(), diff.end(), a[i * 2]) - diff.begin();
            add(v, -1, L);
            v = lower_bound(diff.begin(), diff.end(), a[i * 2 + 1]) - diff.begin();
            add(v, -1, L);
 
            v1 = lower_bound(diff1.begin(), diff1.end(), a[i] + i) - diff1.begin();
            add1(v1, 1, L1);
 
            v2 = lower_bound(diff2.begin(), diff2.end(), a[i * 2] - (i * 2)) - diff2.begin();
            add2(v2, 1, L2);
            v2 = lower_bound(diff2.begin(), diff2.end(), a[i * 2 + 1] - (i * 2 + 1)) - diff2.begin();
            add2(v2, 1, L2);
            v2 = lower_bound(diff2.begin(), diff2.end(), a[i + 1] - (i + 1)) - diff2.begin();
            add2(v2, -1, L2);
        }
    }
    reverse(a, a + n);
    if (n >= 3)
    {
        vector<int> diff, diff1, diff2;
        rep(i, 0, n)
        {
            diff.push_back(a[i]);
            diff1.push_back(a[i] + i);
            diff2.push_back(a[i] - i);
        }
        sort(diff.begin(), diff.end());
        diff.resize(unique(diff.begin(), diff.end()) - diff.begin());
        sort(diff1.begin(), diff1.end());
        diff1.resize(unique(diff1.begin(), diff1.end()) - diff1.begin());
        sort(diff2.begin(), diff2.end());
        diff2.resize(unique(diff2.begin(), diff2.end()) - diff2.begin());
        int L = sz(diff), L1 = sz(diff1), L2 = sz(diff2);
         
        fill(F, F + L, 0);
        fill(F1, F1 + L1, 0);
        fill(F2, F2 + L2, 0);
        rep(i, 0, n)
            if (i != 1)
            {
                int v = lower_bound(diff.begin(), diff.end(), a[i]) - diff.begin();
                add(v, 1, L);
            }
        rep(i, 1, n / 2)
        {
            int v = lower_bound(diff.begin(), diff.end(), a[i] + i) - diff.begin();
            ans2[n - i - 1] += get(v - 1);
            int v1 = lower_bound(diff1.begin(), diff1.end(), a[i] + i) - diff1.begin();
            ans2[n - i - 1] += get1(v1 - 1);
            int v2 = lower_bound(diff2.begin(), diff2.end(), a[i] - i) - diff2.begin();
            ans2[n - i - 1] += get2(v2 - 1);
 
            if (i == n / 2 - 1)
                break;
 
            v = lower_bound(diff.begin(), diff.end(), a[i * 2]) - diff.begin();
            add(v, -1, L);
            v = lower_bound(diff.begin(), diff.end(), a[i * 2 + 1]) - diff.begin();
            add(v, -1, L);
 
            v1 = lower_bound(diff1.begin(), diff1.end(), a[i] + i) - diff1.begin();
            add1(v1, 1, L1);
 
            v2 = lower_bound(diff2.begin(), diff2.end(), a[i * 2] - (i * 2)) - diff2.begin();
            add2(v2, 1, L2);
            v2 = lower_bound(diff2.begin(), diff2.end(), a[i * 2 + 1] - (i * 2 + 1)) - diff2.begin();
            add2(v2, 1, L2);
            v2 = lower_bound(diff2.begin(), diff2.end(), a[i + 1] - (i + 1)) - diff2.begin();
            add2(v2, -1, L2);
        }
    }
    rep(i, 0, n)
        cout << max(ans1[i], ans2[i]) + 1 << "\n";
    return 0;
}