#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <set>

#define fi first
#define se second
#define re return
#define pb push_back

#define F(i, a, b) for (int (i) = (a); (i) < (b); (i)++)
#define f(i, n) F(i, 0, n)

#define all(v) (v).begin(), (v).end()

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

int run();

int main() {
#ifdef home
    freopen("i", "r", stdin);
    freopen("d", "w", stderr);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    run();
}

ll a[150500];
ll b[150500];

map<ll, vector<ll> > p;

map<ll, ll> v;

struct node {
    ll val;
    ll cnt;
    node *l, *r;
    node () {
        l = 0;
        r = 0;
        val = 0;
        cnt = 0;
    }
} *root = new node();

void push(node * cur) {
    if (cur->l) {
        cur->l->cnt += cur->cnt;
        cur->l->val += cur->cnt;
    }
    if (cur->r) {
        cur->r->cnt += cur->cnt;
        cur->r->val += cur->cnt;
    }
    cur->cnt = 0;
}
int sz = 1e9 + 7;

void add(node *cur, int rb, int l = 0, int r = sz) {
    if (l >= rb) {
        re;
    }
    if (r <= rb) {
        cur->val++;
        cur->cnt++;
        re;
    }
    if (!cur->l) {
        cur->l = new node();
    }
    if (!cur->r) {
        cur->r = new node();
    }

//    cerr << " add " << l << ' ' << r << ' ' << rb << ' ' << cur->cnt << ' ' << cur->val << '\n';

//    push(cur);

    int mid = (l + r) / 2;

    add(cur->l, rb, l, mid);
    add(cur->r, rb, mid, r);

    cur->val = max(cur->l->val, cur->r->val);
}

ll get(node *cur, int to, int l = 0, int r = sz) {
    if (!cur) {
        re 0;
    }
    if (l == r - 1) {
        re cur->val;
    }
    if (!cur->l) {
        cur->l = new node();
    }
    if (!cur->r) {
        cur->r = new node();
    }
//    cerr << ' ' << l << ' ' << r << ' ' << cur->cnt << ' ' << cur->val << '\n';
    push(cur);
    int mid = (l + r) / 2;
    if (to < mid) {
        re get(cur->l, to, l, mid);
    } else {
        re get(cur->r, to, mid, r);
    }
}

set<ll> allb;

int run() {
    ll n;
    cin >> n;
    f(i, n) {
        cin >> a[i] >> b[i];
        allb.insert(b[i]);
        p[a[i]].pb(i);
    }

    ll cnt = n;

    ll ans = 0;

    ll cb = 0;

    ll val = 0;

    for (const auto & x : p) {
        ans = max(ans, val + cnt * x.fi);
        for (const auto & y : x.second) {
            add(root, b[y] + 1);
        }
        cnt -= x.second.size();
        while (true) {
            auto ub = allb.upper_bound(cb);
            if (ub == allb.end()) break;
            ll nx = *ub;
            if (get(root, nx) * nx > get(root, cb) * cb) {
                cb = nx;
            } else {
                break;
            }
        }
        val = get(root, cb) * cb;
//        cerr << cb << ' ' << val << ' ' << get(root, cb) << '\n';
    }

    cout << ans;

    return 0;
}