#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <set>

#define fi first
#define se second
#define re return
#define pb push_back

#define F(i, a, b) for (int (i) = (a); (i) < (b); (i)++)
#define f(i, n) F(i, 0, n)

#define all(v) (v).begin(), (v).end()

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

int run();

int main() {
#ifdef home
    freopen("i", "r", stdin);
    freopen("d", "w", stderr);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    run();
}

vector<int> d[10050][10050];

int pr[10050];
int was[10050];

int p[10050];

int cur = 0;

set<pii> make;

vector<int> vis;

void add(int v) {
    vis.pb(v);
    f(i, cur + 1){
        make.insert({i, v});
    }
}

void find(int v, int cur_d) {
//    cerr << "find " << v << ' ' << cur_d << '\n';
    for (auto x : d[v][cur_d]) {
        if (!was[x]) {
            was[x] = 1;
            p[x] = v;
            add(x);
        }
    }
}

int x[10050];
int y[10050];

int run() {
    int n, m;
    cin >> n >> m;
    int k;
    cin >> k;
    f(i, k) {
        cin >> x[i] >> y[i];
    }

    f(i, k) {
        f(j, i) {
            int dist = max(x[i] - x[j], y[i] - y[j]);
            d[i][dist].pb(j);
            d[j][dist].pb(i);
        }
    }

    add(0);

    while (!was[k - 1]) {
        for (auto to : vis) {
            make.insert({cur, to});
        }
        while (!make.empty()) {
            auto cur = *make.begin();
//            cerr << cur.fi << ' ' << cur.se << '\n';
            make.erase(make.begin());
            find(cur.se, cur.fi);
        }
        cur++;
    }

    vector<int> ans;
    int e = k - 1;
    while (e != 0) {
//        cerr << e << '\n';
        ans.pb(e);
        e = p[e];
    }
    ans.pb(0);
    reverse(all(ans));
    cout << ans.size() << '\n';
    for (auto x : ans) {
        cout << x + 1 << ' ';
    }

    return 0;
}