#include <iostream>
#include <vector>

#define fi first
#define se second
#define re return
#define pb push_back

#define F(i, a, b) for (int (i) = (a); (i) < (b); (i)++)
#define f(i, n) F(i, 0, n)

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef long double ld;

int run();

int main() {
#ifdef home
  freopen("i", "r", stdin);
  freopen("d", "w", stderr);
#endif
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.tie(nullptr);

  run();
}

int n;

int a[400500];
char mem[500000000];

int ptr;

void *operator new(size_t sz) {
  int res = ptr;
  ptr += sz;
  re mem + res;
}

struct node {
  int val;
  node *l, *r;

  node() {
    l = 0;
    r = 0;
    val = 0;
  }
} *root = new node();

int sz = 1.05e9;

void add(node *cur, int to, int l = 0, int r = sz) {
//  cerr << "   " << to << ' ' << l << ' ' << r << endl;
  cur->val++;
  if (l == r - 1) {
    re;
  }
  int mid = (l + r) / 2;
  if (to < mid) {
    if (!cur->l) {
      cur->l = new node();
    }
    add(cur->l, to, l, mid);
  } else {
    if (!cur->r) {
      cur->r = new node();
    }
    add(cur->r, to, mid, r);
  }
}

int cnt[400500];

int get(node *cur, int lb, int rb, int l = 0, int r = sz) {
  if (!cur) {
    re 0;
  }
//  cerr << ' ' << lb << ' ' << rb << ' ' << l << ' ' << r << ' ' << cur->val << '\n';
  if (lb <= l && rb >= r) {
    re cur->val;
  }
  if (lb >= r || rb <= l) {
    re 0;
  }
  int mid = (l + r) / 2;
  re get(cur->l, lb, rb, l, mid) + get(cur->r, lb, rb, mid, r);
}

void clear(node *cur) {
  if (cur->l) {
    clear(cur->l);
  }
  if (cur->r) {
    clear(cur->r);
  }
  cur->val = 0;
}

int run() {
//  cerr << 2 * sz;
  int p;
  cin >> n >> p;
  f(i, n) {
    cin >> a[i];
  }

//  vector<pii> a1, a2, a3;
//
//  f(i, n) {
//    int d = min(i, n - i - 1);
//    a1.pb({i - d, -1});
//    a1.pb({i, 1});
//    a2.pb({i, 1});
//    a2.pb({i + d, -1});
//    if (d == i) {
//      a3.pb({i + d, -1});
//      a3.pb({n, 1});
//    } else {
//      a3.pb({i - d, 1});
//    }
//  }


  f(i, n) {
    add(root, a[i] + i);
  }

  f(i, n) {
//    if (i == 3) {
//      cerr << get(root, 0, a[i] + i) << '\n';
//    }
    cnt[i] = max(get(root, 0, a[i] + i), cnt[i]);
  }

  root = new node();

  f(i, n) {
    add(root, a[i] + n - i);
  }

  f(i, n) {
//    if (i == 3) {
//      cerr << a[i] -get(root, 0, a[i] + n - 1) << '\n';
//    }
    cnt[i] = max(get(root, 0, a[i] + n - i), cnt[i]);
  }

  f(i, n) {
    int cc = 0;
    f(j, n) {
      int di = min(min(i, abs(j - i)), n - i - 1);
      if (a[i] + di > a[j]) {
        cc++;
      }
    }
    cnt[i] = max(cc, cnt[i]);
  }


  f(i, n) {
    cout << cnt[i] + 1 << '\n';
  }

  return 0;
}