#include <bits/stdc++.h>

using namespace std;

const int MAXLEN = 3e5;

int toInt(string &data) {
    int res = 0;
    for (int i = data.size() - 1; i >= 0; --i) {
        if (data[i] == '1') {
            res += (1 << (data.size() - i - 1));
        }
    }
    return res;
}

int incr(vector<char> data, int pos) {
    for (pos; data[pos] != '0'; ++pos);
    return pos;
}

void incre(vector<char> &data, int pos) {
    for (pos; data[pos] != '0'; ++pos, data[pos] = '0');
    data[pos] = '1';
}

string toBit(int x) {
    string res;
    while (x) {
        res.push_back(char(x % 2 + '0'));
        x /= 2;
    }
    return res;
}

const int INF = 1e9;

int main() {
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    int n;
    cin >> n;
    vector<string> data(n);
    int minlen = INF;
    vector<int> sz(MAXLEN);
    for (int i = 0; i < n; ++i) {
        cin >> data[i];
        minlen = min(minlen, (int)data[i].size() - 1);
        sz[(int)data[i].size() - 1]++;
    }
//    sort(sz.begin(), sz.end());
    int cnt = 0;
    for (int i = 0; i < MAXLEN; ++i) {
        if (sz[i] == 0) {
            if (cnt) {
                sz[i] = 1;
                --cnt;
            }
        } else {
            cnt += sz[i] - 1;
            sz[i] = 1;
        }
    }
    int last = 0;
    for (int i = 0; i < MAXLEN; ++i) {
        if (sz[i] == 1) {
            last = i;
        }
    }
    for (int i = last; i >= 0; --i) {
        cout << sz[i];
    }
}