#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

#define mp make_pair
#define mt make_tuple
#define all(x) (x).begin(), (x).end()
#define X first
#define Y second
#define A(x) get<0>(x)
#define B(x) get<1>(x)
#define C(x) get<2>(x)
#define D(x) get<3>(x)

#ifdef REK
#define dbg(...) cout <<__VA_ARGS__
#else
#define dbg(...) ((void) 0)
#endif

inline void boost() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
}

constexpr int N = 20005;

int data [N][N];

int max_y_at [N];
int cnt [N];

int n, m, q;

int main(void) {
	//boost();

	cin >> n >> m >> q;

	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= m; j++) {
			cin >> data[i][j];
		}
	}

	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= m; j++) {
			if (data[i][j] > data[i][max_y_at[i]]) {
				max_y_at[i] = j;
			}
		}
	}

	int total = 0;

	for (int i = 1; i <= n; i++) {
		if (cnt[max_y_at[i]] == 0) {
			total++;
		}
		cnt[max_y_at[i]]++;
	}

	while (q--) {
		int r, c, x;
		cin >> r >> c >> x;

		if (data[r][max_y_at[r]] < x) {
			cnt[max_y_at[r]]--;
			if (cnt[max_y_at[r]] == 0) {
				total--;
			}
			data[r][c] = x;
			max_y_at[r] = c;

			if (cnt[max_y_at[r]] == 0) {
				total++;
			}
			cnt[max_y_at[r]]++;

		} else {
			data[r][c] = x;
		}

		cout << total << "\n";
	}

	return 0;
}