#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

#define mp make_pair
#define mt make_tuple
#define all(x) (x).begin(), (x).end()
#define X first
#define Y second
#define A(x) get<0>(x)
#define B(x) get<1>(x)
#define C(x) get<2>(x)
#define D(x) get<3>(x)

#ifdef REK
#define dbg(...) cout <<__VA_ARGS__
#else
#define dbg(...) ((void) 0)
#endif

inline void boost() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
}

int main(void) {
	boost();

	int n;
	cin >> n;

	vector<int> vals;

	for (int i = 0; i < n; i++) {
		int a, b;
		cin >> a >> b;

		assert(a == b);
		vals.push_back(a);
	}

	sort(all(vals));

	ll ans = 0;
	ll best_prv = 0;

	for (int i = 0; i < n; i++) {
		ll cur = vals[i] * 1LL * (n-i);
		if (cur > ans) {
			if (ans > best_prv) {
				best_prv = ans;
			}
			ans = cur;
		}
	}

	cout << ans + best_prv << endl;

	return 0;
}