#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<string>
#include<algorithm>
#include<math.h>

using namespace std;

vector<pair<int, int>> ans;

void upd(vector<int> &in, int l, int r)
{
	vector<int> h;
	for (int i = l; i <= r; i++)
		h.push_back(in[i]);
	int j = l;
	for (int i = 1; i < h.size(); i += 2)
		in[j++] = h[i];
	for (int i = 0; i < h.size(); i += 2)
		in[j++] = h[i];
	ans.push_back({ l, r });
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	//cout.setf(ios::fixed);
	//cout.precision(16);
	int n;
	cin >> n;
	vector<int> in;
	in.push_back(0);
	for (int i = 0; i < n; i++)
	{
		int a;
		cin >> a;
		in.push_back(a);
	}
	int l = 1, r = n;
	while(l <= r)
	{
		if (in[l] == l)
		{
			l++;
			continue;
		}
		int v1 = 0;
		for (int i = l; i <= n; i++)
		{
			if (in[i] == l)
				v1 = i;
		}
		int v2 = 0;
		for (int i = l; i <= n; i++)
		{
			if (in[i] == r)
				v2 = i;
		}
		bool tr1 = false, tr2 = false;
		while (v1 != l || v2 != r)
		{
			for (int i = l; i <= r; i++)
			{
				if (in[i] == l)
					v1 = i;
				if (in[i] == r)
					v2 = i;
			}
			if (v1 == l)
				break;
			if (v2 == r)
				break;
			pair<int, int> s1, s2;
			if ((v1 - l) % 2 == 0)
				s1 = { l + 1, v1 };
			else
				s1 = { l, v1 };
			s2 = { v2, r};
			if (s1.first % 2 == r)
				upd(in, s1.first, r);
			else
				upd(in, s1.first, r - 1);
		}
		if (in[l] == l)
			l++;
		if (in[r] == r)
			r--;
	}
	cout << ans.size() << endl;
	for (int i = 0; i < ans.size(); i++)
		cout << ans[i].first << " " << ans[i].second << endl;
	//system("pause");
}

/*


*/