#include<iostream>
#include<algorithm>
#include<vector>
using namespace std;

#pragma warning(disable : 4996)
#define ll long long int
#define all(vec) vec.begin(), vec.end()

const int N = 2e5 + 100;
int a[N], b[N], t[N];
vector<pair<int, int>> va, vb;
int n;
bool used[N];



int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	
	scanf("%d", &n);

	for (int i = 0; i < n; i++) {
		scanf("%d%d", &a[i], &b[i]);
		va.push_back({ a[i], i });
		vb.push_back({ b[i], i });
	}

	sort(all(va));
	sort(all(vb));

	ll t = 0, w = -1;
	for (int i = 0; i < n; i++) {
		if (w < vb[i].first * (ll)(n - i)) {
			t = i;
			w = vb[i].first * (ll)(n - i);
		}
	}

	ll ans = 0, g = n - t;
	for (int i = n - 1; i >= 0; i--) {
		ll cur = va[i].first * (ll)(n - i);

		int j = lower_bound(all(vb), make_pair(b[va[i].second], va[i].second)) - vb.begin();
		used[j] = 1;

		if (j >= t) {
			g--;
		}

		ans = max(ans, cur);

		while (t < n - 1 && (g - !used[t]) * vb[t + 1].first >
			g * (vb[t].first)) {
			g -= !used[t];
			t++;
		}
		while (t > 0 && (g + !used[t - 1]) * vb[t - 1].first >
			g * vb[t].first)
			t--;
		ans = max(ans, cur + g * vb[t].first);
	}



	printf("%lld", ans);

	return 0;
}