#include<iostream>
#include<algorithm>
#include<vector>
#include<map>
#include<queue>
using namespace std;

#pragma warning(disable : 4996)
#define ll long long int
#define all(vec) vec.begin(), vec.end()

const int N = 1005;
const ll base = 1e9;
int x[N], y[N], p[N];
vector<ll> pw[N], d[N];
bool sel[N];

void sum(vector<ll> &a, vector<ll> &b) {
	a.resize(max(a.size(), b.size()) + 1);
	for (int i = 0; i < b.size(); i++) {
		a[i] += b[i];
	}

	ll c = 0;
	for (int i = 0; i < a.size(); i++) {
		a[i] += c;
		c = a[i] / base;
		a[i %= base;
	}

	while (a.size() > 1 && a.back() == 0)
		a.pop_back();
}

bool operator < (vector<ll> &a, vector<ll> &b) {
	if (a.size() != b.size())
		return a.size() < b.size();
	for (int i = 0; i < a.size(); i++) {
		if (a[i] != b[i])
			return a[i] < b[i];
	}
	return false;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int n, m, k;
	scanf("%d%d%d", &n, &m, &k);


	for (int i = 0; i < k; i++) {
		scanf("%d%d", &x[i], &y[i]);
	}

	pw[0].push_back(1);
	for (int i = 1; i < N; i++) {
		pw[i] = pw[i - 1];
		sum(pw[i], pw[i - 1]);
	}

	for (int i = 0; i < k; i++)
		d[i].resize(100);
	d[0] = { 0 };

	for (int i = 0; i < k; i++) {
		int v = -1;
		for (int j = 0; j < k; j++) {
			if (!sel[j] && d[j] < d[v])
				v = j;
		}
		sel[v] = 1;
		for (int j = 0; j < k; j++) {
			if (!sel[j]) {
				vector<ll> nd = d[v];
				sum(nd, pw[max(abs(x[v] - x[j]), abs(y[v] - y[j]))]);
				if (nd < d[j]) {
					d[j] = nd;
					p[j] = v;
				}
			}
		}
	}

	vector<int> v;
	int x = k - 1;
	while (true) {
		v.push_back(x);
		if (x == 0)
			break;
		x = p[x];
	}

	printf("%d\n", v.size());

	for (int i = (int)v.size() - 1; i >= 0; i--)
		printf("%d ", v[i] + 1);



	return 0;
}