#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

long long prib_inn(vector<long long> &inn)
{
    long long l = inn.size(), otv = 0;
    sort(inn.begin(), inn.end());
    for (long long i=0; i<l; i++){
        otv = max(otv, inn[i]*(l-i));
    }
    return otv;
}

long long prib_inn_pl(vector<pair<long long, long long> > &inn)
{
    sort(inn.begin(), inn.end());
    long long l=inn.size(), otv_pl=0, otv = 0;
    vector<long long> U;
    for (long long i=0; i<l; i++){
        otv_pl = inn[i].first*(l-i);

        long long pri = prib_inn(U);
        if (otv<otv_pl+pri){
            otv = otv_pl+pri;
        }
        U.push_back(inn[i].second);
    }
    return otv;
}

long long prib_inn_pl_p4(vector<pair<long long, long long> > &inn)
{
    sort(inn.begin(), inn.end());
    long long l=inn.size(), otv = 0;
    for (long long i=0; i<l; i++){
        otv = max(otv, inn[i].first*(l-i));
    }
    return otv;
}

long long prib_inn_pl_p5(vector<pair<long long, long long> > &inn)
{
    sort(inn.begin(), inn.end());
    long long l=inn.size();
    vector<long long> dp(l, 0), izm;
    for (int i=1; i<l; i++){
        if (inn[i-1]!=inn[i]){
            izm.push_back(i);
        }
        if (dp[i-1]!=izm[izm.size()-1]){
            int ind = dp[i-1];
            for (int j=ind+1; j<izm.size(); j++){
                if (inn[izm[ind]].first*(i-izm[ind]+1)<inn[izm[j]].first*(i-izm[j]+1)){
                    ind = j;
                }
            }
            dp[i] = ind;
        }
        else{
            dp[i] = dp[i-1];
        }
    }
    int otv = inn[izm[dp[l-1]]].first*(l-izm[dp[l-1]])+inn[izm[dp[izm[dp[l-1]]-1]]].first*(izm[dp[l-1]]-izm[dp[izm[dp[l-1]]-1]]);
    return otv;
}

int main()
{
    long long n;
    cin >> n;
    vector<pair<long long, long long> > A(n, make_pair(0, 0));
    bool p4 = true, p5 = true;
    for (long long i=0; i<n; i++){
        cin >> A[i].first >> A[i].second;
        if (A[i].second!=0) p4 = false;
        if (A[i].first!=A[i].second) p5 = false;
    }
    if (n<=3000){
        cout << prib_inn_pl(A) << endl;
    }
    else{//*/
        if (p4){
            cout << prib_inn_pl_p4(A) << endl;
        }
        else if (p5){
            cout << prib_inn_pl_p5(A) << endl;
        }
    }
}
