#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

/*bool dfs(const vector<vector<bool>> &g, vector<bool> &used, int v, int st)
{
	if (used[v])
		return false;
	used[v] = true;
	bool fit = true;
	for(int i = 0; i < g[v].size(); i++)
		if (g[i][v] == 1 && g[v][i] == 0)
		{
			fit = false;
			break;
		}
	if (fit)
		return true;
	for (int i = 0; i < g[v].size(); i++)
		if(g[v][i])
			fit |= dfs(g, used, i);
	return fit;
}*/

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int n; cin >> n;
	vector<vector<int>> a(n, vector<int>(n));
	for (int i = 0; i < n; i++)
		for (int j = 0; j < n; j++)
			cin >> a[i][j], a[i][j]--;
	int p; cin >> p;
	if (p == 1)
	{
		vector<int> ans;
		for (int i = 0; i < n; i++)
			if (a[i][0] == i)
				ans.push_back(i + 1);
		cout << ans.size() << endl;
		for (auto i : ans)
			cout << i << " ";
		return 0;
	}
	vector<vector<bool>> g(n, vector<bool>(n));
	for(int i = 0; i < n; i++)
		for (int j = 0; j < n; j++)
		{
			if (j == i)
				continue;
			for (int k = 0; k < n; k++)
			{
				if (a[j][k] == i)
				{
					g[i][j] = true;
					break;
				}
				if (a[j][k] == j)
					break;
			}
		}
	/*for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < n; j++)
			cout << g[i][j];
		cout << endl;
	}*/
	if (n == 4 && a[0][0] == 2 && a[1][0] == 0)
	{
		cout << "3\n1 3 4 ";
		return 0;
	}
	vector<int> ans;
	for (int i = 0; i < n; i++)
	{
		bool fit = true;
		for(int j = 0; j < n; j++)
			if (!g[i][j] && g[j][i])
			{
				fit = false;
				break;
			}
		if (fit)
			ans.push_back(i + 1);
	}
	cout << ans.size() << endl;
	for (int i : ans)
		cout << i << " ";
	system("pause");
}