#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#pragma warning (disable : 4996)

const int MAXN = 2e5 + 10;

long long n, a[MAXN], b[MAXN], ind[MAXN];

bool key(int x, int y) {
	return a[x] > a[y];
}

bool key1(int x, int y) {
	return b[x] > b[y];
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	scanf("%d", &n);
	for (int i = 0; i < n; i++) {
		scanf("%lld %lld", &a[i], &b[i]);
		ind[i] = i;
	}
	sort(ind, ind + n, key);
	if (n <= 3000) {
		long long ans = 0;
		for (int i = 0; i < n; i++) {
			ans = max(ans, a[ind[i]] * (i + 1));
			vector < int > lol;
			for (int j = i + 1; j < n; j++) {
				lol.push_back(ind[j]);
			}
			sort(lol.begin(), lol.end(), key1);
			for (int j = 0; j < lol.size() && b[lol[j]] <= a[ind[i]]; j++) {
				ans = max(ans, a[ind[i]] * (i + 1) + b[lol[j]] * (j + 1));
			}
		}
		cout << ans;
		return 0;
	}
	long long ans = a[ind[n - 1]] * n;
	int id = n - 1;
	for (int i = n - 2; i > -1; i--) {
		ans = max(ans, a[ind[i]] * (i + 1));
		ans = max(ans, a[ind[i]] * (i + 1) + (id - i) * a[ind[id]]);
		if (id + a[ind[id]] < a[i]) id = i;
	}
	cout << ans;
	return 0;

}