#include <iostream>
#include <algorithm>

using namespace std;

#pragma warning (disable : 4996)

const int MAXN = 3e5 + 10;

int n, a[MAXN], sparsemi[20][MAXN], sparsema[20][MAXN];

int getmin(int l, int r) {
	int st = 0;
	if (l == r) return a[l];
	while (l + (1 << st) < r) st++;
	if (l + (1 << st) == r + 1) return sparsemi[st][l];
	return min(sparsemi[st][l], sparsemi[st][r - (1 << st) + 1]);
}

int getmax(int l, int r) {
	int st = 0;
	if (l == r) return a[l];
	while (l + (1 << st) < r) st++;
	if (l + (1 << st) == r + 1) return sparsema[st][l];
	return max(sparsema[st][l], sparsema[st][r - (1 << st) + 1]);
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	scanf("%d", &n);
	for (int i = 0; i < n; i++) {
		scanf("%d", &a[i]);
		sparsemi[0][i] = a[i];
		sparsema[0][i] = a[i];
	}
	for (int t = 1; t < 20; t++) {
		for (int i = 0; i < n; i++) {
			if (i + (1 << (t - 1)) < n) {
				sparsemi[t][i] = min(sparsemi[t - 1][i], sparsemi[t - 1][i + (1 << (t - 1))]);
			}
			else {
				sparsemi[t][i] = sparsemi[t - 1][i];
			}
		}
	}
	for (int t = 1; t < 20; t++) {
		for (int i = 0; i < n; i++) {
			if (i + (1 << (t - 1)) < n) {
				sparsema[t][i] = max(sparsema[t - 1][i], sparsema[t - 1][i + (1 << (t - 1))]);
			}
			else {
				sparsema[t][i] = sparsema[t - 1][i];
			}
		}
	}
	int ans = 0;
	for (int i = 0; i < n; ) {
		int l = i;
		int r = n;
		while (r - l > 1) {
			int mid = r + l >> 1;
			if (getmin(i, mid) == a[i]) {
				l = mid;
			}
			else {
				r = mid;
			}
		}
		int rr = l;
		r = l + 1;
		l = i;
		while (r - l > 1) {
			int mid = r + l >> 1;
			if (getmax(mid, rr) == getmax(i, rr)) {
				l = mid;
			}
			else {
				r = mid;
			}
		}
		i = l + 1;
		ans++;
	}
	cout << ans;
}