#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <stack>
#include <set>
#define fr first
#define sc second
#define ll long long
using namespace std;
int n;
int inf = 1e9;
vector <int> a, used;
struct node {
	node *left, *right;
	int tl, tr, sum;
	node(int a = 0, int b = 0) : tl(a), tr(b) {
		sum = 0;
		left = NULL;
		right = NULL;
	}
};

node* build(int l, int r) {
	if (l >= r)
		return 0;
	node* v = new node(l, r);
	if (l + 1 == r)
		return v;

	v->left = build(l, (l + r) / 2);
	v->right = build((l + r) / 2, r);
	return v;
}

int get_sum(node*v, int l, int r) {
	if ((v == NULL) || (v->tl >= r) || (v->tr <= l))
		return 0;
	if (v->tl >= l && v->tr <= r)
		return v->sum;
	return get_sum(v->left, l, r) + get_sum(v->right, l, r);
}

void add(node*& v, int p) {
	if ((v == NULL) || (v->tl > p) || (v->tr <= p))
		return;
	if (v->tl + 1 == v->tr) {
		v->sum = 1;
		return;
	}
	add(v->left, p);
	add(v->right, p);
	v->sum = v->left->sum + v->right->sum;

}
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, type;
	cin >> n >> type;
	a.resize(n);
	used.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		//a[i] += inf;
	}
	if (type == 2) {
		int k = 0;
		vector <int> ans(n, 0);
		bool f = 0;
		for (int l = -1; l <= n; l++) {
			if (f)
				break;
			for (int r = n; r >= l + 1; r--) {
				if (f)
					break;
				vector <int> b, c;
				b = a;
				for (int i = 0; i < n; i++) {
					k++;
					if (k > 1e5) {
						f = 1;
						break;
					}
					if (l != -1 || r != n) {
						if (i > l && i < r) {
							int k1 = 1e9;
							int k2 = 1e9;
							if (l != -1)
								k1 = abs(i - l);
							if (r != n)
								k2 = abs(i - r);
							b[i] = b[i] + min(k1, k2);
						}
					}
				}
				c = b;
				sort(c.begin(), c.end());
				for (int i = 0; i < n; i++) {
					ans[i] = max(ans[i], (int)(upper_bound(c.begin() + ans[i], c.end(), b[i] - 1) - c.begin()));
				}
			}
		}
		if (n < 10000) {
			vector <int> b, c;
			for (int t = 0; t < 100; t++) {
				int l = rand() % n;
				int r = rand() % n;
				if (l > r)
					swap(l, r);
				b = a;
				for (int i = 0; i < n; i++) {
					if (l != -1 || r != n) {
						if (i > l && i < r) {
							int k1 = 1e9;
							int k2 = 1e9;
							if (l != -1)
								k1 = abs(i - l);
							if (r != n)
								k2 = abs(i - r);
							b[i] = b[i] + min(k1, k2);
						}
					}
				}
				c = b;
				sort(c.begin(), c.end());
				for (int i = 0; i < n; i++) {
					ans[i] = max(ans[i], (int)(upper_bound(c.begin() + ans[i], c.end(), b[i] - 1) - c.begin()));
				}

			}
		}
		for (int i = 0; i < n; i++)
			cout << ans[i] + 1 << "\n";
	}
	return 0;
}