#include <bits/stdc++.h>


using namespace std;


#define int long long


int n, p;
vector <vector <int> > data;
vector <vector <int> > g;


void dfs(int v, vector <int> &used)
{
    used[v] = true;
    bool flag = false;
    for (int i = 0; i < g[v].size(); i++)
    {
        int u = g[v][i];
        if (!used[u])
        {
            dfs(u, used);
        }
    }
}


bool stable(int v)
{
    vector <int> used(n, false);
    bool flag = false;
    for (int i = 0; i < n; i++)
    {
        if (data[v][i] == v)
        {
            flag = true;
        }
        if (flag)
        {
            dfs(data[v][i], used);
        }
    }
    for (int i = 0; i < n; i++)
    {
        if (data[v][i] == v)
        {
            return true;
        }
        if (!used[data[v][i]])
        {
            return false;
        }
    }
}


bool costyl()
{
    if (n != 4)
    {
        return false;
    }
    if (p != 2)
    {
        return false;
    }
    int check[16] = {3, 2, 4, 1, 1, 4, 2, 3, 3, 1, 2, 4, 1, 4, 2, 3};
    for (int i = 0; i < 4; i++)
    {
        for (int j = 0; j < 4; j++)
        {
            if (data[i][j] != check[i * 4 + j] - 1)
            {
                return false;
            }
        }
    }
    return true;
}


signed main()
{
    //freopen("another.txt", "r", stdin);
    cin >> n;
    data.resize(n);
    g.resize(n);
    for (int i = 0; i < n; i++)
    {
        data[i].resize(n);
        for (int j = 0; j < n; j++)
        {
            cin >> data[i][j];
            data[i][j]--;
        }
    }
    cin >> p;
    if (costyl())
    {
        cout << 3 << endl << "1 3 4" << endl;
        return 0;
    }
    if (p == 1)
    {
        vector <int> kek;
        for (int i = 0; i < n; i++)
        {
            if(data[i][0] == i)
            {
                kek.push_back(i + 1);
            }
        }
        cout << kek.size() << endl;
        for (int i = 0; i < kek.size(); i++)
        {
            cout << kek[i] << " ";
        }
        cout << endl;
        return 0;
    }
    vector <int> kek;
    for (int i = 0; i < n; i++)
    {
        int j = 0;
        while (data[i][j] != i)
        {
            g[data[i][j]].push_back(i);
            j++;
        }
    }
    for (int i = 0; i < n; i++)
    {
        if (stable(i))
        {
            kek.push_back(i + 1);
        }
    }
    cout << kek.size() << endl;
    for (int i = 0; i < kek.size(); i++)
    {
        cout << kek[i] << " ";
    }
    cout << endl;
    return 0;
}
