#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <fstream>
#include <cmath>
#include <algorithm>
#include <queue>

using namespace std;

const int MAXN = 3e5 + 7;
const int INF = 1e9 + 7;

vector <int> a[MAXN];
int mx_x[MAXN], mx_y[MAXN];

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    //freopen("input.txt", "r", stdin);

    int n, m, q;
    cin >> n >> m >> q;
    for (int i = 0; i < n; ++i) {
        a[i].resize(m);
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }

    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            if (a[mx_y[i]][i] < a[j][i]) mx_y[i] = j;
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (a[i][mx_x[i]] < a[i][j]) mx_x[i] = j;
        }
    }

    int curr = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (j == mx_x[i] && i == mx_y[j]) ++curr;
        }
    }

    for (int i = 0; i < q; ++i) {
        int x, y, val;
        cin >> x >> y >> val;
        --x;
        --y;

        int xval = a[x][mx_x[x]];
        int yval = a[mx_y[y]][y];

        if (val > xval && val > yval) {
            //cout << "t1\n";
            ++curr;
            int besty = mx_y[y];
            int bestx = mx_x[x];
            curr -= (mx_x[besty] == y);
            curr -= (mx_y[bestx] == x);
            curr += (mx_x[x] == y && mx_y[y] == x);
            mx_x[x] = y;
            mx_y[y] = x;
        }
        else if (val > xval && val < yval) {
            //cout << "t2\n";
            int bestx = mx_x[x];
            curr -= (mx_y[bestx] == x);
            mx_x[x] = y;
        }
        else if (val < xval && val > yval) {
            //cout << "t3\n";
            int besty = mx_y[y];
            curr -= (mx_x[besty] == y);
            mx_y[y] = x;
        }
        else {
            //cout << "t4\n";
        }

        a[x][y] = val;
        cout << curr << '\n';
    }

    return 0;
}

