#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>
#include <fstream>
#include <queue>
#include <random>
#include <time.h>

using namespace std;

const int MAXN = 3007;

mt19937 rnd(time(0));
int a[MAXN];
vector <pair <int, int> > ans;

void print(int n) {
    for (int i = 0; i < n; ++i) cout << a[i] << ' ';
    cout << '\n';
}

void func(int l, int r, int n) {
    ans.push_back({l, r});

    vector <int> f, s;
    for (int i = l; i <= r; ++i) {
        if ((i - l) % 2) {
            f.push_back(a[i]);
        }
        else {
            s.push_back(a[i]);
        }
    }

    for (int i = l; i < l + f.size(); ++i) {
        a[i] = f[i - l];
    }

    for (int i = l + f.size(); i <= r; ++i) {
        a[i] = s[i - l - f.size()];
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    //freopen("input.txt", "r", stdin);

    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) cin >> a[i];

    for (int it = 0; it < 1000; ++it) {
        int l = rnd() % n;
        int len = rnd() % (n - l) + 1;
        int r = l + len - 1;
        func(l, r, n);
    }

    for (int it = 0; it < n; ++it) {

        while (true) {
            int p = 0;
            for (int i = 0; i < n - it; ++i) {
                if (a[p] < a[i]) p = i;
            }
            if (p == n - it - 1) break;
            else func(p, n - it - 1, n);
        }

    }

    cout << ans.size() << '\n';
    for (int i = 0; i < ans.size(); ++i) {
        cout << ans[i].first + 1 << ' ' << ans[i].second + 1 << '\n';
    }

    return 0;
}
