#include <bits/stdc++.h>

using namespace std;

struct phone
{
    long long val, ind;
};

bool cmp(phone &f, phone &s)
{
    return f.val < s.val || (f.val == s.val && f.ind < s.ind);
}

int main()
{
    long long n;
    cin >> n;

    vector <pair <long long, long long> > people(n, {0, 0});

    vector <phone> a;
    vector <phone> b;

    for (long long i = 0; i < n; i++)
    {
        cin >> people[i].first >> people[i].second;

        a.push_back({people[i].first, i});
        b.push_back({people[i].second, i});
    }


    sort(a.begin(), a.end(), cmp);
    sort(b.begin(), b.end(), cmp);

    long long best_val = 0;
    pair <long long, long long> cost({0, 0});
    vector <long long> type (n, 1);
    ///1 = buy plus
    ///2 = can't

    long long sum = 0;

    long long val_a = a[0].val, val_b = b[0].val;
    long long last = 0, num_bad = 0;
    for (long long i = 0; i < n; i++)
    {
        val_a = a[i].val;
        sum = (n - i) * val_a + i * b[0].val;
        num_bad = 0;

        for (long long j = 0; j < n; j++)
        {
            val_b = b[j].val;
            sum = (n - i) * val_a + (i - num_bad) * val_b;

            if (sum > best_val)
            {
                best_val = sum;
            }
            if (type[b[j].ind] != 1)
            {
                sum -= b[j].val;
                num_bad++;
            }

        }
        type[a[i].ind] = 2;
    }


    cout << best_val;
    return 0;
}
