#include <bits/stdc++.h>

using namespace std;

bool has_ans = false;
void find_way(int v, int s, int f, vector <int> &ans, vector <vector <int> > &gr, vector <vector <int> > &cost, vector <vector <int> > &way)
{
    if (v == f || has_ans)
    {
        has_ans = true;
        return;
    }
    for (int i = 0; i < gr[v].size(); i++)
    {
        int son = gr[v][i];
        //cout << v << " v son " << son << "\n";
        //cout << way[v][f] << " " <<
        if (way[v][f] == way[son][f] + cost[v][i])
        {
            ans.push_back(son);
            //cout << ans.size() << " " << son << "\n";
            find_way(son, s, f, ans, gr, cost, way);
            if (has_ans)
            {
                return;
            }
        }
    }
}

int main()
{
    int n, m, k;
    cin >> n >> m >> k;
    vector <vector <int> > cost(k, vector <int>());
    vector <vector <int> > gr(k, vector <int>());
    vector <int> st(25, 1);
    for (int i = 1; i < 25; i++)
    {
        st[i] = st[i - 1] * 2;
    }


    vector <pair <int, int> > things(k, {0, 0});

    for (int kk = 0; kk < k; kk++)
    {
        int x, y;
        cin >> things[kk].first >> things[kk].second;
        things[kk].first--;
        things[kk].second--;
    }


    for (int i = 0; i < k; i++)
    {
        for (int j = i + 1; j < k; j++)
        {
            gr[i].push_back(j);
            cost[i].push_back(st[max(abs(things[i].first - things[j].first), abs(things[i].second - things[j].second))]);
            gr[j].push_back(i);
            cost[j].push_back(st[max(abs(things[i].first - things[j].first), abs(things[i].second - things[j].second))]); ///
        }
    }


    vector <vector <int> > way(k, vector <int>(k, st[24]));

    for (int i = 0; i < k; i++)
    {
        way[i][i] = 0;
    }

    for (int i = 0; i < k; i++)
    {
        for (int j = 0; j < gr[i].size(); j++)
        {
            way[i][gr[i][j]] = cost[i][gr[i][j]];
            way[gr[i][j]][i] = cost[i][gr[i][j]];
        }
    }

    while (true)
    {
        bool changed = false;
        for (int t = 0; t < k; t++)
        {
            for (int u = 0; u < k; u++)
            {
                for (int v = 0; v < k; v++)
                {
                    if (way[u][v] > way[u][t] + way[t][v])
                    {
                        way[u][v] = way[u][t] + way[t][v];
                        changed = true;
                    }
                }
            }
        }

        if (!changed)
        {
            break;
        }
    }

    vector <int> ans;
    ans.push_back(0);
    find_way(0, 0, k - 1, ans, gr, cost, way);

    /*for (int i = 0; i < k; i++)
    {
        for (int j = 0; j < k; j++)
        {
            cout << way[i][j] << " ";
        }
        cout << "\n";
    }*/

    cout << ans.size() << "\n";
    for (int i = 0; i < (int)ans.size(); i++)
    {
        cout << ans[i] + 1 << " ";
    }

    return 0;

}

