#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

int main() {
    int n;
    cin >> n;
    ll maxb = 0;
    vector<pair<ll, int>> in(n), inpl(n);
    for (int i = 0; i < n; ++i) {
        cin >> inpl[i].first >> in[i].first;
        in[i].second = inpl[i].second = i;
        maxb = max(maxb, in[i].first);
    }
    sort(in.rbegin(), in.rend());
    sort(inpl.rbegin(), inpl.rend());
    ll ans = 0;
    vector<int> used(n);
    if (maxb == 0) {
        for (int i = 0; i < n; ++i) {
            ans = max(ans, (i + 1) * inpl[i].first);
        }
        cout << ans << endl;
    }
    else {
        for (int i = 0; i < n; ++i) {
            used[inpl[i].second] = 1;
            ll csum = 0, count = 0;
            for (int j = 0; j < n; ++j) {
                if (used[in[j].second]) {
                    continue;
                }
                count++;
                csum = max(csum, count * in[j].first);
            }
            ans = max(ans, (i + 1) * inpl[i].first + csum);
        }
        cout << ans << endl;
    }

}