#include <iostream>
#include <algorithm>
#include <stack>
#include <vector>

using namespace std;
typedef long long ll;

#define size(v) ((int)v.size())
#define all(v) v.begin(), v.end()

const int maxn = 300000;
int a[maxn], n, ls[maxn];

const int ts = 1 << 19;
pair<int, int> st[2 * ts];

pair<int, int> mx(int l, int r) {
	pair<int, int> res = make_pair((int)1e9 + 7, -1);
	l += ts - 1;
	r += ts - 1;
	while (l <= r) {
		if (l & 1)
			res = max(res, st[l++]);
		if (!(r & 1))
			res = max(res, st[r--]);
		l >>= 1;
		r >>= 1;
	}
	return res;
}

signed main() {
	cin >> n;
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	fill(ls, ls + n, n);
	{
		stack<int> tmp;
		for (int i = n - 1; i > -1; --i) {
			while (!tmp.empty() && a[i] <= a[tmp.top()])
				tmp.pop();
			if (!tmp.empty())
				ls[i] = tmp.top();
			tmp.push(i);
		}
		for (int i = 0; i < n; ++i)
			st[i + ts] = make_pair(a[i], i);
		for (int i = ts - 1; i; --i)
			st[i] = max(st[i * 2], st[2 * i + 1]);
	}
	int ans = 0, ind = 0;
	while (ind < n) {
		++ans;
		int l = ind + 1, r = ls[ind];
		ind = mx(l, r).second + 1;
	}
	cout << ans;
	return 0;
}