#include <bits/stdc++.h>

#define f first
#define s second
#define pb push_back
#define mp make_pair
#define IO ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0)
#define all(a) (a).begin(), (a).end()

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

template<typename T1, typename T2> inline void chkmax(T1 & x, T2 y) {if (x < y) x = y;}

const int MAXN = 1e5 + 1;
int a[MAXN], b[MAXN];
int n;
vector<int> all_bs[MAXN];

ll solve() {
	vector<int> as(n), bs(n);
    unordered_map<int, int> cntB, cntA;
	for (int i = 0; i < n; ++i) {
        as[i] = a[i], bs[i] = b[i];
        cntA[a[i]]++;
        cntB[b[i]]++;
	}
    sort(all(as));
    sort(all(bs));
    int n1 = unique(all(as)) - as.begin();
    int n2 = unique(all(bs)) - bs.begin();
    unordered_map<int, int> da, db;
    for (int i = 0; i < n1; ++i)
        da[as[i]] = i;
    for (int i = 0; i < n2; ++i)
        db[bs[i]] = i;
    for (int i = 0; i < n; ++i)
        all_bs[da[a[i]]].pb(b[i]);

    vector<ll> val_b(n2);
    ll ccnt = 0;
    for (int i = n2 - 1; i >= 0; --i) {
        ccnt += cntB[bs[i]];
        val_b[i] = ccnt * bs[i];
    }
    //cout << n1 << endl;
    //for (int i = 0; i < n1; ++i)
      //  cout << as[i] << ' ';
    //cout << endl;
    ll ans = 0;
    ccnt = 0;
    for (int i = n1 - 1; i >= 0; --i) {
        //cout << "on " << i << ": ";
        ccnt += cntA[as[i]];
        for (int j : all_bs[i]) {
            //cout << j << ' ';
            for (int l = db[j]; l >= 0; --l)
                val_b[l] -= bs[l];
        }
        //cout << endl;
        for (int j = 0; j < n2; ++j) {
            //cout << j << ' ' << val_b[j] << endl;
            chkmax(ans, val_b[j] + ccnt * as[i]);
        }
        //cout << "\n---------------\n";
    }
    return ans;
}

void read() {
	cin >> n;
	for (int i = 0; i < n; ++i)
		cin >> a[i] >> b[i];
}

vector<ll> as;

ll get(int l, int r) {
    return (r - l + 1) * as[l];
}

ll solve1() {
    as.resize(n + 1);
    unordered_map<int, int> cntA;
	for (int i = 0; i < n; ++i) {
        as[i] = a[i];
        cntA[a[i]]++;
	}
	sort(all(as));
    int it = 0;
    ll ans = 0;
    for (int i = 0; i < n; ++i) {
        while (get(it, i) <= get(it + 1, i))
            ++it;
        if (get(it, i) < get(i, i))
            it = i;
        chkmax(ans, get(it, i) + get(i + 1, n));
    }
    return ans;
}

int main() {
    IO;
    //freopen("inputC.txt", "r", stdin);
    read();
   	cout << solve1();
    return 0;
}
