#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <algorithm>
#include <iomanip>
#define ll long long
#define null NULL

using namespace std;

const int mx = 4e5;
int n, a[mx];

int get(int l, int r) {
	if (l > r)
		return 0;
	int pos1 = -1, pos2 = -1;
	for (int i = l; i <= r; ++i) {
		if (pos2 == -1 || a[i] >= a[pos2])
			pos2 = i;
	}
	//cout << "pos2 = " << pos2 << endl;
	if (pos2 == r) {
		for (int i = r; i >= l; --i) {
			if (pos1 == -1 || a[i] <= a[pos1])
				pos1 = i;
		}
		//cout << "pos1 = " << pos1 << endl;
		return get(l, pos1 - 1) + 1;
	}
	return get(l, pos2) + get(pos2 + 1, r);
}

int main() {
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	cout << get(0, n - 1) << endl;
}