#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef vector<int> vi;
typedef pair<int, int> pii;

#define inb push_back
#define X first
#define Y second
#define all(v) (v).begin(), (v).end()

const int M = 4e5 + 5;

int n, p, a[M], ans[M], mx[M], mn[M], d[M], bans[M];

void check(int msk)
{
	int l = 0, r = 0;
	for (int j = 0; j < n; ++j)
		if (msk & (1 << j))
			d[l++] = j;
	for (int i = 0; i < n; ++i)
	{
		if (msk & (1 << i)) ++r;
		int x = n;
		if (r) x = min(x, abs(i - d[r - 1]));
		x = min(x, abs(i - d[r]));
		ans[i] = x + a[i];
		bans[i] = ans[i];
	}
	sort(bans, bans + n);
	for (int i = 0; i < n; ++i)
	{
		int x = lower_bound(bans, bans + n, ans[i]) - bans;
		mx[i] = max(mx[i], x);
	}
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> p;
	for (int i = 0; i < n; ++i) cin >> a[i];

	fill(mn, mn + n, n);
	if (p == 1)
	{
		vi bans, dans, gans;
		for (int j = 0; j < n; ++j)
		{
			int x = j;
			ans[j] = x + a[j];
			bans.inb(ans[j]);
		}
		sort(all(bans));
		int x = lower_bound(all(bans), ans[0]) - bans.begin();
		mn[0] = x;
		int bal = 0, dal = 0;
		for (int i = 1, x; i < n; ++i)
		{
			dans.inb(ans[i - 1] - bal - dal);
			sort(all(dans));
			++bal;
			dal++;
			x = lower_bound(all(dans), ans[i] - bal - dal) - dans.begin();
			gans.clear();
			bool f = 0;
			for (int x : bans)
				if (x == ans[i - 1] && !f)
					f = 1;
				else
					gans.inb(x);
			swap(bans, gans);
			x += lower_bound(all(bans), ans[i]) - bans.begin();
			mn[i] = x;
		}
		for (int i = 0; i < n; ++i)
			cout << mn[i] + 1 << '\n';
		exit(0);
	}

	for (int i = 1; i < (1 << n); ++i)
		check(i);
	for (int i = 0; i < n; ++i)
		cout << mx[i] + 1 << '\n';
}