#include <iostream>
#include <vector>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <string>
#include <ctime>
#include <cstring>
#include <bitset>

#define fi first
#define se second

using namespace std;
const int MAXN = 1e5 + 100;

int n;
pair<int, int> mas[MAXN];
map<long long, vector<int>> mp;
bitset<MAXN> used;

long long f(int x){
    long long d = 0;
    long long s = 0;
    long long pind = 0;
    long long ans = 0;

    vector<long long> vec;

    for (int i = 0; i < n; ++i){
        if (!used[i]){
            vec.push_back(mas[i].se);
            d++;
        }
    }

    sort(vec.begin(), vec.end());

    for (auto e : vec){
        if (e > x){
            return ans;
        }

        s += (e - pind) * d;
        ans = max(ans, s);
        s -= e;
        d--;
        pind = e;
    }

    return ans;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    cin >> n;

    for (int i = 0; i < n; ++i){
        cin >> mas[i].fi >> mas[i].se;
        mp[-mas[i].se].push_back(i);
        mp[-mas[i].fi].push_back(i);
    }

    long long ans = 0;
    long long cnt = 0;
    for (auto e1 : mp){
        for (auto e2 : e1.se){
            if (used[e2] == 0){
                used[e2] = 1;
                cnt++;
            } else {
                used[e2] = 0;
                cnt--;
            }
        }

        /*cout << endl <<  -e1.fi << endl;
        for (int i = 0; i < n; ++i){
            cout << used[i];
        }
        cout << endl;
        cout << cnt << ' ' << f(el.fi) << endl;*/

        ans = max(ans, cnt * (-e1.fi) + f(-e1.fi));
    }

    cout << ans << endl;

    return 0;
}

/*
5
80 20
60 50
40 40
15 10
70 30
*/
