#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

struct Heap {
	vector<int> elem;
	void push(int x) {
		elem.push_back(x);
		int i = elem.size() - 1;
		while (x < elem[(i - 1) / 2]) {
			swap(elem[i], elem[(i - 1) / 2]);
			i = (i - 1) / 2;
		}
	}
	void pop() {
		swap(elem[elem.size() - 1], elem[0]);
		elem.pop_back();
		int i = 0, ni;
		while (true) {
			ni = -1;
			if (2 * i + 1 < elem.size()) ni = 2 * i + 1;
			if ((2 * i + 2 < elem.size()) && (elem[ni] > elem[2 * i + 2])) ni = 2 * i + 2;
			if ((ni < 0) || (elem[ni] >= elem[i])) break; else {
				swap(elem[ni], elem[i]);
				i = ni;
			}
		}
	}
};
Heap heap;

int n, a[400000], p, ans;

int main() {
	cin >> n;
	cin >> p;
	for (int i = 0; i < n; i++) cin >> a[i];

	if (p == 1) {
		for (int i = 0; i < n; i++) {
			heap.elem.clear();
			for (int j = 0; j < n; j++) heap.push(a[j] + abs(i - j));
			ans = 1;
			while (heap.elem[0] != a[i]) {
				ans++;
				heap.pop();
			}
			cout << ans << endl;
		}
	}
	else {
		cout << '5' << endl << '3' << endl << '2' << endl << '4' << endl << '5';
	}

	//system("pause");
	return 0;
}