#include <algorithm>
#include <ctime>
#include <cassert>
#include <vector>
#include <iostream>
#include <fstream>

using namespace std;

const int SZ = 500000000;
char mem[SZ];
int ptr = 0;
void* operator new(size_t n)
{
	ptr += n;
	if (ptr >= SZ)
		ptr = SZ / 2;
	return (void*)(mem + ptr - n);
}
void operator delete(void*){}

const int N = 1 << 10;

int inf = 2e9;


struct it
{
	vector<int> t[2 * N];
//	vector<int> gol[2 * N], gor[2 * N];
	void add(int x, int l, int r, int ind, int val)
	{
		t[x].push_back(val);
		if (r - l == 1)
			return;
		int m = (l + r) / 2;
		if (ind < m)
			add(2 * x, l, m, ind, val);
		else
			add(2 * x + 1, m, r, ind, val);
	}
	it()
	{
		for (int i = 2 * N - 1; i > 0; --i)
		{
			int sz = 1;
			if (i < N)
				sz = t[2 * i].capacity() * 2;
			t[i].reserve(sz);
//			gol[i].reserve(sz);
//			gor[i].reserve(sz);
		}
	}
	void build()
	{
		for (int i = 0; i < 2 * N; ++i)
			sort(t[i].begin(), t[i].end());
		/*
		for (int i = 0; i < N; ++i)
		{
			gol[i].resize(t[i].size());
			gor[i].resize(t[i].size());
			for (int j = 0; j < t[i].size(); ++j)
			{
				int ind = lower_bound(t[2 * i].begin(), t[2 * i].end(), t[i][j]) - t[2 * i].begin();
				gol[i][j] = ind;
				ind = lower_bound(t[2 * i + 1].begin(), t[2 * i + 1].end(), t[i][j]) - t[2 * i + 1].begin();
				gor[i][j] = ind;
			}
		}
		*/
	}
	int getcnt(int x, int l, int r, int ql, int qr, int from, int to)
	{
		if (l >= qr || ql >= r)
			return 0;
		if (ql <= l && r <= qr)
			return lower_bound(t[x].begin(), t[x].end(), to) - t[x].begin();
		int m = (l + r) / 2;
		return getcnt(2 * x, l, m, ql, qr, from, to) + getcnt(2 * x + 1, m, r, ql, qr, from, to);
	}
};

#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;

typedef tree<int, bool , less<int>, rb_tree_tag, tree_order_statistics_node_update> mytree;

int main()
{
	ios::sync_with_stdio(false);
	int n;
	cin >> n;
	int p;
	cin >> p;
	vector<int> a(n);
	for (auto& x : a)
		cin >> x;
	/*
	it plus, minus;
	for (int i = 0; i < n; ++i)
	{
		plus.add(1, 0, n, i, a[i] + i);
		minus.add(1, 0, n, i, a[i] - i);
	}
	plus.build();
	minus.build();
	*/
	mytree plus, minus;
	if (p == 1)
	{
		for (int i = 0; i < n; ++i)
			plus.insert(make_pair(a[i] + i, 0));
		for (int i = 0; i < n; ++i)
		{
			int ans = 0;
			int ans1 = plus.order_of_key(a[i] + i);
			ans += ans1;
			ans += minus.order_of_key(a[i] - i);
			plus.erase(a[i] + i);
			minus.insert(make_pair(a[i] - i, 0));
			cout << ans + 1 << '\n';
		}
	}
	else
	{
		/*
		it mem;
		for (int i = 0; i < n; ++i)
			mem.add(1, 0, n, i, a[i]);
		mem.build();
		for (int i = 0; i < n / 2; ++i)
		{
//			int my1 = a[i] + n - i - 1;
			int ans1 = minus.getcnt(1, 0, n, 0, n, -inf, a[i] - i);
			int ans2 = plus.getcnt(1, 0, n, 0, i, -inf, a[i] + i);
			ans2 += minus.getcnt(1, 0, n, i, 2 * i, -inf, a[i] - i);
			ans2 += mem.getcnt(1, 0, n, 2 * i, n, -inf, a[i] + i);
			cout << max(ans1, ans2) + 1 << '\n';
		}
		for (int i = n / 2; i < n; ++i)
		{
			int my1 = a[i] + i;
			int ans1 = plus.getcnt(1, 0, n, 0, n, -inf, my1);
			int ans2 = minus.getcnt(1, 0, n, i + 1, n, -inf, a[i] - i);
			int act = i - (n - i - 1);
			ans2 += plus.getcnt(1, 0, n, act, i, -inf, a[i] + i);
			ans2 += mem.getcnt(1, 0, n, 0, act, -inf, a[i] + (n - i - 1));
			cout << max(ans1, ans2) + 1 << '\n'; 
		}
		*/
	}
	cerr << clock() << '\n';
}
