#include <iostream>
#include <vector>

using namespace std;

const int SZ = 2e5 + 10;

int n, m, q;

int max_in_str[SZ];
int max_in_stolb[SZ];
int is_str[SZ];
int is_stolb[SZ];

int cnt = 0;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin >> n >> m >> q;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            int a;
            cin >> a;
            max_in_str[i] = max(max_in_str[i], a);
            max_in_stolb[j] = max(max_in_stolb[j], a);
        }
    }
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            if (max_in_str[i] == max_in_stolb[j]) {
                is_str[i] = j;
                is_stolb[j] = i;
                cnt++;
            }
        }
    }
    for (int i = 0; i < q; i++) {
        int x, y, now;
        cin >> x >> y >> now;
        if (now > max_in_str[x] && now > max_in_stolb[y]) {
            cnt++;
            max_in_str[x] = now;
            max_in_stolb[y] = now;
            if (is_str[x] != 0) {
                cnt--;
                is_stolb[is_str[x]] = 0;
                is_str[x] = 0;
            }
            if (is_stolb[y] != 0) {
                cnt--;
                is_str[is_stolb[y]] = 0;
                is_stolb[y] = 0;
            }
            is_str[x] = y;
            is_stolb[y] = x;
        }
        else if (now > max_in_str[x]) {
            max_in_str[x] = now;
            if (is_str[x] != 0) {
                cnt--;
                is_stolb[is_str[x]] = 0;
                is_str[x] = 0;
            }
        }
        else if (now > max_in_stolb[y]) {
            max_in_stolb[y] = now;
            if (is_stolb[y] != 0) {
                cnt--;
                is_str[is_stolb[y]] = 0;
                is_stolb[y] = 0;
            }
        }
        cout << cnt << "\n";
    }
    return 0;
}
