#include <iostream>
#include <vector>

using namespace std;

const int SZ = 3e3 + 10;

int n;
int arr[SZ];

vector<pair<int, int> > ans;

void make(int L, int R)
{
    vector<int> vect;
    for (int i = L + 1; i <= R; i += 2)
        vect.push_back(arr[i]);
    for (int i = L; i <= R; i += 2)
        vect.push_back(arr[i]);
    for (int i = 0; i < vect.size(); i++)
        arr[L + i] = vect[i];
    vect.clear();
}

int there(int numb)
{
    for (int i = 1; i <= n; i++)
        if (arr[i] == numb)
            return i;
}

void action(int numb)
{
    vector<int> vect;
    int ind = there(numb);
    int len = ind - numb;
    int now = 1;
    while (len > 0) {
        if (len & 1)
            vect.push_back(now);
        now <<= 1;
        len >>= 1;
    }
    for (int i = 0; i < vect.size(); i++) {
        int step = vect[i];
        if (ind - step * 2 + 1 >= numb) {
            ans.push_back({ind - step * 2 + 1, ind});
            ind -= step;
        }
        else {
            vect.push_back(step / 2);
            vect.push_back(step / 2);
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n;
    for (int i = 1; i <= n; i++)
        cin >> arr[i];
    for (int numb = 1; numb <= n; numb++)
        action(numb);
    cout << ans.size() << "\n";
    for (auto h : ans)
        cout << h.first << ' ' << h.second << "\n";
    return 0;
}
