#include <bits/stdc++.h>

using namespace std;

const int MAX_ANS_SIZE = 15000;
const int MAXN = 3010;
int n;
vector<int> a;

bool ok(const vector<int> &b) {
    for (int i = 0; i < n; i++)
        if (b[i] != i + 1)
            return false;
    return true;
}

void make(vector<int> &b) {
    vector<int> new_b;
    for (int i = 1; i < n; i += 2)
        new_b.push_back(b[i]);
    for (int i = 0; i < n; i += 2)
        new_b.push_back(b[i]);
    b = new_b;
}

int main() {
    #ifdef DEBUG
    assert(freopen("input.txt", "r", stdin));
    assert(freopen("output.txt", "w", stdout));
    #endif // DEBUG
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    vector<pair<int, int>> ans;
    vector<int> b(a);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j + 1 < n; j++) {
            if (b[j] > b[j + 1]) {
                swap(b[j], b[j + 1]);
                ans.push_back({j, j + 1});
            }
        }
    }
    if (ans.size() > MAX_ANS_SIZE) {
        ans.clear();
        vector<int> b(a);
        while (!ok(b)) {
            make(b);
            ans.push_back({0, n - 1});
        }
    }
    cout << ans.size() << "\n";
    for (auto i : ans) {
        cout << i.first + 1 << " " << i.second + 1 << "\n";
    }
    return 0;
}
