#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
#include <set>
#include <sstream>

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;

int main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	int n, m, q;
	cin >> n >> m >> q;

	vector<vector<int>> val(n, vector<int>(m));
	vector<int> ma_s(n, -1), ma_c(m, -1);

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> val[i][j];
			if (ma_s[i] == -1 || val[i][j] > val[i][ma_s[i]])
				ma_s[i] = j;
			if (ma_c[j] == -1 || val[i][j] > val[ma_c[j]][j])
				ma_c[j] = i;
		}
	}

	int cnt = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if (ma_s[i] == j && ma_c[j] == i)
				cnt++;
		}
	}

	for (int x = 0; x < q; x++) {
		int a, b, k;
		cin >> a >> b >> k;
		a--, b--;

		val[a][b] = k;
		bool c1 = false, c2 = false;
		bool w1 = (ma_c[ma_s[a]] == a), w2 = (ma_s[ma_c[b]] == b);
		if (k > val[a][ma_s[a]]) {
			ma_s[a] = b;
			c1 = true;
		}
		if (k > val[ma_c[b]][b]) {
			ma_c[b] = a;
			c2 = true;
		}

		if (!c1 && !c2)
			continue;
			
		if (c1 && c2) {
			cnt -= w1 + w2;
			cnt++;
		}
		else if (c1) {
			cnt -= w1;
			if (ma_s[a] == b && ma_c[b] == a)
				cnt++;
		}
		else {
			cnt -= w2;
			if (ma_s[a] == b && ma_c[b] == a)
				cnt++;
		}
		/*for (int i = 0; i < n; i++) {
			cout << ma_s[i] << ' ';
		}
		cout << endl;
		for (int i = 0; i < m; i++) {
			cout << ma_c[i] << ' ';
		}
		cout << endl << endl;*/
		cout << cnt << endl;
	}

	return 0;
}