#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
#include <set>
#include <sstream>

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;

int main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	int n, t;
	cin >> n;

	vector<vector<int>> p(n, vector<int> (n));

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			int x;
			cin >> x;
			x--;
			p[i][x] = j;
		}
	}
	cin >> t;

	vector<int> ans;
	for (int i = 0; i < n; i++) {
		bool f = false;
		for (int j = 0; j < n; j++) {
			if (p[j][i] == 0)
				f = true;
		}
		if (f)
			ans.push_back(i);
	}

	cout << ans.size() << endl;
	for (int i : ans)
		cout << i + 1 << ' ';

	return 0;
}