#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
#include <set>
#include <sstream>

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;

int n;

int main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	int t;
	cin >> n;

	vector<vector<int>> p(n, vector<int> (n));
	vector<vector<int>> l(n);

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			int x;
			cin >> x;
			x--;
			p[i][x] = j;
			l[i].push_back(x);
		}
	}
	cin >> t;

	vector<bool> stable(n, false);

	for (int i = 0; i < n; i++) {
		if (p[i][i] == 0) {
			stable[i] = true;
		}
	}

	if (t == 1) {
		vector<int> ans;
		
		for (int i = 0; i < n; i++) {
			if (stable[i])
				ans.push_back(i);
		}
		cout << ans.size() << endl;
		for (int i : ans)
			cout << i + 1 << ' ';
		return 0;
	}

	vector<int> ans;

	vector<vector<bool>> can(n, vector<bool> (n));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (p[i][j] <= p[i][i])
				can[i][j] = true;
		}
	}

	for (int i = 0; i < n; i++) {
		for (int left = 0; left < n; left++) {
			if (p[left][left] < p[left][i])
				continue;
			vector<bool> able(n, false);
			for (int j = p[left][left]; j < n; j++) {
				int x = l[left][j];
				for (int k = 0; k < n; k++) {
					if (can[k][x])
						able[k] = true;
				}
			}
			bool ok = true;
			for (bool x : able)
				ok &= x;
			if (ok) {
				ans.push_back(i);
			}
		}
	}
	ans.resize(unique(ans.begin(), ans.end()) - ans.begin());
	cout << ans.size() << endl;
	for (int i : ans)
		cout << i + 1 << ' ';

	return 0;
}