#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <cstdio>
#include <algorithm>

using namespace std;

const int INF = 1e9 + 5;

vector<pair<int, int>> ans;

void s(int l, int r, vector<int> &v) {
	vector<int> ans(r - l);
	int cnt = 0;
	for (int i = l + 1; i < r; i += 2) {
		ans[cnt++] = v[i];
	}
	for (int i = l; i < r; i += 2) {
		ans[cnt++] = v[i];
	}
	for (int i = l; i < r; i++)
		v[i] = ans[i - l];
}

void move(int l, int p, vector<int> &v) {
	while (p > l) {
		ans.push_back({p - 1, p});
		swap(v[p - 1], v[p]);
		p--;
	}
}

int main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	int n;
	cin >> n;

	vector<int> v(n);

	for (int i = 0; i < n; i++)
		cin >> v[i];

	for (int i = 0; i < n; i++) {
		int p = -1;
		for (int j = i; j < n; j++) {
			if (v[j] - 1 == i) {
				p = j;
				break;
			}
		}
		move(i, p, v);
	}

	cout << ans.size() << endl;
	for (int i = 0; i < ans.size(); i++)
		cout << ans[i].first + 1 << ' ' << ans[i].second + 1 << endl;
	return 0;
}