#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> Tree;
typedef long long ll;
typedef long double ld;
const ll INF = 1e18;




const int32_t N = 300001;

ll t[N];

void upd1(int pos, ll cnt)
{
  //  cout << "change " << pos << ' ' << cnt << endl;
    for (;pos < N; pos |= (pos + 1))
        t[pos] += cnt;
}

ll findsum(int i)
{
    ll ans = 0;
   // cout << "find " << i;
    for (;i >= 0; i = ((i & (i + 1)) - 1))
        ans += t[i];
   // cout << ' ' << ans << endl;
    return ans;
}

struct Line
{
    ll k, b;
    Line(ll k, ll b):
        k(k),
        b(b) {}
    ll operator()(ll x)
    {
        return x * k + b;
    }
};

ld f(ld l1k, ld l1b, ld l2k, ld l2b)
{
    return (ld)(l1b - l2b) / (ld)(l2k - l1k);
}

map<ll, ll> mapa, rev;
Tree q;
ll cnt[N];

void add(int i)
{
    ll curi = findsum(i);
    while (true)
    {
        auto it1 = q.lower_bound(i);
        if (it1 == q.end())
            break;
        auto it2 = q.lower_bound(i);
        it2++;
        if (it2 == q.end())
            break;
        ll curit1 = findsum(*it1);
        ll curit2 = findsum(*it2);
        ld x1 = f(curit1, cnt[*it1], curit2, cnt[*it2]);
        ld x2 = f(curi, cnt[i], curit1, cnt[*it1]);
        if (x2 >= x1)
            q.erase(it1);
        else
        {
            break;
        }
    }
    while (true)
    {
        auto it1 = q.lower_bound(i);
        if (it1 == q.begin())
            break;
        it1--;
        if (it1 == q.begin())
            break;
        auto it2 = q.lower_bound(i);
        it2--;
        it2--;
        ll curit1 = findsum(*it1);
        ll curit2 = findsum(*it2);
        ld x1 = f(curit1, cnt[*it1], curit2, cnt[*it2]);
        ld x2 = f(curi, cnt[i], curit1, cnt[*it1]);
        if (x2 <= x1)
            q.erase(it1);
        else
        {
            break;
        }
    }
    bool ok = 1;
    auto it1 = q.lower_bound(i);
    if (it1 != q.end() && it1 != q.begin())
    {
        auto it2 = q.lower_bound(i);
        it2--;
        ll curit1 = findsum(*it1);
        ll curit2 = findsum(*it2);
        ld x2 = f(curi, cnt[i], curit2, cnt[*it2]);
        ld x1 = f(curit1, cnt[*it1], curit2, cnt[*it2]);
        if (x2 >= x1)
            ok = false;
    }
    if (ok)
        q.insert(i);
    /*else
    {
        auto it = q.lower_bound(i);
        if (it == q.end())
            return;
        int tau = *it;
        q.erase(it);
        add(tau);
    }*/
}

ll findmax(ll x, ll kek)
{
    ll ans = 0;
    int l = 0, r = q.size();
    while (r - l > 1)
    {
        int mid = (r + l) / 2;
        auto it1 = q.find_by_order(mid);
        auto it2 = q.find_by_order(mid);
        it2--;
        ll curit1 = findsum(*it1);
        ll curit2 = findsum(*it2);
        ld x1 = f(curit1, cnt[*it1], curit2, cnt[*it2]);
        if (x1 <= (ld)x)
            l = mid;
        else
            r = mid;
    }
    auto it1 = q.find_by_order(l);
 //   if (*it1 < kek)
    //    it1 = q.lower_bound(kek);
    ans = max(ans, (ll)cnt[*it1] + x * (ll)findsum(*it1));
    if (it1 != q.begin())
    {
        it1--;
    //    if (*it1 >= kek)
            ans = max(ans, (ll)cnt[*it1] + x * (ll)findsum(*it1));
        it1++;
    }
    it1++;
    if (it1 != q.end())
        ans = max(ans, (ll)cnt[*it1] + x * (ll)findsum(*it1));
    for (int i : q)
        if (i >= kek)
            ans = max(ans, (ll)cnt[i] + x * (ll)findsum(i));
    return ans;
}

void upd(int pos, int tt)
{
    upd1(pos, tt);
    if (findsum(pos) == findsum(pos - 1))
    {
        auto it = q.lower_bound(pos);
        if (it != q.begin())
        {
            it--;
            q.erase(it);
        }
    }
    q.erase(pos);
  //  add(pos);
    q.insert(pos);
}

void func(int t)
{
    for (int i = 0; i < t; i++)
        q.insert(i);
}

int solve()
{
    int n;
    if (!(cin >> n))
        return 1;
     //for (int i = 0; i < n; i++)
      //  q.insert(i);
    vector<pair<int, int> > q(n);
    for (int i = 0; i < n; i++)
        cin >> q[i].second >> q[i].first;
    sort(q.begin(), q.end());
    ll ans = 0;
    vector<ll> a(n), b(n);
    ll minn = 1e18, minb = 1e18;
    for (int i = 0; i < n; i++)
        a[i] = q[i].second, b[i] = q[i].first, minn = min(minn, a[i]), minb = min(minb, b[i]);
    ans = max(minn, minb) * (ll)n;
    set<int> kek;
    for (int i : a)
        kek.insert(i);
    int cur = 0;
    for (int i : kek)
    {
        mapa[i] = cur;
        rev[cur] = i;
        cur++;
    }
    map<int, int> num;
    for (int i : a)
        num[mapa[i]]++;
    ll curcnt = 0;
    for (int i = kek.size() - 2; i >= 0; i--)
    {
        curcnt += num[i + 1];
        cnt[i] = (ll)curcnt * rev[i + 1];
    }
    for (int i = kek.size() - 2; i >= 0; i--)
        cnt[i] = max(cnt[i], cnt[i + 1]);
    for (int i = n - 1; i >= 0;)
    {
        int j = i;
        while (j >= 0 && b[j] == b[i])
        {
            upd(mapa[a[j]], 1);
            j--;
        }
        int lul = mapa[*kek.lower_bound(b[i])];
       // ans = max(ans, findmax(b[i], lul));
        i = j;
    }
 //   func(kek.size());
    for (int i = 0; i < n;)
    {
        int j = i;
        while (j < n && b[j] == b[i])
        {
            //upd(mapa[a[j]]);
            j++;
        }
        int lul = mapa[*kek.lower_bound(b[i])];
        ans = max(ans, findmax(b[i], lul));
        //upd1(mapa[a[i]], -(j - i));
        for (int k = i; k < j; k++)
            upd(mapa[a[k]], -1);
        i = j;
    }
    cout << ans << endl;
    return 0;
}

int32_t main()
{
    #ifdef ONPC
    freopen("in.txt", "r", stdin);
    #endif // ONPC
    for (int i = 1;; i++)
    {
        #ifdef ONPC
            cout << "Test #" << i << ":\n";
        #endif // ONPC
        if (solve())
            break;
        #ifdef ONPC
            cout << "_________" << endl;
        #endif // ONPC
    }
    #ifdef ONPC
        cout << "finished in " << clock() * 1000LL / CLOCKS_PER_SEC << " ms" << endl;
    #endif
    return 0;
}

