#include <iostream>
#include <algorithm>
#include <bitset>
using namespace std;
bitset<600> dist[600];
long kn[500][2];
long par[500];
bool vis[500];
long n,m,k;
long dst(long a,long b){
    return max(max(kn[a][0]-kn[b][0],kn[b][0]-kn[a][0]),max(kn[a][1]-kn[b][1],kn[b][1]-kn[a][1]));
}
bitset<600> sum(bitset<600> a, bitset<600> b){
    bitset<600> ans;
    int bs=0;
    for (int i = 0; i < 600; ++i) {
        bs+=a[i];
        bs+=b[i];
        if(bs==0) {
            ans[i]=0;
            continue;
        }
        else if(bs==1)
            ans[i]=1,bs=0;
        else if(bs==2)
            ans[i]=0,bs=1;
        else if(bs==3)
            ans[i]=1,bs=1;
    }
    return ans;
}
bitset<600> sum(bitset<600> a, long pow2){
    bitset<600> ans;
    int bs=0;
    bs=1;
    for (int j = 0; j < pow2; ++j) {
        ans[j]=a[j];
    }
    for (int i = pow2; i < 600; ++i) {
        bs+=a[i];
        if(bs==0) {
            ans[i]=0;
            continue;
        }
        else if(bs==1)
            ans[i]=1,bs=0;
        else if(bs==2)
            ans[i]=0,bs=1;
        else if(bs==3)
            ans[i]=1,bs=1;
    }
    return ans;
}

bool better(bitset<600> a, bitset<600> b){
    for (int i = 599; i >=0; --i) {
        if(a[i]!=b[i]){
            if(a[i]==1){
                return true;
            }
            else
                return false;
        }
    }
}
void dfs(long v){
    vis[v]=true;
    for (int i = 0; i < k; ++i) {
        bitset<600> res=sum(dist[v],dst(v,i));
        if(better(dist[i],res) or !vis[i]){
            dist[i]=res;
            par[i]=v;
            dfs(i);
        }
    }
}
void print(long v,long c=1){
    if(v==0){
        cout << c << "\n";
        cout << v+1 << " ";
        return;
    }
    print(par[v],c+1);
    cout << v+1 << " ";
}
int main() {
    cin >> n >> m >> k;
    for (int i = 0; i < k; ++i) {
        cin >> kn[i][0] >> kn[i][1];
    }
    dfs(0);
    print(k-1);
}