#include <iostream>
#include <cmath>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>

using namespace std;

int main()
{
	ios_base::sync_with_stdio(0);

	int n;
	cin >> n;

	vector<vector<int>> bact (n, vector<int>(n));
	for (int j = 0; j < n; j++)
	{
		for (int i = 0; i < n; i++)
		{
			int temp;
			cin >> temp;
			bact[j][i] = temp - 1;
		}
	}

	int p;
	cin >> p;

	if (p == 1)
	{
		vector<int> good;
		for (int i = 0; i < n; i++)
		{
			if (bact[i][0] == i)
				good.push_back(i + 1);
		}
		cout << good.size() << endl;
		for (int i = 0; i < good.size(); i++)
			cout << good[i] << ' ';
		cout << endl;
	}
	else
	{
		vector<int> good;
		for (int i = 0; i < n; i++)
		{
			bool ok = true;
			for (int j = 0; j < n; j++)
			{
				if (j == i)
					continue;
				if (bact[j][0] == j)
				{
					for (int k = 0; k < n; k++)
					{
						if (bact[i][k] == j)
						{
							ok = false;
							break;
						}
						else if (bact[i][k] == i)
							break;
					}
				}
				if (ok == false)
					break;
			}
			if (ok)
			{
				good.push_back(i + 1);
			}
		}
		cout << good.size() << endl;
		for (int i = 0; i < good.size(); i++)
			cout << good[i] << ' ';
		cout << endl;
	}

	system("pause");
	return 0;
}