#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <queue>

using namespace std;

#define X first
#define Y second

const long long MAXN = 1100, INF = 10000000;
long long n, m, k, x[MAXN], y[MAXN];
long long d[MAXN];
bool used[MAXN];
long long pr[MAXN];
vector<long long> ans;

struct kek
{
	pair<int, int> s;
	kek(pair<int, int> a)
	{
		s = a;
	}
	kek()
	{
		s = { 0, 0 };
	}
};

bool operator > (const kek &A, const kek &B)
{
	return A.s > B.s;
}

bool operator < (const kek &A, const kek &B)
{
	return A.s < B.s;
}


long long ras(int a, int b)
{
	return max(abs(x[a] - x[b]), abs(y[a] - y[b]));
}


int main()
{
#if _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin >> n >> m >> k;
	for (int i = 0; i < k; i++)
	{
		d[i] = INF;
		cin >> x[i] >> y[i];
	}
	d[0] = 0;
	priority_queue<kek> q;
	q.push(kek({ 0, 0 }));
	pr[0] = -1;
	while (q.size() > 0)
	{
		pair<int, int> tc = q.top().s;
		q.pop();
		if (used[tc.Y])
			continue;
		used[tc.Y] = true;
		for (int i = 0; i < k; i++)
		{
			if (d[i] > d[tc.Y] + (1ll << ras(i, tc.Y)))
			{
				d[i] = d[tc.Y] + (1ll << ras(i, tc.Y));
				pr[i] = tc.Y;
				q.push(kek({ -d[i], i }));
			}
		}
	}
	int tc = k - 1;
	while (tc != -1)
	{
		ans.push_back(tc + 1);
		tc = pr[tc];
	}
	reverse(ans.begin(), ans.end());
	cout << ans.size() << endl;
	for (int i : ans)
		cout << i << " ";
	return 0;
}