#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define X first
#define Y second

const int MAXN = 3010;

int n;
int a[MAXN], p;

int kalma(int v, int d)
{
	int ans = 0;
	for (int i = 0; i < n; i++)
	{
		if (a[i] + abs(i - d) < a[v] + abs(v - d))
			ans++;
	}
	return ans + 1;
}

int fimi(int v)
{
	int ans = n;
	for (int i = 0; i < n; i++)
	{
		if (v - i >= 0)
			ans = min(ans, kalma(v, v - i));
		if (v + i < n)
			ans = min(ans, kalma(v, v + i));
	}
	return ans;
}

int main()
{
#if _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin >> n >> p;
	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
	}
	for (int i = 0; i < n; i++)
	{
		if (p == 1)
		{
			cout << fimi(i) << endl;
		}
		else
		{
			//cout << fima(i) << endl;
		}
	}

	return 0;
}