#include<bits/stdc++.h>
#define int long long
#define endl '\n'
#define all(a) (a).begin(), (a).end()
#define dbg(a) cout << #a << ' ' << (a) << endl
using namespace std;
void solve();
signed main(){
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    solve();
    return 0;
}


void solve(){
    int n; cin >> n;
    vector<vector<int>> rank(n, vector<int>(n));
    vector<vector<int>> plac(n, vector<int>(n));
    for (int i = 0; i < n; ++i){
        int v;
        for (int j = 0; j < n; ++j) {
            cin >> v; v--;
            rank[i][v] = n - j - 1;
            plac[i][j] = v;
        }
    }
    int p; cin >> p;
    if (p == 1) {
        vector<bool> stable(n, true);

        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                if (i == j) continue;
                if (rank[i][j] > rank[i][i])
                    stable[i] = false;
            }
        }


        cout << count(all(stable), true) << endl;
        for (int i = 0; i < n; ++i)
            if (stable[i])
                cout << i + 1 << ' ';
        cout << endl;
        return;
    }
    vector<bool> stoic(n, false);
    for (int i = 0; i < n; ++i){
        for (int j = 0; j < n; ++j){
            if (rank[i][j] < rank[i][i]) continue;
            bool good = true;
            for (int q = 0; q < n; ++q){
                if (q == i) continue;
                bool res = false;
                for (int h = 0; h < n; ++h){
                    if (rank[q][h] >= rank[q][q] && rank[i][h] <= rank[i][j])
                        res = true;
                }
                if (!res){
                    good = false;
                    break;
                }
            }
            if (good){
                stoic[i] = true;
                break;
            }
        }
    }
    cout << count(all(stoic), true) << endl;
    for (int i = 0; i < n; ++i)
        if (stoic[i])
            cout << i + 1 << ' ';
    cout << endl;
}