#ifndef LOCAL
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx,mmx,abm,popcnt,tune=native")
#endif // LOCAL
#include <bits/stdc++.h>
#define all(x) begin(x), end(x)
#define sz(x) ((int)(x).size())
#define fst first
#define snd second

using namespace std;
using ll = long long; using ull = unsigned ll; using ld = long double;
const int infi = 1e9+100; const ll infl = 1e18L+1000;

using num = set<int, greater<int>>;

num addp2(num a, int p) {
    while(a.count(p)) a.erase(p++);
    a.insert(p);
    return a;
}

int log2f(int x) {return 32 - __builtin_clz(x) - 1;}

const num infn = {1000000};

signed main() {
    #ifdef LOCAL
    ifstream cin("input.txt");
    //ofstream cout("output.txt");
    #endif // LOCAL
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0), cout << fixed << setprecision(10);
    int n, m, k; cin >> n >> m >> k;
    vector<pair<int, int>> a(k);
    for(auto &p : a) cin >> p.fst >> p.snd;
    vector<pair<num, int>> d(k, {infn, -1});
    d[0] = {num{}, -1};
    vector<char> vis(k);
    while(!vis[k-1]) {
        int u = -1;
        num pot{};
        for(int v = 0; v < k; ++v)
        {
            int pw = max(n-a[v].fst, m-a[v].snd);
            num npot = pw ? addp2(d[v].fst, log2f(pw)) : d[v].fst;
            if (!vis[v] && (u == -1 || npot < pot)) u = v, pot = npot;
        }
        vis[u] = 1;
        for(int v = 0; v < k; ++v) if (!vis[v]) {
            num cur = addp2(d[u].fst, max(abs(a[u].fst-a[v].fst), abs(a[u].snd-a[v].snd)));
            if (cur < d[v].fst) d[v].fst = cur, d[v].snd = u;
        }
    }
    vector<int> ans;
    for(int i = k-1; i != -1; i = d[i].snd) ans.push_back(i);
    reverse(all(ans));
    cout << sz(ans) << '\n';
    for(int x : ans) cout << x+1 << ' ';
}
