#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
const long long INF = 1e17;
using namespace std;

int main(){
    int n;
    cin >> n;
    vector <pair <long long, long long> > v(n);
    for (int i = 0; i < n; i++){
        long long x, y;
        cin >> x >> y;
        v[i] = make_pair(x, y);
    }
    sort(v.begin(), v.end());

    long long gans = -INF;

    multiset <long long> s;
    for (int i = 0; i < n; i++){
        long long cans = v[i].first * (n - i);
        gans = max(gans, cans);
        int j = 0;
        for (set <long long> :: iterator it = s.begin(); it != s.end(); it++){
            long long elem = *it;
            gans = max(gans, cans + ((int)s.size() - j) * elem);
            j += 1;
        }
        s.insert(v[i].second);
    }

    long long cans = 0;
    gans = max(gans, cans);
    int j = 0;
    for (set <long long> :: iterator it = s.begin(); it != s.end(); it++){
        int elem = *it;
        gans = max(gans, cans + ((int)s.size() - j) * elem);
        j += 1;
    }

    cout << gans << endl;
}
