#include <iostream>
#include <vector>
#include <random>
using namespace std;


const int MAXN = 3001;
const int INF = 1e9 + 7;
int a[MAXN];

vector <pair <int, int> > ans;
int abs(int x){
    if (x < 0){
        return -x;
    }
    else{
        return x;
    }
}

int check(int L, int R){
    int f = 0;
    int pos = L;
    for (int i = L + 1; i <= R; i += 2){
        f += abs(a[i] - i) - abs(a[i] - pos);
        pos += 1;
    }
    for (int i = L; i <= R; i += 2){
        f += abs(a[i] - i) - abs(a[i] - pos);
        pos += 1;
    }
    return f;
}
void rev(int L, int R){
    ans.push_back(make_pair(L + 1, R + 1));
    //cout << L + 1 << ' ' << R + 1 << endl;
    if (L >= R){
        return;
    }
    vector <int> cur;
    for (int i = L + 1; i <= R; i += 2){
        cur.push_back(a[i]);
    }
    for (int i = L; i <= R; i += 2){
        cur.push_back(a[i]);
    }
    for (int i = L; i <= R; i++){
        a[i] = cur[i - L];
    }
}



int main(){
    int n;
    cin >> n;
    for (int i = 0; i < n; i++){
        cin >> a[i];
        a[i] -= 1;

    }

    for (int L = 0; L < n; L++){

        while (true){
            int mnid = -1;
            int mn = INF;
            for (int i = L; i < n; i++){
                if (mn > a[i]){
                    mn = a[i];
                    mnid = i;
                }
            }
            if (mnid == L){
                break;
            }
            int MXF = 0;
            int mxR = mnid;

            if ((mnid - L) % 2 == 1){
                for (int k = mnid; k < mnid + 100; k++){
                    int ck = rand() % (n - mnid) + mnid;
                    int cur = check(L, ck);
                    if (cur > MXF){
                        MXF = cur;
                        mxR = ck;
                    }
                }
                rev(L, mxR);

            }
            else{
                for (int k = mnid; k < mnid + 100; k++){
                    int ck = rand() % (n - mnid) + mnid;
                    int cur = check(L + 1, ck);
                    if (cur > MXF){
                        MXF = cur;
                        mxR = ck;
                    }
                }
                rev(L + 1, mxR);
            }
        }
        /*
        cout << "WOW" << ' ' << L << endl;
        for (int i = 0; i < n; i++){
            cout << a[i] << ' ';
        }
        cout << endl;
        */

    }
    cout << ans.size() << endl;
    for (int i = 0; i < ans.size(); i++){
        cout << ans[i].first << ' ' << ans[i].second << endl;
    }
}
