#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <bitset>
#include <set>
using namespace std;

typedef long long ll;
typedef long double ld;

#define all(x) x.begin(), x.end()

set <vector <int>> ms;
set < vector <int>> ans;
int n;
vector <vector <int>> best;

void rec(vector <int> cur)
{
	if (ms.count(cur))
	{
		return;
	}
	ms.insert(cur);
	bool changed = false;
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < n; j++)
		{
			if (i == j)
				continue;
			if (best[j][cur[j]] > best[j][cur[i]])
			{
				changed = true;
				int save = cur[j];
				cur[j] = cur[i];
				rec(cur);
				cur[j] = save;
			}
		}
	}
	if (!changed)
	{
		ans.insert(cur);
	}
}

signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int  p;
	cin >> n;
	best.resize(n, vector <int>(n));
	vector <vector <int>> al(n, vector <int>(n));
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < n; j++)
		{
			cin >> al[i][j];
			al[i][j]--;
			best[i][al[i][j]] = j;
		}
	}
	cin >> p;

	if (p == 1)
	{
		vector <int> Ans;
		for (int i = 0; i < n; i++)
		{
			if (best[i][i] == 0)
			{
				Ans.push_back(i);
			}
		}
		cout << Ans.size() << endl;
		for (int i = 0; i < Ans.size(); i++)
		{
			cout << Ans[i] + 1 << " ";
		}
	}
	else
	{
		vector <int> B(n);
		for (int i = 0; i < n; i++)
		{
			B[i] = i;
		}
		rec(B);
		vector <int> Ans;
		for (int i = 0; i < n; i++)
		{
			bool flag = false;
			for (auto it = ans.begin(); it != ans.end(); it++)
			{
				vector <int> cur = *it;
				for (int z = 0; z < cur.size(); z++)
				{
					if (cur[z] == i)
					{
						flag = true;
						break;
					}
				}
				if (flag)
					break;
			}
			if (flag)
				Ans.push_back(i + 1);
		}
		cout << Ans.size() << endl;
		for (int i = 0; i < Ans.size(); i++)
		{
			cout << Ans[i] << " ";
		}
		return 0;
	}
	return 0;
}