#include <iostream>
#include <vector>
#define int long long

using namespace std;

vector<int> hor, ver;
vector<vector<int>> table;
int n, m, q;

signed main() {
    cin.sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> m >> q;
    hor.resize(n);
    ver.resize(m);
    table.resize(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> table[i][j];
        }
    }
    for (; q > 0; q--) {
        int a, b, v;
        cin >> a >> b >> v;
        a--, b--;
        table[a][b] = v;
        int ans = 0;
        hor.clear();
        ver.clear();
        hor.resize(n);
        ver.resize(m);
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                hor[i] = max(hor[i], table[i][j]);
                ver[j] = max(ver[j], table[i][j]);
            }
        }
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (table[i][j] == hor[i] && table[i][j] == ver[j]) {
                    ans++;
                }
            }
        }
        cout << ans << "\n";
        /*if (table[a][b] == max(hor[a], ver[b])) {
            table[a][b] += v;
            hor[a] += v;
            ver[b] += v;
        } else {
            table[a][b] += v;
            int z = 0;
            if (p1[a] == b) {
                hor[a] += v;
                z++;
            } else {
                if (hor[a] < table[a][b]) {
                    hor[a] = table[a][b];
                    if (inans[a][p1[a]]) {
                        inans[a][p1[a]] = 0;
                        ans--;
                    }
                    p1[a] = b;
                    z++;
                }
            }
            if (p2[b] == a) {
                ver[b] += v;
                z++;
            } else {
                if (ver[b] < table[a][b]) {
                    ver[b] = table[a][b];
                    if (inans[p2[b]][b]) {
                        inans[p2[b]][b] = 0;
                        ans--;
                    }
                    p2[b] = a;
                    z++;
                }
            }
            if (z == 2) {
                if (!inans[a][b]) {
                    inans[a][b] = 1;
                    ans++;
                }
            }
        }
        cout << ans << "\n";*/
    }
    return 0;
}