#pragma GCC optimize("O3")
#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define mp make_pair
#define endl '\n'

template <typename T1, typename T2>
ostream & operator << (ostream & out, pair <T1, T2> p) {
    out << p.fi << ' ' << p.se;
    return out;
}

template <typename T1, typename T2>
istream & operator >> (istream & in, pair <T1, T2> & p) {
    in >> p.fi >> p.se;
    return in;
}

template <typename T>
ostream & operator << (ostream & out, vector <T> arr) {
    for (auto x : arr)
        out << x << endl;
    out << endl;
    return out;
}

template <typename T>
istream & operator >> (istream & in, vector <T> & arr) {
    for (auto & x : arr)
        in >> x;
    return in;
}

vector <pair <int, int> > ans;

void op(vector <int> & arr, int l, int r, int & j) {
    vector <int> arr2 = arr;
    ans.push_back(mp(l + 1, r));
    int it = l;
    for (int i = l + 1; i < r; i += 2) {
        if (i == j)
            j = it;
        arr2[it++] = arr[i];
    }
    for (int i = l; i < r; i += 2) {
        arr2[it++] = arr[i];
    }
    arr = arr2;
}

void solve(vector <int> & arr, int l, int r) {
    if (r - l < 2)
        return;
    int m = (r + l) / 2;
    solve(arr, l, m);
    solve(arr, m, r);
    auto arr2 = vector <int> (arr.begin() + l, arr.begin() + r);
    sort(arr2.begin(), arr2.end());
    //cout << "arr = " << arr << endl;
    //cout << l << " " << r << endl;
    //cout << "arr2 = " << arr2 << endl;
    for (int i = 0; i < r - l; ++i) {
        int j = i;
        while (arr[j + l] != arr2[i])
            ++j;
        //cout << j << endl;
        while (j != i) {
            if ((j - i) % 2 == 1) {
                int a = j + l;
                op(arr, i + l, j + l + 1, a);
                j = a - l;
            }
            else {
                int a = j + l;
                op(arr, i + l + 1, j + l + 1, a);
                j = a - l;
            }
        }
    }
}

signed main()
{
    //ios::sync_with_stdio(false);
    //cin.tie(0);
    //cout.tie(0);

    int n;
    cin >> n;
    vector <int> arr(n);
    cin >> arr;
    solve(arr, 0, n);
    cout << ans.size() << endl;
    cout << ans << endl;
    return 0;
}
