#pragma GCC optimize("Ofast")
#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <random>
#include <string>
#include <time.h> 
#include <algorithm>
#define int long long
#define pb push_back 
#define mp make_pair
#define pii pair<int, int>
#define ff first 
#define ss second
#define all(x) x.begin(), x.end()  

using namespace std;
const int maxn = 3e5, inf = 1e18;
int n, p, cnt[maxn];

int get1(string &s1, int id) {
	int time1 = inf; 
	for (int i = 0; i < n; ++i) {
		if (s1[i] == '0') continue;
		time1 = min(time1, abs(id - i) + cnt[id]); 
	}
	return time1; 
}

int get(string &s1, int id) {
	int time1 = get1(s1, id); 
	int cur = 0; 
	for (int i = 0; i < n; ++i) {
		if (time1 > get1(s1, i)) ++cur;
	}
	return cur + 1; 
}

int gen(string &s1, int id) {
	if (s1.size() == n) {
	    int kek = 0;
		for (auto i : s1) kek += (i - '0'); 
		if (!kek) return -inf; 
		return get(s1, id);		
	}
	s1 += '0';
	int val = -inf;
	val = max(val, gen(s1, id));
	s1.pop_back();
	s1 += '1';
	val = max(val, gen(s1, id));
	s1.pop_back();
	return val; 
}
                                                  
void solve() {                                                      
	cin >> n >> p; 	
	for (int i = 0; i < n; ++i) cin >> cnt[i]; 
	for (int i = 0; i < n; ++i) {
		string dd;
		cout << gen(dd, i) << '\n'; 
	}
}

signed main() {
	ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0); 
	#ifdef offline_judge
		freopen("TASK.in", "r", stdin);
		freopen("TASK.out", "w", stdout);
	#endif
	solve(); 
}