import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.lang.reflect.Executable;
import java.util.Locale;
import java.util.StringTokenizer;
import java.util.TreeSet;

public class Main {
    public void solve() throws IOException{
        int n = nextInt(), m = nextInt(), q = nextInt();
        long a[][] = new long[n][m];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                a[i][j] = nextInt();
            }
        }
        long maxn[] = new long[n], maxm[] = new long[m];
        for(int i = 0; i < n; i++){
            for(int j = 0; j < m; j++){
                maxn[i] = Math.max(maxn[i], a[i][j]);
                maxm[j] = Math.max(maxm[j], a[i][j]);
            }
        }
        int cntn[] = new int[n], cntm[] = new int[m];
        for(int i = 0; i < n; i++){
            for(int j = 0; j < m; j++){
                if(a[i][j] == maxn[i]){
                    cntn[i] = j;
                }
                if(a[i][j] == maxm[j]){
                    cntm[j] = i;
                }
            }
        }
        TreeSet<Long> set1 = new TreeSet<>(), set2 = new TreeSet<>(), set = new TreeSet<>();
        for (int i = 0; i < n; i++) {
            set1.add(maxn[i]);
        }
        for (int i = 0; i < m; i++) {
            if(set1.contains(maxm[i])) set.add(maxm[i]);
        }
        for (int qq = 0; qq < q; qq++) {
            int r = nextInt() - 1, c = nextInt() - 1, x = nextInt() - 1;
            a[r][c] = x;
            int cnt = 0;
            if(a[r][c] > maxn[r]){
                if(set.contains(maxn[r])) set.remove(maxn[r]);
                maxn[r] = a[r][c];
                cnt++;
            }
            if(a[r][c] > maxm[c]){
                if(set.contains(maxm[c])) set.remove(maxm[c]);
                maxm[c] = a[r][c];
                cnt++;
            }
            if(cnt == 2){
                set.add(a[r][c]);
            }
            out.println(set.size());

        }
    }
    BufferedReader br;
    StringTokenizer sc;
    PrintWriter out;
    public static void main(String[] args) throws IOException{
        Locale.setDefault(Locale.US);
        new Main().run();
    }
    public void run() throws IOException{
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        }catch (Exception e){
            e.printStackTrace();
            System.exit(1);
        }
    }
    public String nextToken() throws IOException{
        while (sc == null || !sc.hasMoreTokens()){
            try {
                sc = new StringTokenizer(br.readLine());
            }catch (Exception e){
                return null;
            }
        }
        return sc.nextToken();
    }
    public int nextInt() throws IOException{
        return Integer.parseInt(nextToken());
    }
    public long nextLong() throws IOException{
        return Long.parseLong(nextToken());
    }

}
