#include <iostream>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <cassert>
#include <set>

using namespace std;

const int MAXN = 3e5;
const int INF = 1e9 + 7;

int a[MAXN];
int nxt[MAXN];

set <pair <int, int> > s;

int get_max_id(int l, int r) {
    int res = -1, id = -1;
    for (int i = l; i <= r; i++)
        if (res <= a[i]) {
            res = a[i];
            id = i;
        }
    return id;
}

int main() {
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(false);

    int n; cin >> n;
    for (int i = 0; i < n; i++)
        cin >> a[i];

    for (int i = n - 1; i >= 0; i--) {
        /*set <pair <int, int> > :: iterator it = s.upper_bound(make_pair(a[i], -n));
        if (it == s.begin())
            nxt[i] = n;
        else {
            it--;
            nxt[i] = -(*it).second;
        }
        s.insert(make_pair(a[i], -i));*/

        nxt[i] = l;
        while (nxt[i] < n && a[nxt[i]] >= a[i])
            nxt[i]++;
    }

    int l = 0, res = 0;
    while (l < n) {
        int r = get_max_id(l, nxt[l] - 1);
        l = r + 1;
        res++;
    }

    cout << res << endl;

    return 0;
}
