#include <iostream>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <cassert>
#include <set>

using namespace std;

const int MAXN = 3001;

int n;
int a[MAXN];

int find(int i) {
    for (int j = 0; j < n; j++)
        if (a[j] == i)
            return j;
}

vector <int> cur;
vector <pair <int, int> > res;

void go(int l, int r) {
    res.push_back(make_pair(l, r));
    cur.clear();
    for (int i = l + 1; i <= r; i += 2)
        cur.push_back(a[i]);
    for (int i = l; i <= r; i += 2)
        cur.push_back(a[i]);
    for (int i = l; i <= r; i++)
        a[i] = cur[i - l];
}

int main() {
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(false);

    cin >> n;
    for (int i = 0; i < n; i++)
        cin >> a[i];

    for (int i = 1; i <= n; i++) {
        int pos = find(i);
        while (pos != i - 1) {
            if ((i - 1) % 2 != pos % 2)
                go(i - 1, n - 1);
            else
                go(i, n - 1);
            /*cout << res.back().first + 1 << " " << res.back().second + 1 << endl;
            for (int j = 0; j < n; j++)
                cout << a[j] << " ";
            cout << endl;*/
            pos = find(i);
        }
    }

    cout << (int)res.size() << endl;
    for (int i = 0; i < (int)res.size(); i++)
        cout << res[i].first + 1 << " " << res[i].second + 1 << endl;

    return 0;
}
