#include <iostream>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <cassert>
#include <set>

using namespace std;

const int INF = 1e9;

string s1, s2;

int main() {
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(false);

    int n; cin >> n;
    string s1, s2; cin >> s1 >> s2;
    int a = 0, b = 0;
    for (int i = 0; i < (int)s1.length(); i++)
        a = a * 2 + s1[i] - '0';
    for (int i = 0; i < (int)s2.length(); i++)
        b = b * 2 + s2[i] - '0';

    int sum = INF;
    for (int a1 = a; a1 <= 2 * a; a1++)
        for (int b1 = b; b1 <= 2 * b; b1++)
            if ((a1 + b1) == (a1 | b1))
                sum = min(sum, a1 + b1);
    vector <int> res;
    while (sum != 0 || res.empty()) {
        res.push_back(sum % 2);
        sum /= 2;
    }

    reverse(res.begin(), res.end());

    for (int i = 0; i < (int)res.size(); i++)
        cout << res[i];
    cout << endl;

    return 0;
}
