#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdio>

using namespace std;

int k;
vector <int> d;
vector <bool> used;
vector <vector <int> > g;
vector <int> anc;

void dej(int v) {
	int u, mi = -1, ind = -1;
	used[v] = true;
	for (int i = 0; i < k; i++) {
		if (d[i] == -1 || d[i] > d[v] + g[v][i]) {
			d[i] = d[v] + g[v][i];
			anc[i] = v;
		}
	}
	for (int i = 0; i < k; i++) {
		if (!used[i] && (mi == -1 || d[i] < mi)) {
			mi = d[i];
			ind = i;
		}
	}
	if (ind != -1)
		dej(ind);
}

int main() {
	int n, m, v;
	vector <int> step(30, 1);
	for (int i = 1; i < 30; i++)
		step[i] = step[i - 1] * 2;
	cin >> n >> m >> k;
	g.resize(k, vector <int> (k, 0));
	used.resize(k, false);
	d.resize(k, -1);
	anc.resize(k, -1);
	d[0] = 0;
	vector <pair <int, int> > c(n);
	for (int i = 0; i < k; i++)
		cin >> c[i].first >> c[i].second;
	for (int i = 0; i < k; i++) {
		for (int j = 0; j < k; j++) {
			if (i != k)
				g[i][j] = step[max(abs(c[i].first - c[j].first), abs(c[i].second - c[j].second))];
		}
	}
	dej(0);
	v = k - 1;
	vector <int> ans;
	while (v != -1) {
		ans.push_back(v);
		v = anc[v];
	}
	reverse(ans.begin(), ans.end());
	cout << ans.size() << endl;
	for (int i = 0; i < ans.size(); i++)
		cout << ans[i] + 1 << " ";
	system("pause");
	return 0;
}

