#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

vector <int> t;

void upd(int v, int x) {
    while (v > 0) {
        t[v] += x;
        v /= 2;
    }
}

int get_sum(int v, int l, int r, int tl, int tr) {
    int m = (r + l) / 2, u = v / 2, x;
    if (tl > tr)
        return 0;
    if (l == tl && r == tr)
        return t[v];
    return get_sum(2 * v, l, m, tl, min(m, tr)) + get_sum(2 * v + 1, m + 1, r, max(tl, m + 1), tr);
}

int main() {
    int n, m = 1, ind = 0, o;
    pair <int, int> p;
    set <pair <int, int> > k;
    cin >> n >> o;
    while (n > m)
        m *= 2;
    vector <int> a(n);
    vector <int> ans(n, 0);
    t.resize(2 * m, 0);
    for (int i = 0; i < n; i++)
        cin >> a[i];
    for (int i = 0; i < n; i++) {
        k.insert({a[i] - i, i});
    }
    vector <pair <int, int> > q;
    while (!k.empty()) {
        q.clear();
        p = *k.begin();
        q.push_back(p);
        k.erase(p);
        if (!k.empty())
            p = *k.begin();
        while (!k.empty() && q.back().first == p.first) {
            q.push_back(p);
            k.erase(p);
            if (!k.empty())
                p = *k.begin();
        }
        for (int i = 0; i < q.size(); i++) {
            p = q[i];
            ans[p.second] += get_sum(1, 0, m - 1, 0, p.second - 1);
        }
        for (int i = 0; i < q.size(); i++) {
            p = q[i];
            upd(p.second + m, 1);
        }
    }
    for (int i = 0; i < 2 * m; i++)
        t[i] = 0;
    for (int i = 0; i < n; i++) {
        k.insert({a[i] + i, i});
    }
    while (!k.empty()) {
        q.clear();
        p = *k.begin();
        q.push_back(p);
        k.erase(p);
        if (!k.empty())
            p = *k.begin();
        while (!k.empty() && q.back().first == p.first) {
            q.push_back(p);
            k.erase(p);
            if (!k.empty())
                p = *k.begin();
        }
        for (int i = 0; i < q.size(); i++) {
            p = q[i];
            //cout << p.second << endl;
            ans[p.second] += get_sum(1, 0, m - 1, p.second + 1, m - 1);
        }
        for (int i = 0; i < q.size(); i++) {
            p = q[i];
            upd(p.second + m, 1);
        }
    }
    for (int i = 0; i < n; i++)
        cout << ans[i] + 1 << endl;
}
