#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;
typedef long long ll;

vector <pair<int, int> > v;

struct range {
	ll a;
	int b;
	int prev;
};

ll deg2[1000];
range dp[1000];
bool used[1000];

range cre(int n) {
	range x;
	x.a = 1; x.b = n; x.prev = -1;
	return x;
}
 
range pls(range x, range y, int ind) {
	x.prev = y.prev = ind;
	if (x.b - y.b > 38) {
		return x;
	}
	if (y.b - x.b > 38) {
		return y;
	}
	int minn = min(x.b, y.b);
	x.b -= minn; y.b -= minn;
	x.a = x.a * deg2[x.b] + y.a * deg2[y.b];
	x.b = minn;
	while (x.a >= deg2[20]) {
		x.a /= 2;
		x.b++;
	}
	return x;
}

range minim(range x, range y) {
	if (x.b - y.b > 20) {
		return y;
	}
	if (y.b - x.b > 20) {
		return x;
	}
	int minn = min(x.b, y.b);
	x.b -= minn; y.b -= minn;
	if (x.a * deg2[x.b] <= y.a * deg2[y.b]) {
		return x;
	}
	return y;
}

bool eq(range x, range y) {
	if (x.a == y.a && x.b == y.b) return true;
	return false;
}

int main() {
	int n, m, k;
	scanf("%d %d %d", &n, &m, &k);
	for (int i = 0; i < k; i++) {
		int x, y;
		scanf("%d %d", &x, &y);
		v.push_back({ x, y });
	}
	deg2[0] = 1;
	for (int i = 1; i <= 40; i++) {
		deg2[i] = deg2[i - 1] * 2;
	}
	for (int i = 0; i < k; i++) {
		dp[i].a = 1;
		dp[i].b = 1e9;
		dp[i].prev = -1;
	}
	dp[0].a = 0;
	dp[0].b = 0;
	dp[0].prev = -1;
	for (int i = 0; i < k; i++) {
		int mini = -1;
		for (int j = 0; j < k; j++) {
			if (!used[j] && (mini == -1 || eq(minim(dp[j], dp[mini]), dp[j]))) {
				mini = j;
			}
		}
		used[mini] = true;
		for (int j = 0; j < k; j++) {
			if (j != mini) {
				dp[j] = minim(dp[j], pls (dp[mini], cre(max(abs(v[j].first - v[mini].first), abs(v[j].second - v[mini].second))), mini));			
			}
		}
	}
	vector <int> ans;
	int cur = k - 1;
	while (cur >= 0) {
		ans.push_back(cur);
		cur = dp[cur].prev;
	}
	printf("%d\n", ans.size());
	for (int i = ans.size() - 1; i >= 0; i--) {
		printf("%d ", ans[i] + 1);
	}
	return 0;
}