#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;

int p[500][500], n;
set<int> atack[500];

set<int> merge(vector<int> &a) {
	set<int> ans;
	for (int i : a)
		for (int j : atack[i])
			ans.insert(j);
	return ans;
}

bool check(int x) {
	vector<int> enemy;
	int i;
	for (i = 0; i < n; i++) {
		if (p[i][x] > p[i][i])
			enemy.emplace_back(i);
	}
	vector<int> safe;
	set<int> ans;
	bool esc = 0;
	for (int i : atack[x]) {
		safe.clear();
		for (int j : enemy)
			if (p[i][x] < p[i][j])
				safe.emplace_back(j);
		ans = merge(safe);
		esc = 1;
		for (int j : enemy)
			if (ans.count(j) == 0) {
				esc = 0;
				break;
			}
		if (esc)
			return 1;
	}
	return 0;
}

int main() {
	//-------------------------------------------------------------
	ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);//
	//freopen("Text.txt", "r", stdin);                           //
	//-------------------------------------------------------------
	cin >> n;
	int i, j, temp;
	for (i = 0; i < n; i++)
		for (j = 0; j < n; j++) {
			cin >> temp;
			p[i][temp - 1] = j;
		}
	vector<int> ans;
	int type;
	cin >> type;
	if (type == 1) {
		for (i = 0; i < n; i++)
			if (0 == p[i][i])
				ans.emplace_back(i + 1);
	}
	else {
		for (i = 0; i < n; i++)
			for (j = 0; j < n; j++)
				if (p[j][j] >= p[j][i])
					atack[i].insert(j);
		for (i = 0; i < n; i++)
			if (check(i))
				ans.emplace_back(i + 1);
	}
	cout << ans.size() << '\n';
	for (int j : ans)
		cout << j << ' ';
}