#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cassert>
#include <climits>
#include <algorithm>
#include <set>
#include <vector>

using namespace std;
typedef unsigned int index;

int main()
{
#ifdef ONPC
	assert(freopen("a.in", "r", stdin));
	assert(freopen("a.out", "w", stdout));
#else
#endif
	size_t n;
	cin >> n;
	vector<int> a(n);
	for (auto &i: a)
		cin >> i;
	vector<pair<int, int>> ans;
	for (index i = 0; i < n; i++)
	{
		pair<int, int> cur = {a[i], a[i]};
		while (ans.size() > 0 and ans.back().first <= cur.first  and ans.back().second <= cur.second)
		{
			cur.first = ans.back().first;
			ans.pop_back();
		}
		ans.push_back(cur);
	}
	cout << ans.size() << endl;
}
