/*
#include <bits/stdc++.h>

using namespace std;

mt19937 rnd(228);

const int N = 4e5 + 7;

int n, p;

int a[N];

struct rect_queries
{
    vector <int> ret;
    vector <pair <pair <int, int>, pair <int, int> > > quer;
    vector <int> ans;
    vector <int> cur;
    vector <int> tree;
    void build(vector <int> a)
    {
        cur = a;
        int n = (int) a.size();
        for (int i = 0; i < n; i++)
        {
            ret.push_back(a[i]);
        }
        sort(ret.begin(), ret.end());
        ret.resize(unique(ret.begin(), ret.end()) - ret.begin());
        ans.resize(n);
        tree.resize(n);
    }
    void inc(int x)
    {
        int n = ret.size();
        for (; x < n; x = (x | (x + 1)))
        {
            tree[x]++;
        }
    }
    int get(int x)
    {
        int ans = 0;
        for (; x >= 0; x = (x & (x + 1)) - 1)
        {
            ans += tree[x];
        }
        return ans;
    }
    void upd(int ind, int l, int r, int x, int y)
    {
        quer.push_back({{l - 1, x}, {y, -ind}});
        quer.push_back({{r, x}, {y, ind}});
    }
    void s()
    {
        sort(quer.begin(), quer.end());
        int j = -1;
        while (j + 1 < (int) quer.size() && quer[j + 1].first.first < 0) j++;
        for (int i = 0; i < n; i++)
        {
            inc(lower_bound(ret.begin(), ret.end(), cur[i]) - ret.begin());
            while (j + 1 < (int) quer.size() && quer[j + 1].first.first <= i)
            {
                int x1 = quer[j + 1].first.second;
                int x2 = quer[j + 1].second.first;
                int jnd = quer[j + 1].second.second;
                int lol = lower_bound(ret.begin(), ret.end(), x1) - ret.begin();
                lol--;
                int kek = -get(lol);
                lol = upper_bound(ret.begin(), ret.end(), x2) - ret.begin();
                lol--;
                kek += get(lol);
                if (jnd < 0) ans[-jnd] -= kek;
                else ans[jnd] += kek;
                j++;
            }
        }
    }
    int as(int x)
    {
        return ans[x];
    }
};

rect_queries s, t, ok;

int f(int i, int d)
{
    if (i - d < 0)
    {
        if (i + d >= n)
        {
            return 0;
        }
        int me = 1;
        for (int x = 0; x < n; x++)
        {
            if (a[x] + abs((i + d) - x) < a[i] + d) me++;
        }
        return me;
    }
    else if (i + d >= n)
    {
        if (i - d < 0)
        {
            return 0;
        }
        int me = 1;
        for (int x = 0; x < n; x++)
        {
            if (a[x] + abs((i - d) - x) < a[i] + d) me++;
        }
        return me;
    }
    else
    {
        int me = a[i] + d;
        int ans = 1;
        int ret = ok.add
        for (int j = 0; j < n; j++)
        {
            if (i == j) continue;
            if (j <= i - d)
            {
                if (a[j] < me)
                {
                    ans++;
                }
            }
            else if (j < i)
            {
                if (a[j] + j < me + max(0, i - d))
                {
                    ans++;
                }
            }
            else if (j < i + d)
            {
                if (a[j] - j < me - i - d)
                {
                    ans++;
                }
            }
            else
            {
                if (a[j] < me)
                {
                    ans++;
                }
            }
        }
        return ans;
    }
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> p;
    vector <int> x, y;
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
        x.push_back(a[i] - i);
        y.push_back(a[i] + i);
    }
    s.build(x);
    t.build(y);
    ok.build(a);
    for (int i = 0; i < n; i++)
    {
        s.upd(i, 0, i - 1, -1e9, a[i] - i - 1);
        t.upd(i, i + 1, n - 1, -1e9, a[i] + i - 1);
    }
    s.s();
    t.s();
    if (p == 1)
    {
        for (int i = 0; i < n; i++)
        {
            cout << 1 + s.as(i) + t.as(i) << '\n';
        }
        return 0;
    }
    else
    {
        return 0;
    }
}
*/

#include <bits/stdc++.h>

using namespace std;

mt19937 rnd(228);

const int N = 3e5 + 7;
const int LEN = 3e5;
int grab[LEN];
int vis[N];

int n;

string s[N];

bool ok = false;

string ans = "";
string res = "";

void print()
{
    reverse(ans.begin(), ans.end());
    while (ans.size() > 1 && ans.back() == '0') ans.pop_back();
    reverse(ans.begin(), ans.end());
    cout << ans << '\n';
    exit(0);
}

int cnt = 0;

typedef unsigned long long ull;

mt19937_64 dnd(228);

unordered_set <ull> mem;
ull rofl[LEN];
ull hsh = 0;

void rec(int bit)
{
    if (mem.count(hsh * LEN + bit)) return;
    mem.insert(hsh * LEN + bit);
    if (bit == LEN)
    {
        print();
        return;
    }
    int lol = 0;
    for (int i = 0; i < n; i++)
    {
        int ind = bit - (int) (LEN - (int) s[i].size());
        if (!vis[i] && ind >= 0 && s[i][ind] == '1')
        {
            lol++;
        }
    }
    if (lol > 1) return;
    if (lol == 1)
    {
        ans += '1';
        rec(bit + 1);
        ans.pop_back();
    }
    else
    {
        ans += '0';
        rec(bit + 1);
        ans.pop_back();
        int x = 0;
        for (int i = 0; i < n; i++) if (!vis[i])
        {
            x = i;
            break;
        }
        for (int i = 0; i < n; i++)
        {
            if (vis[i] || i == x) continue;
            int delta_i = (int) (LEN - (int) s[i].size());
            int delta_x = (int) (LEN - (int) s[x].size());
            for (int cur = max(bit, min(delta_i, delta_x)); cur < LEN; cur++)
            {
                int real = cur - (int) (LEN - (int) s[i].size());
                int his_real = cur - (int) (LEN - (int) s[x].size());
                char A = (real < 0 ? '0' : s[i][real]);
                char B = (his_real < 0 ? '0' : s[x][his_real]);
                if (A != B)
                {
                    if (A > B)
                    {
                        x = i;
                    }
                    break;
                }
            }
        }
        ans += '1';
        if (!vis[x])
        {
            hsh += rofl[x];
            vis[x] = true;
            rec(bit + 1);
            vis[x] = false;
            hsh -= rofl[x];
        }
        ans.pop_back();
    }
}

int main()
{
    mem.reserve(2e7);
    for (int i = 0; i < LEN; i++) rofl[i] = dnd();
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> n;
    for (int i = 0; i < n; i++)
    {
        cin >> s[i];
    }
    rec(0);
}
