#include <iostream>
#include <algorithm>
#include <vector>
#include <set>

using namespace std;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;

	vector <int> vir(n);
	vector <vector <int>> aff(n, vector <int>(n));
	vector <vector <int>> bck(n, vector <int>(n));
	for (int i = 0; i < n; vir[i] = i, i++) for (int j = 0; j < n; j++) {
		cin >> aff[i][j];
		aff[i][j]--;
		bck[i][aff[i][j]] = n - 1 - j;
	}

	int p;
	cin >> p;

	if (p == 1) {
		int ans = 0;
		vector <int> out;
		for (int i = 0; i < n; i++) {
			if (i == aff[i][0]) ans++, out.push_back(i + 1);
		}
		cout << ans << '\n';
		for (auto t : out) cout << t << ' ';
	}
	else {
		int ans = 0;
		vector <int> out;
		for (int i = 0; i < n; i++) {
			bool give = false;
			for (int j = 0; j < n && !give; j++) {
				if (bck[j][i] >= bck[j][j]) {
					set <int> badboi;
					for (int k = 0; aff[j][k] != i; k++) {
						badboi.insert(aff[j][k]);
					}
					vector <int> cell(n, 0);
					for (int k = 0; aff[j][k] != i; k++) {
						for (int l = 0; aff[aff[j][k]][l] != aff[j][k]; l++) {
							if (badboi.find(aff[aff[j][k]][l]) == badboi.end()) {
								cell[aff[j][k]] = 1;
								break;
							}
						}
						if (cell[aff[j][k]]) continue;
					}
					int h = 0;
					for (int k = 0; k < n; k++) h += cell[k];
					if (badboi.size() <= h) give = true;
				}
			}
			if (give)
				ans++, out.push_back(i + 1);
		}
		cout << ans << '\n';
		for (auto t : out) cout << t << ' ';
	}

	return 0;
}