#include <iostream>
#include <algorithm>
#include <vector>
#include <set>

using namespace std;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;

	vector <int> vir(n);
	vector <vector <int>> aff(n, vector <int>(n));
	vector <vector <int>> bck(n, vector <int>(n));
	for (int i = 0; i < n; vir[i] = i, i++) for (int j = 0; j < n; j++) {
		cin >> aff[i][j];
		aff[i][j]--;
		bck[i][aff[i][j]] = n - 1 - j;
	}

	int p;
	cin >> p;

	if (p == 1) {
		int ans = 0;
		vector <int> out;
		for (int i = 0; i < n; i++) {
			if (i == aff[i][0]) ans++, out.push_back(i + 1);
		}
		cout << ans << '\n';
		for (auto t : out) cout << t << ' ';
	}
	else {
		int ans = 0;
		vector <int> out;
		vector <int> could(n);

		vector <set <int>> kill(n);
		for (int i = 0; i < n; i++) {
			for (int j = 0; aff[i][j] != i; j++) {
				kill[i].insert(aff[i][j]);
			}
		}

		for (int i = 0; i < n; i++) {
			vector <int> ck(kill[i].size() + 1, 0);
			vector <vector <int>> mvb(n);
			int j = 0;
			do {
				if (j == 0) ck[j] = 1;
				else if (ck[j - 1] == 1) {
					for (int k = 0; k < j; k++) {
						if (kill[aff[i][k]].find(aff[i][j]) != kill[aff[i][k]].end())
							kill[aff[i][k]].erase(aff[i][j]), mvb[aff[i][k]].push_back(aff[i][j]);
						if (kill[aff[i][j]].find(aff[i][k]) != kill[aff[i][j]].end())
							kill[aff[i][j]].erase(aff[i][k]), mvb[aff[i][j]].push_back(aff[i][k]);
					}
					bool fds = true;
					for (int k = 0; k < j; k++)
						if (kill[aff[i][k]].empty()) {
							ck[j] = 0;
							fds = false;
							break;
						}
					if (fds) ck[j] = 1;
					else break;
				}
				j++;
			} while (aff[i][j] == i);
			for (int j = 0; j < n; j++) for (auto g : mvb[j]) kill[j].insert(g);

			for (j = 0; j < kill[i].size() + 1; j++) {
				if (ck[j]) could[aff[i][j]] = 1;
			}
		}

		for (int i = 0; i < n; i++) if (could[i]) ans++, out.push_back(i + 1);

		cout << ans << '\n';
		for (auto t : out) cout << t << ' ';
	}

	return 0;
}