import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashSet;
import java.util.StringTokenizer;

public class B {
    public static void main(String[] args) throws IOException {
        BufferedReader b = new BufferedReader(new InputStreamReader(System.in));
        StringTokenizer s = new StringTokenizer(b.readLine());
        int n = Integer.parseInt(s.nextToken());
        int[][] all = new int[n][n];
        for (int i = 0; i < n; i++) {
            s = new StringTokenizer(b.readLine());
            for (int j = 0; j < n; j++) {
                all[i][j] = Integer.parseInt(s.nextToken());
            }
        }
        s = new StringTokenizer(b.readLine());
        int p = Integer.parseInt(s.nextToken());
        if (p == 1) {
            ArrayList<Integer> res = new ArrayList<>();
            for (int i = 0; i < n; i++) {
                if (all[i][0] == (i + 1)) {
                    res.add(i);
                }
            }
            System.out.println(res.size());
            for (int i = 0; i < res.size(); i++) {
                System.out.print((res.get(i) + 1) + " ");
            }
        } else {
            ArrayList<Integer> res = new ArrayList<>();
            boolean[] stable = new boolean[n];
            for (int i = 0; i < n; i++) {
                if (all[i][0] == (i + 1)) {
                    stable[i] = true;
                }
            }
            boolean[] wasAdd = new boolean[n];
            boolean ca;
            for (int i = 0; i < n; i++) {
                boolean can = true;
                for (int j = 0; j < n && can; j++) {
                    ca = !wasAdd[all[i][j] - 1];
                    for (int k = j - 1; k > -1 && can && ca; k--) {
                        ca = false;
                        for (int l = 0; l < n && !ca; l++) {
                            if (all[all[i][k] - 1][l] == all[i][k]) {
                                can = false;
                                break;
                            }
                            for (int m = j; m < n; m++) {
                                if (all[i][m] == all[all[i][k] - 1][l]) {
                                    ca = true;
                                    break;
                                }
                            }
                        }
                    }
                    if (ca) {
                        res.add(all[i][j] - 1);
                        wasAdd[all[i][j] - 1] = true;
                    }
                }
            }
            System.out.println(res.size());
            Collections.sort(res);
            for (int i = 0; i < res.size(); i++) {
                System.out.print((res.get(i) + 1) + " ");
            }
        }
    }
}