import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Arrays;
import java.util.StringTokenizer;

public class C2 {
    public static void main(String[] args) throws IOException {
        BufferedReader b = new BufferedReader(new InputStreamReader(System.in));
        StringTokenizer s = new StringTokenizer(b.readLine());
        int n = Integer.parseInt(s.nextToken());
        long[] in = new long[n];
        for (int i = 0; i < n; i++) {
            s = new StringTokenizer(b.readLine());
            in[i] = Integer.parseInt(s.nextToken());
        }
        Arrays.sort(in);
        long maxCost = 0;
        int prefMax = 0;
        for (int i = 0; i < n; i++) {
            long cost = (n - i) * in[i];
            long max = 0;
            for (int j = prefMax; j < i; j++) {
                if ((i - j) * in[j] > max) {
                    prefMax = j;
                    max = (i - j) * in[j];
                } else if (in[i] * (i - j - 1) <= max) {
                    break;
                }
            }
            maxCost = Math.max(maxCost, cost + max);
        }
        System.out.println(maxCost);
    }
}
