#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <set>
typedef long long ll;
using namespace std;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	int n;
	cin >> n;
	vector<vector<int>> cnt(n, vector<int>(n));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			int x;
			cin >> x;
			cnt[i][x - 1] = j;
		}
	}
	int p;
	cin >> p;
	if (p == 1) {
		vector<int> res;
		for (int i = 0; i < n; i++) {
			if (cnt[i][i] == 0)
				res.push_back(i + 1);
		}
		cout << res.size() << '\n';
		for (int i : res)
			cout << i << ' ';
		return 0;
	}
	vector<int> res;
	for (int i = 0; i < n; i++) {
		bool fl = true;
		vector<int> used(n);
		used[i] = 1;
		for (int j = 0; j < n; j++) {
			if (used[j])
				continue;
			while (!used[j]) {
				used[j] = 1;
				for (int z = 0; z < n; z++) {
					if (cnt[j][z] < cnt[j][z]) {
						j = z;
						continue;
					}
				}
				if (cnt[i][j] < cnt[i][i])
					fl = false;
			}
		}
		if (fl)
			res.push_back(i + 1);
	}
	cout << res.size() << '\n';
	for (int i : res)
		cout << i << ' ';
	return 0;
}