#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <algorithm>
using namespace std;

void inc(string &s) {
	int n = s.size();
	int i = n - 1;
	for (; i >= 0; i--) {
		if (s[i] == '0')
			break;
	}
	if (i == -1) {
		s = '1';
		for (int i = 0; i < n; i++)
			s.push_back('0');
	}
	else {
		s[i] = '1';
	}
}

bool check(string a, string b) {
	int n = a.size();
	int m = b.size();
	for (int i = 0; i < min(n, m); i++) {
		if (a[n - i - 1] == '1' && b[m - i - 1] == '1')
			return false;
	}
	return true;
}

string sum(string a, string b) {
	if (a.size() < b.size())
		a.swap(b);
	int n = a.size();
	string res;
	for (int i = 0; i < n; i++)
		res.push_back('0');
	for (int i = 0; i < n; i++) {
		if (a[n - i - 1] == '1' || (i < b.size() && b[b.size() - i - 1] == '1'))
			res[n - i - 1] = '1';
	}
	return res;
}

bool le(string a, string b) {
	return a.size() < b.size() || (a < b);
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int n;
	cin >> n;
	vector<int> res;
	for (int i = 0; i < n; i++) {
		string s;
		cin >> s;
		res.push_back(s.size() - 1);
	}
	sort(res.begin(), res.end());
	int curi = 0;
	string answ;
	for (int i = 0; i < res.size(); i++) {
		for (; curi < res[i]; curi++)
			answ.push_back('0');
		answ.push_back('1');
		curi++;
	}
	reverse(answ.begin(), answ.end());
	cout << answ;
	return 0;
}