#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <cmath>

using namespace std;

const int MAXN = 501;

int a[MAXN][MAXN];
int vuln[MAXN][MAXN];

int main() {
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif
  cin.tie(0);
  ios::sync_with_stdio(0);

  int n;
  cin >> n;

  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < n; ++j) {
      cin >> a[i][j];
      --a[i][j];
      vuln[i][a[i][j]] = j;
    }
  }

  int p;
  cin >> p;

  vector<int> ans;

  if (p == 1) {
    for (int i = 0; i < n; ++i) {
      bool killed = false;
      for (int j = 0; j < n; ++j) {
        // j -> i
        if (vuln[i][i] > vuln[i][j]) {
          killed = true;
          break;
        }
      }
      if (!killed) ans.push_back(i);
    }
  }
  else {
    for (int v = 0; v < n; ++v) {
      bool found = false;
      for (int cell = 0; cell < n && !found; ++cell) {
        vector<int> pacani;
        for (int i = vuln[cell][v]; i < n; ++i)
          pacani.push_back(a[cell][i]);
        
        bool kok = true;
        for (int i = 0; i < vuln[cell][v] && kok; ++i) {
          int tokill = a[cell][i];
          bool ok = false;
          for (int j : pacani)
            if (vuln[tokill][tokill] > vuln[tokill][j]) {
              ok = true;
              break;
            }
          kok &= ok;
        }

        if (kok)
          found = true;
      }
      if (found) ans.push_back(v);
    }
  }

  cout << ans.size() << '\n';
  for (int id : ans)
    cout << id + 1 << ' ';
  cout << '\n';

  return 0;
}