#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

typedef long long ll;

int n, m, k;
vector <pair <ll, ll > > a;
vector <ll > ans;
ll dist[601][601];
int p[600];
bool used[600];

bool check(int i, int j)
{
	for (int q = 599; q >= 0; q--)
		if (dist[i][q] < dist[j][q])
			return true;
		else if (dist[i][q] > dist[j][q])
			return false;
	return false;
}

void inc(int i, int j, int z)
{
	for (int q = 0; q < 600; q++)
		dist[600][q] = dist[j][q];
	dist[600][z]++;
	for (int q = 0; q < 600 - 1; q++)
	{
		dist[600][q + 1] += dist[600][q] / 2;
		dist[600][q] %= 2;
	}
	if (check(i, 600))
		return;
	for (int q = 0; q < 600; q++)
		dist[i][q] = dist[600][q];
	p[i] = j;
}


void answ()
{
	p[0] = -1;
	for (int i = 1; i < k; i++)
		dist[i][max(a[i].first - 1, a[i].second - 1)] = 1;

	for (int i = 1; i < k; i++)
		for (int j = 0; j < i; j++)
			inc(i, j, max(abs(a[i].first - a[j].first), abs(a[i].second - a[j].second)));

}

int main()
{
	ios_base::sync_with_stdio(0), cin.tie(0);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	cin >> n >> m >> k;
	a.resize(k);
	for (int i = 0; i < k; i++)
		cin >> a[i].first >> a[i].second;
	sort(a.begin(), a.end());
	answ();
	int v = k - 1;
	ans.push_back(v);
	while (p[v] != -1)
	{
		ans.push_back(p[v]);
		v = p[v];
	}
	reverse(ans.begin(), ans.end());

	cout << ans.size() << "\n";
	for (int i = 0; i < ans.size(); i++)
		cout << ans[i] + 1 << ' ';
	return 0;
}