﻿//#include "stdafx.h"

#pragma GCC optimize ("Ofast")

#include <fstream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>

using namespace std;

#ifdef _DEBUG
ifstream cin("input.txt");
ofstream cout("output.txt");
#else
#include <iostream>
#endif

typedef long long ll;

#define all(a) a.begin(), a.end()
#define i_o ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL)

int main() {
	//i_o;
	int n, m, q;
	cin >> n >> m >> q;
	vector <vector <int> > a(n, vector <int>(m));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> a[i][j];
		}
	}
	vector <int> row(n), column(m);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			row[i] = max(row[i], a[i][j]);
		}
	}
	for (int j = 0; j < m; j++) {
		for (int i = 0; i < n; i++) {
			column[j] = max(column[j], a[i][j]);
		}
	}
	unordered_set <int> ans;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if (row[i] == a[i][j] && column[j] == a[i][j]) {
				ans.insert(a[i][j]);
			}
		}
	}
	for (int i = 0; i < q; i++) {
		int r, c, x;
		cin >> r >> c >> x; r--, c--;
		if (column[c] < x && row[r] < x) {
			ans.erase(column[c]);
			ans.erase(row[r]);
			ans.erase(a[r][c]);
			a[r][c] = column[c] = row[r] = x;
			ans.insert(x);
			cout << ans.size() << '\n';
			continue;
		}
		a[r][c] = x;
		if (row[r] < x) {
			ans.erase(row[r]);
			row[r] = x;
		}
		if (column[c] < x) {
			ans.erase(column[c]);
			column[c] = x;
		}
		cout << ans.size() << '\n';
	}
	return 0;
}