﻿//#include "stdafx.h"

#pragma GCC optimize ("Ofast")

#include <fstream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>

using namespace std;

#ifdef _DEBUG
ifstream cin("input.txt");
ofstream cout("output.txt");
#else
#include <iostream>
#endif

typedef long long ll;

#define all(a) a.begin(), a.end()
#define i_o ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL)

const int MAXN = 500;
int n, p, k;
int a[MAXN][MAXN], ord[MAXN][MAXN];

void read() {
	cin >> n;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			cin >> a[i][j]; a[i][j]--;
			ord[i][a[i][j]] = j;
		}
	}
	cin >> p;
	if (p == 1) {
		vector <int> ans;
		for (int i = 0; i < n; i++) {
			if (i == a[i][0]) ans.push_back(i + 1);
		}
		cout << ans.size() << '\n';
		for (auto now : ans) cout << now << ' ';
		exit(0);
	}
}

void solve() {
	vector <int> ans;
	for (int cur = 0; cur < n; cur++) {
		unordered_set <int> b;
		b.insert(cur);
		for (int i = 0; i < n; i++) {
			if (ord[i][cur] < ord[i][i]) b.insert(i);
		}
		int cnt = 0;
		for (int i = 0; i < n; i++) {
			if (b.find(i) == b.end()) continue;
			for (int j = 0; j < n; j++) {
				if (a[i][j] == cur) break;
				if (b.find(a[i][j]) == b.end()) {
					cnt++;
				}
			}
		}
		if (b.size() != cnt) {
			ans.push_back(cur);
		}
	}
	cout << ans.size() << '\n';
	for (auto now : ans) {
		cout << now + 1 << ' ';
	}
}

int main() {
	i_o;
	read();
	solve();
}