﻿//#include "stdafx.h"

#pragma GCC optimize ("Ofast")

#include <fstream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>

using namespace std;

#ifdef _DEBUG
ifstream cin("input.txt");
ofstream cout("output.txt");
#else
#include <iostream>
#endif

typedef long long ll;

#define all(a) a.begin(), a.end()
#define i_o ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL)

const int MAXN = 500;
int n, p, k;
int a[MAXN][MAXN], ord[MAXN][MAXN];
bool BAD[MAXN][MAXN];
int BADCNT[MAXN];
int inters[MAXN][MAXN];

void read() {
	cin >> n;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			cin >> a[i][j]; a[i][j]--;
			ord[i][a[i][j]] = j;
		}
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (a[i][j] == i)break;
			BAD[i][a[i][j]] = true;
			BADCNT[i]++;
		}
	}
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			for (int now = 0; now < n; now++) {
				if (BAD[j][now] && BAD[i][now]) {
					inters[i][j]++;
					inters[j][i]++;
				}
			}
		}
	}
	cin >> p;
	if (p == 1) {
		vector <int> ans;
		for (int i = 0; i < n; i++) {
			if (i == a[i][0]) ans.push_back(i + 1);
		}
		cout << ans.size() << '\n';
		for (auto now : ans) cout << now << ' ';
		exit(0);
	}
}

void solve() {
	vector <int> ans;
	for (int cur = 0; cur < n; cur++) {
		bool FL = false;
		for (int i = 0; i < n; i++) {
			if (ord[i][i] < ord[i][cur]) continue;
			unordered_set <int> bad;
			for (int j = 0; j < n; j++) {
				if (a[i][j] == cur) break;
				bad.insert(a[i][j]);
			}
			bool fl1 = true;
			for (auto v : bad) {
				bool fl = false;
				if (inters[v][i] != BADCNT[v]) {
					fl = true;
				}
				if (!fl) {
					fl1 = false;
					break;
				}
			}
			if (fl1) {
				FL = true;
				break;
			}
		}
		if (FL) {
			ans.push_back(cur);
		}
	}
	cout << ans.size() << '\n';
	for (auto now : ans) {
		cout << now + 1 << ' ';
	}
}

int main() {
	i_o;
	read();
	solve();
}