#include <bits/stdc++.h>
#define ll long long
#define mp make_pair
#define pb push_back
#define X first
#define Y second
#define pii pair<int, int>

using namespace std;

int solve();

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // DEBUG
    solve();
    return 0;
}

const int MAXN = (int)2e5 + 10;

int w[MAXN];
int h[MAXN];
vector<vector<int>> a;

int solve()
{
    int n, m, q;
    cin >> n >> m >> q;
    a.resize(n + 1);
    for (int i = 0; i < n + 1; i++)
        a[i].resize(m + 1);
    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= m; j++)
            cin >> a[i][j];
    for (int i = 1; i <= n; i++)
    {
        for (int j = 1; j <= m; j++)
            if (a[i][j] > a[i][w[i]])
                w[i] = j;
    }
    for (int j = 1; j <= m; j++)
    {
        for (int i = 1; i <= n; i++)
            if (a[i][j] > a[h[j]][j])
                h[j] = i;
    }
    int ans = 0;
    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= m; j++)
            if (w[i] == j && h[j] == i)
            {
                ans++;
            }
    while(q--)
    {
        int i, j, x;
        cin >> i >> j >> x;
        if (w[i] == j && h[j] == i)
        {
            a[i][j] = x;
            cout << ans << endl;
            continue;
        }
        if (w[i] == j)
        {
            if (x < a[h[j]][j])
            {
                a[i][j] = x;
                cout << ans << endl;
                continue;
            }
            ans++;
            if (w[h[j]] == j)
                ans--;
            h[j] = i;
            a[i][j] = x;
            cout << ans << endl;
            continue;
        }
        if (h[j] == i)
        {
            if (x < a[i][w[i]])
            {
                a[i][j] = x;
                cout << ans << endl;
                continue;
            }
            ans++;
            if (h[w[i]] == i)
                ans--;
            w[i] = j;
            a[i][j] = x;
            cout << ans << endl;
            continue;
        }
        if (x < a[i][w[i]] && x < a[h[j]][j])
        {
            a[i][j] = x;
            cout << ans << endl;
            continue;
        }
        if (x > a[i][w[i]] && x > a[h[j]][j])
        {
            if (h[w[i]] == i)
                ans--;
            if (w[h[j]] == j)
                ans--;
            ans++;
            a[i][j] = x;
            w[i] = j;
            h[j] = i;
            cout << ans << endl;
            continue;
        }
        if (x > a[i][w[i]])
        {
            if (h[w[i]] == i)
                ans--;
            w[i] = j;
            a[i][j] = x;
            cout << ans << endl;
            continue;
        }
        if (x > a[h[j]][j])
        {
            if (w[h[j]] == j)
                ans--;
            h[j] = i;
            a[i][j] = x;
            cout << ans << endl;
            continue;
        }
    }
}

