#include <bits/stdc++.h>
#define ll long long
#define mp make_pair
#define pb push_back
#define X first
#define Y second
#define pii pair<int, int>

using namespace std;

int solve();

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // DEBUG
    solve();
    return 0;
}

const int MAXN = (int)3e5 + 10;

pii t[4 * MAXN];
int R[MAXN];
int a[MAXN];
stack<int> st;

void build(int v, int tl, int tr)
{
    if (tl == tr)
    {
        t[v] = mp(a[tl], tl);
        return;
    }
    int tm = (tl + tr) / 2;
    build(2 * v, tl, tm);
    build(2 * v + 1, tm + 1, tr);
    t[v] = max(t[2 * v], t[2 * v + 1]);
}

pii get(int v, int tl, int tr, int l, int r)
{
    if (tl > r || tr < l)
        return mp(-1, -1);
    if (l <= tl && r >= tr)
        return t[v];
    int tm = (tl + tr) / 2;
    return max(get(2 * v, tl, tm, l, r), get(2 * v + 1, tm + 1, tr, l, r));
}

int solve()
{
    int n;
    cin >> n;
    for (int i = 0; i < n; i++)
        cin >> a[i];
    a[n] = -10;
    st.push(n);
    for (int i = n - 1; i >= 0; i--)
    {
        while(!st.empty() && a[st.top()] >= a[i])
            st.pop();
        R[i] = st.top();
        st.push(i);
    }
    build(1, 0, n - 1);
    int l = 0, cnt = 0;
    ///cerr << get(1, 0, n - 1, 1, 1).X << endl;
    while(l < n)
    {
        int r = get(1, 0, n - 1, l, R[l] - 1).Y;
        cnt++;
        l = r + 1;
    }
    cout << cnt << endl;
}

