#include <bits/stdc++.h>
#define ll long long
#define mp make_pair
#define pb push_back
#define X first
#define Y second
#define pii pair<int, int>

using namespace std;

int solve();

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // DEBUG
    solve();
    return 0;
}

const int MAXN = (int)4e5 + 10;

pii a[MAXN];
pii b[MAXN];
int ans[MAXN];
int c[MAXN];
unordered_map<int, int> q;
int f[MAXN];
int n, p;

void add(int x)
{
    for (int i = x; i <= n; i = (i | (i + 1)))
        f[i]++;
}

int get(int x)
{
    int ans = 0;
    for (int i = x; i >= 0; i = (i & (i + 1)) - 1)
        ans += f[i];
    return ans;
}

int solve()
{
    cin >> n >> p;
    for (int i = 1; i <= n; i++)
    {
        int x;
        cin >> x;
        c[i] = x;
        a[i] = mp(x + i, i);
        b[i] = mp(x - i, i);
    }
    sort(a + 1, a + n + 1);
    int cnt = 0;
    for (int i = 1; i <= n; i++)
        if (q[a[i].X] == 0)
            q[a[i].X] = ++cnt;
    for (int i = 1; i <= n; i++)
            a[i].X = q[a[i].X];


    for (int i = n; i > 0; i--)
    {
        add(q[c[i] + i]);
        ans[i] = get(q[c[i] + i] - 1);
    }

    memset(f, 0, sizeof(f));
    sort(b + 1, b + n + 1);
    cnt = 0;
    q.clear();
    for (int i = 1; i <= n; i++)
        if (q[b[i].X] == 0)
            q[b[i].X] = ++cnt;
    for (int i = 1; i <= n; i++)
        b[i].X = q[b[i].X];

    for (int i = 1; i <= n; i++)
    {
        add(q[c[i] - i]);
        ans[i] += get(q[c[i] - i] - 1);
    }
    for (int i = 1; i <= n; i++)
        cout << ans[i] + 1 << endl;
}
