#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define K first
#define L second
using ld = long double;

struct fen {
    int n; vector<int> t;
    fen(int n) : n(n), t(n, 0) {}
    void upd(int v) {
        for(int i = v; i < n; i |= i + 1) t[i]++;
    }
    int get(int v) {
        int ret = 0;
        for(int i = v; i >= 0; i &= i + 1, i--) ret += t[i];
        return ret;
    }
    int get(int l, int r) {
        return get(r) - (l ? get(l - 1) : 0);
    }
};

vector<pair<ll, ll>> l;

inline ld xx(pair<ll, ll> a, pair<ll, ll> b) {
    return ((ld)(a.L - b.L)) / (b.K - a.K);
}

void add(pair<ll, ll> line) {
    while(sz(l) > 1) {
        int u = sz(l);
        if(xx(l[u - 2], l[u - 1]) < xx(l[u - 1], line)) break;
        l.pop_back();
    }
    l.push_back(line);
}

ll get(ll x) {
    int lf = 1, rg = sz(l) - 1;
    if(sz(l) == 1 || x <= xx(l[0], l[1])) lf = 0;
    else while(lf < rg) {
        int md = (lf + rg) >> 1;
        if(x <= xx(l[md - 1], l[md])) rg = md;
        else lf = md + 1;
    }
    return l[lf].K * x + l[lf].L;
}

int main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    //freopen("in.txt", "r", stdin);
    int n; cin >> n;
    vector<pair<int, int>> a(n);
    map<int, int> re;
    bool bnull = true, same = true;
    for(int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
        re[a[i].second];
        bnull &= (!a[i].second);
        same &= (a[i].first == a[i].second);
    }
    sort(all(a), greater<pair<int, int>>());
    int dif = 0;
    for(auto it = re.begin(); it != re.end(); it++) it->second = dif++;
    fen t(dif);
    ll ans = a[n - 1].first * ll(n);

    if(same) {
//
//        for(int i = 0; i < n; i++)
//            for(int j = 0; j <= i; j++)
//                ans = max(ans, ll(a[i].first) * (i + 1) + ((j ? ll(j) * a[j - 1].first : 0) + ll(j) * (-a[i].first)));
//                //ans = max(ans, a[i].first * ll(i - j + 1) + (j ? a[j - 1].first * ll(j) : 0));
//        return cout << ans, 0;


        vector<ll> B(n);
        for(int i = 0; i < n; i++) B[i] = ll(a[i].first) * (i + 1);

        for(int i = 0; i < n; i++) {
            add({-i, i ? -B[i - 1] : 0});
            ll cur = get(a[i].first);
            ans = max(ans, cur + ll(a[i].first) * (i + 1));
        }
        return cout << ans, 0;
    }

    for(int i = n - 1; i >= 0; i--) {
        ll cur = a[i].first * ll(i + 1);
        if(bnull) {
            ans = max(ans, cur);
            continue;
        }
        ll opt = 0;
        for(int j = i + 1; j < n; j++) {
            int b = a[j].second;
            opt = max(opt, ll(b) * t.get(re[b], dif - 1));
        }
        ans = max(ans, cur + opt);
        t.upd(re[a[i].second]);
    }
    cout << ans;
}
