#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
const int INF = 1e9, maxn = 3e3;

struct segTree {
    int n; vector<int> t;
    segTree(int n) : n(n), t(2 * n, 0) {}
    void upd(int v, int x) {
        t[v += n] += x;
        for(v >>= 1; v; v >>= 1) t[v] = t[v * 2] + t[v * 2 + 1];
    }
    int get(int l, int r) {
        int ret = 0;
        for(l += n, r += n; l <= r; l = (l + 1) >> 1, r = (r - 1) >> 1) {
            if(l & 1) ret += t[l];
            if(!(r & 1)) ret += t[r];
        }
        return ret;
    }
};

int main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    //freopen("in.txt", "r", stdin);
    int n, p; cin >> n >> p;
    assert(p == 2);
    vector<int> a(n);
    for(int i = 0; i < n; i++) cin >> a[i];
    if(n == 1) return cout << 1, 0;
    vector<int> opt(n, 0);

    for(int i = 0; i < n; i++) {
        for(int d = 1; ; d++) {
            int l = max(i - d  + 1, 0), r = min(n - 1, i + d - 1);
            if(r - l + 1 == n) break;
            int me = a[i] + min(l ? i - l + 1 : INF, r != n - 1 ? r - i + 1 : INF), cur = 0;
            for(int j = 0; j < n; j++)
                cur += (a[j] + (l <= j && j <= r ? min(l ? j - l + 1 : INF, r != n - 1 ? r - j + 1 : INF) : 0) < me);
            opt[i] = max(opt[i], cur);
        }
    }
/*
    for(int l = 0; l < n; l++)
        for(int r = l; r < n; r++) {
            if(r - l + 1 == n) continue;
            vector<int> x(n);
            for(int i = 0; i < n; i++) x[i] = (l <= i && i <= r ? min(l ? i - l + 1 : INF, r != n - 1 ? r - i + 1 : INF) : 0);
            vector<pair<int, int>> u(n);
            for(int i = 0; i < n; i++) u[i] = {a[i] + x[i], i};
            sort(all(u));
            for(int i = 0; i < n; i++) {
                int j = i;
                while(j != n - 1 && u[j + 1].first == u[j].first) j++;
                for(int k = i; k <= j; k++) opt[u[k].second] = max(opt[u[k].second], i + 1);
                i = j;
            }
        }
*/
    for(int x : opt) cout << x + 1 << '\n';
}
