#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

vector <pair <ll, ll> > t;

void add(ll w, ll l, ll r, ll p, ll x) {
    if (l + 1 == r) {
        t[w] = make_pair(p, x);
        return;
    }
    ll m = (l + r) / 2;
    if (p < m) add(2 * w + 1, l, m, p, x); else add(2 * w + 2, m, r, p, x);
    if (t[2 * w + 2].second >= t[2 * w + 1].second) t[w] = t[2 * w + 2]; else t[w] = t[2 * w + 1];
    return;
}

pair <ll, ll> getmx(ll w, ll l, ll r, ll L, ll R) {
    if (L <= l && r <= R) return t[w];
    if (r <= L || R <= l) return make_pair(0, 0);
    if (l + 1 == r) return t[w];
    ll m = (l + r) / 2;
    pair <ll, ll> p1 = getmx(2 * w + 1, l, m, L, R), p2 = getmx(2 * w + 2, m, r, L, R);
    if (p2.second >= p1.second) return p2; else return p1;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    ll n;
    cin >> n;
    t.resize(4 * n + 1);
    vector <ll> v;
    v.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
        add(0, 0, n, i, v[i]);
    }
    //reverse(v.begin(), v.end());
    vector <ll> mn;
    mn.resize(n);
    mn[n - 1] = n;
    deque <ll> d;
    d.push_back(n - 1);
    for (int i = n - 2; i >= 0; i--) {
        while (d.size() != 0 && v[i] <= v[d.back()]) d.pop_back();
        if (d.size() == 0) mn[i] = n; else mn[i] = d.back();
        d.push_back(i);
    }
    ll ans = 0, p = 0;
    while (p != n) {
        /*ll q = p;
        for (int i = p; i < mn[p]; i++) {
            if (v[i] >= v[q]) q = i;
        }*/
        ans++;
        p = getmx(0, 0, n, p, mn[p]).first + 1;
    }
    cout << ans;
    return 0;
}
