#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <deque>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <random>
#include <ctime>
using namespace std;

#define int int64_t
#define mp make_pair
#define pb push_back
#define pbb pop_back
#define pf pop_front
#define pff push_front
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;

struct MyHash
{
    size_t operator ()(const pii &p) const
    {
        return p.first << 8 + p.second;
    }
};

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, p;
    cin >> n;
    vector<vector<int>> virus(n, vector<int>(n));
    vector<vector<int>> pos(n, vector<int>(n + 1));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> virus[i][j];
            pos[i][virus[i][j]] = j;
        }
    }
    cin >> p;

    vector<int> answer;
    if (p == 1) {
        for (int i = 0; i < n; ++i)
            if (virus[i].front() == i + 1)
                answer.pb(i + 1);
        cout << answer.size() << endl;
        for (int elem : answer)
            cout << elem << " ";
        cout << endl;
        return 0;
    }

    for (int i = 0; i < n; ++i) {
        for (int x = 0; x < n; ++x) {
            if (pos[x][x + 1] < pos[x][i + 1])
                continue;

            vector<bool> used(n + 1);
            for (int color = 1; color <= n; ++color) {
                if (pos[x][i + 1] > pos[x][color])
                    continue;
                for (int j = 0; j < n; ++j)
                    if (pos[j][j + 1] > pos[j][color])
                        used[j + 1] = true;
            }

            bool success = true;
            for (int k = 0; k < pos[x][i + 1]; ++k)
                success &= used[virus[x][k]];
            if (success) {
                answer.pb(i + 1);
                break;
            }
        }

        /*for (int j = 0; j < n; ++j) {
            bool success = true;
            if (pos[j][j + 1] < pos[j][i + 1])
                continue;
            for (int k = 0; k < pos[j][i + 1]; ++k)
                success &= used[virus[j][k]];
            if (success) {
                answer.pb(i + 1);
                break;
            }
        }*/
    }

    cout << answer.size() << endl;
    for (int elem : answer)
        cout << elem << " ";
    cout << endl;

    return 0;
}
