#include <bits/stdc++.h>

using namespace std;

const int maxN = 300005;
const int INF = 1e9;

int arr[maxN];
int dp[maxN];
int pr[maxN];

int st[maxN * 4];
void set_st(int v, int l, int r, int i, int x) {
    if (l == r - 1) {
        st[v] = x;
        return;
    }

    int m = (l + r) / 2;
    if (i < m) set_st(v * 2, l, m, i, x);
    else set_st(v * 2 + 1, m, r, i, x);

    st[v] = min(st[v * 2], st[v * 2 + 1]);
}

int get_st(int v, int l, int r, int a, int b) {
    if (b <= l || r <= a) return INF;
    if (a <= l && r <= b) return st[v];

    int m = (l + r) / 2;
    return min(get_st(v * 2, l, m, a, b), get_st(v * 2 + 1, m, r, a, b));
}

int main() {
    #ifdef DEBUG
        freopen("in.in", "r", stdin);
    #endif // DEBUG

    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int n;
    cin >> n;

    for (int i = 0; i < n; i++) cin >> arr[i];

    for (int i = 0; i <= n; i++) set_st(1, 0, n + 1, i, INF);
    vector<int> st;
    for (int i = 0; i < n; i++) {
        while(st.size() > 0 && arr[st.back()] <= arr[i]) st.pop_back();
        pr[i] = (st.size() > 0 ? st.back() : -1);
        st.push_back(i);
    }

    st.clear();

    for (int i = 0; i < n; i++) {
        while (st.size() > 0 && arr[st.back()] > arr[i]) {
            set_st(1, 0, n + 1, st.back(), INF);
            st.pop_back();
        }
        if (i > 0) set_st(1, 0, n + 1, i, dp[i - 1]);
        st.push_back(i);

        dp[i] = INF;
        if (pr[i] == -1) {
            if (st.size() > 0 && st[0] == 0) dp[i] = 1;
        }

        /*cout << i << ": " << endl;
        for (int x : st) {
            cout << x << " ";
        }
        cout << endl;
        for (int i = 0; i < n; i++) {
            cout << get_st(1, 0, n + 1, i, i + 1) << " ";
        }
        cout << endl;*/
        /*for (int x : st) {
            if (x > 0 && x > pr[i]) dp[i] = min(dp[i], dp[x - 1] + 1);
        }*/
        dp[i] = min(dp[i], get_st(1, 0, n + 1, pr[i] + 1, i + 1) + 1);
        //cout << dp[i] << endl;

    }

    /*for (int i = 0; i < n; i++) cout << dp[i] << " ";
    cout << endl;*/

    cout << dp[n - 1] << endl;

    return 0;
}
