#ifdef _DEBUG
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef pair<int, int> pii;

#define X first
#define Y second
#define inb push_back
#define mk make_pair
#define all(v) (v).begin(), (v).end()

int solve();

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	solve();
	return 0;
}

int solve()
{
	int n;
	cin >> n;
	vector<pii> a(n);
	for (int i = 0; i < n; ++i)
	{
		cin >> a[i].X >> a[i].Y;
	}
	sort(all(a), [&](pii x, pii y)
	{
		if (x.X == y.X)
			return x.Y > y.Y;
		return x.X > y.X;
	});
	ll ans = 0;
	for (int i = 0; i <= n; ++i)
	{
		vi ncur;
		for (int j = i; j < n; ++j)
			ncur.inb(a[j].Y);
		sort(all(ncur), greater<int>());
		ll cans = 0;
		if (i)
			cans = 1ll * a[i - 1].X * i;
		ans = max(ans, cans);
		ll ccnt = 0;
		for (int x : ncur)
		{
			++ccnt;
			ans = max(ans, cans + ccnt * x);
		}
	}
	printf("%lld\n", ans);
	return 0;
}