#include <stdio.h>
#include <algorithm>
 
struct data {
    long long a, b;
    
    data(){}
    data(long long a, long long b): a(a), b(b) {}
};

bool _less(const data &d1, const data &d2) {
	if (d1.a != d2.a) {
		return d1.a < d2.a;
	}
	return d1.b < d2.b;
}

bool _less1(const data &d1, const data &d2) {
	if (d1.b != d2.b) {
		return d1.b < d2.b;
	}
	return d1.a < d2.a;
}
 
int main() {
    int n;
    scanf("%d", &n);
    data arr[n], arr1[n];
    for (int i = 0; i < n; i++) {
        scanf("%lld%lld", &arr[i].a, &arr[i].b);
        arr1[i] = data(arr[i].a, arr[i].b);
    }
    std::sort(arr, arr + n, _less);
    std::sort(arr1, arr1 + n, _less1);
    long long ans = 0, ind1 = 0;
    for (int _ = 0; _ < n; _++) {
		long long ans1 = 0, cnt = 0;
		int iind1 = ind1;
		for (int i = n - 1; i >= ind1; i--) {
			if (arr1[i].a >= arr[_].a) {
				continue;
			}
			cnt++;
			if (cnt * arr1[i].b > ans1) {
				ans1 = cnt * arr1[i].b;
				iind1 = i;
			}
		}
		ind1 = iind1;
		if ((n - _) * arr[_].a + ans1 > ans) {
			ans = (n - _) * arr[_].a + ans1;
		}
    }
    printf("%lld", ans);
    return 0;
}
