#include <stdio.h>

int **come;

const int MAX = 501;

struct co {
	bool arr[MAX];
	
	co() {
		for (int i = 0; i < MAX; i++) {
			arr[i] = false;
		}
	}
	
	bool operator <(co &c) {
		for (int i = 0; i < MAX; i++) {
			if (arr[i] && !c.arr[i]) {
				return false;
			}
			if (!arr[i] && c.arr[i]) {
				return false;
			}
		}
		return false;
	}
	
	co operator +(co &c) {
		int d = 0;
		co res;
		for (int i = MAX - 1; i >= 0; i--) {
			d += arr[i] == true ? 1 : 0;
			d += c.arr[i] == true ? 1 : 0;
			if (d == 0) {
				res.arr[i] = false;
			} else if (d == 1) {
				res.arr[i] = true;
				d = 0;
			} else if (d == 2) {
				res.arr[i] = false;
				d = 1;
			} else if (d == 3) {
				res.arr[i] = true;
				d = 1;
			}
		}
		return res;
	}
	
	void print() {
		for (int i = 0; i < MAX; i++) {
			printf("%d", arr[i] == true);
		}
		printf("\n");
	}
};

int max(int a, int b) {
	a = a < 0 ? -a : a;
	b = b < 0 ? -b : b;
	return a < b ? b : a;
}

void print(int i, int j) {
	if (come[i][j] == -1) {
		printf("%d ", i + 1);
	} else {
		print(i, come[i][j]);
		print(come[i][j], j);
	}
}

int main() {
	int n, m, k;
	scanf("%d%d%d", &n, &m, &k);
	int x[k], y[k];
	for (int i = 0; i < k; i++) {
		scanf("%d%d", &x[i], &y[i]);
	}
	come = new int*[k];
	int cnt[k][k];
	co dp[k][k] = {};
	for (int i = 0; i < k; i++) {
		come[i] = new int[k];
		for (int j = 0; j < k; j++) {
			come[i][j] = -1;
			if (i != j) {
				dp[i][j].arr[MAX - max(x[j] - x[i], y[j] - y[i]) - 1] = true;
			}
			cnt[i][j] = 2;
		}
	}
	for (int kk = 0; kk < k; kk++) {
		for (int i = 0; i < k; i++) {
			for (int j = 0; j < k; j++) {
				if (dp[i][kk] + dp[kk][j] < dp[i][j]) {
					dp[i][j] = dp[i][kk] + dp[kk][j];
					come[i][j] = kk;
					cnt[i][j] = cnt[i][kk] + cnt[kk][j] - 1;
				}
			}
		}
	}
	printf("%d\n", cnt[0][k - 1]);
	print(0, k - 1);
	printf("%d", k);
	return 0;
}
