#pragma GCC optimize ("Ofast")

#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>

using namespace std;

#define forn(i, a, b) for (int i = a; i < b; ++i)
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define mp make_pair


int main() {
	ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	//freopen("input.txt", "r", stdin);


	int n, p;
	cin >> n >> p;
	vector<int> times(n);
	forn(i, 0, n)
		cin >> times[i];

	if (p == 2) {
		vector<int> ans(n, -1);
		vector<int> st_r(n), st_l(n), st_b(n);
		forn(i, 0, n) {
			st_l[i] = times[i] + i;
			st_b[i] = times[i] + i;
		}
		for (int i = n - 1; i >= 0; i--) {
			st_r[i] = times[i] + (n - 1 - i);
			st_b[i] = min(st_l[i], st_r[i]);
		}

		forn(i, 0, n) {
			int faster = 0;
			for (int j = n - 1; j >= 0; j--)
				if (st_r[j] < st_r[i])
					faster++;

			ans[i] = max(ans[i], faster + 1);
			faster = 0;

			forn(j, 0, n)
				if (st_l[j] < st_l[i])
					faster++;
			ans[i] = max(ans[i], faster + 1);

			faster = 0;
			forn(j, 0, n)
				if (st_b[j] < st_b[i])
					faster++;

			ans[i] = max(ans[i], faster + 1);
		}

		forn(i, 0, n)
			cout << ans[i] << endl;
	}
}