#include <iostream>
#include <algorithm>
#include <map>
#include <vector>
#include <set>
#include <string>

using namespace std;

const int N = 200000 + 1;

int cnti[N];
int cntj[N];
int mxi[N];
int mxj[N];

signed main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, m, q;
	cin >> n >> m >> q;
	vector<vector<int>> v(n, vector<int>(m));
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < m; j++)
		{
			cin >> v[i][j];
			mxi[i] = max(mxi[i], v[i][j]);
			mxj[j] = max(mxj[j], v[i][j]);
		}
	}
	for (int i = 0; i < n; i++)
	{
		int mx = 0;
		for (int j = 0; j < m; j++)
		{
			if (v[i][j] > v[i][mx]) mx = j;
		}
		int kek = 0;
		for (int j = 0; j < n; j++)
		{
			if (v[i][mx] > v[j][mx])
			{
				++kek;
			}
		}
		if (kek + 1 == n)
		{
			cnti[i] = mx;
		}
		else
		{
			cnti[i] = -1;
		}
	}

	for (int i = 0; i < m; i++)
	{
		int mx = 0;
		for (int j = 0; j < n; j++)
		{
			if (v[j][i] > v[mx][i]) mx = j;
		}
		int kek = 0;
		for (int j = 0; j < m; j++)
		{
			if (v[mx][i] > v[mx][j])
			{
				++kek;
			}
		}
		if (kek + 1 == m)
		{
			cntj[i] = mx;
		}
		else
		{
			cntj[i] = -1;
		}
	}

	int cur = 0;

	for (int i = 0; i < n; i++)
	{
		if (cnti[i] != -1) ++cur;
	}

	for (int Q = 0; Q < q; Q++)
	{
		int i, j, x;
		cin >> i >> j >> x;
		--i;
		--j;
		if (cnti[i] == j)
		{
			v[i][j] = x;
			mxi[i] = max(mxi[i], x);
			mxj[j] = max(mxj[j], x);
		}
		else
		{
			int add = 0;
			if (x > mxi[i] && x > mxj[j])
			{
				++add;
				mxi[i] = x;
				mxj[j] = x;
				if (cnti[i] != -1) --add;
				if (cntj[j] != -1) --add;
				int a = cnti[i];
				int b = cntj[j];
				if (a != -1) cntj[a] = -1;
				if (b != -1) cnti[b] = -1;
				cnti[i] = j;
				cntj[j] = i;
			}
			else
			{
				if (x > mxi[i] && cnti[i] != -1)
				{
					cntj[cnti[i]] = -1;
					cnti[i] = -1;
					--add;
				}
				if (x > mxj[j] && cntj[j] != -1)
				{
					cnti[cntj[j]] = -1;
					cntj[j] = -1;
					--add;
				}
			}
			v[i][j] = x;
			mxi[i] = max(mxi[i], x);
			mxj[j] = max(mxj[j], x);
			cur += add;
		}
		cout << cur << "\n";
	}

	system("pause");
}