#include <iostream>
#include <algorithm>
#include <map>
#include <vector>
#include <set>
#include <string>
#include <cassert>

using namespace std;

const int N = 500 + 10;

int a[N][N];
int b[N][N];

bool can[N];
bool kill[N][N][N];

signed main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;
	vector<int> mem;
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < n; j++)
		{
			cin >> a[i][j];
			--a[i][j];
			b[i][a[i][j]] = j;
			if (j == 0 && a[i][j] == i)
			{
				mem.push_back(i);
			}
		}
	}

	int p;
	cin >> p;
	if (p == 1)
	{
		cout << mem.size() << "\n";
		for (int i : mem) cout << i + 1 << " ";
		return 0;
	}


	vector<int> cnt;

	for (int i = 0; i < n; i++)
	{
		for (int j = n - 1; j >= 0; j--)
		{
			if (j < n - 1)
			{
				for (int t = 0; t < n; t++)
				{
					kill[i][j][t] = kill[i][j + 1][t];
				}
			}
			for (int t = 0; t < n; t++)
			{
				if (b[t][a[i][j]] <= b[t][t])
				{
					kill[i][j][t] = 1;
				}
			}
			kill[i][j][i] = 1;
		}
	}

	for (int i = 0; i < n; i++)
	{
		bool good = false;
		for (int j = 0; j < n; j++)
		{
			if (b[j][i] <= b[j][j])
			{
				bool kek = true;
				for (int t = 0; t < n; t++)
				{
					if (!kill[j][b[j][i]][t])
					{
						kek = false;
					}
				}
				if (kek) good = true;
			}
		}
		if (good) cnt.push_back(i);
	}


	
	cout << cnt.size() << "\n";
	for (int i : cnt) cout << i + 1 << " ";
	system("pause");
}