#pragma GCC optimize("OFast")
#pragma GCC target("sse,sse2,sse3,tune=native")


#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <map>
#include <vector>
#include <set>
#include <string>
#include <cassert>

using namespace std;

const int N = 500 + 10;

int a[N][N];
int b[N][N];

bool can[N];
bool kill[N][N][N];

int mem[N];
int mem_cnt = 0;
int cnt[N];
int cnt_cnt = 0;

signed main()
{
	/*ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);*/

	int n;
	scanf("%d", &n);
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < n; j++)
		{
			scanf("%d", &a[i][j]);
			--a[i][j];
			b[i][a[i][j]] = j;
			if (j == 0 && a[i][j] == i)
			{
				mem[mem_cnt++] = i;
			}
		}
	}

	int p;
	cin >> p;
	if (p == 1)
	{
		printf("%d\n", (int)mem_cnt);
		for (int i = 0; i < mem_cnt; i++) printf("%d ", mem[i] + 1);
		system("pause");
		return 0;
	}



	for (int i = 0; i < n; i++)
	{
		for (int j = n - 1; j >= 0; j--)
		{
			if (j < n - 1)
			{
				for (int t = 0; t < n; t++)
				{
					kill[i][j][t] = kill[i][j + 1][t];
				}
			}
			for (int t = 0; t < n; t++)
			{
				if (b[t][a[i][j]] <= b[t][t])
				{
					kill[i][j][t] = 1;
				}
			}
			kill[i][j][i] = 1;
		}
	}

	for (int i = 0; i < n; i++)
	{
		bool good = false;
		for (int j = 0; j < n; j++)
		{
			if (b[j][i] <= b[j][j])
			{
				bool kek = true;
				for (int t = 0; t < n; t++)
				{
					if (!kill[j][b[j][i]][t])
					{
						kek = false;
					}
				}
				if (kek) good = true;
			}
		}
		if (good) cnt[cnt_cnt++] = i;
	}



	printf("%d\n", (int)cnt_cnt);
	for (int i = 0; i < cnt_cnt; i++) printf("%d ", cnt[i] + 1);
	system("pause");
}