#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <map>
#include <vector>
#include <set>
#include <string>
#include <cassert>

using namespace std;

typedef long long ll;

const int N = 150000 + 10;

pair<ll, ll> dp[N];
pair<ll, ll> a[N];
ll b[N];
signed main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;

	bool q1 = true;
	bool q2 = true;

	for (int i = 0; i < n; i++)
	{
		cin >> a[i].first >> a[i].second;
		if (a[i].second != 0) q2 = false;
		if (a[i].first != a[i].second) q1 = false;
	}

	if (q2)
	{
		vector<ll> v;
		for (int i = 0; i < n; i++)
		{
			v.push_back(a[i].first);
		}
		sort(v.begin(), v.end());
		ll ans = 0;
		for (int i = 0; i < n; i++)
		{
			ans = max(ans, v[i] * (n - i));
		}
		cout << ans;
		system("pause");
		return 0;
	}

	if (q1)
	{
		for (int i = 0; i < n; i++)
		{
			b[i] = a[i].first;
		}
		sort(b, b + n);

		ll best = 0;
		for (int i = 0; i < n; i++)
		{
			ll cur = b[i] * (n - i);
			ll bb = b[best] * (n - best);
			if (cur > bb)
			{
				best = i;
			}
		}

		ll ans = b[best] * (n - best);
		ll cc = ans;

		for (int i = best + 1; i < n; i++)
		{
			ans = max(ans, cc + b[i] * (n - i) - b[best] * (n - i));
		}
		for (int i = 0; i < best; i++)
		{
			ans = max(ans, cc + b[i] * (i - best));
		}

		cout << ans;

		system("pause");
		return 0;
	}

	sort(a, a + n);
	ll ans = 0;
	vector<ll> v;
	for (int i = 0; i <= n; i++)
	{
		ll cur = 0;
		if (i < n)
			cur += a[i].first * (n - i);
		if (i > 0)
		{
			ll ccur = 0;
			for (int j = 0; ; j++)
			{
				if (j == v.size() || v[j] > a[i - 1].second)
				{
					v.insert(v.begin() + j, a[i - 1].second);
					break;
				}
			}
			for (int j = 0; j < v.size(); j++)
			{
				ccur = max(ccur, v[j] * ((ll)v.size() - j));
			}
			cur += ccur;
		}

		ans = max(ans, cur);
	}
	cout << ans;
	system("pause");
}