#include <bits/stdc++.h>
using namespace std;
#define int long long
const int MAXN = 3e5;
int arr[MAXN];

int tree_mx[MAXN * 4];
int tree_mn[MAXN * 4];

int my_mn(int a, int b) {
	if (arr[a] <= arr[b]) return a;
	return b;
}

int my_mx(int a, int b) {
	if (arr[a] <= arr[b]) return b;
	return a;
}

void build (int v, int l, int r) {
	if (l == r) {
		tree_mx[v] = tree_mn[v] = l;
	} else {
		int m = (l + r) / 2;
		build(v * 2, l, m);
		build(v * 2 + 1, m + 1, r);
		tree_mx[v] = my_mx(tree_mx[v * 2], tree_mx[v * 2 + 1]);
		tree_mn[v] = my_mn(tree_mn[v * 2], tree_mn[v * 2 + 1]);
	}
}

int get_mx(int v, int cl, int cr, int l, int r) {
	if (l == cl && cr == r) return tree_mx[v];
	int cm = (cl + cr) / 2;
	if (r <= cm) return get_mx(v * 2, cl, cm, l, r);
	if (l > cm)  return get_mx(v * 2 + 1, cm + 1, cr, l, r);
	return my_mx(get_mx(v * 2, cl, cm, l, cm), get_mx(v * 2 + 1, cm + 1, cr, cm + 1, r));
}

int get_mn(int v, int cl, int cr, int l, int r) {
	if (l == cl && cr == r) return tree_mn[v];
	int cm = (cl + cr) / 2;
	if (r <= cm) return get_mn(v * 2, cl, cm, l, r);
	if (l > cm)  return get_mn(v * 2 + 1, cm + 1, cr, l, r);
	return my_mn(get_mn(v * 2, cl, cm, l, cm), get_mn(v * 2 + 1, cm + 1, cr, cm + 1, r));
}

int n;

int sol(int l, int r) {
	if (l > r) return 0;
	int id = get_mx(1, 0, n - 1, l, r);
	int jd = get_mn(1, 0, n - 1, l, id);
	return 1 + sol(l, jd - 1) + sol(id + 1, r);
}

signed main() {
	ios_base::sync_with_stdio(false);

	cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> arr[i];
	}
	build(1, 0, n - 1);
	cout << sol(0, n - 1);

	return 0;
}