#include <bits/stdc++.h>

//#define int long long
#define pb push_back
#define mp make_pair
#define x first
#define y second

using namespace std;

struct item {
    int x, y;
    int cnt;
    item *l, *r;
    item(){};
};

typedef item *pitem;

int a[400000];
int place[400000];
unordered_map <int, int> m;

int cnt(pitem t) {
    if (!t)
        return 0;
    return t->cnt;
}

void update(pitem t) {
    if (!t)
        return;
    t->cnt = m[t->x] + cnt(t->l) + cnt(t->r);
}

void merge(pitem &t, pitem l, pitem r) {
    if (!l || !r) {
        t = (!l ? r : l);
        return;
    }
    if (l->y > r->y) {
        merge(l->r, l->r, r);
        t = l;
    } else {
        merge(r->l, l, r->l);
        t = r;
    }
    update(t);
}

void split(pitem t, int x, pitem &l, pitem &r) {
    if (!t) {
        l = 0;
        r = 0;
        return;
    }
    if (t->x > x) {
        split(t->l, x, l, t->l);
        r = t;
    } else {
        split(t->r, x, t->r, r);
        l = t;
    }
    update(t);
}

int get(pitem t, int x) {
    if (!t)
        return 0;
    if (t->x >= x)
        return get(t->l, x);
    else
        return m[t->x] + cnt(t->l) + get(t->r, x);
}

void print(pitem t) {
    if (!t)
        return;
    print(t->l);
    cout << t->x << ' ';
    print(t->r);
}
/*
void insert(pitem &t, pitem p) {
    if (!t)
        return void(t = p);
    if (t->x > p->x)
        insert(t->r, p);
    else {
        split();

    }
}
*/
signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    srand(time(0));
    int n, f;
    cin >> n >> f;
    for (int i = 0; i < n; i++)
        cin >> a[i];
    pitem root = 0;
    for (int i = 0; i < n; i++) {
        int d = a[i] + n - i;
        if (m[d] == 0) {
            m[d] = 1;
            pitem p = new item();
            p->x = d;
            p->y = rand();
            p->cnt = 1;
            p->l = p->r = 0;
            pitem left, right;
            split(root, d, left, right);
            merge(root, left, p);
            merge(root, root, right);
        } else {
            m[d]++;
            pitem t = root;
            while (1) {
                t->cnt++;
                if (t->x == d)
                    break;
                if (t->x > d)
                    t = t->l;
                else
                    t = t->r;
            }
        }
        //print(root);
        //cout << endl;
        place[i] += get(root, d);
    }
    m.clear();
    root = 0;
    for (int i = n - 1; i >= 0; i--) {
        int d = a[i] + i + 1;
        if (m[d] == 0) {
            m[d] = 1;
            pitem p = new item();
            p->x = d;
            p->y = rand();
            p->cnt = 1;
            p->l = p->r = 0;
            pitem left, right;
            split(root, d, left, right);
            merge(root, left, p);
            merge(root, root, right);
        } else {
            m[d]++;
            pitem t = root;
            while (1) {
                t->cnt++;
                if (t->x == d)
                    break;
                if (t->x > d)
                    t = t->l;
                else
                    t = t->r;
            }
        }
        //print(root);
        //cout << endl;
        place[i] += get(root, d);
    }
    for (int i = 0; i < n; i++)
        cout << place[i] + 1 << ' ';
    return 0;
}
