#include <iostream>
#include <vector>
#include <algorithm>
#include <fstream>

using namespace std;
ifstream fin("input.txt");

struct man{
    long long first, second, id;
};

bool cmp(pair <long long, long long> p1, pair <long long, long long> p2) {
    return p1.first < p2.first;
}

bool operator < (man m1, man m2) {
    return m1.first < m2.first;
}

int main() {
    int n, counter;
    long long best, tmp, add;
    cin >> n;
    vector <pair <long long, long long> > v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i].first >> v[i].second;
    }
    sort(v.begin(), v.end(), cmp);
    reverse(v.begin(), v.end());
    long long easy[n];
    vector <man> men(n);
    for (int i = 0; i < n; i++) {
        easy[i] = v[i].second;
        men[i].first = v[i].first;
        men[i].second = v[i].second;
        men[i].id = i;
    }
    sort(men.begin(), men.end());
    reverse(men.begin(), men.end());
    best = 0;
    bool used[n];
    for (int i = 0; i < n; i++) {
        used[i] = false;
    }
    for (int i = 0; i < n; i++) {
        tmp = (i + 1) * men[i].first;
        used[men[i].id] = true;
        add = 0;
        counter = 0;
        for (int j = 0; j < n; j++) {
            if (used[j]) {
                counter++;
            }
            else {
                add = max(add, easy[j] * (j + 1 - counter));
            }
        }
        best = max(best, tmp + add);
    }
    cout << best << '\n';
    return 0;
}
