#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>

#define pb push_back
#define mp make_pair
#define all(x) x.begin(), x.end()
#define pp " "
#define nn "\n"

using namespace std;

typedef long long ll;
typedef long double ld;

int n, p;
vector <int> r, ans, a;
vector <bool> bl;

void check_ans() {
	fill(all(r), n);
	for (int i = 0; i < n; i++) {
		if (bl[i]) {
			for (int j = 0; j < n; j++) {
				r[j] = min(r[j], abs(j - i));
			}
		}
	}
	for (int i = 0; i < n; i++) {
		int y = 1;
		for (int j = 0; j < n; j++) {
			if (a[j] + r[j] < r[i] + a[i]) {
				y++;
			}
		}
		ans[i] = min(ans[i], y);
	}
	return;
}

void rec(int v) {
	if (v == n){
		check_ans();
	}
	else {
		bl[v] = true;
		rec(v + 1);
		bl[v] = false;
		rec(v + 1);
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> p;
	a.resize(n);
	r.resize(n);
	ans.resize(n);
	fill(all(ans), n);
	bl.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	rec(0);
	for (int i = 0; i < n; i++) {
		cout << ans[i] << nn;
	}
}