#include <iostream>

int main(void) {
    int n = 0, m = 0, q = 0;
    std::cin >> n >> m >> q;
    int **a = new int*[n];
    int *maxRow = new int[n];
    int *maxColumn = new int[m];
    for (int j = 0; j < m; j++)
        maxColumn[j] = -1;
    for (int i = 0; i < n; i++) {
        a[i] = new int[m];
        maxRow[i] = -1;
        for (int j = 0; j < m; j++) {
            std::cin >> a[i][j];
            if (maxRow[i] < 0 || a[i][j] > a[i][maxRow[i]])
                maxRow[i] = j;
            if (maxColumn[j] < 0 || a[i][j] > a[maxColumn[j]][j])
                maxColumn[j] = i;
        }
    }

    for (int k = 0; k < q; k++) {
        int r = 0, c = 0, x = 0;
        std::cin >> r >> c >> x;
        r--; c--;
        a[r][c] = x;
        int counter = 0;
        if (x > a[r][maxRow[r]]) {
            maxRow[r] = c;
        }
        if (x > a[maxColumn[c]][c]) {
            maxColumn[c] = r;
        }
        for (int i = 0; i < n; i++)
            for (int j = 0; j < m; j++)
                if (maxRow[i] == j && maxColumn[j] == i) {
                    counter++;
                }

        std::cout << counter << std::endl;
    }
    return 0;
}
