#include <bits/stdc++.h>
using namespace std;

void doRoutine() {
#ifdef LOCAL
    freopen("/home/roi/clion_main/input.txt", "r", stdin);
    freopen("/home/roi/clion_main/output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

#define pii pair<int, int>
#define fi first
#define se second
#define vc vector
#define vi vector<int>
#define vvi vector<vi>
#define pb push_back
#define all(x) x.begin(), x.end()
#define vb vector<bool>

#define int long long
#define D double

// ------------------------------- CODE NOW ------------------------

int n;
const int MAXN = 505;
int arr[MAXN][MAXN];
int pos[MAXN][MAXN]; // pos[i][j] is positions virus i in cell j
int cur_pos[MAXN];

void init_curpos() {
    for (int i = 0; i < n; ++i) {
        cur_pos[i] = pos[i][i];
    }
}

void solve() {
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            pos[arr[i][j]][i] = j;
        }
    }

    vi ans;
    for (int vir = 0; vir < n; ++vir) {
        // check if vir surivives
        init_curpos();
        vi our;
        for (int i = 0; i < n; ++i) {
            if (cur_pos[i] >= pos[vir][i]) {
                cur_pos[i] = pos[vir][i];
                our.pb(i);
            }
        }
        bool sol_exists = false;
        for (auto alive : our) {
            vi bad_cells;
            for (int v = 0; v < cur_pos[alive]; ++v) {
                bad_cells.pb(arr[alive][v]);
            }

            vi good_cells;
            vb inj(n);
            for (int i = cur_pos[alive] + 1; i < n; ++i) {
                good_cells.pb(arr[alive][i]);
                inj[good_cells.back()] = true;
            }

            bool all_bad = false;
            for (auto b : bad_cells) {
                bool killable = false;
                for (int i = 0; i < cur_pos[b]; ++i) {
                    if (inj[arr[b][i]]) {
                        killable = true;
                    }
                }
                if (!killable) {
                    all_bad = true;
                }
            }

            if (!all_bad) {
                sol_exists = true;
            }
        }
        if (sol_exists) {
            ans.pb(vir);
        }
    }
    cout << ans.size() << endl;
    for (auto el : ans) {
        cout << el + 1 << " ";
    }
    cout << endl;
    exit(0);
}

signed main() {
    doRoutine();

    cin >> n;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> arr[i][j];
            --arr[i][j];
        }
    }

    int p;
    cin >> p;
    if (p == 1) {
        vi ans;
        for (int i = 0; i < n; ++i) {
            if (i == arr[i][0]) {
                ans.pb(i);
            }
        }
        cout << ans.size() << endl;
        for (auto el : ans) {
            cout << el + 1 << " ";
        }
        cout << endl;
    }
    else {
        solve();
    }

    return 0;
}