#include <bits/stdc++.h>
using namespace std;

void doRoutine() {
#ifdef LOCAL
    freopen("/home/roi/clion_main/input.txt", "r", stdin);
    freopen("/home/roi/clion_main/output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

#define pii pair<int, int>
#define fi first
#define se second
#define vc vector
#define vi vector<int>
#define vvi vector<vi>
#define pb push_back
#define all(x) x.begin(), x.end()
#define vb vector<bool>

#define int long long
#define D double

// ------------------------------- CODE NOW ------------------------

const int INF = 1000000000000;
const int MAXN = 25;
int g[MAXN][MAXN];
int n, m, k;

int x[MAXN], y[MAXN];

int dist(int i, int j) {
    return (1ll << max(abs(x[i] - x[j]), abs(y[i] - y[j])));
}

void dij() {
    vb used(k);
    vi p(k, -1);

    set<pii> st;
    vi dist(k, INF);
    dist[0] = 0;
    st.insert({0, 0});

    while (!st.empty()) {
        int v = st.begin()->se;
        st.erase(st.begin());
        used[v] = true;
        for (int u = 0; u < k; ++u) {
            if (!used[u]) {
                st.erase({dist[u], u});
                if (dist[u] > dist[v] + g[v][u]) {
                    p[u] = v;
                    dist[u] = min(dist[u], dist[v] + g[v][u]);
                }
                st.insert({dist[u], u});
            }
        }
    }

    vi res;
    int cur = k - 1;
    while (cur != -1) {
        res.pb(cur);
        cur = p[cur];
    }
    reverse(all(res));
    cout << res.size() << endl;
    for (auto el : res) {
        cout << el + 1 << " ";
    }
    cout << endl;
}

signed main() {
    doRoutine();

    cin >> n >> m >> k;
    for (int i = 0; i < k; ++i) {
        cin >> x[i] >> y[i];
    }

    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            g[i][j] = dist(i, j);
        }
    }

    dij();

    return 0;
}