#include <bits/stdc++.h>

#define __int64 long long

using namespace std;
const int N = 300000;
vector<int> ar;
map<int, set<int> > mp;


int n;
int sgmin[N * 4];
pair<int, int> sgmax[N * 4];

void build(int v = 1, int tl = 0, int tr = n - 1) {
    if (tl == tr) {
        sgmin[v] = ar[tl];
        sgmax[v] = {ar[tl], tl};
        return;
    }
    int m = (tl + tr) / 2;
    build(v * 2, tl, m);
    build(v * 2 + 1, m + 1, tr);
    sgmin[v] = min(sgmin[v * 2], sgmin[v * 2 + 1]);
    sgmax[v] = max(sgmax[v * 2], sgmax[v * 2 + 1]);
}


int getMin(int l, int r, int v = 1, int tl = 0, int tr = n - 1) {
    if (tl == l && tr == r) {
        return sgmin[v];
    }
    int m = (tl + tr) / 2;
    if (m >= r) {
        return getMin(l, r, v * 2, tl, m);
    }
    if (m < l) {
        return getMin(l, r, v * 2 + 1, m + 1, tr);
    }

    return min(getMin(l, m, v * 2, tl, m), getMin(m + 1, r, v * 2 + 1, m + 1, tr));
}

pair<int, int> getMax(int l, int r, int v = 1, int tl = 0, int tr = n - 1) {
    if (tl == l && tr == r) {
        return sgmax[v];
    }
    int m = (tl + tr) / 2;
    if (m >= r) {
        return getMax(l, r, v * 2, tl, m);
    }
    if (m < l) {
        return getMax(l, r, v * 2 + 1, m + 1, tr);
    }

    return max(getMax(l, m, v * 2, tl, m), getMax(m + 1, r, v * 2 + 1, m + 1, tr));
}


int main() {
#ifdef DEBUG
    freopen("test.in", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin >> n;
   // n = 300000;
    for (int i = 0; i < n; ++i) {
        int t;
        cin >> t;
        //t = n - i;
        ar.push_back(t);
    }
    build();
    int suma = 0;
    for (int i = 0; i < n; ++i) {
        int l = i;
        int r = n - 1;
        int cur = ar[i];
        while (l < r) {
            int m = (l + r + 1) / 2;
            if (getMin(i, m) < cur)
                r = m - 1;
            else
                l = m;
        }
        i = getMax(i, l).second;
        suma++;
    }
    cout << suma << endl;
    return 0;
}