#include <algorithm>
#include <iostream>
#include <vector>
#include <ctime>
#include <cmath>
using namespace std;

int main(){
    clock_t start = clock();
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<pair<long long, long long> > a(n);
    a.push_back(make_pair(0, 0));
    for(int i = 0; i<n; i++)
        cin >> a[i].first >> a[i].second;
    sort(a.begin(), a.end());
    long long itog = 0;
    for(int i = 0; i<n; i++){
        long long itog1 = 0;
        int l = -1, r = i+1;
        while(r-l>1){
            int m = (l+r)/2;
            if(a[m].second>a[i].second) r = m;
            else l = m;
        }
        itog1 = max(a[l].second*(i+1-l), a[l+1].second*(i-l));
        itog = max(itog, a[i+1].first*(n-i)+itog1);
        //if(clock()-start>2.97*CLOCKS_PER_SEC)
           // break;
    }
    cout << itog;

    return 0;
}
/*
5
80 20
60 50
40 40
15 10
70 30

1
50 0

4
10 0
35 0
20 0
40 0
*/
