#include <algorithm>
#include <iostream>
#include <bitset>
#include <vector>
#include <cmath>
#include <set>
using namespace std;

bitset<20> operator+(bitset<20> a, bitset<20> b){
    bitset<1> k = 0;
    bitset<20> c = 0;
    for(int i = 0; i<20; i++){
        c[i] = a[i]^b[i]^k[0];
        k = (a[i]&b[i])|(b[i]&k[0])|(k[0]&a[i]);
    }
    return c;
}

bitset<20> operator|(bitset<20> a, bitset<20> b){
    bitset<20> c = 0;
    for(int i = 0; i<20; i++){
        c[i] = a[i]|b[i];
    }
    return c;
}

bitset<20> operator++(bitset<20> a){
    return a+1;
}

bool l(bitset<20> a, bitset<20> b){
    for(int i = 20; i>0; i--){
        if(a[i-1]!=b[i-1])
            return a[i-1]<b[i-1];
    }
    return true;
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<bitset<20> > a(n);
    for(int i = 0; i<n; i++){
        string s;
        cin >> s;
        a[i] = bitset<20>(s);
    }
    string s = "";
    bitset<20> f = 1<<11, inc = 1;
    bitset<20> itog = f;
    //cout << f << ' ' << f+inc << endl;
    for(bitset<20> i = a[0]; i!=f; i = i+inc){
        for(bitset<20> j = a[1]; j!=f; j = j+inc){
            bitset<20> c = i+j, d = i|j;
            if(c==d){
                itog = min(itog, c, l);
            }
            //cout << i << ' ' << j << ' ' << c << ' ' << d << ' ' << itog << endl;
        }
    }
    cout << itog;

    return 0;
}
/*
2
10
10

2
10100
1001

3
1
1
110

2
10100
1001

2
100
10

2
11
1

2
1101
1011
*/
