#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#ifndef LOCAL
#define endl "\n"
#endif

template<typename t>
istream &operator>>(istream &in, vector<t> &a) {
    for (auto &x : a) {
        in >> x;
    }
    return in;
}

template<typename t1, typename t2>
ostream &operator<<(ostream &out, const pair<t1, t2> &a) {
    out << a.first << " " << a.second;
    return out;
};

template<typename t>
ostream &operator<<(ostream &out, const vector<t> &a) {
    for (auto &x : a) {
        out << x << endl;
    }
    return out;
}

ostream &operator<<(ostream &out, const vector<int> &a) {
    for (auto &x : a) {
        out << x << " ";
    }
    return out;
}

void s(vector<int> &a, int x, int y) {
    vector<int> a1((y - x + 2) / 2);
    vector<int> a2((y - x + 1) / 2);
    for (int i = x + 1; i <= y; i += 2) {
        a2[(i - x) / 2] = a[i];
    }
    for (int i = x; i <= y; i += 2) {
        a1[(i - x) / 2] = a[i];
    }
    for (int i = 0; i < (y - x + 1) / 2; ++i) {
        a[x + i * 2] = a2[i];
    }
    for (int i = 0; i < (y - x + 2) / 2; ++i) {
        a[x + i * 2 + (y - x + 1) / 2] = a1[i];
    }
}

void swap(int i1, int i2, vector<pair<int, int> > &ans, vector<int> &a) {
    if ((i2 - i1) % 2 == 0) {
        swap(i1 + 1, i2, ans, a);
        ans.push_back({i1 + 1, i1 + 2});
        swap(a[i1], a[i1 + 1]);
        return;
    }
    ans.push_back({i1 + 1, i2 + 1});
    s(a, i1, i2);
    if ((i2 - i1) / 2 != 0) {
        swap(i1, i1 + (i2 - i1) / 2, ans, a);
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<int> a(n);
    cin >> a;
    vector<pair<int, int> > ans;
    for (int i = 0; i < n; ++i) {
        int max_ind = i;
        for (int j = i + 1; j < n; ++j) {
            if (a[j] < a[max_ind]) {
                max_ind = j;
            }
        }
        if (max_ind != i) {
            swap(i, max_ind, ans, a);
        }
    }
    for (int i = 0; i + 1 < n; ++i) {
        assert(a[i] < a[i + 1]);
    }
    cout << ans.size() << endl << ans << endl;
    return 0;
}