#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

#define int long long

const int INF = (1 << 10) + 5;
int n;
vector<int> arr;

int to(string s)
{
	int res = 0;
	for (int i = 0; i < s.size(); ++i)
	{
		res += (s[i] == '1') * (1 << (s.size() - i - 1));
	}
	return res;
}

string tobi(int a)
{
	string res = "";
	while (a)
	{
		if (a & 1)
		{
			res.push_back('1');
		}
		else
		{
			res.push_back('0');
		}
		a >>= 1;
	}
	if (res.size() == 0)
	{
		return "0";
	}
	reverse(res.begin(), res.end());
	return res;
}

signed main()
{
	cin >> n;
	arr.resize(n);
	int res = INF;
	for (int i = 0; i < n; ++i)
	{
		string tmp;
		cin >> tmp;
		arr[i] = to(tmp);
	}
	for (int i = arr[0]; i < INF; ++i)
	{
		for (int j = arr[1]; j < INF; ++j)
		{
			if ((i | j) == i + j && i + j < res)
			{
				res = i + j;
			}
		}
	}
	cout << tobi(res) << endl;
	return 0;
}