#pragma GCC optimize("O3")
#include <bits/stdc++.h>

using namespace std;

typedef unsigned long long ll;
typedef long double ld;

const int M = 1e4 + 10;
const int N = 2 * M;
const ll INF = 1e18;
const int BIG = 1e9 + 239;
const ll B = ((ll)1 << (ll)63);
const int K = 160;
const int S = 63;

int mx[N];
ll v[N][K];

inline void add(int i, int id)
{
    int in = i / S;
    ll d = ((ll)1 << (ll)(i % S));
    while (d != 0)
    {
        ll nd = (v[id][in] + d) >> (ll)63;
        v[id][in] = (v[id][in] + d) & (B - 1);
        if (v[id][in] != 0) mx[id] = max(in, mx[id]);
        d = nd;
        in++;
    }
}

inline bool cmp(int a, int b)
{
    if (mx[a] != mx[b]) return (mx[a] < mx[b]);
    for (int i = mx[a]; i >= 0; i--)
    {
        if (v[a][i] == v[b][i]) continue;
        return (v[a][i] < v[b][i]);
    }
    return false;
}

inline void send(int i, int j)
{
    mx[j] = mx[i];
    memcpy(v[j], v[i], sizeof(v[j]));
}

int n, m, k;
pair<int, int> p[M];
int pr[M], d[M], b;
bool used[M];
char pref[N][N];

bool check(int x1, int y1, int x2, int y2)
{
    if (x1 > x2)
    {
        swap(x1, x2);
        swap(y1, y2);
    }
    int kol = 0;
    if (y2 < y1)
        swap(y1, y2);
    kol = pref[x2 + 1][y2 + 1] + pref[x1][y1] - pref[x1][y2 + 1] - pref[x2 + 1][y1];
    return (kol == 2);
}

int main()
{   /*
    freopen("test.in", "r", stdin);
    freopen("test.out", "w", stdout); /**/
    cin.sync_with_stdio(0);
    cin >> n >> m >> k;
    for (int i = 0; i < k; i++)
        cin >> p[i].first >> p[i].second;
    for (int i = 0; i < k; i++)
    {
        int x = p[i].first;
        int y = p[i].second;
        p[i].first = x + y;
        p[i].second = (x - y) + (m - 1);
    }
    for (int i = 0; i < k; i++)
        pref[p[i].first + 1][p[i].second + 1]++;
    for (int i = 0; i <= n + m; i++)
        for (int j = 0; j <= n + m; j++)
            pref[i + 1][j + 1] += (pref[i][j + 1] + pref[i + 1][j] - pref[i][j]);
    memset(used, 0, sizeof(used));
    for (int i = 1; i < k; i++)
        add(K * S - 1, i);
    for (int i = 0; i < k; i++)
        d[i] = max(n, m);
    for (int z = 0; z < k; z++)
    {
        int t = -1;
        for (int i = 0; i < k; i++)
            if (!used[i])
                if (t == -1 || cmp(i, t))
                    t = i;
        used[t] = true;
        if (t == k - 1) break;
        for (int i = 0; i < k; i++)
            if (!used[i] && check(p[t].first, p[t].second, p[i].first, p[i].second))
            {
                int r = ((abs(p[i].first - p[t].first) + abs(p[i].second - p[t].second)) >> 1);
                if (r >= d[i]) continue;
                if ((r / S) > mx[i]) continue;
                if (mx[t] < mx[i] && (r / S) <= mx[t])
                {
                    send(t, i);
                    add(r, i);
                    pr[i] = t;
                    continue;
                }
                send(t, t + k);
                add(r, t + k);
                if (cmp(t + k, i))
                {
                    send(t + k, i);
                    pr[i] = t;
                }
                else
                    d[i] = r;
            }
    }
    vector<int> ans;
    int x = k - 1;
    while (x != 0)
    {
        ans.push_back(x);
        x = pr[x];
    }
    ans.push_back(x);
    reverse(ans.begin(), ans.end());
    cout << ans.size() << "\n";
    for (int t : ans)
        cout << (t + 1) << " ";
    return 0;
}
