#pragma GCC optimize("O3")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int BIG = 1e9 + 239;
const int M = 3 * 1e5 + 239;
const int T = (1 << 20);

int n;
string s[M];
int len;
vector<char> ans;

bool solve(int d, vector<int> v)
{
    if (v.empty())
    {
        for (int i = 0; i < len - d; i++)
            ans.push_back('0');
        return true;
    }
    if (d == len) return true;
    bool can = true;
    for (int i : v)
        can &= (s[i][d] == '0');
    if (can)
    {
        ans.push_back('0');
        if (solve(d + 1, v)) return true;
        ans.pop_back();
    }
    int sz = 0;
    for (int i : v)
        sz += (s[i][d] == '1');
    if (sz >= 2) return false;
    int id = 0;
    for (int i = 1; i < v.size(); i++)
        if (s[v[i]] > s[v[id]])
            id = i;
    if (sz == 0)
    {
        vector<int> u;
        for (int x = 0; x < id; x++)
            u.push_back(v[x]);
        for (int x = id + 1; x < v.size(); x++)
            u.push_back(v[x]);
        v = u;
    }
    else
        s[v[id]][d] = '0';
    ans.push_back('1');
    bool ch = solve(d + 1, v);
    if (!ch) ans.pop_back();
    if (sz != 0)
        s[v[id]][d] = '1';
    return ch;
}

int main()
{   /*
    freopen("test.in", "r", stdin);
    freopen("test.out", "w", stdout); /**/
    ios::sync_with_stdio(0);
    cin >> n;
    for (int i = 0; i < n; i++)
        cin >> s[i];
    len = 0;
    for (int i = 0; i < n; i++)
        len = max(len, (int)s[i].size() + n);
    for (int i = 0; i < n; i++)
    {
        int k = len - (int)s[i].size();
        reverse(s[i].begin(), s[i].end());
        for (int x = 0; x < k; x++)
            s[i] += '0';
        reverse(s[i].begin(), s[i].end());
    }
    sort(s, s + n);
    vector<int> u;
    for (int i = 0; i < n; i++)
        u.push_back(i);
    solve(0, u);
    bool wr = false;
    for (int i = 0; i < len; i++)
    {
        if (!wr && ans[i] != '0')
            wr = true;
        if (wr)
            cout << ans[i];
    }
    return 0;
}
