#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

#define LL long long

int main()
{
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	ios_base::sync_with_stdio(NULL); cin.tie(0); cout.tie(0);

	int n, m, q;
	cin >> n >> m >> q;

	vector< vector < int > > pole(n, vector < int >(m));
	vector< pair <int, int> > st(n), str(m);


	for (size_t i = 0; i < n; i++)
	{
		for (size_t j = 0; j < m; j++)
		{
			cin >> pole[i][j];
			if (pole[i][j] > st[i].first)
				st[i] = { pole[i][j], j };
			if (pole[i][j] > str[j].first)
				str[j] = { pole[i][j], i };
		}
	}

	int ans = 0;

	for (size_t i = 0; i < n; i++)
	{
		if (str[st[i].second].second == i)
			ans++;
	}

	for (size_t k = 0; k < q; k++)
	{
		int r, c, x;
		cin >> r >> c >> x;
		r--;
		c--;

		if (st[r].second == c && str[c].second == r)
		{
			st[r].first = x;
			str[c].first = x;
			cout << ans << "\n";
		}
		else
		{
			if (x > st[r].first)
				if (str[st[r].second].second == r)
					ans--;
			if (x > str[c].first)
				if (st[str[c].second].second == c)
					ans--;

			if (x > st[r].first)
				st[r] = { x, c };
			if (x > str[c].first)
				str[c] = { x, r };

			if (st[r].second == c && str[c].second == r)
				ans++;

			cout << ans << "\n";
		}
	}

	return 0;
}