#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>

using namespace std;

#define LL long long

vector<int> v, id;

void f(int l, int r)
{
	vector<int> new_v(r - l + 1);

	int j = 0;
	for (size_t i = l + 1; i <= r; i += 2, j++)
		new_v[j] = v[i];
	for (size_t i = l; i <= r; i += 2, j++)
		new_v[j] = v[i];

	for (size_t i = l, j = 0; i <= r; i++, j++)
	{
		v[i] = new_v[j];
		id[v[i]] = i;
	}
}

int main()
{
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	ios_base::sync_with_stdio(NULL); cin.tie(0); cout.tie(0);

	int n;
	cin >> n;

	v.resize(n);
	id.resize(n);
	queue< pair<int, int> > q;

	for (size_t i = 0; i < n; i++)
	{
		cin >> v[i];
		v[i]--;
		id[v[i]] = i;
	}

	for (int i = 0, j = n - 1; i < j;)
	{
		while (id[i] != i && id[j] != j)
		{
			int l, r = j;

			if ((id[i] - i) % 2)
				l = i;
			else
				l = i + 1;

			if (id[j] % 2 == id[i] % 2)
					r = id[i];
			

			q.push({ l, r });
			f(l, r);
		}

		if (id[i] == i)
			i++;
		else
			j--;
	}

	cout << q.size() << "\n";

	while (!q.empty())
	{
		auto p = q.front();
		cout << p.first + 1 << " " << p.second + 1 << "\n";
		q.pop();
	}

	return 0;
}