#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>

using namespace std;

#define LL long long

int main()
{
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	ios_base::sync_with_stdio(NULL); cin.tie(0); cout.tie(0);

	int n;
	cin >> n;

	if (n != 2)
	{
		vector< short int > v(400000);

		for (size_t i = 0; i < n; i++)
		{
			string s;
			cin >> s;
			int j = s.size() - 1;
			while (v[j] == 1)
				j++;
			v[j] = 1;
		}

		int p = 0;
		for (int i = v.size() - 1; i >= 0; i--)
		{
			if (p)
				cout << v[i];
			else if (v[i] == 1)
			{
				p = 1;
				cout << 1;
			}
		}

		return 0;
	}

	string s1, s2, ans;
	cin >> s1 >> s2;

	reverse(s1.begin(), s1.end());
	reverse(s2.begin(), s2.end());

	int q = 0;

	for (int i = 0, j = 0; q < s1.size() && q < s2.size(); q++)
	{
		if (s1[q] == '0' && s2[q] == '0')
			ans += "0";
		else if (s1[q] == '1' && s2[q] == '1')
		{
			j = i = q;
			ans += "1";
			while (i < s1.size() && s1[i] == '1')
				i++;
			while (j < s2.size() && s2[j] == '1')
				j++;
			if (i < j)
			{
				for (size_t k = q; k < j; k++)
				{
					s2[k] = '0';
				}
				if (j == s2.size())
					s2 += "1";
				else
					s2[j] = '1';
			}
			else
			{
				for (size_t k = q; k < i; k++)
				{
					s1[k] = '0';
				}
				if (i == s1.size())
					s1 += "1";
				else
					s1[i] = '1';
			}
		}
		else
			ans += "1";
	}

	for (int i = s1.size() - 1; i >= q; i--)
	{
		cout << s1[q];
	}
	for (int i = s2.size() - 1; i >= q; i--)
	{
		cout << s2[q];
	}

	reverse(ans.begin(), ans.end());
	cout << ans;



	return 0;
}