#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

#define int long long

vector<int> a, b;
int n;

int f(int x, int y)
{
	int res = 0;
	for (int i = 0; i < n; i++)
		if (y <= a[i])
			res += y;
		else if (x <= b[i])
			res += x;

	return res;
}

int tern_b(int x)
{
	int l = x, r = 1e+9 + 1;

	while (r - l > 2) {
		int m1 = l + (r - l) / 3, m2 = r - (r - l) / 3;

		if (f(x, m1) < f(x, m2))
			l = m1;
		else
			r = m2;
	}

	int res = 0;
	for (int i = l; i < r; i++)
		res = max(res, f(x, i));

	return res;
}

int tern_a()
{
	int l = 0, r = 1e+9 + 1;

	while (r - l > 2) {
		int m1 = l + (r - l) / 3, m2 = r - (r - l) / 3;

		if (tern_b(m1) < tern_b(m2))
			l = m1;
		else
			r = m2;
	}

	int res = 0;
	for (int i = l; i < r; i++)
		res = max(res, tern_b(i));

	return res;
}

signed main()
{
	//freopen("input.txt", "r", stdin);
	ios_base::sync_with_stdio(0), cin.tie(0);

	cin >> n;
	a.resize(n);
	b.resize(n);
	
	for (int i = 0; i < n; i++)
		cin >> a[i] >> b[i];

	cout << tern_a();
}
