#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
void entry(int testId);
int main() {
	if (DEV) {
		string fileName = "pub";
		string fin = fileName + ".txt";
		string fout = fileName + "-out.txt";
		freopen(fin.c_str(), "r", stdin);
		freopen(fout.c_str(), "w", stdout);
	}
	else {
		ios_base::sync_with_stdio(false);
		cin.tie(nullptr);
	}
	int i = 0;
	int k = 1e8;
	if (!DEV) k = 1;
	while (!cin.eof() && (k--)) {
		entry(i++);
	}
}
#define endl "\n"
void entry(int testId) {
	int n, m, q;
	cin >> n >> m >> q;
	vector<vector<int>> f(n, vector<int>(m));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			cin >> f[i][j];
		}
	}
	auto silly = [&]() {
		vector<pair<int, int>> vec;
		vector<int> rm(n, -1), cm(m, -1);
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) {
				rm[i] = max(rm[i], f[i][j]);
				cm[j] = max(cm[j], f[i][j]);
			}
		}
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) {
				if (f[i][j] == rm[i] && f[i][j] == cm[j]) {
					vec.emplace_back(i, j);
				}
			}
		}
		return vec;
	};
	for (int i = 0; i < q; ++i) {
		int x, y, v;
		cin >> x >> y >> v;
		--x;
		--y;
		f[x][y] = v;
		auto ret = silly();
		cout << ret.size() << endl;
	}
}