#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef tree<ll, null_type, less<ll>, rb_tree_tag,
             tree_order_statistics_node_update> treap;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll n, i, j, k;
    cin >> n;

    vector<pair<ll, ll>> pref(n);
    treap plus;
    for (i = 0; i < n; i++)
    {
        cin >> pref[i].first >> pref[i].second;

        plus.insert(pref[i].first);
    }

    ll ans = -1;
    for (i = 0; i < n; i++)
    {
        ll price_plus = pref[i].first;

        ans = max(ans, price_plus * (ll)(n - plus.order_of_key(price_plus)));
    }

    cout << ans << endl;

    return 0;
}
