#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
using namespace std;

const int len = 3e5;
int x, y, q;
vector < int > a[len];

multiset < int > r[len], c[len];

vector < int > values;
int pr[len], pc[len];
map < int, pair < int, int > > back;

int cnt = 0;

void addMax(int val, int i, int j){
	values.push_back(val);
	pr[i] = values.size() - 1;
	pc[j] = values.size() - 1;
	back[val] = { i, j };

	cnt++;
}

void delMax(int val){
	auto p = back[val];
	int i = p.first;
	int j = p.second;
	pr[i] = -1;
	pc[j] = -1;

	cnt--;
}
	
int main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	cin >> x >> y >> q;
	for(int i = 0;i < x;i++){
		a[i].resize(y);
		for(auto &el: a[i])
			cin >> el;
	}

	for(int i = 0;i < x;i++){
		for(int j = 0;j < y;j++){
			pc[j] = -1;
			pr[i] = -1;
			r[i].insert(a[i][j]);
			c[j].insert(a[i][j]);
		}
	}

	for(int i = 0;i < x;i++){
		for(int j = 0;j < y;j++){
			if(a[i][j] == (*r[i].rbegin()) && a[i][j] == (*c[j].rbegin())){
				addMax(a[i][j], i, j);
			}
		}
	}

	for(int t = 0;t < q;t++){
		int i, j, val;
		cin >> i >> j >> val;
		--i;
		--j;

		r[i].erase(r[i].find(a[i][j]));
		c[j].erase(c[j].find(a[i][j]));

		a[i][j] = val;

		r[i].insert(a[i][j]);
		c[j].insert(a[i][j]);

		if(pr[i] != -1){
			if(values[pr[i]] < val){
				delMax(values[pr[i]]);
			}
		}
		if(pc[j] != -1){
			if(values[pc[j]] < val){
				delMax(values[pc[j]]);
			}
		}

		if(a[i][j] == (*r[i].rbegin()) && a[i][j] == (*c[j].rbegin())){
			addMax(a[i][j], i, j);
		}

		cout << cnt << endl;
	}
}