#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <iomanip>
#include <algorithm>
#include <cmath>
using namespace std;

int x;
const int len = 3e5;
int a[len];

int t[len * 4];
int t2[len * 4];

void build(int v, int l, int r){
	if(l == r - 1){
		t[v] = a[l];
		t2[v] = a[l];
		return;
	}
	int m = l + r >> 1;
	build(2 * v + 1, l, m);
	build(2 * v + 2, m, r);
	t[v] = min(t[2 * v + 1], t[2 * v + 2]);
	t2[v] = max(t2[2 * v + 1], t2[2 * v + 2]);
}

int gtmin(int v, int l, int r, int from, int to){
	if(from <= l && r <= to)
		return t[v];
	if(from >= r || to <= l)
		return 1ll << 30;
	int m = l + r >> 1;
	return min(gtmin(2 * v + 1, l, m, from, to), gtmin(2 * v + 2, m, r, from, to));
}

int gtmax(int v, int l, int r, int from, int to){
	if(from <= l && r <= to)
		return t2[v];
	if(from >= r || to <= l)
		return 0;
	int m = l + r >> 1;
	return max(gtmax(2 * v + 1, l, m, from, to), gtmax(2 * v + 2, m, r, from, to));
}

int dp[len];

int main(){
	scanf("%d", &x);
	for(int i = 0;i < x;i++){
		scanf("%d", &a[i]);
	}
	build(0, 0, x);

	for(int i = 0;i <= x;i++){
		dp[i] = 1 << 20;
	}

	dp[0] = 0;

	int mn = 1ll << 30;
	int pos = -1;

	for(int i = 0;i < x;i++){
		/*bool ok = false;
		for(int j = 0;j <= i && !ok;j++){
			if(gtmin(0, 0, x, j, i + 1) == a[j] && gtmax(0, 0, x, j, i + 1) == a[i]){
				//dp[i + 1] = min(dp[i + 1], dp[j] + 1);
				if(dp[i + 1] > dp[j] + 1){
					dp[i + 1] = dp[j] + 1;
					ok = true;
				}
			}
		}*/
		int mn = 1ll << 30;
		int mx = 0;
		int pos = i;
		for(int j = i;j >= 0;j--){
			mn = min(mn, a[j]);
			mx = max(mx, a[j]);
			if(mn == a[j] && mx == a[i])
				pos = j;
		}
		dp[i + 1] = min(dp[i + 1], dp[pos] + 1);
	}
	cout << dp[x];
}
