#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <stack>
using namespace std;

const int len = 4000;
int x;
int a[len];
int b[len];
int c[len];

vector < pair < int, int > > ans;

void apply(int l, int r){
	ans.push_back({ l, r - 1 });
	int pos = l;
	for(int i = l + 1;i < r;i += 2)
		b[pos++] = a[i];
	for(int i = l;i < r;i += 2)
		b[pos++] = a[i];
	for(int i = l;i < r;i++)
		a[i] = b[i];
}

bool sorted(int l, int r){
	for(int i = l + 1;i < r;i++){
		if(a[i - 1] > a[i])
			return false;
	}
	return true;
}

void solve(int l, int r, int cnt = 0){
	if(l == r - 1)
		return;
	for(int i = 0;i < (r - l) / 2;i++){
		int ps = l + i;
		int pos = -1;
		for(int j = l;j < r;j++){
			if(a[j] == cnt + i + 1)
				pos = j;
		}

		while(pos != ps){
			if((pos - ps) % 2 == 0){
				apply(ps + 1, pos + 1);
				pos = ps + 1 + (pos - ps) / 2 - 1;
			} else {
				apply(ps, pos + 1);
				pos = ps + (pos - ps + 1) / 2 - 1;
			}
		}
	}
	solve(l + r >> 1, r, cnt + (r - l) / 2);
}

int main(){
	cin >> x;
	for(int i = 0;i < x;i++)
		cin >> a[i];
	/*for(int i = 0;i < x;i++){
		int pos = 0;
		for(int j = i;j < x;j++){
			if(i + 1 == a[j]){
				pos = j;
				break;
			}
		}
		int it = 0;
		while(pos != i){
			if((pos - i) % 2 == 0){
				apply(i + 1, pos + 1);
				pos = i + 1 + (pos - i) / 2 - 1;
			} else {
				apply(i, pos + 1);
				pos = i + (pos - i + 1) / 2 - 1;
			}
		}
	}
	apply(0, x);*/
	solve(0, x);
	//for(int i = 0;i < x;i++)
	//	cout << a[i] << ' ';
	//cout << endl;

	cout << ans.size() << endl;
	for(auto el: ans)
		cout << el.first + 1 << ' ' << el.second + 1 << endl;
}
