#include <iostream>

using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    int n, m, q;
    cin >> n >> m >> q;
    int a[n][m];
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }
    int maxij[n], maxii[m];
    int indmaxj[n], indmaxi[m];
    for (int i = 0; i < n; ++i) {
        maxij[i] = -1;
        for (int j = 0; j < m; ++j) {
            if (a[i][j] > maxij[i]) {
                maxij[i] = a[i][j];
                indmaxj[i] = j;
            }
        }
    }
    for (int j = 0; j < m; ++j) {
        maxii[j] = -1;
        for (int i = 0; i < n; ++i) {
            if (a[i][j] > maxii[j]) {
                maxii[j] = a[i][j];
                indmaxi[j] = i;
            }
        }
    }
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (maxii[j] == a[i][j] && maxij[i] == a[i][j]) {
                ++cnt;
            }
        }
    }
    for (int t = 0; t < q; ++t) {
        int r, c, x;
        cin >> r >> c >> x;
        --r, --c;
        if (maxii[c] == a[r][c] && maxij[r] == a[r][c]) {
            maxii[c] = x;
            maxij[r] = x;
            a[r][c] = x;
            cout << cnt << "\n";
            continue;
        }
        if (x > maxii[c]) {
            if (maxii[c] == maxij[indmaxi[c]]) {
                --cnt;
            }
            maxii[c] = x;
            indmaxi[c] = r;
        }
        if (x > maxij[r]) {
            if (maxij[r] == maxii[indmaxj[r]]) {
                --cnt;
            }
            maxij[r] = x;
            indmaxj[r] = c;
        }
        a[r][c] = x;
        if (maxii[c] == maxij[r] && maxii[c] == a[r][c]) {
            ++cnt;
        }
        cout << cnt << "\n";
    }
    return 0;
}
/*
2 3 3
1 4 3
6 5 2
2 2 9
1 3 5
2 2 10
*/
