#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int MAXL = 20;

pair <int, int> sp[MAXL][1 << MAXL];
int pre[1 << MAXL];

pair <int, int> cmp(pair <int, int> a, pair <int, int> b)
{
    return (a.first > b.first ? a : b);
}

pair <int, int> get(int l, int r)
{
    int st = pre[r - l + 1];
    return cmp(sp[st][l], sp[st][r - (1 << st) + 1]);
}

signed main()
{
#ifdef POSPELOV
    freopen("in.txt", "r", stdin);
#endif // POSPELOV
    ios_base::sync_with_stdio(0);
    int n;
    cin >> n;
    vector <int> arr(n);
    for (int &i : arr)
        cin >> i;
    for (int i = 0; i < n; i++)
        sp[0][i] = {arr[i], i};
    pre[0] = -1;
    for (int i = 1; i <= n; i++)
        pre[i] = pre[i / 2] + 1;
    for (int i = 1; i < MAXL - 1; i++)
        for (int j = 0; j < n; j++)
            sp[i][j] = cmp(sp[i - 1][j], sp[i - 1][j + (1 << (i - 1))]);

    vector <int> nxt(n, n);
    vector <pair <int, int>> st;
    for (int i = n - 1; i >= 0; i--)
    {
        while (!st.empty() && st.back().first >= arr[i])
            st.pop_back();
        if (!st.empty())
            nxt[i] = st.back().second;
        st.push_back({arr[i], i});
    }
    int ans = 0;
    for (int i = 0; i < n; i++)
    {
        int r = nxt[i];
        int pos = get(i, r - 1).second;
        ans++;
        i = pos;
    }
    cout << ans;
    return 0;
}
