#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int MAXN = 1600010;
const int MAXR = 800000;

struct T
{
    int arr[MAXN];
    T()
    {
        for (int i = 0; i < MAXN; i++)
            arr[i] = 0;
    }
    void upd(int v, int vl, int vr, int &p, int &val)
    {
        if (p < vl || vr < p)
            return;
        if (vl == vr)
        {
            arr[v] += val;
            return;
        }
        upd(v * 2, vl, (vl + vr) / 2, p, val);
        upd(v * 2 + 1, (vl + vr) / 2 + 1, vr, p, val);
        arr[v] = arr[v * 2] + arr[v * 2 + 1];
    }
    void upd(int p, int val)
    {
        upd(1, 0, MAXR - 1, p, val);
    }
    int get(int v, int vl, int vr, int &p)
    {
        if (vr < p)
            return 0;
        if (p <= vl)
            return arr[v];
        return get(v * 2, vl, (vl + vr) / 2, p) + get(v * 2 + 1, (vl + vr) / 2 + 1, vr, p);
    }
    int get(int p)
    {
        return get(1, 0, MAXR - 1, p);
    }
};

T t1;
T t2;

signed main()
{
#ifdef POSPELOV
    freopen("in.txt", "r", stdin);
#endif // POSPELOV
    ios_base::sync_with_stdio(0);
    int n, p;
    cin >> n >> p;
    vector <int> arr(n);
    set <int> crds;
    for (int i = 0; i < n; i++)
    {
        cin >> arr[i];
        crds.insert(arr[i] - i);
        crds.insert(arr[i] + i);
    }
    unordered_map <int, int> mp;
    int cnt = 0;
    for (auto it : crds)
        mp[it] = cnt++;
    auto h = [&](int x)
    {
        return mp[x];
    };

    vector <int> ans(n);
    for (int i = 0; i < n; i++)
        t1.upd(h(arr[i] - i), 1);

    for (int i = n - 1; i >= 0; i--)
    {
        t1.upd(h(arr[i] - i), -1);
        ans[i] = (i - t1.get(h(arr[i] - i))) + (n - 1 - i - t2.get(h(arr[i] + i))) + 1;
        t2.upd(h(arr[i] + i), 1);
    }

    for (int i : ans)
        cout << i << " ";
    return 0;
}
