INF = 1 << 10000

def getdist(v, u):
    return (1 << max(abs(a[v][0] - a[u][0]), abs(a[v][1] - a[u][1])))

n, m, k = map(int, input().split())
a = [None] * k

for i in range(k):
    a[i] = list(map(int, input().split()))

used = [False] * k
prev = [-1] * k
dist = [INF] * k
dist[0] = 0
while True:
    v = -1
    for i in range(k):
        if not used[i] and (v == -1 or dist[v] > dist[i]):
            v = i
    if (v == -1):
        break
    used[v] = True
    for u in range(k):
        if v != u and dist[u] >= dist[v] + getdist(v, u):
            dist[u] = dist[v] + getdist(v, u)
            prev[u] = v
            used[u] = False
path = []
v = k - 1
while v != -1:
    path.append(v + 1)
    v = prev[v]
print(len(path))
print(*path[::-1])
