#include <bits/stdc++.h>

using namespace std;

#define f first
#define s second
#define mp make_pair
#define pb push_back
#define all(a) a.begin(), a.end()
#define REP(i, st, n) for (int i = (st); i < (n); ++i)

typedef long long ll;

template <typename T1, typename T2> inline void chkmin(T1 &x, T2 y) { if (y < x) x = y; };
template <typename T1, typename T2> inline void chkmax(T1 &x, T2 y) { if (y > x) x = y; };

const int INF = 2e9;
const int N = 400005;
int n, type;
int a[N];
int ans_stupid[N];
int x[N];
int ord[N];

void read() {
    cin >> n >> type;
    for (int i = 0; i < n; ++i)
        cin >> a[i];
}

void solve_stupid() {
    for (int i = 0; i < n; ++i) {
        ans_stupid[i] = (type == 1 ? INF : -INF);
    }
    for (int mask = 1; mask < (1 << n); ++mask) {
        for (int i = 0; i < n; ++i) x[i] = ((mask & (1 << i)) ? 0 : INF);
        for (int i = 1; i < n; ++i) chkmin(x[i], x[i - 1] + 1);
        for (int i = n - 2; i >= 0; --i) chkmin(x[i], x[i + 1] + 1);

        for (int i = 0; i < n; ++i)
            ord[i] = (x[i] + a[i]);
        sort(ord, ord + n);

        for (int i = 0; i < n; ++i) {
            int l = -1, r = n - 1;
            while (r - l > 1) {
                int mid = (l + r) >> 1;
                if (ord[mid] >= x[i] + a[i])
                    r = mid;
                else
                    l = mid;
            }
            int place = r + 1;
            if (type == 1) {
                chkmin(ans_stupid[i], place);
            }
            else {
                chkmax(ans_stupid[i], place);
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
#ifdef DEBUG
    freopen("C.in", "r", stdin);
#endif // DEBUG

    read();
    solve_stupid();
    for (int i = 0; i < n; ++i)
        cout << ans_stupid[i] << '\n';

    return 0;
}
