#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

int main() {

	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	long long n, m, q;
	cin >> n >> m >> q;

	vector < vector < int > > a(n, vector < int >(m));

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> a[i][j];
		}
	}

	vector < pair < int, int  > > strok(n), stolb(m); //    

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if (strok[i].first < a[i][j]) {
				strok[i] = { a[i][j], j };
			}
			if (stolb[j].first < a[i][j]) {
				stolb[j] = { a[i][j], i };
			}
		}
	}

	int cnt = 0;

	vector < vector < bool > > good(n, vector < bool >(m, false));

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			int temp1 = strok[i].first;
			int temp2 = stolb[j].first;

			if (temp1 == a[i][j] && temp2 == a[i][j]) {
				cnt++;
				good[i][j] = true;
			}
		}
	}

	for (int k = 0; k < q; k++) {
		int x, y, val;
		cin >> x >> y >> val;
		x--;
		y--;
		int temp1 = strok[x].first;
		int temp2 = stolb[y].first;

		int y2 = strok[x].second;
		int x2 = stolb[y].second;

		if (val > temp1) {
			if (good[x][y2] == true) {
				cnt--;
				good[x][y2] = false;
			}
		}
		if (val > temp2) {
			if (good[x2][y] == true) {
				cnt--;
				good[x2][y] = false;
			}
		}



		a[x][y] = val;
		if (strok[x].first < a[x][y]) {
			strok[x] = { a[x][y], y };
		}
		if (stolb[y].first < a[x][y]) {
			stolb[y] = { a[x][y], x };
		}

		temp1 = strok[x].first;
		temp2 = stolb[y].first;

		if (temp1 == a[x][y] && temp2 == a[x][y]) {
			cnt++;
			good[x][y] = true;
		}

		cout << cnt << "\n";
	}





	system("pause");
	return 0;
}