#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <map>
#include <cassert>
#include <string>

using namespace std;

const long long max_L = 1e6;
vector < int > res(max_L, 0);

bool men(string a, string b) {
	if (a.size() == b.size()) {
		for (int i = 0; i < a.size(); i++) {
			if (a[i] == '0' && b[i] == '1')
				return true;
			if (a[i] == '1' && b[i] == '0')
				return false;
		}
	}
	return a.size() <= b.size();
}
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	long long n;
	cin >> n;

	if (n == 2) {
		string a, b;
		cin >> a >> b;
		if (men(b, a)) {
			swap(a, b);
		}

		for (int i = 0; i < a.size(); i++) {
			int id = a.size() - i - 1;
			if (a[i] != '0') {
				res[id] = 1;
			}
		}
		vector < int > one;
		bool ok = false;
		for (int i = 0; i < b.size(); i++) {
			if (b[i] == '0') continue;
			int id = b.size() - i - 1;
			if (res[id] == 1) {
				for (int j = id + 1; j < res.size(); j++) {
					if (res[j] == 0) {
						res[j] = 1;
						for (int q = 0; q < one.size(); q++) {
							if (one[q] < j) {
								res[one[q]] = 0;
							}
						}
						break;
					}
				}
				break;
			}
			else {
				res[id] = 1;
				one.push_back(id);
			}
		}

		long long size = 0;
		for (int i = 0; i < res.size(); i++) {
			if (res[i] == 1) {
				size = i;
			}
		}

		for (int i = size; i >= 0; i--) {
			cout << res[i];
		}

		system("pause");
		return 0;

	}
	vector < long long > cnt(max_L, 0);
	for (int i = 0; i < n; i++) {
		string a;
		cin >> a;

		for (int j = 0; j < a.size(); j++) {
			if (a[j] == '0') continue;
			int id = a.size() - j - 1;
			cnt[id]++;
		}
	}

	for (int i = 0; i < cnt.size(); i++) {
		if (cnt[i] > 0) {
			res[i] = 1;
			cnt[i + 1] += cnt[i] - 1;
		}
	}

	long long size = 0;
	for (int i = 0; i < res.size(); i++) {
		if (res[i] == 1) {
			size = i;
		}
	}

	for (int i = size; i >= 0; i--) {
		cout << res[i];
	}

	system("pause");
	return 0;
}