#include <stdio.h>
#include <bits/stdc++.h>

using namespace std;

int run();

int main() {
    //ios_base::sync_with_stdio(0);
    //cin.tie(nullptr);
    run();
    return 0;
}

const int MX = 2e5 + 10;

vector<pair<int, int> > x(MX, {0, 0}), y(MX, {0, 0});

set<pair<int, int> > goodX, goodY;
void upd(int i) {
    pair<int, int> cur = x[i];
    assert(cur.first != 0);
    assert(cur.second != 0);
    if (y[cur.second].first == cur.first)
        goodX.insert({i, cur.second}), goodY.insert({cur.second, i});
}

vector<int> need;

int run() {
    int n, m, q;
    scanf("%d %d %d", &n, &m, &q);
    vector<vector<int> > a(n + 1, vector<int> (m + 1, 0));
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            scanf("%d", &a[i][j]);
            x[i] = max(make_pair(a[i][j], j), x[i]);
            y[j] = max(make_pair(a[i][j], i), y[j]);
        }
    }

    for (int i = 1; i <= n; ++i)
        upd(i);

    while (q--) {
        int r, c, val;
        scanf("%d %d %d", &r, &c, &val);

        need.clear();
        need.push_back(r);

        auto itx = goodX.lower_bound({r, -1});
        if (itx != goodX.end() && (*itx).first == r) {
            goodX.erase(*itx);
            pair<int, int> er = {(*itx).second, (*itx).first};
            goodY.erase(er);
        }

        auto ity = goodY.lower_bound({c, -1});
        if (ity != goodY.end() && (*ity).first == c) {
            goodY.erase(*ity);
            pair<int, int> er = {(*ity).second, (*ity).first};
            goodX.erase(er);
            need.push_back(er.first);
        }

        //x[r].erase({a[r][c], c});
        //y[c].erase({a[r][c], r});

        a[r][c] = val;

        //x[r].insert({a[r][c], c});
        //y[c].insert({a[r][c], r});
        x[r] = max(make_pair(a[r][c], c), x[r]);
        y[c] = max(make_pair(a[r][c], r), y[c]);

        assert(need.size() <= 2);
        for (int i : need)
            upd(i);

        printf("%d\n", (int)goodX.size());
    }
}


/*
2 3 3
1 4 3
6 5 2
2 2 9
1 3 5
2 2 10
*/
