import java.awt.image.ImagingOpException;
import java.io.*;
import java.util.ArrayList;
import java.util.Locale;
import java.util.StringTokenizer;
import java.util.TreeSet;

public class Main {
    ArrayList<ArrayList<Integer>> q;
    boolean[] used;

    void dfs(int v) {
        if (!used[v]) {
            used[v] = true;
            for (int i = 0; i < q.get(v).size(); i++) {
                dfs(q.get(v).get(i));
            }
        }
    }

    public void solve() throws IOException {
        int n = nextInt();
        int[][] x = new int[n][n];
        int[] g = new int[n];
        int[][] a = new int[n][n];
        ArrayList<Integer> res1 = new ArrayList<>();
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                a[i][j] = nextInt() - 1;
                x[i][a[i][j]] = j;
            }
            if (a[i][0] == i) {
                res1.add(i + 1);
            }
        }
        if (nextInt() == 1) {
            out.println(res1.size());
            for (int i = 0; i < res1.size(); i++) {
                out.print(res1.get(i) + " ");
            }
            return;
        }
        TreeSet<Integer> res = new TreeSet<>();
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if (a[i][j] == i) {
                    g[i] = j;
                }
            }
        }
        for (int i = 0; i < n; i++) {
            int[] g1 = g.clone();
            if (a[i][0] == i){
                res.add(i + 1);
            }
            for (int j = 0; j < n; j++) {
                if (a[i][j] == i) break;
                if (res.contains(a[i][j] + 1)) continue;
                res.add(a[i][j] + 1);
                boolean t = true;
                for (int k = 0; k < n; k++) {
                    if (a[k][g1[k]] == a[i][j]){
                        g1[k]--;
                        if (g1[k] < 0){
                            t = false;
                            break;
                        }
                    }
                }
                if (!t)break;
            }
        }
        out.println(res.size());
        while (res.size() > 0){
            out.print(res.pollFirst() + " ");
        }
    }

    BufferedReader br;
    StringTokenizer sc;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                sc = null;
            }
        }
        return sc.nextToken();
    }

    public Integer nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public Long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

    public void run() throws IOException {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }
}