#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <stdio.h>
#include <map>


using namespace std;

void print(vector<int> s){
    for (int i : s)
        cout << i;
    cout << endl;
}

int main()
{
    #ifdef ONPC
        freopen("test.in", "r", stdin);
    #endif // ONPC
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<int> s(n);
    for (int i = 0; i < n; i++){
        string lst;
        cin >> lst;
        int x = 0;
        for (int j = lst.size() - 1; j >= 0; j--)
            x = x * 2 + int(lst[j] - '0');
        s[i] = x;
    }
    sort(s.begin(), s.end());
    reverse(s.begin(), s.end());
    for (int i = 0; i < (1 << 12); i++){
        int cur = i;
        bool ok = true;
        for (int j = 0; j < n; j++){
            int now = 0;
            for (int k = 11; k >= 0; k--){
                if ((1 << k) & cur){
                    now = (1 << k);
                    break;
                }
            }
            if (now > s[j]){
                cur ^= now;
                continue;
            }
            for (int k = 11; k >= 0; k--){
                if ((cur ^ (1 << k)) && (s[j] ^ (1 << k))){
                    now ^= (1 << k);
                }
                else{
                    if (s[j] ^ (1 << k)){
                        bool flag = false;
                        for (int l = k; l < 12; l++){
                            if ((cur ^ (1 << l)) && (s[j] ^ (1 << l))){
                                now ^= (1 << l);
                                cur ^= now;
                                flag = true;
                                break;
                            }
                            if (s[j] ^ (1 << l))
                                now ^= (1 << l);
                        }
                        if (!flag)
                            ok = false;
                        break;
                    }
                }
            }
            if (!ok)
                break;
        }
        if (ok){
            vector<int> answer;
            while (i > 0){
                answer.push_back(i % 2);
                i /= 2;
            }
            reverse(answer.begin(), answer.end());
            print(answer);
            return 0;
        }
    }
    return 0;
}
