#define _CRT_SECURE_NO_DEPRECATE

#include <iostream>
#include <set>
#include <map>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;

void solve();

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
	return 0;
}

const int maxn = 3000;
int n;
int a[maxn];
vector<int> ansL;
vector<int> ansR;
void qqsort(int l, int r) {
	vector<int> ord;
	for (int i = l + 1; i < r; i += 2)ord.push_back(i);
	for (int i = l; i < r; i += 2)ord.push_back(i);
	vector<int> low(r - l, 0);
	vector<int> up(r - l, 0);
	low[r - l - 1] = a[ord.back()];
	for (int i = r - l - 2; i >= 0; --i)
		low[i] = min(low[i + 1], a[ord[i]]);
	up[0] = a[ord[0]];
	for (int i = 1; i < r - l; ++i)
		up[i] = max(up[i - 1], a[ord[i]]);
	for(int i = 0; i < r - l; ++i)
		if (low[i] >= a[ord[i]] && a[ord[i]] >= up[i]) {
			ansL.push_back(l + 1);
			ansR.push_back(r);
			for (auto& i : ord)i = a[i];
			for (int j = 0; j < r - l; ++j)
				a[j] = ord[j];
		}
}
void solve() {
	cin >> n;
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	qqsort(0, n);
	cout << ansL.size() << endl;
	for (int i = 0; i < ansL.size(); ++i)
		cout << ansL[i] << ' ' << ansR[i] << endl;
}
