#include <bits/stdc++.h>
#define ll long long

using namespace std;

const int INF = 1e9 + 7;
const int MAXN = 3e5 + 7;
const double EPS = 1e-7;
const int N = 1007;

int main() {
    #ifdef MY
        freopen("input.txt", "r", stdin);
    #else
        ios_base::sync_with_stdio(false);
        cin.tie(0);
        cout.tie(0);
    #endif // MY
    int n;
    cin >> n;
    vector <vector <int> > a(n, vector <int> (MAXN + N, 0));
    vector <string> all(n);
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        all[i] = s;
        for (int j = (int) s.size() - 1; j >= 0; j--) {
            a[i][MAXN + N - ((int) s.size() - j)] = s[j] - '0';
        }
    }
    vector <int> bit(MAXN + N, 0);
    vector <int> free(MAXN);
    for (int i = 0; i < MAXN; i++) {
        free[i] = i;
    }
    vector <int> have_num(n, 0);
    set <pair <int, int> > q;
    vector <int> have[n];
    vector <bool> exist(n, true);
    vector <string> pr(n);
    for (int i = MAXN; i < MAXN + N; i++) {
        set <int> now;
        set <pair <string, int> > kek;
        for (int j = 0; j < n; j++) {
            if (a[j][i] && exist[j]) {
                now.insert(j);
                int len = MAXN + N - i - 1;
                string s = "";
                for (int k = max((int) all[j].size() - len, 0); k < (int) all[j].size(); k++) {
                    s += all[j][k];
                }
                reverse(s.begin(), s.end());
                while (s.size() < len) {
                    s += "0";
                }
                reverse(s.begin(), s.end());
                kek.insert({s, j});
                pr[j] = s;
            }
        }
        vector <pair <int, int> > erased;
        while (now.size() > 1) {
            int x = free.back();
            auto it = q.lower_bound({x, INF});
            bool can = false;
            while (it != q.end()) {
                int v = it->second;
                exist[v] = false;
                bit[x] = 1;
                int newx = have[v].back();
                while (have[v].size() && have[v].back() >= x) {
                    bit[have[v].back()] = 0;
                    have[v].pop_back();
                }
                if (now.find(v) != now.end()) {
                    now.erase(v);
                    kek.erase({pr[v], v});
                    break;
                }
                q.erase(it);
                it = q.lower_bound({newx, INF});
                x = newx;
            }
            if (!bit[x]) {
                int v = kek.rbegin()->second;
                exist[v] = false;
                bit[x] = 1;
                while (have[v].size() && have[v].back() > x) {
                    bit[have[v].back()] = 0;
                    have[v].pop_back();
                }
                now.erase(v);
                kek.erase({pr[v], v});
            }
            free.pop_back();
        }
        for (auto p : erased) {
            if (!exist[p.second]) continue;
            q.insert(p);
        }
        if (!now.size()) {
            free.push_back(i);
        } else {
            bit[i] = 1;
            have[*now.begin()].push_back(i);
            q.insert({i, *now.begin()});
        }
    }
    string res = "";
    for (int i = 0; i < MAXN + N; i++) {
        res += (char) (bit[i] + '0');
    }
    reverse(res.begin(), res.end());
    while (res.back() == '0') {
        res.pop_back();
    }
    reverse(res.begin(), res.end());
    cout << res;
}
