#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("sse4,popcnt,tune=native")

#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <cstdlib>
#include <cassert>

using namespace std;

typedef long long ll;
typedef long double ld;

//#define int long long
#define all(v) v.begin(),v.end()
#define rall(v) v.rbegin(),v.rend()
#define sz(v) (int)v.size()

void run();

signed main() {
	iostream::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	run();
#ifdef _DEBUG
	cerr << "\nOK\n";
	while (1);
#endif
}

void run() {
	int n, m, q;
	cin >> n >> m >> q;
	vector<vector<int>> mat(n, vector<int>(m));

	vector<pair<int, int>> max_row(n);
	vector<pair<int, int>> max_col(m);
	vector<bool> ok_row(n);
	vector<bool> ok_col(m);

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> mat[i][j];
			max_row[i] = max(max_row[i], { mat[i][j], j });
			max_col[j] = max(max_col[j], { mat[i][j], i });
		}
	}

	int cur_ans = 0;
	for (int i = 0; i < n; i++) {
		if (max_col[max_row[i].second].second == i) {
			cur_ans++;
			ok_row[i] = ok_col[max_row[i].second] = 1;
		}
	}
	//cout << cur_ans << endl;
	for (int i = 0; i < q; i++) {
		int x, y, k;
		cin >> x >> y >> k;
		x--;
		y--;
		bool kek = false;
		if (k > max_row[x].first && ok_row[x]) {
			kek = true;
			cur_ans--;
			ok_row[x] = 0;
			ok_col[max_row[x].second] = 0;
		}
		if (!kek && k > max_col[y].first && ok_col[y]) {
			kek = true;
			cur_ans--;
			ok_row[max_col[y].second] = 0;
			ok_col[y] = 0;
		}
		max_row[x] = max(max_row[x], { k, y });
		max_col[y] = max(max_col[y], { k, x });
		if (max_row[x].second == y && max_col[y].second == x) {
			cur_ans++;
			ok_row[x] = ok_col[y] = 1;
		}
		cout << cur_ans << endl;
	}
}