#include <iostream>
#include <vector>

#define fi first
#define se second
#define re return
#define pb push_back

#define F(i, a, b) for (int (i) = (a); (i) < (b); (i)++)
#define f(i, n) F(i, 0, n)

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef long double ld;

int run();

int main() {
#ifdef home
  freopen("i", "r", stdin);
  freopen("d", "w", stderr);
#endif
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.tie(nullptr);

  run();
}

int n;

int a[400500];
char mem[400000000];

int ptr;

//void *operator new(size_t sz) {
//  int res = ptr;
//  ptr += sz;
//  re mem + res;
//}

struct node {
  int val;
  node *l, *r;

  node() {
    l = 0;
    r = 0;
    val = 0;
  }
} *root = new node();

int sz = 1.05e9;

void add(node *cur, int to, int l = 0, int r = sz) {
//  cerr << "   " << to << ' ' << l << ' ' << r << endl;
  cur->val++;
  if (l == r - 1) {
    re;
  }
  int mid = (l + r) / 2;
  if (to < mid) {
    if (!cur->l) {
      cur->l = new node();
    }
    add(cur->l, to, l, mid);
  } else {
    if (!cur->r) {
      cur->r = new node();
    }
    add(cur->r, to, mid, r);
  }
}

int cnt[400500];

int get(node *cur, int lb, int rb, int l = 0, int r = sz) {
  if (!cur) {
    re 0;
  }
//  cerr << ' ' << lb << ' ' << rb << ' ' << l << ' ' << r << ' ' << cur->val << '\n';
  if (lb <= l && rb >= r) {
    re cur->val;
  }
  if (lb >= r || rb <= l) {
    re 0;
  }
  int mid = (l + r) / 2;
  re get(cur->l, lb, rb, l, mid) + get(cur->r, lb, rb, mid, r);
}

void clear(node *cur) {
  if (cur->l) {
    clear(cur->l);
  }
  if (cur->r) {
    clear(cur->r);
  }
  cur->val = 0;
}

vector<pii> a1[400500];
vector<pii> a2[400500];
vector<pii> a3[400500];

int cc3[400500];

int t[400500];

int run() {
//  cerr << 2 * sz;
  int p;
  cin >> n >> p;
  f(i, n) {
    cin >> a[i];
  }

  f(i, n) {
    int d = min(i, n - i - 1);
    a1[i - d].push_back({i, -1});
    a1[i].push_back({i, 1});
    a2[i].push_back({i, 1});
    a2[i + d].push_back({i, -1});
    if (d == i) {
//      if (i == 2) cerr << i + d + 1 << ' ' << n << endl;
      a3[i + d + 1].push_back({i, -1});
      a3[n].push_back({i, 1});
    } else {
      a3[i - d].push_back({i, 1});
    }
    t[i] = a[i] + d;
  }


  f(i, n) {
    for (auto x : a1[i]) {
      int j = x.fi;
      cc3[j] += x.se * get(root, 0, a[j] + j);
    }
    add(root, a[i] + i);
  }

  f(i, n) {
    cnt[i] = max(get(root, 0, a[i] + i), cnt[i]);
  }

  root = new node();

//  cerr << cc3[1] << endl;

  for (int i = n - 1; i >= 0; i--) {
    for (auto x : a2[i]) {
      int j = x.fi;
//      if (j == 1) {
//        cerr << i << ' ' << a[j] + n - j << ' ' << get(root, 0, a[j] + n - j) << '\n';
//      }
      cc3[j] += x.se * get(root, 0, a[j] + n - j);
    }
//    cerr << " " << "push " << i << " / " << a[i] + n - i << '\n';
    add(root, a[i] + n - i);
  }

  f(i, n) {
    cnt[i] = max(get(root, 0, a[i] + n - i), cnt[i]);
  }

  root = new node();

//  cerr << cc3[1] << endl;

  f(i, n) {
//    if (i == 2) {
//      for (auto x : a3[i]) {
//        cerr << ' ' << x.fi << ' ' << x.se << '\n';
//      }
//    }
    for (auto x : a3[i]) {
      int j = x.fi;
//      if (j == 2) {
//        cerr << get(root, 0, t[j]) << ' ' << x.se << ' ' << i << '\n';
//      }
      cc3[j] += x.se * get(root, 0, t[j]);
    }
    add(root, a[i]);
  }
  for (auto x : a3[n]) {
    int j = x.fi;
//    if (j == 2) {
//      cerr << get(root, 0, t[j]) << ' ' << x.se << ' ' << n << '\n';
//    }
    cc3[j] += x.se * get(root, 0, t[j]);
  }


//  cerr << cc3[1] << '\n';
  f(i, n) {
    cout << max(cc3[i], cnt[i]) + 1 << '\n';
  }

  return 0;
}