#include <bits/stdc++.h>

using namespace std;

const int MAXN = 505;

struct Num {
    bool st[MAXN];
    Num() {
        fill_n(st, MAXN, 0);
    }
    Num(bool fl) {
        fill_n(st, MAXN, 1);
    }
    bool operator<(const Num &n) const {
        for (int i = MAXN - 1; i >= 0; --i) {
            if (st[i] == n.st[i]) {
                continue;
            }
            return !st[i];
        }
        return false;
    }
};

void add(Num &n, int k) {
    while (n.st[k]) {
        n.st[k] = 0;
        k++;
    }
    n.st[k] = 1;
}

int main() {
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m, k;
    cin >> n >> m >> k;
    vector<pair<int, int>> data(k);
    for (int i = 0; i < k; ++i) {
        cin >> data[i].first >> data[i].second;
    }
    vector<Num> dist(k, Num(true));
    dist[0] = Num();
    vector<bool> used(k, 0);
    vector<int> pr(k, -1);
    for (int i = 0; i < k; ++i) {
        int p = -1;
        for (int j = 0; j < k; ++j) {
            if (!used[j] && (p == -1 || dist[j] < dist[p])) {
                p = j;
            }
        }
        if (p == -1) {
            break;
        }
        used[p] = 1;
        for (int j = 0; j < k; ++j) {
            auto nd = dist[p];
            int d = max(abs(data[p].first - data[j].first), abs(data[p].second - data[j].second));
            add(nd, d);
            if (nd < dist[j] && !used[j]) {
                dist[j] = nd;
                pr[j] = p;
            }
        }
    }
    int now = k - 1;
    vector<int> ans;
    while (now != -1) {
        ans.push_back(now);
        now = pr[now];
    }
    cout << ans.size() << "\n";
    for (int i = ans.size() - 1; i >= 0; --i) {
        cout << ans[i] + 1 << " ";
    }
}