#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("unroll-all-loops")
#pragma GCC target("sse,sse2,ssse3")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ll long long
#define all(x) x.begin(), x.end()
#define F first
#define S second
#define pb push_back

using namespace std;
using namespace __gnu_pbds;

using ordered_set = tree<pair<int, int>, null_type, less<pair<int, int>>, rb_tree_tag, tree_order_statistics_node_update>;

void run();

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    run();
    return 0;
}

#define debug(x) debugdo(cout << x << endl)
#define debugs(x) debugdo(cout << x << " ")
#define debug_for(x) debug(#x":"); for (auto _x: x) debugs(_x); debug("")

#define DEBUG
#if defined DEBUG && defined LOCAL
    #define debugdo(x) x
#else
    #define debugdo(x)
#endif

struct ordered_multiset
{
    int t = 0;
    ordered_set s;
    inline void insert(int x)
    {
        s.insert({x, t++});
    }
    inline int order_of_key(int x)
    {
        return s.order_of_key({x, 0});
    }
    inline void clear()
    {
        s.clear();
    }
};

void run()
{
    int n, p;
    cin >> n >> p;
    vector<int> a(n);
    for (auto &x: a)
        cin >> x;
    int t = 0;
    if (p == 1)
    {
        vector<int> ans(n);
        ordered_set p;
        int d = 0;
        for (int i = 0; i < n; i++)
        {
            d++;
            ans[i] += p.order_of_key({a[i] - d, 0});
            p.insert({a[i] - d, t++});
        }
        debug_for(ans);
        p.clear();
        d = 0;
        for (int i = n - 1; i >= 0; i--)
        {
            d++;
            ans[i] += p.order_of_key({a[i] - d, 0});
            p.insert({a[i] - d, t++});
        }
        for (auto x: ans)
            cout << x + 1 << "\n";
    }
    else
    {
        vector<int> ans1(n), ans2(n);
        ordered_multiset s, m, p;
        int d = 0;
        auto upd = [&]()
        {
            for (int i = 0; i < n; i++)
            {
                if (i > n / 2)
                {
                    ans2[i] += m.order_of_key(a[i] + i);
                    int r = (n - 1 - i) * 2;
                    ans1[i] += m.order_of_key(a[i] + i);
                }
                d++;
                p.insert(a[i] - d);
                if (i < n / 2 || n % 2 == 0 && i == n / 2)
                {
                    ans1[i] += m.order_of_key(a[i] + i);
                    //debug(p.order_of_key(a[i] - d));
                    ans2[i] += p.order_of_key(a[i] - d);
                }
                if (i == n / 2 && n % 2)
                {
                    ans1[i] += m.order_of_key(a[i] + i);
                }
                s.insert(a[i]);
                m.insert(a[i] + i);
                if ((n - 1 - i) % 2 == 0 && i + (n - 1 - i) / 2 > n / 2)
                {
                    ans1[i + (n - 1 - i) / 2] += s.order_of_key(a[i + (n - 1 - i) / 2] + (n - 1 - i) / 2);
                    ans1[i + (n - 1 - i) / 2] -= m.order_of_key(a[i + (n - 1 - i) / 2] + (n - 1 - i) / 2 + i);
                }
            }
        };
        upd();
        d = 0;
        s.clear();
        m.clear();
        p.clear();
        reverse(all(ans1));
        reverse(all(ans2));
        reverse(all(a));
        upd();
        reverse(all(ans1));
        reverse(all(ans2));
        for (int i = 0; i < n; i++)
            cout << max(ans1[i], ans2[i]) + 1 << "\n";
    }
}

/*
5 2
8 5 5 7 7

7 2
6 8 6 2 5 9 3
*/
