#include<bits/stdc++.h>
#define int long long
using namespace std;

const int MAXN = 1000;
int dp[MAXN][MAXN];
pair<int, int> pre[MAXN][MAXN];

int dist(int x1, int y1, int x2, int y2){
    return 1 << (max(abs(x1 - x2), abs(y1 - y2)));
}

signed main(){
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // DEBUG
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m, k;
    cin >> n >> m >> k;
    for(int i = 0; i < n; i++){
        for(int j = 0; j < m; j++){
            dp[i][j] = 1e17;
            pre[i][j] = (pair<int, int>){-1, -1};
        }
    }
    vector<pair<int, int>> q(k);
    for(int i = 0; i < k; i++){
        cin >> q[i].first >> q[i].second;
        q[i].first--;q[i].second--;
    }
    dp[0][0] = 0;
    for(int i = 0; i < n; i++){
        for(int j = 0; j < m; j++){
            for(auto it : q){
                int d = dist(i, j, it.first, it.second);
                if(dp[it.first][it.second] > dp[i][j] + d){
                    dp[it.first][it.second] = dp[i][j] + d;
                    pre[it.first][it.second] = {i, j};
                }
            }
        }
    }
    pair<int, int> fin = (pair<int, int>){n-1, m-1};
    vector<int> ans;
    while(fin.first != -1){
        for(int i = 0; i < k; i++){
            if(q[i] == fin){
                ans.push_back(i + 1);
                break;
            }
        }
        pair<int, int> nxt = pre[fin.first][fin.second];
        fin = nxt;
    }
    reverse(ans.begin(), ans.end());
    cout << ans.size() << '\n';
    for(auto it : ans){
        cout << it << ' ';
    }
    return 0;
}

