#include<iostream>
#include<algorithm>
#include<vector>
#include<map>
#include<queue>
using namespace std;

#pragma warning(disable : 4996)
#define ll long long int
#define all(vec) vec.begin(), vec.end()

const int N = 505;
const ll base = 1e18;
int x[N], y[N], p[N];
vector<ll> w[N][N], pw[N], d[N];

void sum(vector<ll> &a, vector<ll> &b) {
	a.resize(max(a.size(), b.size()) + 1);
	for (int i = 0; i < b.size(); i++) {
		a[i] += b[i];
	}

	for (int i = 0, c= 0; i < a.size(); i++) {
		a[i] += c;
		c = a[i] / base;
		a[i] %= base;
	}
	while (a.size() > 1 && a.back() == 0)
		a.pop_back();
}

bool operator < (vector<ll> &a, vector<ll> &b) {
	if (a.size() != b.size())
		return a.size() > b.size();
	for (int i = 0; i < a.size(); i++) {
		if (a[i] != b[i])
			return a[i] > b[i];
	}
	return false;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int n, m, k;
	scanf("%d%d%d", &n, &m, &k);


	for (int i = 0; i < k; i++) {
		scanf("%d%d", &x[i], &y[i]);
	}

	pw[0].push_back(1);
	for (int i = 1; i < N; i++) {
		pw[i] = pw[i - 1];
		sum(pw[i], pw[i - 1]);
	}
	
	for (int i = 0; i < k; i++) {
		w[i][i].push_back(0);
		for (int j = 0; j < k; j++) {
			if (i != j)
				w[i][j] = w[j][i] = pw[max(abs(x[i] - x[j]), abs(y[i] - y[j]))];
		}
	}

	for (int i = 0; i < k; i++)
		d[i] = pw[N - 1];
	d[0] = { 0 };

	priority_queue<pair<vector<ll>, int>, vector<pair<vector<ll>, int>>> q;
	q.push({ d[0], 0 });
	while (!q.empty()) {
		int node = q.top().second;
		auto cd = q.top().first;
		q.pop();
		if (cd < d[node])
			continue;

		for (int i = 0; i < k; i++) {
			auto nd = cd;
			sum(nd, w[node][i]);
			if (d[i] < nd) {
				d[i] = nd;
				p[i] = node;
				q.push({ d[i], i });
			}
		}
	}

	vector<int> v;
	int x = k - 1;
	while (true) {
		v.push_back(x);
		if (x == 0)
			break;
		x = p[x];
	}

	printf("%d\n", v.size());

	for (int i = v.size() - 1; i >= 0; i--)
		printf("%d ", v[i] + 1);



	return 0;
}