#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <cstring>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>
using namespace std;

#pragma warning (disable : 4996)
#define ll long long int

const int N = 3e5 + 100;
char t[N], s[N];
vector<int> x, y;
int a[2];

void brute() {
	int len = strlen(t), p = 1, g = 0;
	for (int i = len - 1; i >= 0; i--, p *= 2) {
		if (t[i] == '1')
			g += p;
	}
	a[0] = g;
	g = 0;
	len = strlen(s), p = 1, g = 0;
	for (int i = len - 1; i >= 0; i--, p *= 2) {
		if (s[i] == '1')
			g += p;
	}
	a[1] = g;

	int sum = 1e9;
	for (int i = a[0]; i < 10000; i++) {
		for (int j = a[1]; j < 10000; j++) {
			if ((i & j) == 0) {
				sum = min(sum, i + j);
			}
		}
	}

	vector<int> v;
	while (sum > 0) {
		v.push_back(sum & 1);
		sum >>= 1;
	}

	for (int i = v.size() - 1; i >= 0; i--)
		printf("%d", v[i]);
	printf("\n");
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int n;
	scanf("%d %s %s", &n, t, s);

	int lt = strlen(t), ls = strlen(s);

	for (int i = lt - 1; i >= 0; i--)
		x.push_back(t[i] - '0');
	for (int i = ls - 1; i >= 0; i--)
		y.push_back(s[i] - '0');

	int mx = max(x.size(), y.size()) + 1;
	x.resize(mx);
	y.resize(mx);

	brute();

	int j = -1;
	for (int i = mx - 1; i >= 0; i--) {
		if (x[i] && y[i]) {
			j = i;
			break;
		}
	}

	while (j != -1) {
		bool less = false;
		for (int i = j - 1; i >= 0; i--) {
			if (x[i] != y[i]) {
				less = x[i] < y[i];
				break;
			}
		}
		if (less) {
			while (x[j])
				j++;
			for (int i = 0; i < j; i++)
				x[i] = 0;
			x[j] = 1;
			if ((x[j] & y[j]) == 0)
				j = -1;
		}
		else {
			while (y[j])
				j++;
			for (int i = 0; i < j; i++)
				y[i] = 0;
			y[j] = 1;
			if ((x[j] & y[j]) == 0)
				j = -1;
		}
	}

	while ((x[mx - 1] | y[mx - 1]) == 0)
		mx--;

	for (int i = mx - 1; i >= 0; i--) {
		printf("%d", x[i] | y[i]);
	}
	return 0;
}