#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>
#define INF 1000000

using namespace std;

long long abs(long long y)
{
    if (y>=0) return y;
    else return -y;
}

void BFS(long long v, vector<pair<long long, long long> > &Ver, long long k, vector<long long> &Rass, queue<long long> &Que, vector<vector<long long> > &Sp)
{
    for (long long i=0; i<k; i++){
        long long le = 1<<(max(abs(Ver[v].first-Ver[i].first), abs(Ver[v].second-Ver[i].second)));
        if (Rass[i]>Rass[v]+le){
            Rass[i] = Rass[v]+le;
            Que.push(i);
            vector<long long> W = Sp[v];
            W.push_back(v);
            Sp[i] = W;
        }
    }
}

int main()
{
    long long n, m, k;
    cin >> n >> m >> k;
    vector<pair<long long, long long> > Ver(k, make_pair(0, 0));
    for (long long i=0; i<k; i++){
        cin >> Ver[i].first >> Ver[i].second;
    }

    vector<long long> A(k, INF);
    A[0] = 0;
    queue<long long> Que;
    Que.push(0);
    vector<long long> Vsp;
    vector<vector<long long> > Sp(k, Vsp);
    while (Que.size()!=0){
        BFS(Que.front(), Ver, k, A, Que, Sp);
        Que.pop();
    }
    /*for (long long i=0; i<k; i++){
        cout << A[i] << " ";
    }//*/

    cout << Sp[k-1].size()+1 << endl;
    for (long long i=0; i<Sp[k-1].size(); i++){
        cout << Sp[k-1][i]+1 << " ";
    }
    cout << k << endl;//*/
}
