#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

#define int long long

int n, m, q;

int get(int i, int j)
{
	return i * m + j;
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	cin >> n >> m >> q;
	vector<vector<int>> a(n, vector<int>(m));
	vector<int> x(n), y(m);
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
			cin >> a[i][j];
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
			x[i] = max(x[i], a[i][j]);
	for (int j = 0; j < m; j++)
		for (int i = 0; i < n; i++)
			y[j] = max(y[j], a[i][j]);
	int k = 0;
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
			if (a[i][j] == x[i] && a[i][j] == y[j])
				k++;
	for (int test = 0; test < q; test++)
	{
		int r, c, cur; cin >> r >> c >> cur;
		r--, c--;
		a[r][c] = cur;
		y[c] = max(y[c], cur);
		x[r] = max(x[r], cur);
		int k = 0;
		for (int i = 0; i < n; i++)
			for (int j = 0; j < m; j++)
				if (a[i][j] == x[i] && a[i][j] == y[j])
					k++;
		cout << k << "\n";
	}
	system("pause");
}