#include <iostream>
#include <vector>
#include <algorithm>
#include <ctime>
using namespace std;

int get(vector<int> a)
{
	int ans = 0;
	for(int i = 0; i < a.size(); i++)
		for(int j = 0; j < a.size() - 1; j++)
			if (a[j] > a[j + 1])
			{
				ans++;
				swap(a[j], a[j + 1]);
			}
	return ans;
}

vector<int> trans(vector<int> &a, int l, int r)
{
	vector<int> ans;
	for (int i = 0; i < l; i++)
		ans.push_back(a[i]);
	for (int j = l + 1; j <= r; j += 2)
		ans.push_back(a[j]);
	for (int j = l; j <= r; j += 2)
		ans.push_back(a[j]);
	for (int i = r + 1; i < a.size(); i++)
		ans.push_back(a[i]);
	return ans;
}

int main()
{
	srand(time(0));
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int n; cin >> n;
	vector<int> a(n);
	for (auto &i : a)
		cin >> i;
	vector<pair<int, int>> ans;
	int last = get(a);
	for (int i = 0; i < 15000; i++)
	{
		int l = rand() % n, r = rand() % (n - l) + l;
		vector<int> b = trans(a, l, r);
		int cur = get(b);
		if (cur < last)
		{
			a = b;
			last = cur;
			ans.emplace_back(l + 1, r + 1);
		}
	}
	cout << ans.size() << endl;
	for (auto i : ans)
		cout << i.first << " " << i.second << "\n";
	system("pause");
}