#include <vector>
#include <set>
#include <iostream>
#include <algorithm>
#include <map>
  
using namespace std;
  
typedef long long ll;
 
const int N = 507;
 
vector <int> a[N];
int w[N][N];
 
bool can(int n, int x) {
    bool flag = false;
    for (int i = 0; i < n; ++i) {
        if (w[i][i] < w[i][x]) continue;
        vector <int> tmp(n, -1);
        tmp[i] = x;
        set <int> can;
        for (int j = n - 1; j >= w[i][x]; --j) {
            can.insert(a[i][j]);
        }
        bool ck = true;
        for (int j = 0; j < n; ++j) {
            if (j == i) continue;
            for (int k = 0; k <= w[j][j]; ++k) {
                if (can.count(a[j][k])) {
                    tmp[j] = a[j][k];
                    break;
                }
            }
            if (tmp[j] == -1) {
                ck = false;
                break;
            }
        }
        if (ck) flag = true;
    }
    return flag;    
}
  
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            int x;
            cin >> x;
            --x;
            a[i].push_back(x);
            w[i][x] = j;
        }
    }
    int p;
    cin >> p;
    vector <int> ans;
    if (p == 1) {
        for (int i = 0; i < n; ++i) {
            if (a[i][0] == i) {
                ans.push_back(i);
            }
        }
        cout << ans.size() << endl;
        for (auto e : ans) {
            cout << e + 1 << " ";
        }
        cout << "\n";
        return 0;
    }
    for (int i = 0; i < n; ++i) {
        if (can(n, i)) {
            ans.push_back(i + 1);
        }
    }
    cout << ans.size() << endl;
    for (auto e : ans) {
        cout << e << " ";
    }
    cout << "\n";
}