#include <bits/stdc++.h>
using namespace std;
const int K = 500;
struct Number{bool v[K];};
Number INF;
vector<pair<int, int> > v;
Number create(int a, int b){
    int x = max(abs(v[a].first - v[b].first), abs(v[a].second - v[b].second));
    Number nm;
    for (int i=0; i < K; i++) nm.v[i] = false;
    nm.v[x] = true;
    return nm;
}
Number sl(Number &a, Number &b){
    Number res;
    for (int i=0; i < K; i++) res.v[i] = false;
    int dop=0;
    for (int i=0; i < K; i++){
        dop += a.v[i] + b.v[i];
        res.v[i] = dop%2;
        if (dop>1) dop=1;
        else dop=0;
    }
    if (dop > 0) return INF;
    return res;
}
bool rmn(Number &a, Number &b){
    for (int i=K-1; i >= 0; i--){
        if (a.v[i] != b.v[i]){
            return (!a.v[i]);
        }
    }
    return true;
}
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    for (int i=0; i < K; i++){
        INF.v[i] = true;
    }
    int n, m, k;
    cin >> n >> m >> k;
    for (int i=0; i < k; i++){
        int x, y;
        cin >> x >> y;
        v.push_back(make_pair(x, y));
    }
    vector<Number> dijkstra(k);
    for (int i=0; i < k; i++) dijkstra[i] = INF;
    for (int i=0; i < K; i++) dijkstra[0].v[i] = false;
    vector<bool> used(k);
    fill(used.begin(), used.end(), false);
    vector<int> rt(k);
    for (int i=0; i < k; i++){
        Number nmn = INF;
        int wh=-1;
        for (int j=0; j < k; j++){
            if (!used[j]){
                if (rmn(dijkstra[j], nmn)){
                    nmn = dijkstra[j];
                    wh = j;
                }
            }
        }
        used[wh] = true;
        for (int j=0; j < k; j++){
            if (!used[j]){
                Number rr = create(j, wh);
                Number rst = sl(dijkstra[wh], rr);
                if (rmn(rst, dijkstra[j])){
                    dijkstra[j] = rst;
                    rt[j] = wh;
                }
            }
        }
    }
    vector<int> ans;
    int V = k-1;
    while (true){
        ans.push_back(V);
        if (V==0) break;
        V = rt[V];
    }
    cout << ans.size() << endl;
    reverse(ans.begin(), ans.end());
    for (int i=0; i < ans.size(); i++) cout << ans[i]+1 << " ";
    return 0;
}
