#include <bits/stdc++.h>

using namespace std;

#define int long long

struct Node{
    int x, y;
    Node * l = 0, r = 0, p = 0;
    Node()
    {
        x = 0;
        y = rand();
    }
    Node(int a)
    {
        x = a;
        y = rand();
    }
};

pair<Node*, Node*> split (Node * node, int x)
{
    if (node == 0)
    {
        return node;
    }
    if (node->x > x)
    {
        if (node->l != 0)
        {
            auto w = split(node->l, x);
            node->l = w.second
            return {w.first, node};
        }
        else
        {
            return {0, node};
        }
    }
    else if (node->x < x)
    {
        if (node->r != 0)
        {
            auto w = split(node->r, x);
            node->r = w.first;
            return {node, w.second};
        }
        else
        {
            return {node, 0};
        }
    }
    else
    {
        auto w = node->l;
        node->l = 0;
        return {w, node};
    }
}

Node *merg(Node *a, Node * b)
{
    if (a == 0)
    {
        return b;
    }
    if (b == 0)
    {
        return a;
    }
    if (a->y < b->y)
    {
        auto x = split(a, b->x);
        b->l = merg(b->l, x.first);
        b->r = merg(b->r, x.second);
        return b;
    }
    else
    {
        auto x = split(b, a->x);
        a->l = merg(a->l, x.first);
        a->r = merg(a->r, x.second);
        return a;
    }
}

Node *add (Node * root, int x)
{
    Node *node = new Node(x);
    return merg(root, node);
}

signed main()
{
    int n;
    cin >> n;
    vector<int> v(n);
    for (int i = 0; i < n; i++)
    {
        cin >> v[i];
    }
    int x = 0;
    int start = 0;
    int last = 0;
    int ans = 1;
    while (x < n)
    {
        //cout << x << ' ' << ans << endl;
        if (v[x] < v[start])
        {
            ans++;
            start = last + 1;
            last = start;
            x = start;
        }
        else if (v[x] >= v[last])
        {
            last = x;
        }
        x++;
        if (x == n && last != n - 1)
        {
            ans++;
            start = last + 1;
            last = start;
            x = start;
        }
    }
    cout << ans;
    return 0;
}




//set<pair<int, int>> s1;
//    vector<int> nb(n, n + 1);
//    for(int i = n - 1; i >= 0; i--)
//    {
//        auto x = s1.lower_bound({v[i], i});
//        if (x != s1.end())
//        {
//            nb[i] = (*x).second;
//        }
//        s1.insert({v[i] - 1, i});
//    }
//    set<pair<int, int>> s2;
//    vector<int> nm(n, n + 1);
//    for(int i = n - 1; i >= 0; i--)
//    {
//        auto x = s2.lower_bound({-v[i], i});
//        if (x != s2.end())
//        {
//            nm[i] = (*x).second;
//        }
//        s2.insert({-(v[i]) - 1, i});
//    }
//    for (int i = 0; i < n; i++)
//    {
//        cout << nm[i] << nb[i] << endl;
//    }
