#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main()
{
    int n;
    cin >> n;
    vector<int> a(n);
    vector<pair<int, int> > p(n);
    for (int i = 0; i < n; i++){
        cin >> a[i];
        p[i].first = a[i];
        p[i].second = i;
    }
    sort(p.begin(), p.end());
    for (int i = 0; i < n; i++){
        a[p[i].second] = i;
    }
    vector<pair<int, int> > ans;
    for (int i = 0; i < n; i++){
        int pos = i;
        while(a[pos] != i){
            pos++;
        }
        while (pos > i){
            ans.push_back(make_pair(pos - 1, pos));
            swap(a[pos], a[pos - 1]);
            pos--;
        }
    }
    cout << ans.size() << endl;
    for (auto i : ans){
        cout << i.first + 1 << ' ' << i.second + 1 << endl;
    }
    return 0;
}
