#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

bool is(int a, int pos){
    return ((a >> pos) & 1);
}

int main()
{
    int n;
    cin >> n;
    vector<int> a(n);
    int p;
    cin >> p;
    for (int i = 0; i < n; i++){
        cin >> a[i];
    }
    vector<int> ans;
    if (p == 1){
        ans.resize(n, 1000000000);
    }else{
        ans.resize(n, 0);
    }
    for (int v = 1; v < (1 << n); v++){
        vector<int> pos;
        pos.push_back(-1000000000);
        for (int i = 0; i < n; i++){
            if ((v >> i) & 1){
                pos.push_back(i);
            }
        }
        pos.push_back(1000000000);
        vector<pair<int, int> > time(n);
        int l = 0;
        int r = 1;
        for (int i = 0; i < n; i++){
            while (l < pos.size() && pos[l] <= i){
                l++;
            }
            l--;
            while (i > pos[r]){
                r++;
            }
            time[i].first = a[i] + min(i - pos[l], pos[r] - i);
            time[i].second = i;
        }
        sort(time.begin(), time.end());
        vector<int> place(n);
        place[time[0].second] = 1;
        for (int i = 1; i < n; i++){
            if (time[i].first == time[i - 1].first){
                place[time[i].second] = place[time[i - 1].second];
            }else{
                place[time[i].second] = i + 1;
            }
        }
        for (int i = 0; i < n; i++){
            if (p == 1){
                if (place[i] < ans[i]){
                    ans[i] = place[i];
                }
            }else{
                if (place[i] > ans[i]){
                    ans[i] = place[i];
                }
            }
        }
    }
    for (auto i : ans){
        cout << i << endl;
    }
    return 0;
}
