#include <bits/stdc++.h>
#define pb push_back
#define mp make_pair
#define x first
#define y second

using namespace std;

typedef long long ll;

int a[400005];
pair <int, int> A[400005], B[400005];
int tim[400005];
int lefts[400005], rights[400005];
int fen1[400005], fen2[400005];

int f(int x)
{
    return (x & (-x));
}

void upd1(int v, int n)
{
    for (int i = v; i <= n; i += f(i))
        fen1[i]++;
    return;
}

int get_sum1(int v)
{
    int s = 0;
    for (int i = v; i > 0; i -= f(i))
        s += fen1[i];
    return s;
}

void upd2(int v)
{
    for (int i = v; i > 0; i -= f(i))
        fen2[i]++;
    return;
}

int get_sum2(int v, int n)
{
    int s = 0;
    for (int i = v; i <= n; i += f(i))
        s += fen2[i];
    return s;
}

bool cmp(pair <int, int> a, pair <int, int> b)
{
    return (a.x < b.x || (a.x == b.x && a.y > b.y));
}

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0); cin.tie(0);
    int n, p;
    cin >> n >> p;
    for (int i = 1; i <= n; i++)
        cin >> a[i];

    if (p == 1)
    {
        for (int i = 1; i <= n; i++)
        {
            A[i].x = a[i] - i;
            A[i].y = i;
            B[i].x = a[i] + i;
            B[i].y = i;
        }
        sort(A + 1, A + n + 1, cmp);
        sort(B + 1, B + n + 1);

        for (int i = 1; i <= n; i++)
        {
            int s = get_sum1(A[i].y - 1);
            upd1(A[i].y, n);
            lefts[A[i].y] = s;
        }
        for (int i = 1; i <= n; i++)
        {
            int s = get_sum2(B[i].y + 1, n);
            upd2(B[i].y);
            rights[B[i].y] = s;
        }

        for (int i = 1; i <= n; i++)
            cout << lefts[i] + rights[i] + 1 << '\n';
        exit(0);
    }
    else
    {
        for (int i = 1; i <= n; i++)
        {
            int r = n - i, l = i - 1;
            int ans = 0;

            if (l < r)
            {
                for (int j = 1; j <= n; j++)
                    tim[j] = a[j] + n - j;
                int sum = 0;
                for (int j = 1; j <= n; j++)
                    if (tim[j] < tim[i]) sum++;
                ans = max(ans, sum + 1);
            }
            if (r < l)
            {
                for (int j = 1; j <= n; j++)
                    tim[j] = a[j] + j - 1;
                int sum = 0;
                for (int j = 1; j <= n; j++)
                    if (tim[j] < tim[i]) sum++;
                ans = max(ans, sum + 1);
            }
            int ll = 2 * i - 1, rr = 2 * i - n;
            int grl = max(1, rr), grr = min(n, ll);

            for (int j = 1; j <= n; j++)
                tim[j] = a[j] + max(min(j - grl, grr - j), 0);
            int sum = 0;
            for (int j = 1; j <= n; j++)
                if (tim[j] < tim[i]) sum++;
            ans = max(ans, sum + 1);

            cout << ans << '\n';
        }
        exit(0);
    }
    return 0;
}

