#include <iostream>
#include <vector>
#include <time.h>
#include <algorithm>

using namespace std;

vector<pair<int, int> > all;

void op(int l, int r, vector<int>& a) {
	vector<int> cur;
	for (int i = l + 1; i <= r; i += 2) {
		cur.push_back(a[i]);
	}
	for (int i = l; i <= r; i += 2) {
		cur.push_back(a[i]);
	}
	for (int i = l; i <= r; i++) {
		a[i] = cur[i - l];
	}
}

int main()
{
	srand(time(NULL));
	int n;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	for (int i = 0; i < n; i++) {
		int j = min_element(a.begin() + i, a.end()) - a.begin();
		int mx = *max_element(a.begin(), a.end() - i);
		while (j > i) {
			int left;
			if ((j - i) % 2 == 0) {
				left = i + 1;
			}
			else {
				left = i;
			}
			int it = 0;
			while (1) {
				it++;
				int right = rand() % (n - j) + j;
				auto old_a = a;
				op(left, right, a);
				int ind1 = find(a.begin(), a.end(), old_a[j]) - a.begin();
				int ind2 = find(a.begin(), a.end(), mx) - a.begin();
				if ((ind1 - ind2) % 2 == 1 || it >= 5) {
					j = i + (j - i) / 2;
					all.push_back({ left, right });
					break;
				}
				else {
					a = old_a;
				}
			}
		}
	}
	/*for (int i = 0; i < n; i++) {
	cout << a[i] << ' ';
	}
	cout << endl;*/
	cout << (int)all.size() << endl;
	for (auto elem : all) {
		cout << elem.first + 1 << ' ' << elem.second + 1 << '\n';
	}
	return 0;
}