#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <fstream>
#include <cmath>
#include <algorithm>
#include <queue>

using namespace std;
#define int long long

const int MAXN = 150000 + 7;
const int INF = 1e16 + 7;

int a[MAXN], b[MAXN];

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    //freopen("input.txt", "r", stdin);

    int n;
    cin >> n;

    for (int i = 0; i < n; ++i) {
        cin >> a[i] >> b[i];
    }

    vector <int> a1;
    for (int i = 0; i < n; ++i) a1.push_back(a[i]);
    sort(a1.begin(), a1.end());
    reverse(a1.begin(), a1.end());

    vector <int> b1;
    for (int i = 0; i < n; ++i) b1.push_back(b[i]);
    sort(b1.begin(), b1.end());
    reverse(b1.begin(), b1.end());

    int ans = 0;
    for (int i = 0; i <= n; ++i) {
        int cost1;
        if (i == 0) cost1 = INF;
        else cost1 = a1[i - 1];

        vector <int> ost;
        for (int j = 0; j < n; ++j) {
            if (a[j] < cost1) ost.push_back(b[j]);
        }
        sort(ost.begin(), ost.end());
        reverse(ost.begin(), ost.end());

        for (int j = 0; j <= ost.size(); ++j) {
            int cost2;
            if (j == 0) cost2 = INF;
            else cost2 = ost[j - 1];

            if (cost1 < cost2 && cost2 != INF) continue;

            ans = max(ans, i * cost1 + j * cost2);
        }
    }

    cout << ans << '\n';
    return 0;
}

