#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_set>

using namespace std;

typedef long long ll;
typedef long double ld;

int main()
{
	ll n, mx_b = 0, mx_a = 0;
	cin >> n;
	bool equal = true;
	vector <pair <ll, ll>> v(n);
	for (int i = 0; i < n; ++i)
	{
		cin >> v[i].first >> v[i].second;
		mx_a = max(v[i].first, mx_a);
		mx_b = max(v[i].second, mx_b);
		if (v[i].first != v[i].second)
		{
			equal = false;
		}
	}
	ll ans = 0;
	if (n <= 100 && mx_b <= 100 && mx_a <= 100)
	{
		for (int i = 0; i <= 100; ++i)
		{
			for (int j = i; j <= 100; ++j)
			{
				ll temp_ans = 0;
				for (int k = 0; k < n; ++k)
				{
					if (v[k].first >= j)
					{
						temp_ans += j;
					}
					else if (v[k].second >= i)
					{
						temp_ans += i;
					}
				}
				ans = max(ans, temp_ans);
			}
		}
		cout << ans;
		return 0;
	}
	if (mx_b == 0)
	{
		sort(v.begin(), v.end());
		for (int i = 0; i < n; ++i)
		{
			ans = max(ans, (n - i) * v[i].first);
		}
		cout << ans;
		return 0;
	}
	if (equal)
	{
		vector <pair<ll, ll>> e;
		vector <ll> pref_sums, dp = {0};
		for (int i = 0; i < n; ++i)
		{
			if (e.empty() || e[e.size() - 1].first != v[i].first)
			{
				e.push_back({ v[i].first, 1 });
				if (pref_sums.empty())
				{
					pref_sums.push_back(e[0].second);
					dp.push_back(0);
				}
				else
				{
					pref_sums.push_back(pref_sums[pref_sums.size() - 1] + e[e.size() - 1].second);
				}
			}
			else
			{
				e[e.size() - 1].second++;
			}
		}
		ll start = 0, end = 1, temp_ans = 0;
		while (end <= e.size())
		{
			temp_ans = pref_sums[end - 1];
			if (start > 0)
			{
				temp_ans -= pref_sums[start - 1];
			}
			dp[end] = max(dp[end], temp_ans * e[start].first);
			while (start < end - 1 && e[start].first * temp_ans < e[start + 1].first * (pref_sums[end - 1] - pref_sums[start]))
			{
				++start;
				temp_ans = pref_sums[end - 1] - pref_sums[start];
				dp[end] = max(dp[end], temp_ans * e[start].first);
			}
			++end;
		}
		for (int i = 0; i < dp.size(); ++i)
		{
			ans = max(ans, dp[i] + (n - pref_sums[i]) * e[i].first);
		}
		cout << ans;
		return 0;
	}
	return 0;
}
/*

*/