#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

void shift(vector <ll> &v, ll l, ll r)
{
	vector <ll> res = v;
	if ((r - l) % 2)
	{
		--r;
	}
	for (int i = l; i < r; ++i)
	{
		if ((i - l) % 2)
		{
			res[l + (i - l) / 2] = v[i];
		}
		else
		{
			res[l + (i - l) / 2 + (r - l) / 2] = v[i];
		}
	}
	v = res;
}

int main()
{
	ll n;
	cin >> n;
	vector <ll> v(n);
	for (int i = 0; i < n; ++i)
	{
		cin >> v[i];
	}
	vector <ll> s, temp;
	s = temp = v;
	sort(s.begin(), s.end());
	auto i = temp.begin();
	vector <pair<ll, ll>> ans;
	while (temp != s)
	{
		while (i != temp.end() && i == min_element(i, temp.end()))
		{
			++i;
		}
		if (i == temp.end())
		{
			break;
		}
		swap(temp[min_element(i, temp.end()) - temp.begin() - 1], temp[min_element(i, temp.end()) - temp.begin()]);
		ans.push_back({ min_element(i, temp.end()) - temp.begin() - 1, min_element(i, temp.end()) - temp.begin() });
	}
	cout << ans.size() << endl;
	for (int i = 0; i < ans.size(); ++i) 
	{
		cout << ans[i].first + 2 << " " << ans[i].second + 2 << endl;
	}
	return 0;
}
/*
6
2 3 1 1 5 1
*/