#include <iostream>

using namespace std;

const int MAX_N = 200000;
int max_row[MAX_N], max_column[MAX_N], ans_row[MAX_N], ans_column[MAX_N];

int main() {
    ios_base :: sync_with_stdio(0);
    //cin.tie(0);
    int n, m, q, cnt = 0, r, c, x;
    cin >> n >> m >> q;
    int field[n][m];
    bool good[n][m];
    for (int i = 0; i < MAX_N; i++) {
        max_row[i] = max_column[i] = ans_row[i] = ans_column[i] = -1;
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            good[i][j] = 0;
            cin >> field[i][j];
            max_row[i] = max(max_row[i], field[i][j]);
            max_column[j] = max(max_column[j], field[i][j]);
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if ((field[i][j] == max_row[i]) && (field[i][j] == max_column[j])) {
                good[i][j] = 1;
                ans_row[i] = j;
                ans_column[j] = i;
                cnt++;
            }
        }
    }
    bool were_r, were_c;
    for (int i = 0; i < q; i++) {
        cin >> r >> c >> x;
        r--;
        c--;
        //cout << r << ' ' << c << ' ' << x << ' ' ;
        if ((field[r][c] == max_row[r]) && (field[r][c] == max_column[c])) {
            field[r][c] = x;
            max_row[r] = x;
            max_column[c] = x;
            cout << cnt << "\n";
            continue;
        }
        were_r = were_c = 0;
        //if (field[r][c] == were_r)
        field[r][c] = x;
        max_row[r] = max(max_row[r], x);
        max_column[c] = max(max_column[c], x);
        if ((field[r][c] == max_row[r])) {
            if (ans_row[r] != -1) {
                cnt--;
                ans_column[ans_row[c]] = -1;
            }
            ans_row[r] = -1;
        }
        if ((field[r][c] == max_column[c])) {
            if (ans_column[c] != -1) {
                cnt--;
                ans_row[ans_column[c]] = -1;
            }
            ans_column[c] = -1;
        }
        if ((field[r][c] == max_row[r]) && (field[r][c] == max_column[c])) {
            good[r][c] = 1;
            ans_row[r] = c;
            ans_column[c] = r;
            cnt++;
        }
        cout << cnt << "\n";
    }
    return 0;
}
