#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<vector>
#include<algorithm>
#include<stdio.h>
#include<math.h>
#include<string>
#include<stack>
#include<queue>
#include<set>
#include<map>
#include<tuple>

using namespace std;

struct node {
	int x, mx;
	int l, r;
	node*left = NULL, *right = NULL;
	node() {};
	node(int l, int r, vector<int>&v) :l(l), r(r) {
		if (r - l > 1) {
			int m = (l + r) / 2;
			left = new node(l, m, v);
			right = new node(m, r, v);
			mx = max(left->mx, right->mx);
			x = (left->mx > right->mx) ? left->x : right->x;
		}
		else {
			mx = v[l];
			x = l;
		}
	}
};

pair<int,int> get(node*a, int l, int r) {
	if (a->l >= r || a->r <= l) {
		return { 0,0 };
	}
	if (a->l >= l && a->r <= r) {
		return { a->mx,a->x };
	}
	return max(get(a->left, l, r), get(a->right, l, r));
}

int main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	int n;
	cin >> n;
	vector<int>v(n);
	for (int i = 0; i < n; i++) {
		cin >> v[i];
	}
	node*a = new node(0, n, v);
	set<pair<int, int>>st;
	vector<int>next(n);
	for (int i = n - 1; i >= 0; i--) {
		pair<int, int>p = { v[i]-1,-i };
		auto j = st.upper_bound(p);
		if (j != st.begin()) {
			--j;
			next[i] = -j->second;
		}
		else {
			next[i] = n;
		}
		p.first++;
		st.insert(p);
	}
	int ans = 0;
	for (int i = 0; i < n; i++) {
		int mn = next[i];
		int mx = get(a, i, mn).second;
		i = mx;
		ans++;
	}
	cout << ans;
}