#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

int main() {
    int n;
    cin >> n;
    ll maxb = 0;
    bool flag = 1;
    vector<pair<ll, int>> in(n), inpl(n);
    for (int i = 0; i < n; ++i) {
        cin >> inpl[i].first >> in[i].first;
        in[i].second = inpl[i].second = i;
        maxb = max(maxb, in[i].first);
        if (inpl[i].first != in[i].first) {
            flag = 0;
        }
    }
    sort(in.rbegin(), in.rend());
    sort(inpl.rbegin(), inpl.rend());
    ll ans = 0;
    if (flag) {
        for (int i = 0; i < n; ++i) {
            ll l = i + 1, r = n - 1;
            while (l + 1 < r) {
                ll mid1 = l + (r - l) / 3;
                ll mid2 = mid1 + (r - l) / 3;
                if (in[mid1].first * (mid1 - i) < in[mid2].first * (mid2 - mid1)) {
                    l = mid1;
                }
                else {
                    r = mid2;
                }
            }
            if (in[l].first * (l - i) < in[r].first * (r - i)) {
                l = r;
            }
            ans = max(ans, in[i].first * (i + 1) + in[l].first * (l - i));
        }
    }
    else if (maxb == 0) {
        for (int i = 0; i < n; ++i) {
            ans = max(ans, (i + 1) * inpl[i].first);
        }
    }
    else {
        vector<int> used(n);
        for (int i = 0; i < n; ++i) {
            used[inpl[i].second] = 1;
            ll csum = 0, count = 0;
            for (int j = 0; j < n; ++j) {
                if (used[in[j].second]) {
                    continue;
                }
                count++;
                csum = max(csum, count * in[j].first);
            }
            ans = max(ans, (i + 1) * inpl[i].first + csum);
        }
    }
    cout << ans << endl;
}