#include <vector>
#include <algorithm>
#include <iostream>

using namespace std;
typedef long long ll;

int main() {
	ios_base::sync_with_stdio(false);
	int n, m, k;
	cin >> n >> m >> k;
	vector<vector<int>> g(k, vector<int> (k));
	vector<pair<int, int>> p(k);
	for (int i = 0; i < k; ++i)
		cin >> p[i].first >> p[i].second;
	for (int i = 0; i < k; ++i)
		for (int j = 0; j < k; ++j)
			g[i][j] = max(abs(p[i].first - p[j].first), abs(p[i].second - p[j].second));
	const ll UNDEF = (ll)2e17 + 8;
	vector<ll> d(k, UNDEF);
	vector<int> us(k), prv(k, -1);
	d[0] = 0;
	for (int it = 0; it < k; ++it) {
		int v = -1;
		for (int j = 0; j < k; ++j)
			if (!us[j] && (v == -1 || d[j] < d[v]))
				v = j;
		us[v] = 1;
		for (int i = 0; i < k; ++i)
			if (d[i] > d[v] + g[v][i]) {
				d[i] = d[v] + g[v][i];
				prv[i] = v;
			}
	}
	vector<int> w;
	int c = k - 1;
	while (prv[c] != -1) {
		w.push_back(c);
		c = prv[c];
	}
	reverse(w.begin(), w.end());
	cout << w.size() << '\n';
	for (auto u : w)
		cout << u + 1 << ' ';
	return 0;
}