#pragma GCC optimize("O3")
#include <iostream>
#include <algorithm>
#include <queue>
#include <string>
#include <vector>
#include <fstream>
#include <cassert>
#include <bitset>

using namespace std;
typedef long long ll;

#define size(v) ((int)v.size())
#define all(v) v.begin(), v.end()

const int maxn = 100;
int a[maxn], c[maxn], n, d[maxn];

vector<int> g[maxn];

void bfs() {
	queue<int> q;
	for (int i = 0; i < n; ++i)
		if (d[i] == 0)
			q.push(i);
	while (!q.empty()) {
		int v = q.front();
		q.pop();
		for (auto u : g[v])
			if (d[u] > d[v] + 1) {
				d[u] = d[v] + 1;
				q.push(u);
			}
	}
}

signed main() {
	//  ifstream fin("inp.txt");
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> a[0];
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	for (int i = 1; i < n - 1; ++i) {
		g[i].push_back(i + 1); g[i].push_back(i - 1);
	}
	g[0].push_back(1);
	g[n - 1].push_back(n - 2);
	for (int i = 0; i < n; ++i) {
		for (int j = -1; j < i; ++j)
			for (int z = n; z > i; --z) {
				if (j == -1 && z == n)
					continue;
				fill(d, d + n, (int)1e9);
				for (int k = 0; k < n; ++k)
					if (k <= j || k >= z)
						d[k] = 0;
				bfs();
				int cnt = 0;
				for (int k = 0; k < n; ++k) {
					if (d[k] + a[k] < d[i] + a[i])
						++cnt;
				}
				c[i] = max(cnt, c[i]);
			}
	}
	for (int i = 0; i < n; ++i)
		cout << c[i] + 1 << '\n';
	return 0;
}