#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef vector<int> vi;
typedef long long ll;
typedef pair<int, int> pii;

#define inb push_back
#define X first
#define Y second

const int INF = 2e9;
const int M = 1e5 + 5;

int n;
pii a[M];

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	for (int i = 0; i < n; ++i)
		cin >> a[i].Y >> a[i].X;
	sort(a, a + n);
	vi d;
	ll ans = 0;
	for (int i = 0; i < n; ++i)
	{
		d.clear();
		ll an = 0, bal = 0;
		for (int j = 0; j < n; ++j)
			if (a[j].Y < a[i].Y)
				d.inb(a[j].X);
			else
				an += a[i].Y;
		for (int j = 0; j < d.size(); ++j)
			bal = max(bal, (ll)d[j] * ((ll)d.size() - j));
		ans = max(ans, an + bal);
	}
	cout << ans << '\n';
}