#include <iostream>
#include <vector>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <string>
#include <ctime>
#include <cstring>
#include <bitset>

using namespace std;

struct V{
    int x;
    int i;
    int j;

    V(){
    }

    V(int a, int b, int c){
        x = a;
        i = b;
        j = c;
    }
};

bool operator < (const V& a, const V& b){
    return a.x < b.x;
}

int n, m, q;
vector<vector<int>> vec;
vector<V> hor;
vector<V> ver;
vector<vector<int>> fa;
int ans = 0;

void pr(int i, int j, int x){
    if (x == 1){
        fa[i][j]++;
        if (fa[i][j] == 2){
            ans++;
        }
    } else {
        fa[i][j]--;
        if (fa[i][j] == 1){
            ans--;
        }
    }
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    cin >> n >> m >> q;

    vec.resize(n);
    fa.resize(n);
    hor.resize(n);
    ver.resize(m);

    fill(hor.begin(), hor.end(), V(-1, 0, 0));
    fill(ver.begin(), ver.end(), V(-1, 0, 0));

    for (int i = 0; i < n; ++i){
        vec[i].resize(m);
        fa[i].resize(m);
        for (int j = 0; j < m; ++j){
            cin >> vec[i][j];
            fa[i][j] = 0;
            hor[i] = max(hor[i], V(vec[i][j], i, j));
            ver[j] = max(ver[j], V(vec[i][j], i, j));
        }
    }

    for (auto e : ver){
        pr(e.i, e.j, 1);
    }

    for (auto e : hor){
        pr(e.i, e.j, 1);
    }

    while (q--){
        int i, j, x;
        cin >> i >> j >> x;
        i--; j--;

        pr(hor[i].i, hor[i].j, -1);
        pr(ver[j].i, ver[j].j, -1);

        vec[i][j] = x;

        hor[i] = max(hor[i], V(vec[i][j], i, j));
        ver[j] = max(ver[j], V(vec[i][j], i, j));

        pr(hor[i].i, hor[i].j, 1);
        pr(ver[j].i, ver[j].j, 1);
        cout << ans << '\n';
    }
    cout << endl;

    return 0;
}
