#include <iostream>
#include <vector>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <bitset>
#include <ctime>
#include <string>
#include <cstring>

#define fi first
#define se second

using namespace std;

int n;

string f(string s1, string s2, string s3, int ind){
    for (int i = ind; i < n; ++i){
        s1[i] = '0';
    }

    for (int i = ind - 1; i >= 0; --i){
        if ((s1[i] == '0') && (s2[i] == '0')){
            s1[i] = '1';
            break;
        }

        if (s1[i] == '1'){
            s1[i] = '0';
        }
    }

    for (int i = 0; i < n; ++i){
        if ((s1[i] == '1') || (s2[i] == '1')){
            s3[i] = '1';
        }
    }
    return s3;
}

void pr(string s){
    bool fl = false;
    for (auto e : s){
        if (e == '1'){
            fl = true;
        }

        if (fl){
            cout << e;
        }
    }
    cout << endl;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    cin >> n;

    string s1;
    string s2;

    cin >> s1;
    cin >> s2;

    s1 = '0' + s1;
    s2 = '0' + s2;

    if (s1.size() > s2.size()){
        swap(s1, s2);
    }

    string s3;
    for (int i = 0; i < (int)s2.size() - (int)s1.size(); ++i){
        s3 += '0';
    }

    s1 = s3 + s1;

    while (s3.size() < s2.size()){
        s3 += '0';
    }

    n = s1.size();
    int ind = -1;

    for (int i = 0; i < n; ++i){
        if ((s1[i] == '1') && (s2[i] == '1')){
            ind = i;
            break;
        }
    }

    if (ind == -1){
        for (int i = 0; i < n; ++i){
            if ((s1[i] == '1') || (s2[i] == '1')){
                s3[i] = '1';
            }
        }

        pr(s3);
    } else {
        pr(min(f(s1, s2, s3, ind), f(s2, s1, s3, ind)));
    }

    return 0;
}
