#include <bits/stdc++.h>

using namespace std;
typedef long long nagai;

nagai ans = 0;
vector<int> as;
vector<int> bs;

const int N = 1 << 18;
nagai t[2 * N];

void add(int x, int y)
{
	x += N;
	t[x] += y;
	while (x > 1)
		t[x >> 1] = t[x] + t[x ^ 1], x >>= 1;
}

int get(int l, int r)
{
	l += N;
	r += N;
	int ans = 0;
	while (l < r)
	{
		if (l & 1)
			ans += t[l++];
		if (r & 1)
			ans += t[--r];
		l >>= 1, r >>= 1;
	}
	return ans;
}

int n;

void calc(int l, int r, int optl, int optr)
{
	if (r - l == 0)
		return;
	int m = (l + r) / 2;
	nagai opt = 1, opti = -1;
	nagai prefback = get(0, N);
	for (int i = optl; i <= optr; ++i)
	{
		nagai val = 1LL * m * (n - prefback) + 1LL * bs[i] * (prefback - get(0, i));
		if (val > opt)
			opt = val, opti = i;
	}
	ans = max(ans, opt);
	calc(l, m, optl, opti);
	for (int i = l; i < m; ++i)
		add(i, 1);
	calc(m + 1, r, opti, optr);
}

int main()
{
	ios::sync_with_stdio(false);
	cin >> n;
	vector<int> a(n), b(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i] >> b[i], as.push_back(a[i]), bs.push_back(b[i]);
	set<int> mem(as.begin(), as.end());
	as.assign(mem.begin(), mem.end());
	mem = set<int>(bs.begin(), bs.end());
	bs.assign(mem.begin(), mem.end());
	for (auto& x : b)
		x = lower_bound(bs.begin(), bs.end(), x) - bs.begin();
	int ptr = 0;
	int cnt1 = 0;
	vector<int> a2 = a;
	sort(a2.begin(), a2.end());
	calc(0, as.size(), 0, bs.size());
	cout << ans << '\n';

}
