#include <bits/stdc++.h>

const int N = 300100;
const int LG = 20;

int n;
int a[N];
int spMin[LG][N], spMax[LG][N];
int lg[N];

int calcLog(int n) {
    int res = 0;
    while ((1 << res) <= n) {
        ++res;
    }
    return res - 1;
}

void init() {
    for (int i = 1; i < N; ++i) {
        lg[i] = calcLog(i);
    }
    for (int i = 0; i < n; ++i) {
        spMin[0][i] = a[i];
        spMax[0][i] = a[i];
    }
    for (int i = 1; i < LG; ++i) {
        for (int j = 0; j < n; ++j) {
            spMin[i][j] = spMin[i - 1][j];
            spMax[i][j] = spMax[i - 1][j];
            if (j + (1 << (i - 1)) < n) {
                spMin[i][j] = std::min(spMin[i][j], spMin[i - 1][j + (1 << (i - 1))]);
                spMax[i][j] = std::max(spMax[i][j], spMax[i - 1][j + (1 << (i - 1))]);
            }
        }
    }
}

int getMin(int l, int r) {
    int len = r - l + 1;
    int id = lg[len];
    return std::min(spMin[id][l], spMin[id][r - (1 << id) + 1]);
}

int getMax(int l, int r) {
    int len = r - l + 1;
    int id = lg[len];
    return std::max(spMax[id][l], spMax[id][r - (1 << id) + 1]);
}

int main(void) {
    scanf("%d", &n);
    for (int i = 0; i < n; ++i) {
        scanf("%d", &a[i]);
    }
    init();
    int ans = 0;
    int start = 0;
    while (start != n) {
        int l = start - 1, r = n;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (getMin(start, m) < a[start]) {
                r = m;
            } else {
                l = m;
            }
        }
        int end = start;
        for (int j = start; j <= l; ++j) {
            if (getMax(start, j) == a[j]) {
                end = j;
            }
        }
        ++ans;
        start = end + 1;
        /*int end = start;
        for (int i = start + 1; i < n; ++i) {
            if (a[i] < a[start]) {
                break;
            }
            if (a[i] >= a[end]) {
                end = i;
            }
        }
        ++ans;
        start = end + 1;*/
    }
    printf("%d\n", ans);
    return 0;
}