#include <fstream>
#include <iostream>
#include <cmath>
#include <vector>
#include <climits>
#include <queue>
#include <algorithm>

using namespace std;

int main() {
//    ifstream cin("input.txt");
    int n, p;
    cin >> n >> p;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    if (p == 1) {
        for (int i = 0; i < n; i++) {
            vector<int> times(n);
            for (int j = 0; j < n; j++) {
                times[j] = a[j] + abs(j - i);
            }
            sort(times.begin(), times.end());
            for (int j = 0; j < n; j++) {
                if (times[j] == a[i]) {
                    cout << j + 1 << '\n';
                    break;
                }
            }
        }
    } else {
        vector<int> times[3];
        for (int i = 0; i < n; i++) {
            times[i].resize(n);
        }
        for (int v: {0, 1, 2}) {
            for (int j = 0; j < n; j++) {
                if (v == 0) times[v][j] = a[j] + j;
                else if (v == 1) times[v][j] = a[j] + n - 1 - j;
                else times[v][j] = a[j] + min(n - 1 - j, j);
            }
            sort(times[v].begin(), times[v].end());
        }
        for (int i = 0; i < n; i++) {
            int worst = 0;
            for (int v: {0, 1, 2}) {
                int cost;
                if (v == 0) cost = a[i] + i;
                else if (v == 1) cost = a[i] + n - 1 - i;
                else cost = a[i] + min(n - 1 - i, i);
                for (int j = 0; j < n; j++) {
                    if (times[v][j] == cost) {
                        worst = max(j, worst);
                        break;
                    }
                }
            }
            cout << worst + 1 << '\n';
        }
    }

    return 0;
}