#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int SZ = 1e5 + 10;

int n;
vector<int> vect;
int max_on_suf[SZ];

int arr[SZ];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n;
    for (int i = 0; i < n; i++) {
        int a;
        cin >> a;
        vect.push_back(a);
        cin >> a;
    }
    sort(vect.begin(), vect.end());
    reverse(vect.begin(), vect.end());
    for (int i = 1; i <= vect.size(); i++)
        arr[vect.size() - i] = vect[vect.size() - i] * i;
    int max_ind = vect.size() - 1;
    for (int i = vect.size() - 1; i >= 0; i--) {
        if (arr[i] > arr[max_ind])
            max_ind = i;
        max_on_suf[i] = max_ind;
    }
    int res = 0;
    for (int i = 0; i < vect.size(); i++) {
        int now = vect[i] * (i + 1);
        int ind = max_on_suf[i + 1];
        now += vect[ind] * (ind - i);
        res = max(res, now);
    }
    cout << res;
    return 0;
}
