#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>

using namespace std;

const int SZ = 1e3 + 10;
const int INF = 1e9;

int n, p;
int arr[SZ];
bool work[SZ];

int ans[SZ];

int start_time(int ind, int L, int R)
{
    if (ind < L || ind > R)
        return 0;
    int res = INF;
    if (L > 0)
        res = min(res, ind - L + 1);
    if (R < n - 1)
        res = min(res, R - ind + 1);
    return res;
}

void upd(int ind, int L, int R)
{
    int sum = 0;
    for (int i = 0; i < n; i++) {
        if (arr[i] + start_time(i, L, R) < arr[ind] + start_time(ind, L, R))
            sum++;
    }
    ans[ind] = max(ans[ind], sum + 1);
}

void action(int ind)
{
    for (int i = 0; i < n; i++)
        work[i] = true;
    for (int len = 0; len < n; len++) {
        if (ind - len >= 0)
            work[ind - len] = false;
        if (ind + len < n)
            work[ind + len] = false;
        upd(ind, ind - len, ind + len);
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> p;
    for (int i = 0; i < n; i++)
        cin >> arr[i];
    for (int i = 0; i < n; i++)
        action(i);
    for (int i = 0; i < n; i++)
        cout << ans[i] << "\n";
    return 0;
}
