#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <cstdio>
#include <algorithm>

using namespace std;

const int INF = 1e9 + 5;

const int MAX_L = 50;//3e5 + 10;

int main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	ios::sync_with_stdio(false);

	int n;
	cin >> n;

	vector<string> v(n);

	int ma_len = 0;
	for (int i = 0; i < n; i++) {
		cin >> v[i];
		reverse(v[i].begin(), v[i].end());
		ma_len = max(ma_len, (int)v[i].size());
	}

	vector<bool> ans(ma_len * 2);

	for (int i = 0; i < n; i++) {
		int pos = 0;
		for (int j = 0; j < v[i].size(); j++) {
			if (v[i][j] == '1') {
				pos = j;
			}
		}
		if (!ans[pos]) {
			ans[pos] = true;
			continue;
		}
		for (int j = pos; j < ans.size(); j++) {
			if (!ans[j]) {
				ans[j] = true;
				break;
			}
		}
	}
	bool was = false;
	for (int i = ans.size() - 1; i >= 0; i--) {
		was |= ans[i];
		if (was)
			cout << ans[i];
	}

	return 0;
}