// #define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define pii pair<int, int>
#define pll pair<ll, ll>
#define mp make_pair
#define pb push_back
#define ld long double
#define pas(x) cout << #x << ' ' << x << 1endl;


struct stree
{
    int k;
    vector<int> t;
    stree(int n) {
        k = 1;
        while (k <= n) k *= 2;
        t.assign(2 * k, 0);
    }

    void update(int p, int v) {
    	p += k;
    	while (p > 0) {
    		t[p] += v;
    		p /= 2;
    	}
    }
 
    int get_sum(int l, int r) {
        int res = 0;
        for (l += k, r += k; l <= r; l /= 2, r /= 2) {
            if (l % 2 == 1) {
               res += t[l];
                l++;
            }
            if (r % 2 == 0) {
                res += t[r];
                r--;
            }
        }
        return res;
    }
};




int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	
	int n; cin >> n;
	int p; cin >> p;
	vector<int> a(n);

	for (int &i : a) cin >> i;

	for (int cur = 0; cur < n; cur++) {
		int res = 1;

		// 0 ways
		int tmp = 0;
		for (int i = 0; i < n; i++) {
			if (a[i] < a[cur]) tmp++;
		}
		res = tmp + 1;
		// left
		for (int j = 0; j < cur; j++) {
			int tmp = 0;
			for (int i = 0; i < n; i++) {
				if (i <= j) {
					if (a[i] < a[cur] + abs(j - cur)) tmp++;
				} else {
					if (a[i] + abs(j - i) < a[cur] + abs(j - cur)) tmp++;
				}
			}
			res = max(res, tmp+1);
		}
		// right
		for (int j = cur + 1; j < n; j++) {
			int tmp = 0;
			for (int i = 0; i < n; i++) {
				if (i >= j) {
					if (a[i] < a[cur] + abs(j - cur)) tmp++;
				} else {
					if (a[i] + abs(j - i) < a[cur] + abs(j - cur)) tmp++;
				}
			}
			res = max(res, tmp+1);
		}
		// both
		for (int dist = 1; dist <= min(cur, n - 1 - cur); dist++) {
			int tmp = 0;
			for (int i = 0; i < n; i++) {
				if (i <= cur - dist || i >= cur + dist) {
					if (a[i] < a[cur] + dist) tmp++;
				} else {
					if (i < cur) {
						if (a[i] < a[cur] + cur - i) tmp++;
					} else {
						if (a[i] < a[cur] + i - cur) tmp++;
					}
				}
			}
			res = max(res, tmp+1);
		}
		cout << res << ' ';
	}


	return 0;
}