#include<bits/stdc++.h>
using namespace std;
vector< vector<int> > atac, def;
vector<bool> ch(500), used;
int dan[500][500];
int n, p;

bool calc(int v, int t) {
    ch.assign(n, 0);
    ch[v] = 1;
    ch[t] = 1;
    bool good  = 0;
    for(int i = 0; i < n; i++) {
        if(dan[v][i] == t) {
            good = 1;
        }
        if(good) {
            for(auto k: atac[dan[v][i]]) {
                ch[k] = 1;
            }
            ch[dan[v][i]] = 1;
        }
    }
    for(int i = 0; i < n; i++) {
        if(dan[v][i] == v)
            break;
        if(!ch[dan[v][i]])
            return 0;
    }
    return 1;
}

bool go(int v) {
    if(calc(v, v))
        return 1;
    for(auto u: atac[v]) {
        if(calc(u, v))
            return 1;
    }
    return 0;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    //freopen("Tests.txt", "r", stdin);
    cin >> n;
    atac.resize(n);
    used.resize(n, 0);
    def.resize(n);
    ch.resize(n);
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < n; j++) {
            cin >> dan[i][j];
            dan[i][j]--;
        }
    }
    cin >> p;
    vector<int> ans;
    if(p == 1) {
        for(int i = 0; i < n; i++) {
            if(dan[i][0] == i) {
                ans.push_back(i + 1);
            }
        }
    } else {
        for(int i = 0; i < n; i++) {
            for(int j = 0; j < n; j++) {
                if(dan[i][j] == i) {
                    for(int k = j; k < n; k++) {
                        def[i].push_back(dan[i][k]);
                    }
                    break;
                }
                atac[dan[i][j]].push_back(i);
            }
        }
        for(int t = 0; t < n; t++) {
            if(go(t)) {
                ans.push_back(t + 1);
            }
        }
    }
    cout << ans.size() << "\n";
    for(int i = 0; i < ans.size(); i++) {
        cout << ans[i] << " ";
    }
    return 0;
}
