#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <set>
#include <cmath>
#include <algorithm>
#include <string>
#include <deque>
#include <map>
#include <unordered_map>

#define rn(n) int n; cin >> n
#define fv(i, n) for (int i = 0; i < n; i++)
#define fi(n) fv(i, n)
#define fj(n) fv(j, n)
#define vi vector <int>
#define ll long long

using namespace std;

const int INF = 1000000007;

int main() {
	ios::sync_with_stdio(false);
#ifdef Local_file
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	rn(n); rn(m); rn(q);
	vector <vi> v(n);
	fi(n) {
		fj(m) {
			rn(d);
			v[i].emplace_back(d);
		}
	}
	vector <pair <int, int>> lines(n), columns(m);
	fi(n) {
		lines[i] = { 0, -1 };
		fj(m) {
			if (lines[i].first < v[i][j]) {
				lines[i] = { v[i][j], j };
			}
		}
	}
	fi(m) {
		columns[i] = { 0, -1 };
		fj(n) {
			if (columns[i].first < v[j][i]) {
				columns[i] = { v[j][i], j };
			}
		}
	}
	unordered_map <int, int> ch;
	int ans = 0;
	fi(columns.size()) {
		ch[columns[i].first]++;
	}
	fi(lines.size()) {
		ch[lines[i].first]++;
	}
	for (auto it = ch.begin(); it != ch.end(); it++) {
		if (it->second >= 2) ans++;
	}
	fi(q) {
		if (i >= 5000) exit(1);
		rn(x); rn(y); rn(c);
		x--;
		y--;
		ch[lines[x].first]--;
		if (ch[lines[x].first] == 1) ans--;
		ch[columns[y].first]--;
		if (ch[columns[y].first] == 1) ans--;
		if (c > lines[x].first && c > columns[y].first) {
			lines[x] = { c, y };
			columns[y] = { c, x };
		}
		else if (c > columns[y].first) {
			columns[y] = { c, x };
		}
		else if (c > lines[x].first) {
			lines[x] = { c, y };
		}
		ch[lines[x].first]++;
		if (ch[lines[x].first] == 2) ans++;
		ch[columns[y].first]++;
		if (ch[columns[y].first] == 2) ans++;

		cout << ans << endl;
	}
}