#include <iostream>
#include <algorithm>
#include <fstream>
#include <vector>

using namespace std;

vector<vector<int>> matrix;

int main()
{
	int n, m, q;
	ifstream fin("input.txt");
	ofstream fout("output.txt");
	fin >> n >> m >> q;
	matrix.resize(n);
	for (int i = 0; i < n; i++)
		matrix[i].resize(m);
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
			fin >> matrix[i][j];
	vector<int> maxRow(n, 0);
	vector<int> maxColumn(m, 0);
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
		{
			if (matrix[i][j] > matrix[i][maxRow[i]])
				maxRow[i] = j;
			if (matrix[i][j] > matrix[maxColumn[j]][j])
				maxColumn[j] = i;
		}
	for (int k = 0; k < q; k++)
	{
		int x, y, v;
		fin >> y >> x >> v;
		x--;
		y--;
		matrix[y][x] = v;
		for (int i = 0; i < n; i++)
			for (int j = 0; j < m; j++)
			{
				if (matrix[i][j] > matrix[i][maxRow[i]])
					maxRow[i] = j;
				if (matrix[i][j] > matrix[maxColumn[j]][j])
					maxColumn[j] = i;
			}
		int count = 0;
		for (int i = 0; i < n; i++)
		{
			for (int j = 0; j < m; j++)
				if (maxRow[i] == j && maxColumn[j] == i)
					count++;
		}
		fout << count << '\n';
	}
	fin.close();
	fout.close();
	return 0;
}