#include <iostream>
#include <algorithm>
#include <fstream>
#include <vector>

using namespace std;

vector<vector<int>> matrix;
vector<vector<bool>> matrixB;

int main()
{
	int n, m, q;
	//ifstream fin("input.txt");
	cin >> n >> m >> q;
	//fin >> n >> m >> q;
	matrix.resize(n);
	matrixB.resize(n);
	for (int i = 0; i < n; i++)
	{
		matrix[i].resize(m);
		matrixB[i].resize(m);
	}
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
			cin >> matrix[i][j];
			//fin >> matrix[i][j];
	vector<int> maxRow(n, 0);
	vector<int> maxColumn(m, 0);
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
		{
			if (matrix[i][j] > matrix[i][maxRow[i]])
				maxRow[i] = j;
			if (matrix[i][j] > matrix[maxColumn[j]][j])
				maxColumn[j] = i;
		}
	int count = 0;
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < m; j++)
			if (maxRow[i] == j && maxColumn[j] == i)
			{
				matrixB[i][j] = true;
				count++;
			}
	}
	for (int k = 0; k < q; k++)
	{
		int x, y, v;
		cin >> y >> x >> v;
		//fin >> y >> x >> v;
		x--;
		y--;
		matrix[y][x] = v;
		if (matrixB[y][x])
		{
			cout << count << endl;
			continue;
		}
		if (matrix[y][x] > matrix[y][maxRow[y]])
		{
			if (matrixB[y][maxRow[y]])
			{
				matrixB[y][maxRow[y]] = false;
				count--;
			}
			maxRow[y] = x;
		}
		if (matrix[y][x] > matrix[maxColumn[x]][x])
		{
			maxColumn[x] = y;
			if (matrixB[maxColumn[x]][x])
			{
				matrix[maxColumn[x]][x] = false;
				count--;
			}		
		}
		if (maxRow[y] == x && maxColumn[x] == y)
		{
			matrixB[y][x] = true;
			count++;
		}
		cout << count << endl;
	}
	//fin.close();
	return 0;
}