#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

#pragma comment(linker, "/STACK:536870912")

using namespace std;

int main()
{
	int n, p;
	cin >> n >> p;
	vector<int> time(n);
	for (int i = 0; i < n; i++)
		cin >> time[i];
	
	vector<int> nmin(n, 99999999);
	//vector<int> nmax(n, -1);
	for (int i = 0; i < n; i++)
	{
		int l = i, r = i;
		vector<pair<int, int>> trt(n);
		while (l >= 0 || r < n)
		{
			if (l >= 0)
				trt[l] = { time[l] + (i - l), l };
			if (r < n)
				trt[r] = { time[r] + (r - i), r };
			l--;
			r++;
		}
		sort(trt.begin(), trt.end());
		int count = 1;
		nmin[trt[0].second] = min(nmin[trt[0].second], count);
		for (int j = 1; j < n; j++)
		{
			if (trt[j].first > trt[j - 1].first)
				count++;
			nmin[trt[j].second] = min(nmin[trt[j].second], count);
		}
	}
	for (auto i : nmin)
		cout << i << endl;
	return 0;
}