#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

#define _ inline
#define f first
#define sec second
#define pb push_back
#define ins insert
#define ers erase
#define mk make_pair
#define rsz resize
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define int ll
#define endl '\n'

#define prev prevv
#define next nextt
#define left leftt
#define right rightt

mt19937 Random(int(time(0)));

const int INF = 1e9 + 10;
const int MOD = 1e9 + 7;
const int P = 239017;
const ll BINF = 1e18 + 10;
const ld EPS = 1e-9;

const int N = 3e5 + 10;
const int LOG = 22;
int mx[N][LOG], mn[N][LOG], kek[N], dp[N], arr[N];
pair<int, int> t[8 * N], cur_res;

_ int get_max(int l, int r) {
    int cur = kek[r - l + 1];
    return max(mx[l][cur], mx[r - (1 << cur) + 1][cur]);
}

_ int get_min(int l, int r) {
    int cur = kek[r - l + 1];
    return min(mn[l][cur], mn[r - (1 << cur) + 1][cur]);
}

void relax(int v) {
    t[v] = max(t[2 * v], t[2 * v + 1]);
}

void build(int v, int l, int r) {
    if (l == r) {
        t[v] = {arr[l], l};
        return;
    }
    int mid = (l + r) / 2;
    build(2 * v, l, mid);
    build(2 * v + 1, mid + 1, r);
    relax(v);
}

_ void get(int v, int l, int r, int a, int b) {
    if (l > b || r < a) {
        return;
    }
    if (l >= a && r <= b) {
        cur_res = max(cur_res, t[v]);
        return;
    }
    int mid = (l + r) / 2;
    get(2 * v, l, mid, a, b);
    get(2 * v + 1, mid + 1, r, a, b);
}

_ void source() {
    int n;
    cin >> n;
    for (int i = 1; i <= n; i++) {
        cin >> arr[i];
        mx[i][0] = arr[i];
        mn[i][0] = arr[i];
    }
    build(1, 1, n);
    for (int i = 1; i < LOG; i++) {
        int cur_len = 1 << i, prev_len = cur_len / 2;
        for (int j = 1; j + cur_len - 1 <= n; j++) {
            mx[j][i] = max(mx[j][i - 1], mx[j + prev_len][i - 1]);
            mn[j][i] = min(mn[j][i - 1], mn[j + prev_len][i - 1]);
        }
    }
    kek[1] = 0;
    for (int i = 2; i <= n; i++) {
        kek[i] = kek[i / 2] + 1;
    }
    for (int i = 1; i <= n; i++) {
        dp[i] = INF;
    }
    for (int i = 0; i < n; i++) {
        int l = i + 1, r = n + 1;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            if (get_min(i + 1, mid) == arr[i + 1]) {
                l = mid;
            }
            else {
                r = mid;
            }
        }
        cur_res = {0, 0};
        get(1, 1, n, i + 1, l);
        int to = cur_res.sec;
        //cout << i << ' ' << l << ' ' << to << endl;
        dp[to] = min(dp[to], dp[i] + 1);
    }
    cout << dp[n];
}

signed main() {
#ifdef EXTRATERRESTRIAL_
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    source();
    return 0;
}
