#include <bits/stdc++.h>

using namespace std;
/*
vector<int> merge(vector<int> a, vector<int> b)
{
    vector<int> res;
    int i = 0;
    int j = 0;
    while (i < a.size() && j < b.size())
    {
        if (a[i] < b[j]) res.push_back(a[i++]);
        else res.push_back(b[j++]);
    }
    while (i < a.size())
        res.push_back(a[i++]);
    while (j < b.size())
        res.push_back(b[j++]);
    return res;
}

struct merge_tree
{
    int sz = 1;
    vector<vector<int> > MT;
    vector<int> L, R;
    merge_tree(vector<int> a)
    {
        while (sz < a.size()) sz <<= 1;
        L.resize(sz << 1);
        R.resize(sz << 1);
        MT.resize(sz << 1);
        for (int i = 0; i < a.size(); ++i) MT[sz + i].push_back(a[i]);
        build();
    }
    void build(int x = 1)
    {
        if (x >= sz)
        {
            L[x] = x - sz;
            R[x] = x - sz;
            return;
        }
        build(x << 1);
        build(x << 1 | 1);
        MT[x] = merge(MT[x << 1], MT[x << 1 | 1]);
    }
};
*/

int sum(vector<int> &a, int l, int r)
{
    int res = 0;
    for (int i = l; i <= r; ++i) res += a[i];
    return res;
}

struct segtree
{
    int sz = 1;
    vector<int> L, R, DO;
    segtree(vector<int> a)
    {
        while (sz < a.size()) sz <<= 1;
        DO.resize(sz << 1);
        L.resize(sz << 1);
        R.resize(sz << 1);
        for (int i = 0; i < a.size(); ++i) DO[sz + i] = a[i];
        build();
    }
    segtree(int n)
    {
        while (sz < n) sz <<= 1;
        DO.resize(sz << 1);
        L.resize(sz << 1);
        R.resize(sz << 1);
        build();
    }
    void build(int x = 1)
    {
        if (x >= sz)
        {
            L[x] = x - sz;
            R[x] = x - sz;
            return;
        }
        build(x << 1);
        build(x << 1 | 1);
        L[x] = L[x << 1];
        R[x] = R[x << 1 | 1];
        DO[x] = DO[x << 1] + DO[x << 1 | 1];
    }
    int get(int l, int r)
    {
        l += sz;
        r += sz;
        int res = 0;
        while (l <= r)
        {
            if ((l & 1) == 1) res += DO[l++];
            if ((r & 1) == 0) res += DO[r--];
            l >>= 1;
            r >>= 1;

        }
        return res;
    }
    void add(int pos)
    {
        ++DO[sz + pos];
        int now = sz + pos;
        now >>= 1;
        while (now)
        {
            DO[now] = DO[now << 1] + DO[now << 1 | 1];
            now >>= 1;
        }
    }
};

int main()
{
    int n, p;
    scanf("%d %d", &n, &p);
    vector<int> a(n);
    for (int i = 0; i < n; ++i)
    {
        scanf("%d", &a[i]);
    }
    /*vector<int> x(n);
    for (int i = 0; i < n; ++i) x[i] = a[i] + i;
    merge_tree l(x);
    for (int i = 0; i < n; ++i)
    {
        x[i] -= i;
        x[i] += n - i - 1;
    }
    merge_tree r(x);*/
    if (p == 1)
    {
        vector<int> l(n), r(n);
        for (int i = 0; i < n; ++i)
        {
            l[i] = a[i] + i;
            r[i] = a[i] + n - 1 - i;
        }
        vector<int> all;
        for (int i = 0; i < l.size(); ++i) all.push_back(l[i]);
        for (int i = 0; i < r.size(); ++i) all.push_back(r[i]);
        sort(all.begin(), all.end());
        map<int, int> x;
        for (int i = all.size() - 1; i > -1; --i) x[all[i]] = i;
        vector<int> ans(n);
        segtree lx(all.size());
        for (int i = n - 1; i > -1; --i)
        {
            int val = x[l[i]];
            lx.add(val);
            ans[i] = lx.get(0, val - 1);
        }
        segtree rx(all.size());
        for (int i = 0; i < n; ++i)
        {
            rx.add(x[r[i]]);
            ans[i] += rx.get(0, x[r[i]] - 1);
        }
        for (int i = 0; i < ans.size(); ++i) printf("%d\n", ans[i] + 1);
        cout << endl;
    }
}
