#include <bits/stdc++.h>

//#pragma target("sse, sse2, sse3, ssse3, sse4, popcnt, abm, mmx, avx, tune==native")
//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")

using namespace std;

vector <vector <pair <int, unsigned long long> > > g;
typedef unsigned long long ull;
vector <ull> dist;
vector <int> prevv;
const int INF = 1e9;
int n, m, k;

void dijkstra(int v = 1)
{
    set <pair <ull, int> > cur;
    dist[v] = 0;
    for (int i = 1; i <= k; ++i)
    {
        cur.insert({dist[i], i});
    }
    //cout << "ok\n";
    vector <bool> used(k +1);
    while (!cur.empty())
    {
        auto x = (*cur.begin());
        cur.erase(cur.begin());
        int to = x.second;
        used[to] = true;
        //cout << "to " << to  << " " << cur.size()<< endl;
        ull we = x.first;
        for (pair <int, unsigned long long> next : g[to])
        {
            if (!used[next.first]){
                cur.erase({dist[next.first], next.first});
                if (we + next.second < dist[next.first])
                    prevv[next.first] = to;
                dist[next.first] = min(dist[next.first], we + next.second);
                cur.insert({dist[next.first], next.first});
            }
        }
    }
    vector <int> ans;
    int idx = k;
    ans.push_back(k);
    while (prevv[idx] != -1)
    {
        ans.push_back(prevv[idx]);
        idx = prevv[idx];
    }
    cout << ans.size() << endl;
    reverse(ans.begin(), ans.end());
    for (int i = 0 ; i < (int)ans.size(); ++i)
    {
        cout << ans[i] << ' ';
    }
   //cout << dist[k] << endl;
}



int main()
{

    cin >> n >> m >> k;
    map <pair <int, int>, int> idx;
    g.resize(k + 1);
    vector <pair <int, int> > lis(1);
    for (int i = 0 ; i < k; ++i)
    {
        int v, to;
        cin >> v >> to;
        lis.push_back({v, to});
    }
    for (int i = 1; i <= k; ++i)
    {
        for (int j = i + 1; j <= k; ++j)
        {
            ull w = (1ULL << (max(abs(lis[i].first - lis[j].first), abs(abs(lis[i].second - lis[j].second)))));
            g[i].push_back({j, w});
            g[j].push_back({i, w});
        }
    }
    dist.resize(k + 1, INF);
    prevv.resize(k + 1, -1);
    dijkstra();
    return 0;
}
