#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

int n;

vector <pair <int, int> > perm;

const int INF = 1e9;

void swapp(vector <int> & a, int L, int R)
{
    int r = R;
    while (r != L)
    {
        if ((r - L) % 2 == 0 || r == L + 1)
        {
            swap(a[r], a[r - 1]);
            perm.push_back({r, r + 1});
            --r;
        }
        else
        {
            perm.push_back({L + 1, r + 1});
            vector <int> cop;
            for (int i =L; i <= r; ++i)
                cop.push_back(a[i]);
            for (int i = 1; i < cop.size(); i += 2){
                a[L + i / 2] = cop[i];
            }
            for (int i = 0; i < cop.size(); i += 2){
                a[L + ((int)cop.size() - 0) / 2 + i / 2] = cop[i];
            }
            r = L + (r - L) / 2;
        }
       // cout << L << " " << r << endl;
      //  for (int k =0 ; k < n; ++k)
      //  {
       //     cout << a[k] << " ";
      //  }
      //  cout <<  endl;
    }

     //swap(a[j - 1], a[j]);
    //perm.push_back({j, j + 1});

}

void bubble(vector <int> & a)
{
    for (int i = 0; i < n - 1; ++i)
    {
        int minn = a[i];
        int idx = i;
        //cout << "\n mintgy " << i << endl;;
        for (int j = i + 1; j < n; ++j)
        {
            //cout  << minn << " " << a[j] << endl;
            if (a[j] < minn)
            {
                minn = a[j];
                idx = j;
            }
        }
       // cout<< "min " << i << " " << a[idx] << endl;
        swapp(a, i, idx);
       // for (int k =0 ; k < n; ++k)
       // {
         //   cout << a[k] << " ";
       // }
       // cout <<  endl;
    }

}

int main()
{
    cin >> n;
    vector <int> a(n);
    for (int i = 0 ; i < n; ++i)
    {
        cin >> a[i];
    }
    bubble(a);
    cout << perm.size() << endl;
    for (auto x : perm)
    {
        cout << x.first << " " << x.second << '\n';
    }
    return 0;
}
