#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

#pragma target("sse, sse2, sse3, ssse3, sse4, popcnt, abm, mmx, avx, tune==native")
#pragma GCC optimize("unroll-loops")

int n;

int main()
{
    cin >> n;
    int p;
    cin >> p;
    vector <int> a(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> a[i];
    }
    vector <int> best(n);
    for (ull i = 1; i < (1ULL << n); ++i)
    {
        for (int k = 0; k < n; ++k)
        {
            int cur = a[k];
            int L = k;
            int R = k;
            while (L >= 0 && ((i >> (n - L - 1)) & 1) != 1)
            {
                --L;
            }
            while (R < n && ((i >> (n - R - 1)) & 1) != 1)
            {
                ++R;
            }
            if (R != n && L != -1)
                cur += min(abs(k - L), abs(k - R));
            else if (R != n)
                cur += abs(k - R);
            else
                cur += abs(k - L);


            int cnt = 0;
            L = 0;
            R = -1;
            while (L >= 0 && ((i >> (n - L - 1)) & 1) != 1)
            {
                --L;
            }
            for (int j = 0; j < n; ++j)
            {
                if (j > R)
                {
                    L = R;
                    while (R < n && ((i >> (n - R - 1)) & 1) != 1)
                    {
                        ++R;
                    }
                }
                if ((R != n && (a[j] + abs(j - R) < cur)) || (L != -1 && (a[j] + abs(j - L) < cur)))
                {
                    ++cnt;
                }
            }
            best[k] = max(best[k], cnt + 1);
        }
    }
    for (int i =0 ; i < n; ++i)
    {
        cout << best[i] << '\n';
    }
    return 0;
}
