typedef long long ll;
typedef long double ld;
#include<iostream>
#include<vector>
#include<string>
#include<iomanip>
#include<algorithm>
#include<iomanip>
#include<map>
#include<set>
#include<unordered_set>

ll INF = 1e18;

using namespace std;

vector<pair<ll, ll>>v;

ll get_sum(ll l, ll r) {
	ll ans = 0;
	for (ll i = l; i < r; i++) {
		ans = max(ans, v[i].first * (i - l + 1));
	}
	return ans;
}

int main() {
	cin.tie(0);
	cout.tie(0);
	cin.sync_with_stdio(0);
	ll n;
	cin >> n;
	v.resize(n);
	vector<ll>numbers;
	multiset<ll>st;
	for (ll i = 0; i < n; i++) {
		cin >> v[i].first >> v[i].second;
		numbers.push_back(v[i].second);
	}
	numbers.push_back(0);
	sort(v.rbegin(), v.rend());
	sort(numbers.begin(), numbers.end());
	numbers.erase(unique(numbers.begin(), numbers.end()), numbers.end());
	ll ans = 0;

	for (int it = 0; it < 10; it++) {
		ll l = n / 10 * it, r = n / 10 * (it + 1);
		while (r - l > 3) {
			ll m1 = l + (r - l) / 3;
			ll m2 = r - (r - l) / 3;
			if (get_sum(0, m1) + get_sum(m1, n) <= get_sum(0, m2) + get_sum(m2, n)) {
				l = m1;
			}
			else {
				r = m2;
			}
		}
		for (ll m1 = l; m1 <= r; m1++) {
			ans = max(ans, get_sum(0, m1) + get_sum(m1, n));
		}
	}

	ll l = 0, r = v.size();
	while (r - l > 3) {
		ll m1 = l + (r - l) / 3;
		ll m2 = r - (r - l) / 3;
		if (get_sum(0,m1) + get_sum(m1,n) <= get_sum(0, m2) + get_sum(m2, n)) {
			l = m1;
		}
		else {
			r = m2;
		}
	}
	for (ll m1 = l; m1 <= r; m1++) {
		ans = max(ans, get_sum(0, m1) + get_sum(m1, n));
	}


	cout << ans;
	return 0;
}