typedef long long ll;
typedef long double ld;
#include<iostream>
#include<vector>
#include<string>
#include<iomanip>
#include<map>
#include<set>
#include<algorithm>
#include<deque>
#include<string>
#include<ctime>

using namespace std;

ll INF = 1e9;

ll has(ll a, ll b) {
	return (a&b) != 0;
}

void prll(ll num) {
	vector<ll>ans;
	while (num > 0) {
		ans.push_back(num % 2);
		num /= 2;
	}
	reverse(ans.begin(), ans.end());
	for (auto now : ans) {
		cout << now;
	}
}

ll scan() {
	string s;
	cin >> s;
	ll ans = 0;
	for (auto now : s) {
		ans = ans * 2 + now-'0';
	}
	return ans;
}

int main() {
	cin.tie(0);
	cout.tie(0);
	cin.sync_with_stdio(0);
	ll n;
	cin >> n;
	vector<ll>v(n);
	ll ans = INF;
	for (ll i = 0; i < n; i++) {
		v[i] = scan();
	}
	sort(v.begin(), v.end());
	do {
		ll a = v[0];
		for (ll i = 1; i < n; i++) {
			for (ll num = v[i];; num++) {
				if (has(a, num) == 0) {
					a += num;
					break;
				}
			}
		}
		ans = min(ans, a);
	} while (next_permutation(v.begin(), v.end()) && clock()<1000);

	prll(ans);

	return 0;
}