#include<bits/stdc++.h>

using namespace std;
#define x first
#define y second
vector<pair<int, int>> v;
vector<bool> dist(int a, int b)
{
    vector<bool> res;
    res.assign(504, 0);
    int aa = max(abs(v[a].x - v[b].x), abs(v[a].y - v[b].y));
    res[aa] = 1;
    return res;
}
int g[500][500];
vector<bool> d[500];
int pr[500];
bool used[500];
vector<bool> f(vector<bool> &a, vector<bool> &b)
{
    vector<bool> c;
    for (int i : a) c.push_back(i);
    for (int i = 502; i >= 0; --i)
    {
        if (!b[i])
        {
            continue;
        }
        int ind = i;
        while (c[ind])
        {
            c[ind] = false;
            ind++;
        }
        c[ind] = true;
    }
    return c;
}
bool ch(vector<bool> &a, vector<bool> &b)
{
    for (int i = 502; i >= 0; --i)
    {
        if (a[i] && !b[i]) return false;
        if (!a[i] && b[i]) return true;
    }
    return false;
}
void dijkstra(int n)
{
    for (int i = 0; i < n; ++i)
    {
        d[i] = dist(0, i);
        pr[i] = 0;
    }
    for (int i = 0; i < 502; ++i) d[0][i] = false;
    used[0] = true;
    for (int i = 0; i < n; ++i)
    {
        int mn = -1;
        for (int j = 0; j < n; ++j)
        {
            if (!used[j] && (mn == -1 || ch(d[j], d[mn]))) mn = j;
        }
        if (mn == -1) break;
        used[mn] = true;
        for (int j = 0; j < n; ++j)
        {
            vector<bool> dd = dist(mn, j);
            vector<bool> ff = f(d[mn], dd);
            if (ch(ff, d[j]))
            {
                d[j] = ff;
                pr[j] = mn;
            }
        }
    }
}
signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    int n, m, k;
    cin >> n >> m >> k;
    v.resize(k);
    for (int i = 0; i < k; ++i)
    {
        cin >> v[i].x >> v[i].y;
    }
    dijkstra(k);
    vector<int> ans;
    int cur = k - 1;
    ans.push_back(cur);
    while (cur != 0)
    {
        cur = pr[cur];
        ans.push_back(cur);
    }
    cout << ans.size() << endl;
    reverse(ans.begin(), ans.end());
    for (int i : ans) cout << i + 1 << " ";
}
