#include <iostream>
#include <vector>
using namespace std;

const int MAXN = 3e5 + 10;
const int INF = 1e9 + 7;
int a[MAXN];

int nxmx[MAXN];
int nxmn[MAXN];


int getmx(int L, int R){
    int MX = -INF;
    int mxid = 0;
    for (int i = L; i <= R; i++){
        if (MX < a[i]){
            mxid = i;
            MX = a[i];
        }
    }
    return mxid;
}


int main(){
    int n;
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    for (int i = 0; i < n; i++){
        cin >> a[i];
    }

    vector <pair <int, int> > st;

    for (int i = n - 1; i >= 0; i--){
        while ((st.size() > 0) and (a[i] > st[st.size() - 1].first)){
            st.pop_back();
        }
        if (st.size() == 0){
            nxmx[i] = -1;
        }
        else{
            nxmx[i] = st[st.size() - 1].second;
        }
        if ((st.size() > 0) and (st[st.size() - 1].first == a[i])){
            st.pop_back();
        }
        st.push_back(make_pair(a[i], i));
    }

    st.resize(0);

    for (int i = n - 1; i >= 0; i--){
        while ((st.size() > 0) and (a[i] <= st[st.size() - 1].first)){
            st.pop_back();
        }
        if (st.size() == 0){
            nxmn[i] = -1;
        }
        else{
            nxmn[i] = st[st.size() - 1].second;
        }
        st.push_back(make_pair(a[i], i));
    }

    /*
    for (int i = 0; i < n; i++){
        cout << a[i] << ' ';
    }
    cout << endl;
    for (int i = 0; i < n; i++){
        cout << nxmn[i] + 1 << ' ';
    }
    cout << endl;
    for (int i = 0; i < n; i++){
        if (nxmn[i] == -1){
            cout << 0;
        }
        else{
            cout << a[nxmn[i]];
        }
        cout << ' ';
    }
    cout << endl;
*/

    /*
    cout << get(0, n - 1) << endl;
    */



    int ans = 0;
    int L = 0;

    while (L < n){
        int R = L;

        while ((nxmx[R] != -1) and ((nxmx[R] < nxmn[L]) or (nxmn[L] == -1))  ){
            R = nxmx[R];
        }
        ans += 1;
        L = R + 1;
    }
    cout << ans << endl;


}
