#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <bitset>
#include <set>
#include <map>
using namespace std;

typedef long long ll;
typedef long double ld;

#define all(x) x.begin(), x.end()
#define int ll

struct proc
{
	int x, y, num;
	void scan(int _num)
	{
		num = _num;
		cin >> x >> y;
	}
};

vector <int> D;

struct Cmp
{
	bool operator ()(int a, int b)const
	{
		if (D[a] != D[b])
			return D[a] < D[b];
		return a < b;
	}
};

int rast(proc a, proc b)
{
	return max(abs(a.x - b.x), abs(a.y - b.y));
}

signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, m, k;
	cin >> n >> m >> k;
	vector <proc> A(k);
	D.resize(k, 1e18);
	for (int i = 0; i < k; i++)
	{
		A[i].scan(i);
	}
	set <int, Cmp> Dj;
	D[0] = 0;
	Dj.insert(0);
	vector <bool> used(k);
	vector <int> pr(k);
	pr[0] = -1;
	while (!Dj.empty())
	{
		int v = *Dj.begin();
		Dj.erase(v);
		if (!used[v])
		{
			used[v] = true;
			for (int i = 0; i < k; i++)
			{
				if (D[i] > D[v] + (1 << rast(A[i], A[v])))
				{
					Dj.erase(i);
					D[i] = D[v] + (1 << rast(A[i], A[v]));
					pr[i] = v;
					Dj.insert(i);
				}
			}
		}
	}
	int cur = k - 1;
	vector <int>Ans;
	while (cur != -1)
	{
		Ans.push_back(cur + 1);
		cur = pr[cur];
	}
	reverse(all(Ans));
	cout << Ans.size() << endl;
	for (int i = 0; i < Ans.size(); i++)
	{
		cout << Ans[i] << " ";
	}
	return 0;
}