#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define ff first
#define ss second

using namespace std;
using namespace __gnu_pbds;

typedef tree<pair<int, int>, null_type, less<pair<int, int>>, rb_tree_tag, tree_order_statistics_node_update> oset;

vector<int> arr;
vector<int> ans;

int main() {
    int n, p;
    cin >> n >> p;
    arr.resize(n);
    for (int i = 0; i < n; i++) cin >> arr[i];
    ans.resize(n);
    for (int l1 = -1; l1 < n; l1++) {
        for (int r1 = l1; r1 <= n; r1++) {
            if (l1 == -1 && r1 == n) continue;
            vector<pair<int, int>> curr(n);
            int l = l1, r = r1;
            if (l1 == -1) l = -1e9;
            if (r1 == n) r = 1e9;
            //cout << l << " " << r << endl;
            for (int i = 0; i < n; i++) {
                curr[i].second = i;
                curr[i].first = arr[i];
                if (i > l && i < r) curr[i].first += min(abs(l - i), abs(r - i));
            }
            sort(curr.begin(), curr.end());
            int prev = -1;
            int cnt = 0;
            for (int i = 0; i < curr.size(); i++) {
                if (curr[i].first != prev) {
                    prev = curr[i].first;
                    cnt = 0;
                }
                //cout << t[i].second << " " << i + 1 - cnt << endl;
                ans[curr[i].second] = max(ans[curr[i].second], i - cnt);
                cnt++;
            }
        }
    }
    for (auto el: ans) cout << el + 1 << endl;
    return 0;
}