#include <bits/stdc++.h>

using namespace std;

#define int int64_t
#define se second
#define fi first
#define mp make_pair
#define endl '\n'

template <typename T1, typename T2>
ostream & operator << (ostream & out, pair <T1, T2> p)
{
    out << p.fi << " " << p.se << endl;
    return out;
}

template <typename T1, typename T2>
istream & operator >> (istream & in, pair <T1, T2> & p) {
    in >> p.fi >> p.se;
    return in;
}

template <typename T>
istream & operator >> (istream & in, vector <T> & arr) {
    for (auto & x : arr)
        in >> x;
    return in;
}

template <typename T>
ostream & operator << (ostream & out, vector <T> arr) {
    for (auto x : arr)
        out << x << " ";
    return out;
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m, q;
    cin >> n >> m >> q;
    vector <vector <int> > arr(n, vector <int> (m));
    cin >> arr;
    vector <int> mxr(n);
    vector <int> mxc(m);
    vector <int> posr(n), posc(m);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (arr[i][j] > mxc[j]) {
                posc[j] = i;
            }
            if (arr[i][j] > mxr[i]) {
                posr[i] = j;
            }
            mxc[j] = max(mxc[j], arr[i][j]);
            mxr[i] = max(mxr[i], arr[i][j]);
        }
    }
    vector <int> cntc(m), cntr(n);
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (arr[i][j] == mxr[i] && arr[i][j] == mxc[j]) {
                ans++;
                cntc[j]++;
                cntr[i]++;
            }
        }
    }
    for (int i = 0; i < q; ++i) {
        int r, c, x;
        cin >> r >> c >> x;
        --r;
        --c;
        if (arr[r][c] == mxc[c] && arr[r][c] == mxr[r]) {
            arr[r][c] = x;
            mxc[c] = x;
            mxr[r] = x;
            cout << ans << endl;
            continue;
        }
        if (x > mxr[r]) {
            if (cntr[r] > 0) {
                cntr[r]--;
                ans--;
                cntc[posr[r]]--;
            }
            posr[r] = c;
            mxr[r] = x;
        }
        if (x > mxc[c]) {
            if (cntc[c] > 0) {
                cntr[posc[c]]--;
                cntc[c]--;
                ans--;
            }
            mxc[c] = x;
            posc[c] = r;
        }
        if (x == mxc[c] && x == mxr[r]) {
            ans++;
            cntc[c]++;
            cntr[r]++;
        }
        arr[r][c] = x;
        cout << ans << endl;
    }
    return 0;
}
