#include <bits/stdc++.h>

using namespace std;

#define int int64_t
#define se second
#define fi first
#define mp make_pair
#define endl '\n'

template <typename T1, typename T2>
ostream & operator << (ostream & out, pair <T1, T2> p)
{
    out << p.fi << " " << p.se << endl;
    return out;
}

template <typename T1, typename T2>
istream & operator >> (istream & in, pair <T1, T2> & p) {
    in >> p.fi >> p.se;
    return in;
}

template <typename T>
istream & operator >> (istream & in, vector <T> & arr) {
    for (auto & x : arr)
        in >> x;
    return in;
}

template <typename T>
ostream & operator << (ostream & out, vector <T> arr) {
    for (auto x : arr)
        out << x << " ";
    return out;
}

vector <pair <int, int> > arr;

int get(vector <int> a, int id = 0) {
    if (a.size() == 0) {
        return 0;
    }
    int n = a.size();
    int l = id, r = n;
    for (int i = 0; i < 100; ++i) {
        int m1 = (2 * l + r) / 3;
        int m2 = (l + 2 * r) / 3;
        if ((n - m2) * a[m2] > (n - m1) * a[m1]) {
            r = m2;
        }
        else {
            l = m1;
        }
    }
    int ans = 0;
    for (int i = max(id, l - 2); i < min(r + 2, n); ++i) {
        ans = max(ans, (n - i) * a[i]);
    }
    return ans;
}

signed main()
{
    //ios::sync_with_stdio(false);
    //cin.tie(0);
    //cout.tie(0);

    int n;
    cin >> n;
    arr.resize(n);
    cin >> arr;
    sort(arr.begin(), arr.end());
    int ans = 0;
    int now = 0;
    vector <int> a;
    for (int i = 0; i < n; ++i)
        a.push_back(arr[i].se);
    vector <int> b;
    int j = 0;
    for (int i = 0; i < n; ++i) {
        while (j < i - 1 && a[j + 1] * (i - j - 1) > b[j] * (i - j))
            ++j;
        ans = max(ans, b[j] * (i - j) + (n - i) * a[i]);
        b.push_back(arr[i].se);
    }
    cout << ans << endl;
    return 0;
}
