#include <iostream>
#include <vector>
#define int long long  
#define pb bush_back 
#define all(x) x.begin(), x.end()

using namespace std;
const int maxn = 2e5, inf = 1e18;
int n, m, q, max_x[maxn], max_y[maxn]; 
vector<int> cnt[maxn];

void solve() {
	cin >> n >> m >> q; 	    
	for (int i = 0; i < n; ++i) {
		cnt[i].resize(m);
		for (int j = 0; j < m; ++j)  cin >> cnt[i][j];
	}
	int now = 0; 
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) max_y[i] = max(max_y[i], cnt[i][j]);	
	}
	for (int i = 0; i < m; ++i) {
		for (int j = 0; j < n; ++j) max_x[i] = max(max_x[i], cnt[j][i]);
	}
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (cnt[i][j] == max(max_x[j], max_y[i])) ++now;
		}
	}
	for (int k = 0; k < q; ++k) {
		int r, c, x;
		cin >> r >> c >> x;
		--r; --c; 
		for (int i = 0; i < n; ++i) {
			if (cnt[i][c] == max(max_y[i], max_x[c])) --now;
		}						
		for (int j = 0; j < m; ++j) {
			if (cnt[r][j] == max(max_y[r], max_x[j])) --now;
		}
		if (cnt[r][c] == max(max_y[r], max_x[c])) now++; 
		cnt[r][c] = x; 
	/*	if (k == q - 1) {
			for (int i = 0; i < n; ++i) {
				cout << max_y[i] << " ";
			}
			cout << '\n';
			for (int i = 0; i < m; ++i) {
				cout << max_x[i] << " ";
			}
			cout << '\n'; 
		}
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) {
				cout << cnt[i][j] << " "; 
			}
			cout << '\n'; 
		}
		cout << '\n';*/
		max_x[c] = max(max_x[c], x); 
		max_y[r] = max(max_y[r], x);
		for (int i = 0; i < n; ++i) {
			if (cnt[i][c] == max(max_y[i], max_x[c])) ++now;
		}						
		for (int j = 0; j < m; ++j) {
			if (cnt[r][j] == max(max_y[r], max_x[j])) ++now;
		}
		if (cnt[r][c] == max(max_x[c], max_y[r])) --now;
		cout << now << '\n'; 
	}	
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	#ifdef offline_judge
		freopen("TASK.in", "r", stdin); 
		freopen("TASK.out", "w", stdout);
	#endif		
	solve();	
}