import org.omg.CORBA.INTERNAL;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.lang.reflect.Array;
import java.lang.reflect.Executable;
import java.util.*;

public class Main {
    ArrayList<Integer> g[];
    boolean utr[];
    void dfs(int v){
        if(utr[v]) return;
        utr[v] = true;
        for(int u : g[v]){
            dfs(v);
        }
    }
    public void solve() throws IOException {
        int n = nextInt();
        g = new ArrayList[n + 1];
        utr = new ArrayList[n + 1];
        for (int i = 0; i <= n; i++) {
            g[i] = new ArrayList<>();
        }
        int lvl[][] = new int[n][n];
        int a[][] = new int[n][n];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                a[i][j] = nextInt() - 1;
                lvl[i][a[i][j]] = j;
            }
        }
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if(i == j) continue;
                if(lvl[j][i] < lvl[j][j]) g[i].add(j);
            }
        }
        int type = nextInt();
        if(type == 1){
            ArrayList<Integer> res = new ArrayList<>();
            for (int i = 0; i < n; i++) {
                if(a[i][0] == i) res.add(i + 1);
            }
            out.println(res.size());
            for(int i : res){
                out.print(i + " ");
            }
        }else{
            int clr[] = new int[n];
            for (int i = 0; i < n; i++) {
                clr[i] = i;
            }
            boolean st[] = new boolean[n];

            TreeSet<Integer> res = new TreeSet<>();
            for (int i = 0; i < n; i++) {
                if (a[i][0] == i) {
                    st[i] = true;
                    g[n].add(i);
                    res.add(i + 1);
                }
            }
            dfs(n);int min[] = new int[n];
            for (int i = 0; i < n; i++) {
                min[i] = n - 1;
            }
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < n; j++) {
                    if(!st[j]) continue;
                    min[i] = Math.min(min[i], lvl[i][j]);
                }
            }
            for (int i = 0; i < n; i++) {

                if(st[i]) continue;
                for (int j = 0; j < n; j++) {
                    clr[j] = j;
                }
                boolean ut[] = new boolean[n];
                boolean utt[] = new boolean[n];

                for (int j = 0; j < n; j++) {

                    if(j == i) continue;
                    if(lvl[j][j] > lvl[j][i]){
                        clr[j] = i;
                    }else {
                        ut[j] = true;
                        utt[j] = true;
                    }
                }
                for (int j = 0; j < n; j++) {
                    if(clr[j] == i){
                        boolean tr = true;
                        for (int q = 0; q < lvl[j][i]; q++) {
                            if(st[a[j][q]]){
                                tr = false;
                                break;
                            }
                        }

                        for (int q = 0; q < lvl[j][i] && tr; q++) {
                            if(clr[a[j][q]] == a[j][q] && min[a[j][q]] > lvl[a[j][q]][a[j][q]] && !utr[a[j][q]]){
                                tr = false;
                                break;
                            }
                        }
                        if(tr){
                            res.add(i + 1);
                            break;
                        }
                    }
                }
            }
            out.println(res.size());
            for(int i : res){
                out.print(i + " ");
            }
        }
    }

    BufferedReader br;
    StringTokenizer sc;
    PrintWriter out;

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

    public void run() throws IOException {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    public String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                return null;
            }
        }
        return sc.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

}
