#include <iostream>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <cassert>
#include <set>

using namespace std;

const int MAXN = 5e5;

int n;
int a[MAXN], res[MAXN];

int add;

struct Kek {

    vector <int> k;

    void init() {
        k.clear();
    }

    void insert(int v) {
        k.push_back(v);
    }

    int get_lt(int v) {
        int res = 0;
        for (int i = 0; i < (int)k.size(); i++)
            if (k[i] < v)
                res++;
        return res;
    }

} kek;

int main() {
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(false);

    int p; cin >> n >> p;
    for (int i = 0; i < n; i++)
        cin >> a[i];

    fill(res, res + MAXN, 0);

    kek.init(); add = 0;
    for (int i = 0; i < n; i++) {
        res[i] += kek.get_lt(a[i] - add);
        kek.insert(a[i] - add);
        add++;
    }
    kek.init(); add = 0;
    for (int i = n - 1; i >= 0; i--) {
        res[i] += kek.get_lt(a[i] - add);
        kek.insert(a[i] - add);
        add++;
    }

    for (int i = 0; i < n; i++)
        cout << res[i] + 1 << endl;

    return 0;
}
