#include <bits/stdc++.h>

using namespace std;
int n, m, q, ans;
pair<int, int> m_col[200000], m_row[200000];
void calc_ans(const int& r, const int& c, const int& x) {
    int xc = m_col[c].first, xr = m_row[r].first;
    bool was_ans_col = (m_col[c].first == m_row[m_col[c].second].first);
    bool was_ans_row = (m_row[r].first == m_col[m_row[r].second].first);
    if (m_col[c].second == r && m_row[r].second == c) {
        m_col[c] = { x, r };
        m_row[r] = { x, c };
        return;
    }
    if (x < xc && x < xr) return; ///x < xc, xr
    if (m_col[c].second != r && m_row[r].second != c) {
        if (xc < x && x < xr) { ///xc < x < xr
            m_col[c] = { x, r };
            if (was_ans_col) ans--;
            return;
        }
        if (xr < x && x < xc) { ///xr < x < xc
            m_row[r] = { x, c };
            if (was_ans_row) ans--;
            return;
        }
        if (xc < x && xr < x) { ///xc, xr < x
            m_col[c] = { x, r };
            m_row[r] = { x, c };
            ans++;
            if (was_ans_col) ans--;
            if (was_ans_row) ans--;
            return;
        }
    }
    if (m_col[c].second == r) {
        m_col[c] = { x, r };
        if (x > xr) {
            m_row[r] = { x, c };
            if (!was_ans_row) ans++;
        }
        return;
    }
    if (m_row[r].second == c) {
        m_row[r] = { x, c };
        if (x > xc) {
            m_col[c] = { x, r };
            if (!was_ans_col) ans++;
        }
        return;
    }
}
void ans_build() {
    for (int i = 0; i < n; i++) if (m_row[i].first == m_col[m_row[i].second].first) ans++;
}
void print() {
    for (int i = 0; i < n; i++) printf("(%d, %d) ", m_row[i].first, m_row[i].second);
    printf("\n");
    for (int i = 0; i < m; i++) printf("(%d, %d) ", m_col[i].first, m_col[i].second);
    printf("\n");
}
int main()
{
    { //freopen and other
    ios::sync_with_stdio(false); cin.tie(nullptr);
    #ifdef eugene
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    #endif // eugene
    }
    cin >> n >> m >> q;
    for (int i = 0; i < n; i++) for (int j = 0; j < m; j++) {
        int x;
        cin >> x;
        if (m_row[i].first < x) m_row[i] = { x, j };
        if (m_col[j].first < x) m_col[j] = { x, i };
    }
    ans_build();
    //cerr << ans << endl;
    //print();
    for (int i = 0; i < q; i++) {
        int r, c, x;
        cin >> r >> c >> x;
        r--; c--;
        calc_ans(r, c, x);
        cout << ans << endl;
        //print();
    }
    return 0;
}
