#include<bits/stdc++.h>

using namespace std;

typedef long long int ll;

#define sz(x) (long long int) (x.size())
#define pb push_back()
#define pii pair <int, int>

vector <pii> tree;
vector <pii> treemn;
vector <int> a;
const int INF = 1e9 + 5;
int n;

void build(int i, int l, int r) {
    if (l == r) {
        tree[i].first = a[l - 1];
        tree[i].second = l - 1;
        return;
    }
    int m = (l + r) / 2;
    build (2 * i, l, m);
    build(2 * i + 1, m + 1, r);
    if (tree[2 * i].first > tree[2 * i + 1].first) {
        tree[i] = tree[2 * i];
    }
    else
        tree[i] = tree[2 * i + 1];
}

void buildmn(int i, int l, int r) {
    if (l == r) {
        treemn[i].first = a[l - 1];
        treemn[i].second = l - 1;
        return;
    }
    int m = (l + r) / 2;
    buildmn (2 * i, l, m);
    buildmn(2 * i + 1, m + 1, r);
    if (treemn[2 * i].first <= treemn[2 * i + 1].first) {
        treemn[i] = treemn[2 * i];
    }
    else
        treemn[i] = treemn[2 * i + 1];
}

pii getmn(int i, int l, int r, int nl, int nr, int val) {
    if (l > nr || r < nl)
        return {INF, n};
    if (l >= nl && r <= nr) {
        if (treemn[i].first < val)
            return treemn[i];
        if (l == r)
            return {INF, n};
        int m = (l + r) / 2;
        getmn(2 * i, l, m, nl, nr, val);
    }
    int m = (l + r) / 2;
    pii c = getmn(2 * i, l, m, nl, nr, val);
    pii d = getmn(2 * i + 1, m + 1, r, nl, nr,val);
    if (c.first < d.first)
        return c;
    return d;
}

pii getmx(int i, int l, int r, int nl, int nr) {
    if (l > nr || r < nl)
        return {-INF, -1};
    if (l >= nl && r <= nr) {
        return tree[i];
    }
    int m = (l + r) / 2;
    pii c = getmx(2 * i, l, m, nl, nr);
    pii d = getmx(2 * i + 1, m + 1, r, nl, nr);
    if (c.first > d.first)
        return c;
    return d;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    a.resize(n);
    tree.resize(4 * n);
    treemn.resize(4 * n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    build(1, 1, n);
    buildmn(1, 1, n);
    int i = 0, cnt = 0;
    while (i < n) {
        pii in = getmn(1, 1, n, i + 1, n, a[i]);
        int l = in.second;
        pii c = getmx(1, 1, n, i + 1, l + 1);
        ++cnt;
        i = c.second + 1;
    }
    cout << cnt << endl;
}
