#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9 + 548;

int main()
{
    int n, p;
    cin >> n >> p;
    vector <int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    vector <int> ans(n, 0);
    for (int mask = 0; mask < (1 << n); mask++) {
        vector <int> dist(n, INF);
        int lst = -INF;
        for (int i = 0; i < n; i++) {
            if (mask & (1 << i)) {
                lst = i;
                dist[i] = 0;
            }
            else {
                dist[i] = min(dist[i], abs(i - lst));
            }
        }
        lst = -INF;
        for (int i = n - 1; i >= 0; i--) {
            if (mask & (1 << i)) {
                lst = i;
                dist[i] = 0;
            }
            else {
                dist[i] = min(dist[i], abs(i - lst));
            }
        }
        vector <pair <int, int> > r(n);
        for (int i = 0; i < n; i++) {
            r[i] = {dist[i] + a[i], i};
        }
        sort(r.begin(), r.end());
        int k = 0;
        for (int i = 1; i < n; i++) {
            if (r[i].first != r[i - 1].first) {
                k = i;
            }
            ans[r[i].second] = max(ans[r[i].second], k);
        }
    }
    for (int i : ans) {
        cout << i + 1 << endl;
    }
    return 0;
}
