#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
//#include "Source.h"

using namespace std;

typedef long long ll;

const int MAXN = 600;

vector<pair<ll, ll> > v;
int n;

void solve3000() {
	ll res = 0;
	ll a = 0;
	for (int i = v.size() - 1; i >= 0; --i) {
		ll cur = 0;
		vector<ll> b;
		for (int j = 0; j <= i; ++j)
			b.push_back(v[j].second);
		sort(b.begin(), b.end());
		for (int j = 0; j < b.size(); ++j)
			cur = max(cur, b[j] * (b.size() - j));
		res = max(res, a + cur);
		//cout << cur << " " << a << " " << b.size() << endl;

		while (i - 1 >= 0 && v[i].first == v[i - 1].first)
			--i;
		a = v[i].first * (v.size() - i);
	}
	cout << max(res, a) << '\n';
}

void solve0() {
	ll res = 0;
	for (int i = 0; i < n; ++i)
		res = max(res, v[i].first * (n - i));
	cout << res;
}

ll inter(ll start1, ll k1, ll k2) {
	ll a = k2 - k1;
	if (a == 0)
		return -1;
	ll val = start1 / a;
	if (start1 % a != 0)
		val++;
	return val;
}

void solveab() {
	ll res = 0;
	vector<ll> pos(n, 0);
	vector<pair<int, ll> > id = { {0, 0} };
	for (int i = 1; i < n; ++i) {
		while (true) {
			int a = id.back().first;
			ll x = inter((i - a) * v[a].first, v[a].first, v[i].first) + i - 1;
			if (x == -1)
				break;
			else if (x <= id.back().second)
				id.pop_back();
			else {
				id.push_back({ i, x });
				break;
			}
		}
	}
	for (int i = 0; i < id.size(); ++i)
		if (id[i].second < n)
			pos[id[i].second] = id[i].first;
	for (int i = 1; i < n; ++i)
		pos[i] = max(pos[i], pos[i - 1]);
	for (ll i = 0; i < n; ++i)
		pos[i] = (i + 1 - pos[i]) * v[pos[i]].first;
	reverse(pos.begin(), pos.end());
	pos.push_back(0);
	reverse(pos.begin(), pos.end());
	v.push_back({ 0, 0 });
	for (int i = 0; i < pos.size(); ++i)
		res = max(v[i].first * (n - i) + pos[i], res);
	cout << res;
}

void solve() {
	cin >> n;
	v.resize(n);
	for (int i = 0; i < n; ++i)
		cin >> v[i].first >> v[i].second;
	sort(v.begin(), v.end());
	if (n <= 3000)
		solve3000();
	else if (v[0].first == 0)
		solve0();
	else
		solveab();
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
#ifdef Sam
	freopen("input.in", "r", stdin);
	freopen("output.out", "w", stdout);
#endif
	solve();
	return 0;
}