#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

struct line
{
	ll k, b;
};

ld inter(const line &a, const line &b)
{
	return (a.b - b.b) / (ld) (b.k - a.k);
}

ll f(const line &a, ll x)
{
	return a.k * x + a.b;
}

struct block
{
	vector <int> cur;
	vector <line> ls;
	block()
	{
	}
	void build()
	{
		ls.clear();
		for (int p = 0; p < (int) cur.size(); p++)
		{
			ll k = cur[p];
			ll b = cur[p] * (ll) p;
			line c = {k, b};
			if (!ls.empty() && ls.back().k == k)
			{
				ls.pop_back();
			}
			else
			{
				while ((int) ls.size() > 1)
				{
					auto b = ls.back();
					auto a = ls[(int) ls.size() - 2];
					if (inter(a, b) <= inter(b, c))
					{
						ls.pop_back();
					}
					else
					{
						break;
					}
				}
			}
			ls.push_back(c);
		}
	}
	void del(int x)
	{
		cur.erase(find(cur.begin(), cur.end(), x));
		build();
	}
	ll eval(int add)
	{
		if (ls.empty())
		{
			return 0;
		}
		int l = -1, r = (int) ls.size() - 1;
		while (l < r - 1)
		{
			int m = (l + r) / 2;
			if (f(ls[m], add) <= f(ls[m + 1], add))
			{
				l = m;
			}
			else
			{
				r = m;
			}
		}
		return f(ls[l + 1], add);
	}
};

const int B = 700;

vector <block> b;

int main()
{
#ifdef ONPC
	freopen("a.in", "r", stdin);
#endif
	ios::sync_with_stdio(0);
	cin.tie(0);
	int n;
	cin >> n;
	vector <pair <int, int> > e;
	vector <int> cur;
	for (int i = 0; i < n; i++)
	{
		int a, b;
		cin >> a >> b;
		cur.push_back(b);
		e.push_back({a, b});
	}
	sort(e.rbegin(), e.rend());
	sort(cur.rbegin(), cur.rend());
	for (int i = 0; i < (int) cur.size(); i += B)
	{
		int en = min((int) cur.size(), i + B);
		vector <int> new_cur;
		for (int j = i; j < en; j++)
		{
			new_cur.push_back(cur[j]);
		}
		block ret;
		ret.cur = new_cur;
		ret.build();
		b.push_back(ret);
	}
	ll ret = -1e18;
	for (int i = 0; i < n; i++)
	{
		ll ans = (i + 1) * (ll) e[i].first;
		for (int j = 0; j < (int) b.size(); j++)
		{
			if (!b[j].cur.empty() && b[j].cur.back() <= e[i].second)
			{
				b[j].del(e[i].second);
				break;
			}
		}
		int add = 1;
		ll res = 0;
		for (int j = 0; j < (int) b.size(); j++)
		{
			res = max(res, b[j].eval(add));
			add += (int) b[j].cur.size();
		}
		ret = max(ret, ans + res);
	}
	cout << ret << '\n';
}
