#include <iostream>
#include <vector>
#include <deque>
#include <algorithm>

using namespace std;

int n;
vector <int> a, bck;

void f(int l, int r) {
	vector <int> local(r - l + 1);
	int j = 0;
	for (int i = l + 1; i <= r; i += 2) local[j++] = a[i];
	for (int i = l; i <= r; i += 2) local[j++] = a[i];
	for (int i = l; i <= r; i++) a[i] = local[i - l], bck[a[i]] = i;
}

int main() {
	cin >> n;

	a.resize(n);
	bck.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i], a[i]--;
		bck[a[i]] = i;
	}

	int ans = 0;
	vector <pair <int, int>> out;
	
	for (int i = 0; i < n; i++) {
		while (bck[i] != i) {
			ans++;
			if ((bck[i] - i) % 2 == 1) {
				out.push_back({ i, bck[i] });
				f(i, bck[i]);
			}
			else {
				out.push_back({ i + 1, bck[i] });
				f(i + 1, bck[i]);
			}
		}
	}

	cout << ans << '\n';
	for (auto cur : out) cout << cur.first + 1 << ' ' << cur.second + 1 << '\n';

	return 0;
}