#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

vector<int> ta, a, tam, b, tb;

void builda(int v, int tl, int tr) {
	if (tl == tr) {
		ta[v] = a[tl];
		return;
	}
	int tm = (tl + tr) / 2;
	builda(2 * v, tl, tm);
	builda(2 * v + 1, tm + 1, tr);
	ta[v] = max(ta[2 * v], ta[2 * v + 1]);
}

int getMaxa(int v, int tl, int tr, int l, int r) {
	if (tl > r || tr < l)
		return -1e9;
	if (tl >= l && tr <= r)
		return ta[v];
	int tm = (tl + tr) / 2;
	return max(getMaxa(2 * v, tl, tm, l, r), getMaxa(2 * v + 1, tm + 1, tr, l, r));
}

void buildam(int v, int tl, int tr) {
	if (tl == tr) {
		tam[v] = a[tl];
		return;
	}
	int tm = (tl + tr) / 2;
	buildam(2 * v, tl, tm);
	buildam(2 * v + 1, tm + 1, tr);
	tam[v] = min(tam[2 * v], tam[2 * v + 1]);
}

int getMina(int v, int tl, int tr, int l, int r) {
	if (tl > r || tr < l)
		return 1e9;
	if (tl >= l && tr <= r)
		return tam[v];
	int tm = (tl + tr) / 2;
	return min(getMina(2 * v, tl, tm, l, r), getMina(2 * v + 1, tm + 1, tr, l, r));
}

void buildb(int v, int tl, int tr) {
	if (tl == tr) {
		tb[v] = b[tl];
		return;
	}
	int tm = (tl + tr) / 2;
	buildb(2 * v, tl, tm);
	buildb(2 * v + 1, tm + 1, tr);
	tb[v] = min(tb[2 * v], tb[2 * v + 1]);
}

int getMinb(int v, int tl, int tr, int l, int r) {
	if (tl > r || tr < l)
		return 1e9;
	if (tl >= l && tr <= r)
		return tb[v];
	int tm = (tl + tr) / 2;
	return min(getMinb(2 * v, tl, tm, l, r), getMinb(2 * v + 1, tm + 1, tr, l, r));
}

int main() {
	int n;
	cin >> n;
	a.resize(n);
	for (int i = 0; i < n; i++)
		cin >> a[i];
	int cnt = 0;
	ta.resize(4 * n);
	tam.resize(4 * n);
	builda(1, 0, n - 1);
	buildam(1, 0, n - 1);
	b.resize(n);
	for (int i = 0; i < n; i++) {
		int l = 0, r = i;
		while (l < r) {
			int m = (l + r) / 2;
			if (getMaxa(1, 0, n - 1, m, i) == a[i])
				r = m;
			else
				l = m + 1;
		}
		b[i] = l;
	}
	tb.resize(4 * n);
	buildb(1, 0, n - 1);
	for (int i = 0; i < n;) {
		int l = 1, r = n - i;
		while (l < r) {
			int m = (l + r + 1) / 2;
			if (getMina(1, 0, n - 1, i, i + m - 1) == a[i])
				l = m;
			else
				r = m - 1;
		}
		l = 1;
		while (l < r) {
			int m = (l + r + 1) / 2;
			if (getMinb(1, 0, n - 1, i + m - 1, n - 1) <= i)
				l = m;
			else
				r = m - 1;
		}
		cnt++;
		i += l;
	}
	cout << cnt;
	return 0;
}
