#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

vector<int> ta, a, tam, b, tb;

void builda(int v, int tl, int tr) {
	if (tl == tr) {
		ta[v] = a[tl];
		return;
	}
	int tm = (tl + tr) / 2;
	builda(2 * v, tl, tm);
	builda(2 * v + 1, tm + 1, tr);
	ta[v] = max(ta[2 * v], ta[2 * v + 1]);
}

int getMaxa(int v, int tl, int tr, int l, int r) {
	if (tl > r || tr < l)
		return -1e9;
	if (tl >= l && tr <= r)
		return ta[v];
	int tm = (tl + tr) / 2;
	return max(getMaxa(2 * v, tl, tm, l, r), getMaxa(2 * v + 1, tm + 1, tr, l, r));
}

void buildam(int v, int tl, int tr) {
	if (tl == tr) {
		tam[v] = a[tl];
		return;
	}
	int tm = (tl + tr) / 2;
	buildam(2 * v, tl, tm);
	buildam(2 * v + 1, tm + 1, tr);
	tam[v] = min(tam[2 * v], tam[2 * v + 1]);
}

int getMina(int v, int tl, int tr, int l, int r) {
	if (tl > r || tr < l)
		return 1e9;
	if (tl >= l && tr <= r)
		return tam[v];
	int tm = (tl + tr) / 2;
	return min(getMina(2 * v, tl, tm, l, r), getMina(2 * v + 1, tm + 1, tr, l, r));
}

void buildb(int v, int tl, int tr) {
	if (tl == tr) {
		tb[v] = b[tl];
		return;
	}
	int tm = (tl + tr) / 2;
	buildb(2 * v, tl, tm);
	buildb(2 * v + 1, tm + 1, tr);
	tb[v] = min(tb[2 * v], tb[2 * v + 1]);
}

int getMinb(int v, int tl, int tr, int l, int r) {
	if (tl > r || tr < l)
		return 1e9;
	if (tl >= l && tr <= r)
		return tb[v];
	int tm = (tl + tr) / 2;
	return min(getMinb(2 * v, tl, tm, l, r), getMinb(2 * v + 1, tm + 1, tr, l, r));
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; i++)
		cin >> a[i];
	vector<pair<int, int>> res;
	for (int i = 0; i < n; i++) {
		for (int j = 1; j < n; j++) {
			if (a[j - 1] > a[j]) {
				res.push_back({ j, j + 1 });
				swap(a[j - 1], a[j]);
			}
		}
	}
	cout << res.size() << '\n';
	for (pair<int, int> i : res)
		cout << i.first << ' ' << i.second << '\n';
	return 0; 
}
