#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdio>

using namespace std;

long long check(vector<long long> &tree, long long l, long long r, long long curl, long long curr, long long v)
{
	if (curr <= l || curl >= r)
	{
		return 0;
	}
	if (curr <= r && curl >= l)
	{
		return tree[v];
	}
	long long mid = (curr - curl) / 2 + curl;
	return check(tree, l, r, curl, mid, v * 2 + 1) + check(tree, l, r, mid, curr, v * 2 + 2);
}

void ch(vector<long long> &tree, long long curl, long long curr, long long v, long long el, long long nel)
{
	if (curr - curl == 1)
	{
		tree[v] = nel;
		return;
	}
	long long mid = (curr - curl) / 2 + curl;
	if (el < mid)
	{
		ch(tree, curl, mid, v * 2 + 1, el, nel);
	}
	else
	{
		ch(tree, mid, curr, v * 2 + 2, el, nel);
	}
	tree[v] = tree[v * 2 + 1] + tree[v * 2 + 2];
}

int main()
{
	long long n, p;
	cin >> n >> p;
	vector<long long > dist(n);
	vector<pair<long long, long long> > tmp(n);
	for (long long i = 0; i < n; i++)
	{
		cin >> dist[i];
		tmp[i] = { dist[i] + i, i };
	}
	long long t = 1;
	while (t < n)
		t *= 2;
	vector<long long> tree(t * 2 - 1, 0);
	vector<long long> answ(n);
	sort(tmp.begin(), tmp.end());
	long long curel = -1;
	vector<long long> nums;
	for (long long i = 0; i < n; i++)
	{
		if (tmp[i].first != curel)
		{
			curel = tmp[i].first;
			for (long long j = 0; j < nums.size(); j++)
			{
				ch(tree, 0, t, 0, nums[j], 1);
			}
			nums.clear();
		}
		answ[tmp[i].second] += check(tree, tmp[i].second, t, 0, t, 0);
		nums.push_back(tmp[i].second);
	}
	tree.assign(t * 2 - 1, 0);
	tmp.assign(n, { 0, 0 });
	for (long long i = 0; i < n; i++)
	{
		tmp[i] = { dist[i] + n - 1 - i, i };
	}
	sort(tmp.begin(), tmp.end());
	curel = -1;
	nums.clear();
	for (long long i = 0; i < n; i++)
	{
		if (tmp[i].first != curel)
		{
			curel = tmp[i].first;
			for (long long j = 0; j < nums.size(); j++)
			{
				ch(tree, 0, t, 0, nums[j], 1);
			}
			nums.clear();
		}
		answ[tmp[i].second] += check(tree, 0, tmp[i].second + 1, 0, t, 0);
		nums.push_back(tmp[i].second);
	}
	for (long long i = 0; i < n; i++)
	{
		cout << answ[i] + 1 << endl;
	}
	cin >> n;
    return 0;
}