#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

#define rep(i, n) for (int (i) = 0; (i) < (n); ++(i))
#define f first
#define s second
#define all(x) (x).begin(), (x).end()

const int MAXN = 300005;
int n;
int a[MAXN];
int lw[MAXN];
int t[MAXN * 4];

int build(int v, int tl, int tr) {
	if (tr <= tl) return n;
	if (tr - tl == 1) {
		t[v] = tl;
		return tl;
	}
	int tm = tl + (tr - tl) / 2;
	int p = build(v * 2 + 1, tl, tm);
	int q = build(v * 2 + 2, tm, tr);
	if (a[p] > a[q]) {
		t[v] = p;
		return p;
	} else {
		t[v] = q;
		return q;
	}
}

int query(int v, int tl, int tr, int l, int r) {
	if (r <= tl || tr <= l) return n;
	if (l <= tl && tr <= r) return t[v];

	int tm = tl + (tr - tl) / 2;
	int p = query(v * 2 + 1, tl, tm, l, r);
	int q = query(v * 2 + 2, tm, tr, l, r);
	if (a[p] > a[q]) {
		return p;
	} else {
		return q;
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	cin >> n;
	rep(i, n) {
		cin >> a[i];
	}
	a[n] = INT_MIN;

	set<pair<int, int>> s;
	s.insert({INT_MIN, -n});
	for (int i = n - 1; i >= 0; --i) {
		auto t = prev(s.lower_bound({a[i], INT_MIN}));
		lw[i] = -(*t).s;
		s.insert({a[i], -i});
	}

	build(0, 0, n);

	int cnt = 0;
	int pos = 0;
	while (pos < n) {
		// int to = query(0, 0, n, pos, lw[pos]);
		// cout << pos << ' ' << lw[pos] << ' ' << to << endl;
		int to = pos;
		for (int i = pos + 1; i < lw[pos]; ++i) {
			if (a[i] >= a[to]) {
				to = i;
			}
		}
		cnt++;
		pos = to + 1;
		// cout << pos << endl;
	}
	cout << cnt << endl;
}