#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

#define rep(i, n) for (int (i) = 0; (i) < (n); ++(i))
#define f first
#define s second
#define all(x) (x).begin(), (x).end()

const int MAXN = 3005;
int n;
int a[MAXN];
int t[MAXN];
vector<pii> ans;

void rear(int l, int r) {
	ans.push_back({l, r});
	for (int i = l; i <= r; ++i) {
		t[i] = a[i];
	}
	int i;
	for (i = 0; l + 1 + 2 * i <= r; ++i) {
		a[l + i] = t[l + 1 + 2 * i];
	}
	for (int j = 0; l + 2 * j <= r; ++j) {
		a[l + i + j] = t[l + 2 * j];
	}
}

void sw(int a, int b) {
	while (a != b) {
		int sz = a - b;
		if (sz & 1) {
			// int t = (n - b);
			rear(a, b);
			b = a + sz / 2;
		} else {
			// int t = (n - b);
			rear(a + 1, b);
			b = a + sz / 2;
		}
	}
}

int main() {
	srand(time(0));
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	cin >> n;
	rep(i, n) {
		cin >> a[i];
	}


	for (int i = 0; i < n - 1; ++i) {
		int mn = i;
		for (int j = i + 1; j < n; ++j) {
			if (a[j] < a[mn]) mn = j;
		}
		if (mn == i) continue;
		sw(i, mn);
		// rep(i, n) {
		// 	cout << a[i] << ' ';
		// }
		// cout << endl;
	}

	cout << ans.size() << endl;
	for (auto it : ans) {
		cout << it.f + 1 << ' ' << it.s + 1 << endl;
	}

	// while (true) {
	// 	int l, r;
	// 	cin >> l >> r;
	// 	rear(l - 1, r - 1);
	// 	rep(i, n) {
	// 		cout << a[i] << ' ';
	// 	}
	// 	cout << endl;
	// }
}