#include <iostream>
#include <vector>
#include <stdio.h>
#include <stack>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

int mas[300100];
int bm[300100];
pair<int, int> tree[8000000];
stack<pair<int, int> > st;

void build(int v, int l, int r) {
	if (r - l == 1) {
		tree[v] = { mas[l], l };
		return;
	}
	int m = (l + r) / 2;
	build(v * 2, l, m);
	build(v * 2 + 1, m, r);
	if (tree[v * 2].first > tree[v * 2 + 1].first)
		tree[v] = tree[v * 2];
	else
		tree[v] = tree[v * 2 + 1];
}

pair<int, int> getmax(int v, int l, int r, int lt, int rt) {
	if (lt >= l && rt <= r) {
		return tree[v];
	}
	if (lt >= r || rt <= l) {
		return { 0, 0 };
	}
	int m = (lt + rt) / 2;
	pair<int, int> a = getmax(v * 2, l, r, lt, m);
	pair<int, int> b = getmax(v * 2 + 1, l, r, m, rt);
	if (a.first > b.first)
		return a;
	else
		return b;
}

int main() {
	ios_base::sync_with_stdio(false);
	//freopen("In.txt", "r", stdin);
	//freopen("Out.txt", "w", stdout);
	int n;
	cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> mas[i];
	}
	for (int i = 0; i < n; i++) {
		while (st.size() && st.top().first > mas[i]) {
			bm[st.top().second] = i;
			st.pop();
		}
		st.push({ mas[i], i });
	}
	while (st.size()) {
		bm[st.top().second] = n;
		st.pop();
	}
	build(1, 0, n);
	int cmax = mas[0];
	int maxp = 0;
	int st = mas[0];
	int ans = 0;
	for (int i = 0; i < n; i++) {
		i = getmax(1, i, bm[i], 0, n).second;
		ans++;
	}
	cout << ans;
	return 0;
}